(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('stream'), require('util'), require('escape-string-regexp'), require('tty'), require('ms'), require('object.assign'), require('debug'), require('events'), require('mkdirp'), require('os'), require('isexe'), require('growl')) :
	typeof define === 'function' && define.amd ? define(['stream', 'util', 'escape-string-regexp', 'tty', 'ms', 'object.assign', 'debug', 'events', 'mkdirp', 'os', 'isexe', 'growl'], factory) :
	(global = global || self, global.mocha = factory(global.stream, global.util, global.escapeStringRegexp, global.tty, global.ms, global.object, global.debug, global.events, global.mkdirp, global.os, global.isexe, global.growl));
}(this, function (stream, util, escapeStringRegexp, tty, ms, object, debug, events, mkdirp, os, isexe, growl) { 'use strict';

	stream = stream && stream.hasOwnProperty('default') ? stream['default'] : stream;
	util = util && util.hasOwnProperty('default') ? util['default'] : util;
	escapeStringRegexp = escapeStringRegexp && escapeStringRegexp.hasOwnProperty('default') ? escapeStringRegexp['default'] : escapeStringRegexp;
	tty = tty && tty.hasOwnProperty('default') ? tty['default'] : tty;
	ms = ms && ms.hasOwnProperty('default') ? ms['default'] : ms;
	object = object && object.hasOwnProperty('default') ? object['default'] : object;
	debug = debug && debug.hasOwnProperty('default') ? debug['default'] : debug;
	events = events && events.hasOwnProperty('default') ? events['default'] : events;
	mkdirp = mkdirp && mkdirp.hasOwnProperty('default') ? mkdirp['default'] : mkdirp;
	os = os && os.hasOwnProperty('default') ? os['default'] : os;
	isexe = isexe && isexe.hasOwnProperty('default') ? isexe['default'] : isexe;
	growl = growl && growl.hasOwnProperty('default') ? growl['default'] : growl;

	var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function commonjsRequire () {
		throw new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');
	}

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	function getCjsExportFromNamespace (n) {
		return n && n.default || n;
	}

	var WritableStream = stream.Writable;
	var inherits = util.inherits;

	var browserStdout = BrowserStdout;


	inherits(BrowserStdout, WritableStream);

	function BrowserStdout(opts) {
	  if (!(this instanceof BrowserStdout)) { return new BrowserStdout(opts) }

	  opts = opts || {};
	  WritableStream.call(this, opts);
	  this.label = (opts.label !== undefined) ? opts.label : 'stdout';
	}

	BrowserStdout.prototype._write = function(chunks, encoding, cb) {
	  var output = chunks.toString ? chunks.toString() : chunks;
	  if (this.label === false) {
	    console.log(output);
	  } else {
	    console.log(this.label+':', output);
	  }
	  process.nextTick(cb);
	};

	var _empty_module = {};

	var _empty_module$1 = /*#__PURE__*/Object.freeze({
		default: _empty_module
	});

	var diff = createCommonjsModule(function (module) {
	/* See LICENSE file for terms of use */

	/*
	 * Text diff implementation.
	 *
	 * This library supports the following APIS:
	 * JsDiff.diffChars: Character by character diff
	 * JsDiff.diffWords: Word (as defined by \b regex) diff which ignores whitespace
	 * JsDiff.diffLines: Line based diff
	 *
	 * JsDiff.diffCss: Diff targeted at CSS content
	 *
	 * These methods are based on the implementation proposed in
	 * "An O(ND) Difference Algorithm and its Variations" (Myers, 1986).
	 * http://citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.4.6927
	 */
	(function(global, undefined) {
	  var objectPrototypeToString = Object.prototype.toString;

	  /*istanbul ignore next*/
	  function map(arr, mapper, that) {
	    if (Array.prototype.map) {
	      return Array.prototype.map.call(arr, mapper, that);
	    }

	    var other = new Array(arr.length);

	    for (var i = 0, n = arr.length; i < n; i++) {
	      other[i] = mapper.call(that, arr[i], i, arr);
	    }
	    return other;
	  }
	  function clonePath(path) {
	    return { newPos: path.newPos, components: path.components.slice(0) };
	  }
	  function removeEmpty(array) {
	    var ret = [];
	    for (var i = 0; i < array.length; i++) {
	      if (array[i]) {
	        ret.push(array[i]);
	      }
	    }
	    return ret;
	  }
	  function escapeHTML(s) {
	    var n = s;
	    n = n.replace(/&/g, '&amp;');
	    n = n.replace(/</g, '&lt;');
	    n = n.replace(/>/g, '&gt;');
	    n = n.replace(/"/g, '&quot;');

	    return n;
	  }

	  // This function handles the presence of circular references by bailing out when encountering an
	  // object that is already on the "stack" of items being processed.
	  function canonicalize(obj, stack, replacementStack) {
	    stack = stack || [];
	    replacementStack = replacementStack || [];

	    var i;

	    for (i = 0; i < stack.length; i += 1) {
	      if (stack[i] === obj) {
	        return replacementStack[i];
	      }
	    }

	    var canonicalizedObj;

	    if ('[object Array]' === objectPrototypeToString.call(obj)) {
	      stack.push(obj);
	      canonicalizedObj = new Array(obj.length);
	      replacementStack.push(canonicalizedObj);
	      for (i = 0; i < obj.length; i += 1) {
	        canonicalizedObj[i] = canonicalize(obj[i], stack, replacementStack);
	      }
	      stack.pop();
	      replacementStack.pop();
	    } else if (typeof obj === 'object' && obj !== null) {
	      stack.push(obj);
	      canonicalizedObj = {};
	      replacementStack.push(canonicalizedObj);
	      var sortedKeys = [],
	          key;
	      for (key in obj) {
	        sortedKeys.push(key);
	      }
	      sortedKeys.sort();
	      for (i = 0; i < sortedKeys.length; i += 1) {
	        key = sortedKeys[i];
	        canonicalizedObj[key] = canonicalize(obj[key], stack, replacementStack);
	      }
	      stack.pop();
	      replacementStack.pop();
	    } else {
	      canonicalizedObj = obj;
	    }
	    return canonicalizedObj;
	  }

	  function buildValues(components, newString, oldString, useLongestToken) {
	    var componentPos = 0,
	        componentLen = components.length,
	        newPos = 0,
	        oldPos = 0;

	    for (; componentPos < componentLen; componentPos++) {
	      var component = components[componentPos];
	      if (!component.removed) {
	        if (!component.added && useLongestToken) {
	          var value = newString.slice(newPos, newPos + component.count);
	          value = map(value, function(value, i) {
	            var oldValue = oldString[oldPos + i];
	            return oldValue.length > value.length ? oldValue : value;
	          });

	          component.value = value.join('');
	        } else {
	          component.value = newString.slice(newPos, newPos + component.count).join('');
	        }
	        newPos += component.count;

	        // Common case
	        if (!component.added) {
	          oldPos += component.count;
	        }
	      } else {
	        component.value = oldString.slice(oldPos, oldPos + component.count).join('');
	        oldPos += component.count;

	        // Reverse add and remove so removes are output first to match common convention
	        // The diffing algorithm is tied to add then remove output and this is the simplest
	        // route to get the desired output with minimal overhead.
	        if (componentPos && components[componentPos - 1].added) {
	          var tmp = components[componentPos - 1];
	          components[componentPos - 1] = components[componentPos];
	          components[componentPos] = tmp;
	        }
	      }
	    }

	    return components;
	  }

	  function Diff(ignoreWhitespace) {
	    this.ignoreWhitespace = ignoreWhitespace;
	  }
	  Diff.prototype = {
	    diff: function(oldString, newString, callback) {
	      var self = this;

	      function done(value) {
	        if (callback) {
	          setTimeout(function() { callback(undefined, value); }, 0);
	          return true;
	        } else {
	          return value;
	        }
	      }

	      // Handle the identity case (this is due to unrolling editLength == 0
	      if (newString === oldString) {
	        return done([{ value: newString }]);
	      }
	      if (!newString) {
	        return done([{ value: oldString, removed: true }]);
	      }
	      if (!oldString) {
	        return done([{ value: newString, added: true }]);
	      }

	      newString = this.tokenize(newString);
	      oldString = this.tokenize(oldString);

	      var newLen = newString.length, oldLen = oldString.length;
	      var editLength = 1;
	      var maxEditLength = newLen + oldLen;
	      var bestPath = [{ newPos: -1, components: [] }];

	      // Seed editLength = 0, i.e. the content starts with the same values
	      var oldPos = this.extractCommon(bestPath[0], newString, oldString, 0);
	      if (bestPath[0].newPos + 1 >= newLen && oldPos + 1 >= oldLen) {
	        // Identity per the equality and tokenizer
	        return done([{value: newString.join('')}]);
	      }

	      // Main worker method. checks all permutations of a given edit length for acceptance.
	      function execEditLength() {
	        for (var diagonalPath = -1 * editLength; diagonalPath <= editLength; diagonalPath += 2) {
	          var basePath;
	          var addPath = bestPath[diagonalPath - 1],
	              removePath = bestPath[diagonalPath + 1],
	              oldPos = (removePath ? removePath.newPos : 0) - diagonalPath;
	          if (addPath) {
	            // No one else is going to attempt to use this value, clear it
	            bestPath[diagonalPath - 1] = undefined;
	          }

	          var canAdd = addPath && addPath.newPos + 1 < newLen,
	              canRemove = removePath && 0 <= oldPos && oldPos < oldLen;
	          if (!canAdd && !canRemove) {
	            // If this path is a terminal then prune
	            bestPath[diagonalPath] = undefined;
	            continue;
	          }

	          // Select the diagonal that we want to branch from. We select the prior
	          // path whose position in the new string is the farthest from the origin
	          // and does not pass the bounds of the diff graph
	          if (!canAdd || (canRemove && addPath.newPos < removePath.newPos)) {
	            basePath = clonePath(removePath);
	            self.pushComponent(basePath.components, undefined, true);
	          } else {
	            basePath = addPath;   // No need to clone, we've pulled it from the list
	            basePath.newPos++;
	            self.pushComponent(basePath.components, true, undefined);
	          }

	          oldPos = self.extractCommon(basePath, newString, oldString, diagonalPath);

	          // If we have hit the end of both strings, then we are done
	          if (basePath.newPos + 1 >= newLen && oldPos + 1 >= oldLen) {
	            return done(buildValues(basePath.components, newString, oldString, self.useLongestToken));
	          } else {
	            // Otherwise track this path as a potential candidate and continue.
	            bestPath[diagonalPath] = basePath;
	          }
	        }

	        editLength++;
	      }

	      // Performs the length of edit iteration. Is a bit fugly as this has to support the
	      // sync and async mode which is never fun. Loops over execEditLength until a value
	      // is produced.
	      if (callback) {
	        (function exec() {
	          setTimeout(function() {
	            // This should not happen, but we want to be safe.
	            /*istanbul ignore next */
	            if (editLength > maxEditLength) {
	              return callback();
	            }

	            if (!execEditLength()) {
	              exec();
	            }
	          }, 0);
	        }());
	      } else {
	        while (editLength <= maxEditLength) {
	          var ret = execEditLength();
	          if (ret) {
	            return ret;
	          }
	        }
	      }
	    },

	    pushComponent: function(components, added, removed) {
	      var last = components[components.length - 1];
	      if (last && last.added === added && last.removed === removed) {
	        // We need to clone here as the component clone operation is just
	        // as shallow array clone
	        components[components.length - 1] = {count: last.count + 1, added: added, removed: removed };
	      } else {
	        components.push({count: 1, added: added, removed: removed });
	      }
	    },
	    extractCommon: function(basePath, newString, oldString, diagonalPath) {
	      var newLen = newString.length,
	          oldLen = oldString.length,
	          newPos = basePath.newPos,
	          oldPos = newPos - diagonalPath,

	          commonCount = 0;
	      while (newPos + 1 < newLen && oldPos + 1 < oldLen && this.equals(newString[newPos + 1], oldString[oldPos + 1])) {
	        newPos++;
	        oldPos++;
	        commonCount++;
	      }

	      if (commonCount) {
	        basePath.components.push({count: commonCount});
	      }

	      basePath.newPos = newPos;
	      return oldPos;
	    },

	    equals: function(left, right) {
	      var reWhitespace = /\S/;
	      return left === right || (this.ignoreWhitespace && !reWhitespace.test(left) && !reWhitespace.test(right));
	    },
	    tokenize: function(value) {
	      return value.split('');
	    }
	  };

	  var CharDiff = new Diff();

	  var WordDiff = new Diff(true);
	  var WordWithSpaceDiff = new Diff();
	  WordDiff.tokenize = WordWithSpaceDiff.tokenize = function(value) {
	    return removeEmpty(value.split(/(\s+|\b)/));
	  };

	  var CssDiff = new Diff(true);
	  CssDiff.tokenize = function(value) {
	    return removeEmpty(value.split(/([{}:;,]|\s+)/));
	  };

	  var LineDiff = new Diff();

	  var TrimmedLineDiff = new Diff();
	  TrimmedLineDiff.ignoreTrim = true;

	  LineDiff.tokenize = TrimmedLineDiff.tokenize = function(value) {
	    var this$1 = this;

	    var retLines = [],
	        lines = value.split(/^/m);
	    for (var i = 0; i < lines.length; i++) {
	      var line = lines[i],
	          lastLine = lines[i - 1],
	          lastLineLastChar = lastLine && lastLine[lastLine.length - 1];

	      // Merge lines that may contain windows new lines
	      if (line === '\n' && lastLineLastChar === '\r') {
	          retLines[retLines.length - 1] = retLines[retLines.length - 1].slice(0, -1) + '\r\n';
	      } else {
	        if (this$1.ignoreTrim) {
	          line = line.trim();
	          // add a newline unless this is the last line.
	          if (i < lines.length - 1) {
	            line += '\n';
	          }
	        }
	        retLines.push(line);
	      }
	    }

	    return retLines;
	  };

	  var PatchDiff = new Diff();
	  PatchDiff.tokenize = function(value) {
	    var ret = [],
	        linesAndNewlines = value.split(/(\n|\r\n)/);

	    // Ignore the final empty token that occurs if the string ends with a new line
	    if (!linesAndNewlines[linesAndNewlines.length - 1]) {
	      linesAndNewlines.pop();
	    }

	    // Merge the content and line separators into single tokens
	    for (var i = 0; i < linesAndNewlines.length; i++) {
	      var line = linesAndNewlines[i];

	      if (i % 2) {
	        ret[ret.length - 1] += line;
	      } else {
	        ret.push(line);
	      }
	    }
	    return ret;
	  };

	  var SentenceDiff = new Diff();
	  SentenceDiff.tokenize = function(value) {
	    return removeEmpty(value.split(/(\S.+?[.!?])(?=\s+|$)/));
	  };

	  var JsonDiff = new Diff();
	  // Discriminate between two lines of pretty-printed, serialized JSON where one of them has a
	  // dangling comma and the other doesn't. Turns out including the dangling comma yields the nicest output:
	  JsonDiff.useLongestToken = true;
	  JsonDiff.tokenize = LineDiff.tokenize;
	  JsonDiff.equals = function(left, right) {
	    return LineDiff.equals(left.replace(/,([\r\n])/g, '$1'), right.replace(/,([\r\n])/g, '$1'));
	  };

	  var JsDiff = {
	    Diff: Diff,

	    diffChars: function(oldStr, newStr, callback) { return CharDiff.diff(oldStr, newStr, callback); },
	    diffWords: function(oldStr, newStr, callback) { return WordDiff.diff(oldStr, newStr, callback); },
	    diffWordsWithSpace: function(oldStr, newStr, callback) { return WordWithSpaceDiff.diff(oldStr, newStr, callback); },
	    diffLines: function(oldStr, newStr, callback) { return LineDiff.diff(oldStr, newStr, callback); },
	    diffTrimmedLines: function(oldStr, newStr, callback) { return TrimmedLineDiff.diff(oldStr, newStr, callback); },

	    diffSentences: function(oldStr, newStr, callback) { return SentenceDiff.diff(oldStr, newStr, callback); },

	    diffCss: function(oldStr, newStr, callback) { return CssDiff.diff(oldStr, newStr, callback); },
	    diffJson: function(oldObj, newObj, callback) {
	      return JsonDiff.diff(
	        typeof oldObj === 'string' ? oldObj : JSON.stringify(canonicalize(oldObj), undefined, '  '),
	        typeof newObj === 'string' ? newObj : JSON.stringify(canonicalize(newObj), undefined, '  '),
	        callback
	      );
	    },

	    createTwoFilesPatch: function(oldFileName, newFileName, oldStr, newStr, oldHeader, newHeader) {
	      var ret = [];

	      if (oldFileName == newFileName) {
	        ret.push('Index: ' + oldFileName);
	      }
	      ret.push('===================================================================');
	      ret.push('--- ' + oldFileName + (typeof oldHeader === 'undefined' ? '' : '\t' + oldHeader));
	      ret.push('+++ ' + newFileName + (typeof newHeader === 'undefined' ? '' : '\t' + newHeader));

	      var diff = PatchDiff.diff(oldStr, newStr);
	      diff.push({value: '', lines: []});   // Append an empty value to make cleanup easier

	      // Formats a given set of lines for printing as context lines in a patch
	      function contextLines(lines) {
	        return map(lines, function(entry) { return ' ' + entry; });
	      }

	      // Outputs the no newline at end of file warning if needed
	      function eofNL(curRange, i, current) {
	        var last = diff[diff.length - 2],
	            isLast = i === diff.length - 2,
	            isLastOfType = i === diff.length - 3 && current.added !== last.added;

	        // Figure out if this is the last line for the given file and missing NL
	        if (!(/\n$/.test(current.value)) && (isLast || isLastOfType)) {
	          curRange.push('\\ No newline at end of file');
	        }
	      }

	      var oldRangeStart = 0, newRangeStart = 0, curRange = [],
	          oldLine = 1, newLine = 1;
	      for (var i = 0; i < diff.length; i++) {
	        var current = diff[i],
	            lines = current.lines || current.value.replace(/\n$/, '').split('\n');
	        current.lines = lines;

	        if (current.added || current.removed) {
	          // If we have previous context, start with that
	          if (!oldRangeStart) {
	            var prev = diff[i - 1];
	            oldRangeStart = oldLine;
	            newRangeStart = newLine;

	            if (prev) {
	              curRange = contextLines(prev.lines.slice(-4));
	              oldRangeStart -= curRange.length;
	              newRangeStart -= curRange.length;
	            }
	          }

	          // Output our changes
	          curRange.push.apply(curRange, map(lines, function(entry) {
	            return (current.added ? '+' : '-') + entry;
	          }));
	          eofNL(curRange, i, current);

	          // Track the updated file position
	          if (current.added) {
	            newLine += lines.length;
	          } else {
	            oldLine += lines.length;
	          }
	        } else {
	          // Identical context lines. Track line changes
	          if (oldRangeStart) {
	            // Close out any changes that have been output (or join overlapping)
	            if (lines.length <= 8 && i < diff.length - 2) {
	              // Overlapping
	              curRange.push.apply(curRange, contextLines(lines));
	            } else {
	              // end the range and output
	              var contextSize = Math.min(lines.length, 4);
	              ret.push(
	                  '@@ -' + oldRangeStart + ',' + (oldLine - oldRangeStart + contextSize)
	                  + ' +' + newRangeStart + ',' + (newLine - newRangeStart + contextSize)
	                  + ' @@');
	              ret.push.apply(ret, curRange);
	              ret.push.apply(ret, contextLines(lines.slice(0, contextSize)));
	              if (lines.length <= 4) {
	                eofNL(ret, i, current);
	              }

	              oldRangeStart = 0;
	              newRangeStart = 0;
	              curRange = [];
	            }
	          }
	          oldLine += lines.length;
	          newLine += lines.length;
	        }
	      }

	      return ret.join('\n') + '\n';
	    },

	    createPatch: function(fileName, oldStr, newStr, oldHeader, newHeader) {
	      return JsDiff.createTwoFilesPatch(fileName, fileName, oldStr, newStr, oldHeader, newHeader);
	    },

	    applyPatch: function(oldStr, uniDiff) {
	      var diffstr = uniDiff.split('\n'),
	          hunks = [],
	          i = 0,
	          remEOFNL = false,
	          addEOFNL = false;

	      // Skip to the first change hunk
	      while (i < diffstr.length && !(/^@@/.test(diffstr[i]))) {
	        i++;
	      }

	      // Parse the unified diff
	      for (; i < diffstr.length; i++) {
	        if (diffstr[i][0] === '@') {
	          var chnukHeader = diffstr[i].split(/@@ -(\d+),(\d+) \+(\d+),(\d+) @@/);
	          hunks.unshift({
	            start: chnukHeader[3],
	            oldlength: +chnukHeader[2],
	            removed: [],
	            newlength: chnukHeader[4],
	            added: []
	          });
	        } else if (diffstr[i][0] === '+') {
	          hunks[0].added.push(diffstr[i].substr(1));
	        } else if (diffstr[i][0] === '-') {
	          hunks[0].removed.push(diffstr[i].substr(1));
	        } else if (diffstr[i][0] === ' ') {
	          hunks[0].added.push(diffstr[i].substr(1));
	          hunks[0].removed.push(diffstr[i].substr(1));
	        } else if (diffstr[i][0] === '\\') {
	          if (diffstr[i - 1][0] === '+') {
	            remEOFNL = true;
	          } else if (diffstr[i - 1][0] === '-') {
	            addEOFNL = true;
	          }
	        }
	      }

	      // Apply the diff to the input
	      var lines = oldStr.split('\n');
	      for (i = hunks.length - 1; i >= 0; i--) {
	        var hunk = hunks[i];
	        // Sanity check the input string. Bail if we don't match.
	        for (var j = 0; j < hunk.oldlength; j++) {
	          if (lines[hunk.start - 1 + j] !== hunk.removed[j]) {
	            return false;
	          }
	        }
	        Array.prototype.splice.apply(lines, [hunk.start - 1, hunk.oldlength].concat(hunk.added));
	      }

	      // Handle EOFNL insertion/removal
	      if (remEOFNL) {
	        while (!lines[lines.length - 1]) {
	          lines.pop();
	        }
	      } else if (addEOFNL) {
	        lines.push('');
	      }
	      return lines.join('\n');
	    },

	    convertChangesToXML: function(changes) {
	      var ret = [];
	      for (var i = 0; i < changes.length; i++) {
	        var change = changes[i];
	        if (change.added) {
	          ret.push('<ins>');
	        } else if (change.removed) {
	          ret.push('<del>');
	        }

	        ret.push(escapeHTML(change.value));

	        if (change.added) {
	          ret.push('</ins>');
	        } else if (change.removed) {
	          ret.push('</del>');
	        }
	      }
	      return ret.join('');
	    },

	    // See: http://code.google.com/p/google-diff-match-patch/wiki/API
	    convertChangesToDMP: function(changes) {
	      var ret = [],
	          change,
	          operation;
	      for (var i = 0; i < changes.length; i++) {
	        change = changes[i];
	        if (change.added) {
	          operation = 1;
	        } else if (change.removed) {
	          operation = -1;
	        } else {
	          operation = 0;
	        }

	        ret.push([operation, change.value]);
	      }
	      return ret;
	    },

	    canonicalize: canonicalize
	  };

	  /*istanbul ignore next */
	  /*global module */
	  if (module.exports) {
	    module.exports = JsDiff;
	  } else if (typeof undefined === 'function' && undefined.amd) {
	    /*global define */
	    undefined([], function() { return JsDiff; });
	  } else if (typeof global.JsDiff === 'undefined') {
	    global.JsDiff = JsDiff;
	  }
	}(commonjsGlobal));
	});

	var he = createCommonjsModule(function (module, exports) {
	(function(root) {

		// Detect free variables `exports`.
		var freeExports = exports;

		// Detect free variable `module`.
		var freeModule = module &&
			module.exports == freeExports && module;

		// Detect free variable `global`, from Node.js or Browserified code,
		// and use it as `root`.
		var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal;
		if (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal) {
			root = freeGlobal;
		}

		/*--------------------------------------------------------------------------*/

		// All astral symbols.
		var regexAstralSymbols = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
		// All ASCII symbols (not just printable ASCII) except those listed in the
		// first column of the overrides table.
		// https://html.spec.whatwg.org/multipage/syntax.html#table-charref-overrides
		var regexAsciiWhitelist = /[\x01-\x7F]/g;
		// All BMP symbols that are not ASCII newlines, printable ASCII symbols, or
		// code points listed in the first column of the overrides table on
		// https://html.spec.whatwg.org/multipage/syntax.html#table-charref-overrides.
		var regexBmpWhitelist = /[\x01-\t\x0B\f\x0E-\x1F\x7F\x81\x8D\x8F\x90\x9D\xA0-\uFFFF]/g;

		var regexEncodeNonAscii = /<\u20D2|=\u20E5|>\u20D2|\u205F\u200A|\u219D\u0338|\u2202\u0338|\u2220\u20D2|\u2229\uFE00|\u222A\uFE00|\u223C\u20D2|\u223D\u0331|\u223E\u0333|\u2242\u0338|\u224B\u0338|\u224D\u20D2|\u224E\u0338|\u224F\u0338|\u2250\u0338|\u2261\u20E5|\u2264\u20D2|\u2265\u20D2|\u2266\u0338|\u2267\u0338|\u2268\uFE00|\u2269\uFE00|\u226A\u0338|\u226A\u20D2|\u226B\u0338|\u226B\u20D2|\u227F\u0338|\u2282\u20D2|\u2283\u20D2|\u228A\uFE00|\u228B\uFE00|\u228F\u0338|\u2290\u0338|\u2293\uFE00|\u2294\uFE00|\u22B4\u20D2|\u22B5\u20D2|\u22D8\u0338|\u22D9\u0338|\u22DA\uFE00|\u22DB\uFE00|\u22F5\u0338|\u22F9\u0338|\u2933\u0338|\u29CF\u0338|\u29D0\u0338|\u2A6D\u0338|\u2A70\u0338|\u2A7D\u0338|\u2A7E\u0338|\u2AA1\u0338|\u2AA2\u0338|\u2AAC\uFE00|\u2AAD\uFE00|\u2AAF\u0338|\u2AB0\u0338|\u2AC5\u0338|\u2AC6\u0338|\u2ACB\uFE00|\u2ACC\uFE00|\u2AFD\u20E5|[\xA0-\u0113\u0116-\u0122\u0124-\u012B\u012E-\u014D\u0150-\u017E\u0192\u01B5\u01F5\u0237\u02C6\u02C7\u02D8-\u02DD\u0311\u0391-\u03A1\u03A3-\u03A9\u03B1-\u03C9\u03D1\u03D2\u03D5\u03D6\u03DC\u03DD\u03F0\u03F1\u03F5\u03F6\u0401-\u040C\u040E-\u044F\u0451-\u045C\u045E\u045F\u2002-\u2005\u2007-\u2010\u2013-\u2016\u2018-\u201A\u201C-\u201E\u2020-\u2022\u2025\u2026\u2030-\u2035\u2039\u203A\u203E\u2041\u2043\u2044\u204F\u2057\u205F-\u2063\u20AC\u20DB\u20DC\u2102\u2105\u210A-\u2113\u2115-\u211E\u2122\u2124\u2127-\u2129\u212C\u212D\u212F-\u2131\u2133-\u2138\u2145-\u2148\u2153-\u215E\u2190-\u219B\u219D-\u21A7\u21A9-\u21AE\u21B0-\u21B3\u21B5-\u21B7\u21BA-\u21DB\u21DD\u21E4\u21E5\u21F5\u21FD-\u2205\u2207-\u2209\u220B\u220C\u220F-\u2214\u2216-\u2218\u221A\u221D-\u2238\u223A-\u2257\u2259\u225A\u225C\u225F-\u2262\u2264-\u228B\u228D-\u229B\u229D-\u22A5\u22A7-\u22B0\u22B2-\u22BB\u22BD-\u22DB\u22DE-\u22E3\u22E6-\u22F7\u22F9-\u22FE\u2305\u2306\u2308-\u2310\u2312\u2313\u2315\u2316\u231C-\u231F\u2322\u2323\u232D\u232E\u2336\u233D\u233F\u237C\u23B0\u23B1\u23B4-\u23B6\u23DC-\u23DF\u23E2\u23E7\u2423\u24C8\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2550-\u256C\u2580\u2584\u2588\u2591-\u2593\u25A1\u25AA\u25AB\u25AD\u25AE\u25B1\u25B3-\u25B5\u25B8\u25B9\u25BD-\u25BF\u25C2\u25C3\u25CA\u25CB\u25EC\u25EF\u25F8-\u25FC\u2605\u2606\u260E\u2640\u2642\u2660\u2663\u2665\u2666\u266A\u266D-\u266F\u2713\u2717\u2720\u2736\u2758\u2772\u2773\u27C8\u27C9\u27E6-\u27ED\u27F5-\u27FA\u27FC\u27FF\u2902-\u2905\u290C-\u2913\u2916\u2919-\u2920\u2923-\u292A\u2933\u2935-\u2939\u293C\u293D\u2945\u2948-\u294B\u294E-\u2976\u2978\u2979\u297B-\u297F\u2985\u2986\u298B-\u2996\u299A\u299C\u299D\u29A4-\u29B7\u29B9\u29BB\u29BC\u29BE-\u29C5\u29C9\u29CD-\u29D0\u29DC-\u29DE\u29E3-\u29E5\u29EB\u29F4\u29F6\u2A00-\u2A02\u2A04\u2A06\u2A0C\u2A0D\u2A10-\u2A17\u2A22-\u2A27\u2A29\u2A2A\u2A2D-\u2A31\u2A33-\u2A3C\u2A3F\u2A40\u2A42-\u2A4D\u2A50\u2A53-\u2A58\u2A5A-\u2A5D\u2A5F\u2A66\u2A6A\u2A6D-\u2A75\u2A77-\u2A9A\u2A9D-\u2AA2\u2AA4-\u2AB0\u2AB3-\u2AC8\u2ACB\u2ACC\u2ACF-\u2ADB\u2AE4\u2AE6-\u2AE9\u2AEB-\u2AF3\u2AFD\uFB00-\uFB04]|\uD835[\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDCCF\uDD04\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDD6B]/g;
		var encodeMap = {'\xAD':'shy','\u200C':'zwnj','\u200D':'zwj','\u200E':'lrm','\u2063':'ic','\u2062':'it','\u2061':'af','\u200F':'rlm','\u200B':'ZeroWidthSpace','\u2060':'NoBreak','\u0311':'DownBreve','\u20DB':'tdot','\u20DC':'DotDot','\t':'Tab','\n':'NewLine','\u2008':'puncsp','\u205F':'MediumSpace','\u2009':'thinsp','\u200A':'hairsp','\u2004':'emsp13','\u2002':'ensp','\u2005':'emsp14','\u2003':'emsp','\u2007':'numsp','\xA0':'nbsp','\u205F\u200A':'ThickSpace','\u203E':'oline','_':'lowbar','\u2010':'dash','\u2013':'ndash','\u2014':'mdash','\u2015':'horbar',',':'comma',';':'semi','\u204F':'bsemi',':':'colon','\u2A74':'Colone','!':'excl','\xA1':'iexcl','?':'quest','\xBF':'iquest','.':'period','\u2025':'nldr','\u2026':'mldr','\xB7':'middot','\'':'apos','\u2018':'lsquo','\u2019':'rsquo','\u201A':'sbquo','\u2039':'lsaquo','\u203A':'rsaquo','"':'quot','\u201C':'ldquo','\u201D':'rdquo','\u201E':'bdquo','\xAB':'laquo','\xBB':'raquo','(':'lpar',')':'rpar','[':'lsqb',']':'rsqb','{':'lcub','}':'rcub','\u2308':'lceil','\u2309':'rceil','\u230A':'lfloor','\u230B':'rfloor','\u2985':'lopar','\u2986':'ropar','\u298B':'lbrke','\u298C':'rbrke','\u298D':'lbrkslu','\u298E':'rbrksld','\u298F':'lbrksld','\u2990':'rbrkslu','\u2991':'langd','\u2992':'rangd','\u2993':'lparlt','\u2994':'rpargt','\u2995':'gtlPar','\u2996':'ltrPar','\u27E6':'lobrk','\u27E7':'robrk','\u27E8':'lang','\u27E9':'rang','\u27EA':'Lang','\u27EB':'Rang','\u27EC':'loang','\u27ED':'roang','\u2772':'lbbrk','\u2773':'rbbrk','\u2016':'Vert','\xA7':'sect','\xB6':'para','@':'commat','*':'ast','/':'sol','undefined':null,'&':'amp','#':'num','%':'percnt','\u2030':'permil','\u2031':'pertenk','\u2020':'dagger','\u2021':'Dagger','\u2022':'bull','\u2043':'hybull','\u2032':'prime','\u2033':'Prime','\u2034':'tprime','\u2057':'qprime','\u2035':'bprime','\u2041':'caret','`':'grave','\xB4':'acute','\u02DC':'tilde','^':'Hat','\xAF':'macr','\u02D8':'breve','\u02D9':'dot','\xA8':'die','\u02DA':'ring','\u02DD':'dblac','\xB8':'cedil','\u02DB':'ogon','\u02C6':'circ','\u02C7':'caron','\xB0':'deg','\xA9':'copy','\xAE':'reg','\u2117':'copysr','\u2118':'wp','\u211E':'rx','\u2127':'mho','\u2129':'iiota','\u2190':'larr','\u219A':'nlarr','\u2192':'rarr','\u219B':'nrarr','\u2191':'uarr','\u2193':'darr','\u2194':'harr','\u21AE':'nharr','\u2195':'varr','\u2196':'nwarr','\u2197':'nearr','\u2198':'searr','\u2199':'swarr','\u219D':'rarrw','\u219D\u0338':'nrarrw','\u219E':'Larr','\u219F':'Uarr','\u21A0':'Rarr','\u21A1':'Darr','\u21A2':'larrtl','\u21A3':'rarrtl','\u21A4':'mapstoleft','\u21A5':'mapstoup','\u21A6':'map','\u21A7':'mapstodown','\u21A9':'larrhk','\u21AA':'rarrhk','\u21AB':'larrlp','\u21AC':'rarrlp','\u21AD':'harrw','\u21B0':'lsh','\u21B1':'rsh','\u21B2':'ldsh','\u21B3':'rdsh','\u21B5':'crarr','\u21B6':'cularr','\u21B7':'curarr','\u21BA':'olarr','\u21BB':'orarr','\u21BC':'lharu','\u21BD':'lhard','\u21BE':'uharr','\u21BF':'uharl','\u21C0':'rharu','\u21C1':'rhard','\u21C2':'dharr','\u21C3':'dharl','\u21C4':'rlarr','\u21C5':'udarr','\u21C6':'lrarr','\u21C7':'llarr','\u21C8':'uuarr','\u21C9':'rrarr','\u21CA':'ddarr','\u21CB':'lrhar','\u21CC':'rlhar','\u21D0':'lArr','\u21CD':'nlArr','\u21D1':'uArr','\u21D2':'rArr','\u21CF':'nrArr','\u21D3':'dArr','\u21D4':'iff','\u21CE':'nhArr','\u21D5':'vArr','\u21D6':'nwArr','\u21D7':'neArr','\u21D8':'seArr','\u21D9':'swArr','\u21DA':'lAarr','\u21DB':'rAarr','\u21DD':'zigrarr','\u21E4':'larrb','\u21E5':'rarrb','\u21F5':'duarr','\u21FD':'loarr','\u21FE':'roarr','\u21FF':'hoarr','\u2200':'forall','\u2201':'comp','\u2202':'part','\u2202\u0338':'npart','\u2203':'exist','\u2204':'nexist','\u2205':'empty','\u2207':'Del','\u2208':'in','\u2209':'notin','\u220B':'ni','\u220C':'notni','\u03F6':'bepsi','\u220F':'prod','\u2210':'coprod','\u2211':'sum','+':'plus','\xB1':'pm','\xF7':'div','\xD7':'times','<':'lt','\u226E':'nlt','<\u20D2':'nvlt','=':'equals','\u2260':'ne','=\u20E5':'bne','\u2A75':'Equal','>':'gt','\u226F':'ngt','>\u20D2':'nvgt','\xAC':'not','|':'vert','\xA6':'brvbar','\u2212':'minus','\u2213':'mp','\u2214':'plusdo','\u2044':'frasl','\u2216':'setmn','\u2217':'lowast','\u2218':'compfn','\u221A':'Sqrt','\u221D':'prop','\u221E':'infin','\u221F':'angrt','\u2220':'ang','\u2220\u20D2':'nang','\u2221':'angmsd','\u2222':'angsph','\u2223':'mid','\u2224':'nmid','\u2225':'par','\u2226':'npar','\u2227':'and','\u2228':'or','\u2229':'cap','\u2229\uFE00':'caps','\u222A':'cup','\u222A\uFE00':'cups','\u222B':'int','\u222C':'Int','\u222D':'tint','\u2A0C':'qint','\u222E':'oint','\u222F':'Conint','\u2230':'Cconint','\u2231':'cwint','\u2232':'cwconint','\u2233':'awconint','\u2234':'there4','\u2235':'becaus','\u2236':'ratio','\u2237':'Colon','\u2238':'minusd','\u223A':'mDDot','\u223B':'homtht','\u223C':'sim','\u2241':'nsim','\u223C\u20D2':'nvsim','\u223D':'bsim','\u223D\u0331':'race','\u223E':'ac','\u223E\u0333':'acE','\u223F':'acd','\u2240':'wr','\u2242':'esim','\u2242\u0338':'nesim','\u2243':'sime','\u2244':'nsime','\u2245':'cong','\u2247':'ncong','\u2246':'simne','\u2248':'ap','\u2249':'nap','\u224A':'ape','\u224B':'apid','\u224B\u0338':'napid','\u224C':'bcong','\u224D':'CupCap','\u226D':'NotCupCap','\u224D\u20D2':'nvap','\u224E':'bump','\u224E\u0338':'nbump','\u224F':'bumpe','\u224F\u0338':'nbumpe','\u2250':'doteq','\u2250\u0338':'nedot','\u2251':'eDot','\u2252':'efDot','\u2253':'erDot','\u2254':'colone','\u2255':'ecolon','\u2256':'ecir','\u2257':'cire','\u2259':'wedgeq','\u225A':'veeeq','\u225C':'trie','\u225F':'equest','\u2261':'equiv','\u2262':'nequiv','\u2261\u20E5':'bnequiv','\u2264':'le','\u2270':'nle','\u2264\u20D2':'nvle','\u2265':'ge','\u2271':'nge','\u2265\u20D2':'nvge','\u2266':'lE','\u2266\u0338':'nlE','\u2267':'gE','\u2267\u0338':'ngE','\u2268\uFE00':'lvnE','\u2268':'lnE','\u2269':'gnE','\u2269\uFE00':'gvnE','\u226A':'ll','\u226A\u0338':'nLtv','\u226A\u20D2':'nLt','\u226B':'gg','\u226B\u0338':'nGtv','\u226B\u20D2':'nGt','\u226C':'twixt','\u2272':'lsim','\u2274':'nlsim','\u2273':'gsim','\u2275':'ngsim','\u2276':'lg','\u2278':'ntlg','\u2277':'gl','\u2279':'ntgl','\u227A':'pr','\u2280':'npr','\u227B':'sc','\u2281':'nsc','\u227C':'prcue','\u22E0':'nprcue','\u227D':'sccue','\u22E1':'nsccue','\u227E':'prsim','\u227F':'scsim','\u227F\u0338':'NotSucceedsTilde','\u2282':'sub','\u2284':'nsub','\u2282\u20D2':'vnsub','\u2283':'sup','\u2285':'nsup','\u2283\u20D2':'vnsup','\u2286':'sube','\u2288':'nsube','\u2287':'supe','\u2289':'nsupe','\u228A\uFE00':'vsubne','\u228A':'subne','\u228B\uFE00':'vsupne','\u228B':'supne','\u228D':'cupdot','\u228E':'uplus','\u228F':'sqsub','\u228F\u0338':'NotSquareSubset','\u2290':'sqsup','\u2290\u0338':'NotSquareSuperset','\u2291':'sqsube','\u22E2':'nsqsube','\u2292':'sqsupe','\u22E3':'nsqsupe','\u2293':'sqcap','\u2293\uFE00':'sqcaps','\u2294':'sqcup','\u2294\uFE00':'sqcups','\u2295':'oplus','\u2296':'ominus','\u2297':'otimes','\u2298':'osol','\u2299':'odot','\u229A':'ocir','\u229B':'oast','\u229D':'odash','\u229E':'plusb','\u229F':'minusb','\u22A0':'timesb','\u22A1':'sdotb','\u22A2':'vdash','\u22AC':'nvdash','\u22A3':'dashv','\u22A4':'top','\u22A5':'bot','\u22A7':'models','\u22A8':'vDash','\u22AD':'nvDash','\u22A9':'Vdash','\u22AE':'nVdash','\u22AA':'Vvdash','\u22AB':'VDash','\u22AF':'nVDash','\u22B0':'prurel','\u22B2':'vltri','\u22EA':'nltri','\u22B3':'vrtri','\u22EB':'nrtri','\u22B4':'ltrie','\u22EC':'nltrie','\u22B4\u20D2':'nvltrie','\u22B5':'rtrie','\u22ED':'nrtrie','\u22B5\u20D2':'nvrtrie','\u22B6':'origof','\u22B7':'imof','\u22B8':'mumap','\u22B9':'hercon','\u22BA':'intcal','\u22BB':'veebar','\u22BD':'barvee','\u22BE':'angrtvb','\u22BF':'lrtri','\u22C0':'Wedge','\u22C1':'Vee','\u22C2':'xcap','\u22C3':'xcup','\u22C4':'diam','\u22C5':'sdot','\u22C6':'Star','\u22C7':'divonx','\u22C8':'bowtie','\u22C9':'ltimes','\u22CA':'rtimes','\u22CB':'lthree','\u22CC':'rthree','\u22CD':'bsime','\u22CE':'cuvee','\u22CF':'cuwed','\u22D0':'Sub','\u22D1':'Sup','\u22D2':'Cap','\u22D3':'Cup','\u22D4':'fork','\u22D5':'epar','\u22D6':'ltdot','\u22D7':'gtdot','\u22D8':'Ll','\u22D8\u0338':'nLl','\u22D9':'Gg','\u22D9\u0338':'nGg','\u22DA\uFE00':'lesg','\u22DA':'leg','\u22DB':'gel','\u22DB\uFE00':'gesl','\u22DE':'cuepr','\u22DF':'cuesc','\u22E6':'lnsim','\u22E7':'gnsim','\u22E8':'prnsim','\u22E9':'scnsim','\u22EE':'vellip','\u22EF':'ctdot','\u22F0':'utdot','\u22F1':'dtdot','\u22F2':'disin','\u22F3':'isinsv','\u22F4':'isins','\u22F5':'isindot','\u22F5\u0338':'notindot','\u22F6':'notinvc','\u22F7':'notinvb','\u22F9':'isinE','\u22F9\u0338':'notinE','\u22FA':'nisd','\u22FB':'xnis','\u22FC':'nis','\u22FD':'notnivc','\u22FE':'notnivb','\u2305':'barwed','\u2306':'Barwed','\u230C':'drcrop','\u230D':'dlcrop','\u230E':'urcrop','\u230F':'ulcrop','\u2310':'bnot','\u2312':'profline','\u2313':'profsurf','\u2315':'telrec','\u2316':'target','\u231C':'ulcorn','\u231D':'urcorn','\u231E':'dlcorn','\u231F':'drcorn','\u2322':'frown','\u2323':'smile','\u232D':'cylcty','\u232E':'profalar','\u2336':'topbot','\u233D':'ovbar','\u233F':'solbar','\u237C':'angzarr','\u23B0':'lmoust','\u23B1':'rmoust','\u23B4':'tbrk','\u23B5':'bbrk','\u23B6':'bbrktbrk','\u23DC':'OverParenthesis','\u23DD':'UnderParenthesis','\u23DE':'OverBrace','\u23DF':'UnderBrace','\u23E2':'trpezium','\u23E7':'elinters','\u2423':'blank','\u2500':'boxh','\u2502':'boxv','\u250C':'boxdr','\u2510':'boxdl','\u2514':'boxur','\u2518':'boxul','\u251C':'boxvr','\u2524':'boxvl','\u252C':'boxhd','\u2534':'boxhu','\u253C':'boxvh','\u2550':'boxH','\u2551':'boxV','\u2552':'boxdR','\u2553':'boxDr','\u2554':'boxDR','\u2555':'boxdL','\u2556':'boxDl','\u2557':'boxDL','\u2558':'boxuR','\u2559':'boxUr','\u255A':'boxUR','\u255B':'boxuL','\u255C':'boxUl','\u255D':'boxUL','\u255E':'boxvR','\u255F':'boxVr','\u2560':'boxVR','\u2561':'boxvL','\u2562':'boxVl','\u2563':'boxVL','\u2564':'boxHd','\u2565':'boxhD','\u2566':'boxHD','\u2567':'boxHu','\u2568':'boxhU','\u2569':'boxHU','\u256A':'boxvH','\u256B':'boxVh','\u256C':'boxVH','\u2580':'uhblk','\u2584':'lhblk','\u2588':'block','\u2591':'blk14','\u2592':'blk12','\u2593':'blk34','\u25A1':'squ','\u25AA':'squf','\u25AB':'EmptyVerySmallSquare','\u25AD':'rect','\u25AE':'marker','\u25B1':'fltns','\u25B3':'xutri','\u25B4':'utrif','\u25B5':'utri','\u25B8':'rtrif','\u25B9':'rtri','\u25BD':'xdtri','\u25BE':'dtrif','\u25BF':'dtri','\u25C2':'ltrif','\u25C3':'ltri','\u25CA':'loz','\u25CB':'cir','\u25EC':'tridot','\u25EF':'xcirc','\u25F8':'ultri','\u25F9':'urtri','\u25FA':'lltri','\u25FB':'EmptySmallSquare','\u25FC':'FilledSmallSquare','\u2605':'starf','\u2606':'star','\u260E':'phone','\u2640':'female','\u2642':'male','\u2660':'spades','\u2663':'clubs','\u2665':'hearts','\u2666':'diams','\u266A':'sung','\u2713':'check','\u2717':'cross','\u2720':'malt','\u2736':'sext','\u2758':'VerticalSeparator','\u27C8':'bsolhsub','\u27C9':'suphsol','\u27F5':'xlarr','\u27F6':'xrarr','\u27F7':'xharr','\u27F8':'xlArr','\u27F9':'xrArr','\u27FA':'xhArr','\u27FC':'xmap','\u27FF':'dzigrarr','\u2902':'nvlArr','\u2903':'nvrArr','\u2904':'nvHarr','\u2905':'Map','\u290C':'lbarr','\u290D':'rbarr','\u290E':'lBarr','\u290F':'rBarr','\u2910':'RBarr','\u2911':'DDotrahd','\u2912':'UpArrowBar','\u2913':'DownArrowBar','\u2916':'Rarrtl','\u2919':'latail','\u291A':'ratail','\u291B':'lAtail','\u291C':'rAtail','\u291D':'larrfs','\u291E':'rarrfs','\u291F':'larrbfs','\u2920':'rarrbfs','\u2923':'nwarhk','\u2924':'nearhk','\u2925':'searhk','\u2926':'swarhk','\u2927':'nwnear','\u2928':'toea','\u2929':'tosa','\u292A':'swnwar','\u2933':'rarrc','\u2933\u0338':'nrarrc','\u2935':'cudarrr','\u2936':'ldca','\u2937':'rdca','\u2938':'cudarrl','\u2939':'larrpl','\u293C':'curarrm','\u293D':'cularrp','\u2945':'rarrpl','\u2948':'harrcir','\u2949':'Uarrocir','\u294A':'lurdshar','\u294B':'ldrushar','\u294E':'LeftRightVector','\u294F':'RightUpDownVector','\u2950':'DownLeftRightVector','\u2951':'LeftUpDownVector','\u2952':'LeftVectorBar','\u2953':'RightVectorBar','\u2954':'RightUpVectorBar','\u2955':'RightDownVectorBar','\u2956':'DownLeftVectorBar','\u2957':'DownRightVectorBar','\u2958':'LeftUpVectorBar','\u2959':'LeftDownVectorBar','\u295A':'LeftTeeVector','\u295B':'RightTeeVector','\u295C':'RightUpTeeVector','\u295D':'RightDownTeeVector','\u295E':'DownLeftTeeVector','\u295F':'DownRightTeeVector','\u2960':'LeftUpTeeVector','\u2961':'LeftDownTeeVector','\u2962':'lHar','\u2963':'uHar','\u2964':'rHar','\u2965':'dHar','\u2966':'luruhar','\u2967':'ldrdhar','\u2968':'ruluhar','\u2969':'rdldhar','\u296A':'lharul','\u296B':'llhard','\u296C':'rharul','\u296D':'lrhard','\u296E':'udhar','\u296F':'duhar','\u2970':'RoundImplies','\u2971':'erarr','\u2972':'simrarr','\u2973':'larrsim','\u2974':'rarrsim','\u2975':'rarrap','\u2976':'ltlarr','\u2978':'gtrarr','\u2979':'subrarr','\u297B':'suplarr','\u297C':'lfisht','\u297D':'rfisht','\u297E':'ufisht','\u297F':'dfisht','\u299A':'vzigzag','\u299C':'vangrt','\u299D':'angrtvbd','\u29A4':'ange','\u29A5':'range','\u29A6':'dwangle','\u29A7':'uwangle','\u29A8':'angmsdaa','\u29A9':'angmsdab','\u29AA':'angmsdac','\u29AB':'angmsdad','\u29AC':'angmsdae','\u29AD':'angmsdaf','\u29AE':'angmsdag','\u29AF':'angmsdah','\u29B0':'bemptyv','\u29B1':'demptyv','\u29B2':'cemptyv','\u29B3':'raemptyv','\u29B4':'laemptyv','\u29B5':'ohbar','\u29B6':'omid','\u29B7':'opar','\u29B9':'operp','\u29BB':'olcross','\u29BC':'odsold','\u29BE':'olcir','\u29BF':'ofcir','\u29C0':'olt','\u29C1':'ogt','\u29C2':'cirscir','\u29C3':'cirE','\u29C4':'solb','\u29C5':'bsolb','\u29C9':'boxbox','\u29CD':'trisb','\u29CE':'rtriltri','\u29CF':'LeftTriangleBar','\u29CF\u0338':'NotLeftTriangleBar','\u29D0':'RightTriangleBar','\u29D0\u0338':'NotRightTriangleBar','\u29DC':'iinfin','\u29DD':'infintie','\u29DE':'nvinfin','\u29E3':'eparsl','\u29E4':'smeparsl','\u29E5':'eqvparsl','\u29EB':'lozf','\u29F4':'RuleDelayed','\u29F6':'dsol','\u2A00':'xodot','\u2A01':'xoplus','\u2A02':'xotime','\u2A04':'xuplus','\u2A06':'xsqcup','\u2A0D':'fpartint','\u2A10':'cirfnint','\u2A11':'awint','\u2A12':'rppolint','\u2A13':'scpolint','\u2A14':'npolint','\u2A15':'pointint','\u2A16':'quatint','\u2A17':'intlarhk','\u2A22':'pluscir','\u2A23':'plusacir','\u2A24':'simplus','\u2A25':'plusdu','\u2A26':'plussim','\u2A27':'plustwo','\u2A29':'mcomma','\u2A2A':'minusdu','\u2A2D':'loplus','\u2A2E':'roplus','\u2A2F':'Cross','\u2A30':'timesd','\u2A31':'timesbar','\u2A33':'smashp','\u2A34':'lotimes','\u2A35':'rotimes','\u2A36':'otimesas','\u2A37':'Otimes','\u2A38':'odiv','\u2A39':'triplus','\u2A3A':'triminus','\u2A3B':'tritime','\u2A3C':'iprod','\u2A3F':'amalg','\u2A40':'capdot','\u2A42':'ncup','\u2A43':'ncap','\u2A44':'capand','\u2A45':'cupor','\u2A46':'cupcap','\u2A47':'capcup','\u2A48':'cupbrcap','\u2A49':'capbrcup','\u2A4A':'cupcup','\u2A4B':'capcap','\u2A4C':'ccups','\u2A4D':'ccaps','\u2A50':'ccupssm','\u2A53':'And','\u2A54':'Or','\u2A55':'andand','\u2A56':'oror','\u2A57':'orslope','\u2A58':'andslope','\u2A5A':'andv','\u2A5B':'orv','\u2A5C':'andd','\u2A5D':'ord','\u2A5F':'wedbar','\u2A66':'sdote','\u2A6A':'simdot','\u2A6D':'congdot','\u2A6D\u0338':'ncongdot','\u2A6E':'easter','\u2A6F':'apacir','\u2A70':'apE','\u2A70\u0338':'napE','\u2A71':'eplus','\u2A72':'pluse','\u2A73':'Esim','\u2A77':'eDDot','\u2A78':'equivDD','\u2A79':'ltcir','\u2A7A':'gtcir','\u2A7B':'ltquest','\u2A7C':'gtquest','\u2A7D':'les','\u2A7D\u0338':'nles','\u2A7E':'ges','\u2A7E\u0338':'nges','\u2A7F':'lesdot','\u2A80':'gesdot','\u2A81':'lesdoto','\u2A82':'gesdoto','\u2A83':'lesdotor','\u2A84':'gesdotol','\u2A85':'lap','\u2A86':'gap','\u2A87':'lne','\u2A88':'gne','\u2A89':'lnap','\u2A8A':'gnap','\u2A8B':'lEg','\u2A8C':'gEl','\u2A8D':'lsime','\u2A8E':'gsime','\u2A8F':'lsimg','\u2A90':'gsiml','\u2A91':'lgE','\u2A92':'glE','\u2A93':'lesges','\u2A94':'gesles','\u2A95':'els','\u2A96':'egs','\u2A97':'elsdot','\u2A98':'egsdot','\u2A99':'el','\u2A9A':'eg','\u2A9D':'siml','\u2A9E':'simg','\u2A9F':'simlE','\u2AA0':'simgE','\u2AA1':'LessLess','\u2AA1\u0338':'NotNestedLessLess','\u2AA2':'GreaterGreater','\u2AA2\u0338':'NotNestedGreaterGreater','\u2AA4':'glj','\u2AA5':'gla','\u2AA6':'ltcc','\u2AA7':'gtcc','\u2AA8':'lescc','\u2AA9':'gescc','\u2AAA':'smt','\u2AAB':'lat','\u2AAC':'smte','\u2AAC\uFE00':'smtes','\u2AAD':'late','\u2AAD\uFE00':'lates','\u2AAE':'bumpE','\u2AAF':'pre','\u2AAF\u0338':'npre','\u2AB0':'sce','\u2AB0\u0338':'nsce','\u2AB3':'prE','\u2AB4':'scE','\u2AB5':'prnE','\u2AB6':'scnE','\u2AB7':'prap','\u2AB8':'scap','\u2AB9':'prnap','\u2ABA':'scnap','\u2ABB':'Pr','\u2ABC':'Sc','\u2ABD':'subdot','\u2ABE':'supdot','\u2ABF':'subplus','\u2AC0':'supplus','\u2AC1':'submult','\u2AC2':'supmult','\u2AC3':'subedot','\u2AC4':'supedot','\u2AC5':'subE','\u2AC5\u0338':'nsubE','\u2AC6':'supE','\u2AC6\u0338':'nsupE','\u2AC7':'subsim','\u2AC8':'supsim','\u2ACB\uFE00':'vsubnE','\u2ACB':'subnE','\u2ACC\uFE00':'vsupnE','\u2ACC':'supnE','\u2ACF':'csub','\u2AD0':'csup','\u2AD1':'csube','\u2AD2':'csupe','\u2AD3':'subsup','\u2AD4':'supsub','\u2AD5':'subsub','\u2AD6':'supsup','\u2AD7':'suphsub','\u2AD8':'supdsub','\u2AD9':'forkv','\u2ADA':'topfork','\u2ADB':'mlcp','\u2AE4':'Dashv','\u2AE6':'Vdashl','\u2AE7':'Barv','\u2AE8':'vBar','\u2AE9':'vBarv','\u2AEB':'Vbar','\u2AEC':'Not','\u2AED':'bNot','\u2AEE':'rnmid','\u2AEF':'cirmid','\u2AF0':'midcir','\u2AF1':'topcir','\u2AF2':'nhpar','\u2AF3':'parsim','\u2AFD':'parsl','\u2AFD\u20E5':'nparsl','\u266D':'flat','\u266E':'natur','\u266F':'sharp','\xA4':'curren','\xA2':'cent','$':'dollar','\xA3':'pound','\xA5':'yen','\u20AC':'euro','\xB9':'sup1','\xBD':'half','\u2153':'frac13','\xBC':'frac14','\u2155':'frac15','\u2159':'frac16','\u215B':'frac18','\xB2':'sup2','\u2154':'frac23','\u2156':'frac25','\xB3':'sup3','\xBE':'frac34','\u2157':'frac35','\u215C':'frac38','\u2158':'frac45','\u215A':'frac56','\u215D':'frac58','\u215E':'frac78','\uD835\uDCB6':'ascr','\uD835\uDD52':'aopf','\uD835\uDD1E':'afr','\uD835\uDD38':'Aopf','\uD835\uDD04':'Afr','\uD835\uDC9C':'Ascr','\xAA':'ordf','\xE1':'aacute','\xC1':'Aacute','\xE0':'agrave','\xC0':'Agrave','\u0103':'abreve','\u0102':'Abreve','\xE2':'acirc','\xC2':'Acirc','\xE5':'aring','\xC5':'angst','\xE4':'auml','\xC4':'Auml','\xE3':'atilde','\xC3':'Atilde','\u0105':'aogon','\u0104':'Aogon','\u0101':'amacr','\u0100':'Amacr','\xE6':'aelig','\xC6':'AElig','\uD835\uDCB7':'bscr','\uD835\uDD53':'bopf','\uD835\uDD1F':'bfr','\uD835\uDD39':'Bopf','\u212C':'Bscr','\uD835\uDD05':'Bfr','\uD835\uDD20':'cfr','\uD835\uDCB8':'cscr','\uD835\uDD54':'copf','\u212D':'Cfr','\uD835\uDC9E':'Cscr','\u2102':'Copf','\u0107':'cacute','\u0106':'Cacute','\u0109':'ccirc','\u0108':'Ccirc','\u010D':'ccaron','\u010C':'Ccaron','\u010B':'cdot','\u010A':'Cdot','\xE7':'ccedil','\xC7':'Ccedil','\u2105':'incare','\uD835\uDD21':'dfr','\u2146':'dd','\uD835\uDD55':'dopf','\uD835\uDCB9':'dscr','\uD835\uDC9F':'Dscr','\uD835\uDD07':'Dfr','\u2145':'DD','\uD835\uDD3B':'Dopf','\u010F':'dcaron','\u010E':'Dcaron','\u0111':'dstrok','\u0110':'Dstrok','\xF0':'eth','\xD0':'ETH','\u2147':'ee','\u212F':'escr','\uD835\uDD22':'efr','\uD835\uDD56':'eopf','\u2130':'Escr','\uD835\uDD08':'Efr','\uD835\uDD3C':'Eopf','\xE9':'eacute','\xC9':'Eacute','\xE8':'egrave','\xC8':'Egrave','\xEA':'ecirc','\xCA':'Ecirc','\u011B':'ecaron','\u011A':'Ecaron','\xEB':'euml','\xCB':'Euml','\u0117':'edot','\u0116':'Edot','\u0119':'eogon','\u0118':'Eogon','\u0113':'emacr','\u0112':'Emacr','\uD835\uDD23':'ffr','\uD835\uDD57':'fopf','\uD835\uDCBB':'fscr','\uD835\uDD09':'Ffr','\uD835\uDD3D':'Fopf','\u2131':'Fscr','\uFB00':'fflig','\uFB03':'ffilig','\uFB04':'ffllig','\uFB01':'filig','fj':'fjlig','\uFB02':'fllig','\u0192':'fnof','\u210A':'gscr','\uD835\uDD58':'gopf','\uD835\uDD24':'gfr','\uD835\uDCA2':'Gscr','\uD835\uDD3E':'Gopf','\uD835\uDD0A':'Gfr','\u01F5':'gacute','\u011F':'gbreve','\u011E':'Gbreve','\u011D':'gcirc','\u011C':'Gcirc','\u0121':'gdot','\u0120':'Gdot','\u0122':'Gcedil','\uD835\uDD25':'hfr','\u210E':'planckh','\uD835\uDCBD':'hscr','\uD835\uDD59':'hopf','\u210B':'Hscr','\u210C':'Hfr','\u210D':'Hopf','\u0125':'hcirc','\u0124':'Hcirc','\u210F':'hbar','\u0127':'hstrok','\u0126':'Hstrok','\uD835\uDD5A':'iopf','\uD835\uDD26':'ifr','\uD835\uDCBE':'iscr','\u2148':'ii','\uD835\uDD40':'Iopf','\u2110':'Iscr','\u2111':'Im','\xED':'iacute','\xCD':'Iacute','\xEC':'igrave','\xCC':'Igrave','\xEE':'icirc','\xCE':'Icirc','\xEF':'iuml','\xCF':'Iuml','\u0129':'itilde','\u0128':'Itilde','\u0130':'Idot','\u012F':'iogon','\u012E':'Iogon','\u012B':'imacr','\u012A':'Imacr','\u0133':'ijlig','\u0132':'IJlig','\u0131':'imath','\uD835\uDCBF':'jscr','\uD835\uDD5B':'jopf','\uD835\uDD27':'jfr','\uD835\uDCA5':'Jscr','\uD835\uDD0D':'Jfr','\uD835\uDD41':'Jopf','\u0135':'jcirc','\u0134':'Jcirc','\u0237':'jmath','\uD835\uDD5C':'kopf','\uD835\uDCC0':'kscr','\uD835\uDD28':'kfr','\uD835\uDCA6':'Kscr','\uD835\uDD42':'Kopf','\uD835\uDD0E':'Kfr','\u0137':'kcedil','\u0136':'Kcedil','\uD835\uDD29':'lfr','\uD835\uDCC1':'lscr','\u2113':'ell','\uD835\uDD5D':'lopf','\u2112':'Lscr','\uD835\uDD0F':'Lfr','\uD835\uDD43':'Lopf','\u013A':'lacute','\u0139':'Lacute','\u013E':'lcaron','\u013D':'Lcaron','\u013C':'lcedil','\u013B':'Lcedil','\u0142':'lstrok','\u0141':'Lstrok','\u0140':'lmidot','\u013F':'Lmidot','\uD835\uDD2A':'mfr','\uD835\uDD5E':'mopf','\uD835\uDCC2':'mscr','\uD835\uDD10':'Mfr','\uD835\uDD44':'Mopf','\u2133':'Mscr','\uD835\uDD2B':'nfr','\uD835\uDD5F':'nopf','\uD835\uDCC3':'nscr','\u2115':'Nopf','\uD835\uDCA9':'Nscr','\uD835\uDD11':'Nfr','\u0144':'nacute','\u0143':'Nacute','\u0148':'ncaron','\u0147':'Ncaron','\xF1':'ntilde','\xD1':'Ntilde','\u0146':'ncedil','\u0145':'Ncedil','\u2116':'numero','\u014B':'eng','\u014A':'ENG','\uD835\uDD60':'oopf','\uD835\uDD2C':'ofr','\u2134':'oscr','\uD835\uDCAA':'Oscr','\uD835\uDD12':'Ofr','\uD835\uDD46':'Oopf','\xBA':'ordm','\xF3':'oacute','\xD3':'Oacute','\xF2':'ograve','\xD2':'Ograve','\xF4':'ocirc','\xD4':'Ocirc','\xF6':'ouml','\xD6':'Ouml','\u0151':'odblac','\u0150':'Odblac','\xF5':'otilde','\xD5':'Otilde','\xF8':'oslash','\xD8':'Oslash','\u014D':'omacr','\u014C':'Omacr','\u0153':'oelig','\u0152':'OElig','\uD835\uDD2D':'pfr','\uD835\uDCC5':'pscr','\uD835\uDD61':'popf','\u2119':'Popf','\uD835\uDD13':'Pfr','\uD835\uDCAB':'Pscr','\uD835\uDD62':'qopf','\uD835\uDD2E':'qfr','\uD835\uDCC6':'qscr','\uD835\uDCAC':'Qscr','\uD835\uDD14':'Qfr','\u211A':'Qopf','\u0138':'kgreen','\uD835\uDD2F':'rfr','\uD835\uDD63':'ropf','\uD835\uDCC7':'rscr','\u211B':'Rscr','\u211C':'Re','\u211D':'Ropf','\u0155':'racute','\u0154':'Racute','\u0159':'rcaron','\u0158':'Rcaron','\u0157':'rcedil','\u0156':'Rcedil','\uD835\uDD64':'sopf','\uD835\uDCC8':'sscr','\uD835\uDD30':'sfr','\uD835\uDD4A':'Sopf','\uD835\uDD16':'Sfr','\uD835\uDCAE':'Sscr','\u24C8':'oS','\u015B':'sacute','\u015A':'Sacute','\u015D':'scirc','\u015C':'Scirc','\u0161':'scaron','\u0160':'Scaron','\u015F':'scedil','\u015E':'Scedil','\xDF':'szlig','\uD835\uDD31':'tfr','\uD835\uDCC9':'tscr','\uD835\uDD65':'topf','\uD835\uDCAF':'Tscr','\uD835\uDD17':'Tfr','\uD835\uDD4B':'Topf','\u0165':'tcaron','\u0164':'Tcaron','\u0163':'tcedil','\u0162':'Tcedil','\u2122':'trade','\u0167':'tstrok','\u0166':'Tstrok','\uD835\uDCCA':'uscr','\uD835\uDD66':'uopf','\uD835\uDD32':'ufr','\uD835\uDD4C':'Uopf','\uD835\uDD18':'Ufr','\uD835\uDCB0':'Uscr','\xFA':'uacute','\xDA':'Uacute','\xF9':'ugrave','\xD9':'Ugrave','\u016D':'ubreve','\u016C':'Ubreve','\xFB':'ucirc','\xDB':'Ucirc','\u016F':'uring','\u016E':'Uring','\xFC':'uuml','\xDC':'Uuml','\u0171':'udblac','\u0170':'Udblac','\u0169':'utilde','\u0168':'Utilde','\u0173':'uogon','\u0172':'Uogon','\u016B':'umacr','\u016A':'Umacr','\uD835\uDD33':'vfr','\uD835\uDD67':'vopf','\uD835\uDCCB':'vscr','\uD835\uDD19':'Vfr','\uD835\uDD4D':'Vopf','\uD835\uDCB1':'Vscr','\uD835\uDD68':'wopf','\uD835\uDCCC':'wscr','\uD835\uDD34':'wfr','\uD835\uDCB2':'Wscr','\uD835\uDD4E':'Wopf','\uD835\uDD1A':'Wfr','\u0175':'wcirc','\u0174':'Wcirc','\uD835\uDD35':'xfr','\uD835\uDCCD':'xscr','\uD835\uDD69':'xopf','\uD835\uDD4F':'Xopf','\uD835\uDD1B':'Xfr','\uD835\uDCB3':'Xscr','\uD835\uDD36':'yfr','\uD835\uDCCE':'yscr','\uD835\uDD6A':'yopf','\uD835\uDCB4':'Yscr','\uD835\uDD1C':'Yfr','\uD835\uDD50':'Yopf','\xFD':'yacute','\xDD':'Yacute','\u0177':'ycirc','\u0176':'Ycirc','\xFF':'yuml','\u0178':'Yuml','\uD835\uDCCF':'zscr','\uD835\uDD37':'zfr','\uD835\uDD6B':'zopf','\u2128':'Zfr','\u2124':'Zopf','\uD835\uDCB5':'Zscr','\u017A':'zacute','\u0179':'Zacute','\u017E':'zcaron','\u017D':'Zcaron','\u017C':'zdot','\u017B':'Zdot','\u01B5':'imped','\xFE':'thorn','\xDE':'THORN','\u0149':'napos','\u03B1':'alpha','\u0391':'Alpha','\u03B2':'beta','\u0392':'Beta','\u03B3':'gamma','\u0393':'Gamma','\u03B4':'delta','\u0394':'Delta','\u03B5':'epsi','\u03F5':'epsiv','\u0395':'Epsilon','\u03DD':'gammad','\u03DC':'Gammad','\u03B6':'zeta','\u0396':'Zeta','\u03B7':'eta','\u0397':'Eta','\u03B8':'theta','\u03D1':'thetav','\u0398':'Theta','\u03B9':'iota','\u0399':'Iota','\u03BA':'kappa','\u03F0':'kappav','\u039A':'Kappa','\u03BB':'lambda','\u039B':'Lambda','\u03BC':'mu','\xB5':'micro','\u039C':'Mu','\u03BD':'nu','\u039D':'Nu','\u03BE':'xi','\u039E':'Xi','\u03BF':'omicron','\u039F':'Omicron','\u03C0':'pi','\u03D6':'piv','\u03A0':'Pi','\u03C1':'rho','\u03F1':'rhov','\u03A1':'Rho','\u03C3':'sigma','\u03A3':'Sigma','\u03C2':'sigmaf','\u03C4':'tau','\u03A4':'Tau','\u03C5':'upsi','\u03A5':'Upsilon','\u03D2':'Upsi','\u03C6':'phi','\u03D5':'phiv','\u03A6':'Phi','\u03C7':'chi','\u03A7':'Chi','\u03C8':'psi','\u03A8':'Psi','\u03C9':'omega','\u03A9':'ohm','\u0430':'acy','\u0410':'Acy','\u0431':'bcy','\u0411':'Bcy','\u0432':'vcy','\u0412':'Vcy','\u0433':'gcy','\u0413':'Gcy','\u0453':'gjcy','\u0403':'GJcy','\u0434':'dcy','\u0414':'Dcy','\u0452':'djcy','\u0402':'DJcy','\u0435':'iecy','\u0415':'IEcy','\u0451':'iocy','\u0401':'IOcy','\u0454':'jukcy','\u0404':'Jukcy','\u0436':'zhcy','\u0416':'ZHcy','\u0437':'zcy','\u0417':'Zcy','\u0455':'dscy','\u0405':'DScy','\u0438':'icy','\u0418':'Icy','\u0456':'iukcy','\u0406':'Iukcy','\u0457':'yicy','\u0407':'YIcy','\u0439':'jcy','\u0419':'Jcy','\u0458':'jsercy','\u0408':'Jsercy','\u043A':'kcy','\u041A':'Kcy','\u045C':'kjcy','\u040C':'KJcy','\u043B':'lcy','\u041B':'Lcy','\u0459':'ljcy','\u0409':'LJcy','\u043C':'mcy','\u041C':'Mcy','\u043D':'ncy','\u041D':'Ncy','\u045A':'njcy','\u040A':'NJcy','\u043E':'ocy','\u041E':'Ocy','\u043F':'pcy','\u041F':'Pcy','\u0440':'rcy','\u0420':'Rcy','\u0441':'scy','\u0421':'Scy','\u0442':'tcy','\u0422':'Tcy','\u045B':'tshcy','\u040B':'TSHcy','\u0443':'ucy','\u0423':'Ucy','\u045E':'ubrcy','\u040E':'Ubrcy','\u0444':'fcy','\u0424':'Fcy','\u0445':'khcy','\u0425':'KHcy','\u0446':'tscy','\u0426':'TScy','\u0447':'chcy','\u0427':'CHcy','\u045F':'dzcy','\u040F':'DZcy','\u0448':'shcy','\u0428':'SHcy','\u0449':'shchcy','\u0429':'SHCHcy','\u044A':'hardcy','\u042A':'HARDcy','\u044B':'ycy','\u042B':'Ycy','\u044C':'softcy','\u042C':'SOFTcy','\u044D':'ecy','\u042D':'Ecy','\u044E':'yucy','\u042E':'YUcy','\u044F':'yacy','\u042F':'YAcy','\u2135':'aleph','\u2136':'beth','\u2137':'gimel','\u2138':'daleth'};

		var regexEscape = /["&'<>`]/g;
		var escapeMap = {
			'"': '&quot;',
			'&': '&amp;',
			'\'': '&#x27;',
			'<': '&lt;',
			// See https://mathiasbynens.be/notes/ambiguous-ampersands: in HTML, the
			// following is not strictly necessary unless it’s part of a tag or an
			// unquoted attribute value. We’re only escaping it to support those
			// situations, and for XML support.
			'>': '&gt;',
			// In Internet Explorer ≤ 8, the backtick character can be used
			// to break out of (un)quoted attribute values or HTML comments.
			// See http://html5sec.org/#102, http://html5sec.org/#108, and
			// http://html5sec.org/#133.
			'`': '&#x60;'
		};

		var regexInvalidEntity = /&#(?:[xX][^a-fA-F0-9]|[^0-9xX])/;
		var regexInvalidRawCodePoint = /[\0-\x08\x0B\x0E-\x1F\x7F-\x9F\uFDD0-\uFDEF\uFFFE\uFFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F\uDBBF\uDBFF][\uDFFE\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
		var regexDecode = /&(CounterClockwiseContourIntegral|DoubleLongLeftRightArrow|ClockwiseContourIntegral|NotNestedGreaterGreater|NotSquareSupersetEqual|DiacriticalDoubleAcute|NotRightTriangleEqual|NotSucceedsSlantEqual|NotPrecedesSlantEqual|CloseCurlyDoubleQuote|NegativeVeryThinSpace|DoubleContourIntegral|FilledVerySmallSquare|CapitalDifferentialD|OpenCurlyDoubleQuote|EmptyVerySmallSquare|NestedGreaterGreater|DoubleLongRightArrow|NotLeftTriangleEqual|NotGreaterSlantEqual|ReverseUpEquilibrium|DoubleLeftRightArrow|NotSquareSubsetEqual|NotDoubleVerticalBar|RightArrowLeftArrow|NotGreaterFullEqual|NotRightTriangleBar|SquareSupersetEqual|DownLeftRightVector|DoubleLongLeftArrow|leftrightsquigarrow|LeftArrowRightArrow|NegativeMediumSpace|blacktriangleright|RightDownVectorBar|PrecedesSlantEqual|RightDoubleBracket|SucceedsSlantEqual|NotLeftTriangleBar|RightTriangleEqual|SquareIntersection|RightDownTeeVector|ReverseEquilibrium|NegativeThickSpace|longleftrightarrow|Longleftrightarrow|LongLeftRightArrow|DownRightTeeVector|DownRightVectorBar|GreaterSlantEqual|SquareSubsetEqual|LeftDownVectorBar|LeftDoubleBracket|VerticalSeparator|rightleftharpoons|NotGreaterGreater|NotSquareSuperset|blacktriangleleft|blacktriangledown|NegativeThinSpace|LeftDownTeeVector|NotLessSlantEqual|leftrightharpoons|DoubleUpDownArrow|DoubleVerticalBar|LeftTriangleEqual|FilledSmallSquare|twoheadrightarrow|NotNestedLessLess|DownLeftTeeVector|DownLeftVectorBar|RightAngleBracket|NotTildeFullEqual|NotReverseElement|RightUpDownVector|DiacriticalTilde|NotSucceedsTilde|circlearrowright|NotPrecedesEqual|rightharpoondown|DoubleRightArrow|NotSucceedsEqual|NonBreakingSpace|NotRightTriangle|LessEqualGreater|RightUpTeeVector|LeftAngleBracket|GreaterFullEqual|DownArrowUpArrow|RightUpVectorBar|twoheadleftarrow|GreaterEqualLess|downharpoonright|RightTriangleBar|ntrianglerighteq|NotSupersetEqual|LeftUpDownVector|DiacriticalAcute|rightrightarrows|vartriangleright|UpArrowDownArrow|DiacriticalGrave|UnderParenthesis|EmptySmallSquare|LeftUpVectorBar|leftrightarrows|DownRightVector|downharpoonleft|trianglerighteq|ShortRightArrow|OverParenthesis|DoubleLeftArrow|DoubleDownArrow|NotSquareSubset|bigtriangledown|ntrianglelefteq|UpperRightArrow|curvearrowright|vartriangleleft|NotLeftTriangle|nleftrightarrow|LowerRightArrow|NotHumpDownHump|NotGreaterTilde|rightthreetimes|LeftUpTeeVector|NotGreaterEqual|straightepsilon|LeftTriangleBar|rightsquigarrow|ContourIntegral|rightleftarrows|CloseCurlyQuote|RightDownVector|LeftRightVector|nLeftrightarrow|leftharpoondown|circlearrowleft|SquareSuperset|OpenCurlyQuote|hookrightarrow|HorizontalLine|DiacriticalDot|NotLessGreater|ntriangleright|DoubleRightTee|InvisibleComma|InvisibleTimes|LowerLeftArrow|DownLeftVector|NotSubsetEqual|curvearrowleft|trianglelefteq|NotVerticalBar|TildeFullEqual|downdownarrows|NotGreaterLess|RightTeeVector|ZeroWidthSpace|looparrowright|LongRightArrow|doublebarwedge|ShortLeftArrow|ShortDownArrow|RightVectorBar|GreaterGreater|ReverseElement|rightharpoonup|LessSlantEqual|leftthreetimes|upharpoonright|rightarrowtail|LeftDownVector|Longrightarrow|NestedLessLess|UpperLeftArrow|nshortparallel|leftleftarrows|leftrightarrow|Leftrightarrow|LeftRightArrow|longrightarrow|upharpoonleft|RightArrowBar|ApplyFunction|LeftTeeVector|leftarrowtail|NotEqualTilde|varsubsetneqq|varsupsetneqq|RightTeeArrow|SucceedsEqual|SucceedsTilde|LeftVectorBar|SupersetEqual|hookleftarrow|DifferentialD|VerticalTilde|VeryThinSpace|blacktriangle|bigtriangleup|LessFullEqual|divideontimes|leftharpoonup|UpEquilibrium|ntriangleleft|RightTriangle|measuredangle|shortparallel|longleftarrow|Longleftarrow|LongLeftArrow|DoubleLeftTee|Poincareplane|PrecedesEqual|triangleright|DoubleUpArrow|RightUpVector|fallingdotseq|looparrowleft|PrecedesTilde|NotTildeEqual|NotTildeTilde|smallsetminus|Proportional|triangleleft|triangledown|UnderBracket|NotHumpEqual|exponentiale|ExponentialE|NotLessTilde|HilbertSpace|RightCeiling|blacklozenge|varsupsetneq|HumpDownHump|GreaterEqual|VerticalLine|LeftTeeArrow|NotLessEqual|DownTeeArrow|LeftTriangle|varsubsetneq|Intersection|NotCongruent|DownArrowBar|LeftUpVector|LeftArrowBar|risingdotseq|GreaterTilde|RoundImplies|SquareSubset|ShortUpArrow|NotSuperset|quaternions|precnapprox|backepsilon|preccurlyeq|OverBracket|blacksquare|MediumSpace|VerticalBar|circledcirc|circleddash|CircleMinus|CircleTimes|LessGreater|curlyeqprec|curlyeqsucc|diamondsuit|UpDownArrow|Updownarrow|RuleDelayed|Rrightarrow|updownarrow|RightVector|nRightarrow|nrightarrow|eqslantless|LeftCeiling|Equilibrium|SmallCircle|expectation|NotSucceeds|thickapprox|GreaterLess|SquareUnion|NotPrecedes|NotLessLess|straightphi|succnapprox|succcurlyeq|SubsetEqual|sqsupseteq|Proportion|Laplacetrf|ImaginaryI|supsetneqq|NotGreater|gtreqqless|NotElement|ThickSpace|TildeEqual|TildeTilde|Fouriertrf|rmoustache|EqualTilde|eqslantgtr|UnderBrace|LeftVector|UpArrowBar|nLeftarrow|nsubseteqq|subsetneqq|nsupseteqq|nleftarrow|succapprox|lessapprox|UpTeeArrow|upuparrows|curlywedge|lesseqqgtr|varepsilon|varnothing|RightFloor|complement|CirclePlus|sqsubseteq|Lleftarrow|circledast|RightArrow|Rightarrow|rightarrow|lmoustache|Bernoullis|precapprox|mapstoleft|mapstodown|longmapsto|dotsquare|downarrow|DoubleDot|nsubseteq|supsetneq|leftarrow|nsupseteq|subsetneq|ThinSpace|ngeqslant|subseteqq|HumpEqual|NotSubset|triangleq|NotCupCap|lesseqgtr|heartsuit|TripleDot|Leftarrow|Coproduct|Congruent|varpropto|complexes|gvertneqq|LeftArrow|LessTilde|supseteqq|MinusPlus|CircleDot|nleqslant|NotExists|gtreqless|nparallel|UnionPlus|LeftFloor|checkmark|CenterDot|centerdot|Mellintrf|gtrapprox|bigotimes|OverBrace|spadesuit|therefore|pitchfork|rationals|PlusMinus|Backslash|Therefore|DownBreve|backsimeq|backprime|DownArrow|nshortmid|Downarrow|lvertneqq|eqvparsl|imagline|imagpart|infintie|integers|Integral|intercal|LessLess|Uarrocir|intlarhk|sqsupset|angmsdaf|sqsubset|llcorner|vartheta|cupbrcap|lnapprox|Superset|SuchThat|succnsim|succneqq|angmsdag|biguplus|curlyvee|trpezium|Succeeds|NotTilde|bigwedge|angmsdah|angrtvbd|triminus|cwconint|fpartint|lrcorner|smeparsl|subseteq|urcorner|lurdshar|laemptyv|DDotrahd|approxeq|ldrushar|awconint|mapstoup|backcong|shortmid|triangle|geqslant|gesdotol|timesbar|circledR|circledS|setminus|multimap|naturals|scpolint|ncongdot|RightTee|boxminus|gnapprox|boxtimes|andslope|thicksim|angmsdaa|varsigma|cirfnint|rtriltri|angmsdab|rppolint|angmsdac|barwedge|drbkarow|clubsuit|thetasym|bsolhsub|capbrcup|dzigrarr|doteqdot|DotEqual|dotminus|UnderBar|NotEqual|realpart|otimesas|ulcorner|hksearow|hkswarow|parallel|PartialD|elinters|emptyset|plusacir|bbrktbrk|angmsdad|pointint|bigoplus|angmsdae|Precedes|bigsqcup|varkappa|notindot|supseteq|precneqq|precnsim|profalar|profline|profsurf|leqslant|lesdotor|raemptyv|subplus|notnivb|notnivc|subrarr|zigrarr|vzigzag|submult|subedot|Element|between|cirscir|larrbfs|larrsim|lotimes|lbrksld|lbrkslu|lozenge|ldrdhar|dbkarow|bigcirc|epsilon|simrarr|simplus|ltquest|Epsilon|luruhar|gtquest|maltese|npolint|eqcolon|npreceq|bigodot|ddagger|gtrless|bnequiv|harrcir|ddotseq|equivDD|backsim|demptyv|nsqsube|nsqsupe|Upsilon|nsubset|upsilon|minusdu|nsucceq|swarrow|nsupset|coloneq|searrow|boxplus|napprox|natural|asympeq|alefsym|congdot|nearrow|bigstar|diamond|supplus|tritime|LeftTee|nvinfin|triplus|NewLine|nvltrie|nvrtrie|nwarrow|nexists|Diamond|ruluhar|Implies|supmult|angzarr|suplarr|suphsub|questeq|because|digamma|Because|olcross|bemptyv|omicron|Omicron|rotimes|NoBreak|intprod|angrtvb|orderof|uwangle|suphsol|lesdoto|orslope|DownTee|realine|cudarrl|rdldhar|OverBar|supedot|lessdot|supdsub|topfork|succsim|rbrkslu|rbrksld|pertenk|cudarrr|isindot|planckh|lessgtr|pluscir|gesdoto|plussim|plustwo|lesssim|cularrp|rarrsim|Cayleys|notinva|notinvb|notinvc|UpArrow|Uparrow|uparrow|NotLess|dwangle|precsim|Product|curarrm|Cconint|dotplus|rarrbfs|ccupssm|Cedilla|cemptyv|notniva|quatint|frac35|frac38|frac45|frac56|frac58|frac78|tridot|xoplus|gacute|gammad|Gammad|lfisht|lfloor|bigcup|sqsupe|gbreve|Gbreve|lharul|sqsube|sqcups|Gcedil|apacir|llhard|lmidot|Lmidot|lmoust|andand|sqcaps|approx|Abreve|spades|circeq|tprime|divide|topcir|Assign|topbot|gesdot|divonx|xuplus|timesd|gesles|atilde|solbar|SOFTcy|loplus|timesb|lowast|lowbar|dlcorn|dlcrop|softcy|dollar|lparlt|thksim|lrhard|Atilde|lsaquo|smashp|bigvee|thinsp|wreath|bkarow|lsquor|lstrok|Lstrok|lthree|ltimes|ltlarr|DotDot|simdot|ltrPar|weierp|xsqcup|angmsd|sigmav|sigmaf|zeetrf|Zcaron|zcaron|mapsto|vsupne|thetav|cirmid|marker|mcomma|Zacute|vsubnE|there4|gtlPar|vsubne|bottom|gtrarr|SHCHcy|shchcy|midast|midcir|middot|minusb|minusd|gtrdot|bowtie|sfrown|mnplus|models|colone|seswar|Colone|mstpos|searhk|gtrsim|nacute|Nacute|boxbox|telrec|hairsp|Tcedil|nbumpe|scnsim|ncaron|Ncaron|ncedil|Ncedil|hamilt|Scedil|nearhk|hardcy|HARDcy|tcedil|Tcaron|commat|nequiv|nesear|tcaron|target|hearts|nexist|varrho|scedil|Scaron|scaron|hellip|Sacute|sacute|hercon|swnwar|compfn|rtimes|rthree|rsquor|rsaquo|zacute|wedgeq|homtht|barvee|barwed|Barwed|rpargt|horbar|conint|swarhk|roplus|nltrie|hslash|hstrok|Hstrok|rmoust|Conint|bprime|hybull|hyphen|iacute|Iacute|supsup|supsub|supsim|varphi|coprod|brvbar|agrave|Supset|supset|igrave|Igrave|notinE|Agrave|iiiint|iinfin|copysr|wedbar|Verbar|vangrt|becaus|incare|verbar|inodot|bullet|drcorn|intcal|drcrop|cularr|vellip|Utilde|bumpeq|cupcap|dstrok|Dstrok|CupCap|cupcup|cupdot|eacute|Eacute|supdot|iquest|easter|ecaron|Ecaron|ecolon|isinsv|utilde|itilde|Itilde|curarr|succeq|Bumpeq|cacute|ulcrop|nparsl|Cacute|nprcue|egrave|Egrave|nrarrc|nrarrw|subsup|subsub|nrtrie|jsercy|nsccue|Jsercy|kappav|kcedil|Kcedil|subsim|ulcorn|nsimeq|egsdot|veebar|kgreen|capand|elsdot|Subset|subset|curren|aacute|lacute|Lacute|emptyv|ntilde|Ntilde|lagran|lambda|Lambda|capcap|Ugrave|langle|subdot|emsp13|numero|emsp14|nvdash|nvDash|nVdash|nVDash|ugrave|ufisht|nvHarr|larrfs|nvlArr|larrhk|larrlp|larrpl|nvrArr|Udblac|nwarhk|larrtl|nwnear|oacute|Oacute|latail|lAtail|sstarf|lbrace|odblac|Odblac|lbrack|udblac|odsold|eparsl|lcaron|Lcaron|ograve|Ograve|lcedil|Lcedil|Aacute|ssmile|ssetmn|squarf|ldquor|capcup|ominus|cylcty|rharul|eqcirc|dagger|rfloor|rfisht|Dagger|daleth|equals|origof|capdot|equest|dcaron|Dcaron|rdquor|oslash|Oslash|otilde|Otilde|otimes|Otimes|urcrop|Ubreve|ubreve|Yacute|Uacute|uacute|Rcedil|rcedil|urcorn|parsim|Rcaron|Vdashl|rcaron|Tstrok|percnt|period|permil|Exists|yacute|rbrack|rbrace|phmmat|ccaron|Ccaron|planck|ccedil|plankv|tstrok|female|plusdo|plusdu|ffilig|plusmn|ffllig|Ccedil|rAtail|dfisht|bernou|ratail|Rarrtl|rarrtl|angsph|rarrpl|rarrlp|rarrhk|xwedge|xotime|forall|ForAll|Vvdash|vsupnE|preceq|bigcap|frac12|frac13|frac14|primes|rarrfs|prnsim|frac15|Square|frac16|square|lesdot|frac18|frac23|propto|prurel|rarrap|rangle|puncsp|frac25|Racute|qprime|racute|lesges|frac34|abreve|AElig|eqsim|utdot|setmn|urtri|Equal|Uring|seArr|uring|searr|dashv|Dashv|mumap|nabla|iogon|Iogon|sdote|sdotb|scsim|napid|napos|equiv|natur|Acirc|dblac|erarr|nbump|iprod|erDot|ucirc|awint|esdot|angrt|ncong|isinE|scnap|Scirc|scirc|ndash|isins|Ubrcy|nearr|neArr|isinv|nedot|ubrcy|acute|Ycirc|iukcy|Iukcy|xutri|nesim|caret|jcirc|Jcirc|caron|twixt|ddarr|sccue|exist|jmath|sbquo|ngeqq|angst|ccaps|lceil|ngsim|UpTee|delta|Delta|rtrif|nharr|nhArr|nhpar|rtrie|jukcy|Jukcy|kappa|rsquo|Kappa|nlarr|nlArr|TSHcy|rrarr|aogon|Aogon|fflig|xrarr|tshcy|ccirc|nleqq|filig|upsih|nless|dharl|nlsim|fjlig|ropar|nltri|dharr|robrk|roarr|fllig|fltns|roang|rnmid|subnE|subne|lAarr|trisb|Ccirc|acirc|ccups|blank|VDash|forkv|Vdash|langd|cedil|blk12|blk14|laquo|strns|diams|notin|vDash|larrb|blk34|block|disin|uplus|vdash|vBarv|aelig|starf|Wedge|check|xrArr|lates|lbarr|lBarr|notni|lbbrk|bcong|frasl|lbrke|frown|vrtri|vprop|vnsup|gamma|Gamma|wedge|xodot|bdquo|srarr|doteq|ldquo|boxdl|boxdL|gcirc|Gcirc|boxDl|boxDL|boxdr|boxdR|boxDr|TRADE|trade|rlhar|boxDR|vnsub|npart|vltri|rlarr|boxhd|boxhD|nprec|gescc|nrarr|nrArr|boxHd|boxHD|boxhu|boxhU|nrtri|boxHu|clubs|boxHU|times|colon|Colon|gimel|xlArr|Tilde|nsime|tilde|nsmid|nspar|THORN|thorn|xlarr|nsube|nsubE|thkap|xhArr|comma|nsucc|boxul|boxuL|nsupe|nsupE|gneqq|gnsim|boxUl|boxUL|grave|boxur|boxuR|boxUr|boxUR|lescc|angle|bepsi|boxvh|varpi|boxvH|numsp|Theta|gsime|gsiml|theta|boxVh|boxVH|boxvl|gtcir|gtdot|boxvL|boxVl|boxVL|crarr|cross|Cross|nvsim|boxvr|nwarr|nwArr|sqsup|dtdot|Uogon|lhard|lharu|dtrif|ocirc|Ocirc|lhblk|duarr|odash|sqsub|Hacek|sqcup|llarr|duhar|oelig|OElig|ofcir|boxvR|uogon|lltri|boxVr|csube|uuarr|ohbar|csupe|ctdot|olarr|olcir|harrw|oline|sqcap|omacr|Omacr|omega|Omega|boxVR|aleph|lneqq|lnsim|loang|loarr|rharu|lobrk|hcirc|operp|oplus|rhard|Hcirc|orarr|Union|order|ecirc|Ecirc|cuepr|szlig|cuesc|breve|reals|eDDot|Breve|hoarr|lopar|utrif|rdquo|Umacr|umacr|efDot|swArr|ultri|alpha|rceil|ovbar|swarr|Wcirc|wcirc|smtes|smile|bsemi|lrarr|aring|parsl|lrhar|bsime|uhblk|lrtri|cupor|Aring|uharr|uharl|slarr|rbrke|bsolb|lsime|rbbrk|RBarr|lsimg|phone|rBarr|rbarr|icirc|lsquo|Icirc|emacr|Emacr|ratio|simne|plusb|simlE|simgE|simeq|pluse|ltcir|ltdot|empty|xharr|xdtri|iexcl|Alpha|ltrie|rarrw|pound|ltrif|xcirc|bumpe|prcue|bumpE|asymp|amacr|cuvee|Sigma|sigma|iiint|udhar|iiota|ijlig|IJlig|supnE|imacr|Imacr|prime|Prime|image|prnap|eogon|Eogon|rarrc|mdash|mDDot|cuwed|imath|supne|imped|Amacr|udarr|prsim|micro|rarrb|cwint|raquo|infin|eplus|range|rangd|Ucirc|radic|minus|amalg|veeeq|rAarr|epsiv|ycirc|quest|sharp|quot|zwnj|Qscr|race|qscr|Qopf|qopf|qint|rang|Rang|Zscr|zscr|Zopf|zopf|rarr|rArr|Rarr|Pscr|pscr|prop|prod|prnE|prec|ZHcy|zhcy|prap|Zeta|zeta|Popf|popf|Zdot|plus|zdot|Yuml|yuml|phiv|YUcy|yucy|Yscr|yscr|perp|Yopf|yopf|part|para|YIcy|Ouml|rcub|yicy|YAcy|rdca|ouml|osol|Oscr|rdsh|yacy|real|oscr|xvee|andd|rect|andv|Xscr|oror|ordm|ordf|xscr|ange|aopf|Aopf|rHar|Xopf|opar|Oopf|xopf|xnis|rhov|oopf|omid|xmap|oint|apid|apos|ogon|ascr|Ascr|odot|odiv|xcup|xcap|ocir|oast|nvlt|nvle|nvgt|nvge|nvap|Wscr|wscr|auml|ntlg|ntgl|nsup|nsub|nsim|Nscr|nscr|nsce|Wopf|ring|npre|wopf|npar|Auml|Barv|bbrk|Nopf|nopf|nmid|nLtv|beta|ropf|Ropf|Beta|beth|nles|rpar|nleq|bnot|bNot|nldr|NJcy|rscr|Rscr|Vscr|vscr|rsqb|njcy|bopf|nisd|Bopf|rtri|Vopf|nGtv|ngtr|vopf|boxh|boxH|boxv|nges|ngeq|boxV|bscr|scap|Bscr|bsim|Vert|vert|bsol|bull|bump|caps|cdot|ncup|scnE|ncap|nbsp|napE|Cdot|cent|sdot|Vbar|nang|vBar|chcy|Mscr|mscr|sect|semi|CHcy|Mopf|mopf|sext|circ|cire|mldr|mlcp|cirE|comp|shcy|SHcy|vArr|varr|cong|copf|Copf|copy|COPY|malt|male|macr|lvnE|cscr|ltri|sime|ltcc|simg|Cscr|siml|csub|Uuml|lsqb|lsim|uuml|csup|Lscr|lscr|utri|smid|lpar|cups|smte|lozf|darr|Lopf|Uscr|solb|lopf|sopf|Sopf|lneq|uscr|spar|dArr|lnap|Darr|dash|Sqrt|LJcy|ljcy|lHar|dHar|Upsi|upsi|diam|lesg|djcy|DJcy|leqq|dopf|Dopf|dscr|Dscr|dscy|ldsh|ldca|squf|DScy|sscr|Sscr|dsol|lcub|late|star|Star|Uopf|Larr|lArr|larr|uopf|dtri|dzcy|sube|subE|Lang|lang|Kscr|kscr|Kopf|kopf|KJcy|kjcy|KHcy|khcy|DZcy|ecir|edot|eDot|Jscr|jscr|succ|Jopf|jopf|Edot|uHar|emsp|ensp|Iuml|iuml|eopf|isin|Iscr|iscr|Eopf|epar|sung|epsi|escr|sup1|sup2|sup3|Iota|iota|supe|supE|Iopf|iopf|IOcy|iocy|Escr|esim|Esim|imof|Uarr|QUOT|uArr|uarr|euml|IEcy|iecy|Idot|Euml|euro|excl|Hscr|hscr|Hopf|hopf|TScy|tscy|Tscr|hbar|tscr|flat|tbrk|fnof|hArr|harr|half|fopf|Fopf|tdot|gvnE|fork|trie|gtcc|fscr|Fscr|gdot|gsim|Gscr|gscr|Gopf|gopf|gneq|Gdot|tosa|gnap|Topf|topf|geqq|toea|GJcy|gjcy|tint|gesl|mid|Sfr|ggg|top|ges|gla|glE|glj|geq|gne|gEl|gel|gnE|Gcy|gcy|gap|Tfr|tfr|Tcy|tcy|Hat|Tau|Ffr|tau|Tab|hfr|Hfr|ffr|Fcy|fcy|icy|Icy|iff|ETH|eth|ifr|Ifr|Eta|eta|int|Int|Sup|sup|ucy|Ucy|Sum|sum|jcy|ENG|ufr|Ufr|eng|Jcy|jfr|els|ell|egs|Efr|efr|Jfr|uml|kcy|Kcy|Ecy|ecy|kfr|Kfr|lap|Sub|sub|lat|lcy|Lcy|leg|Dot|dot|lEg|leq|les|squ|div|die|lfr|Lfr|lgE|Dfr|dfr|Del|deg|Dcy|dcy|lne|lnE|sol|loz|smt|Cup|lrm|cup|lsh|Lsh|sim|shy|map|Map|mcy|Mcy|mfr|Mfr|mho|gfr|Gfr|sfr|cir|Chi|chi|nap|Cfr|vcy|Vcy|cfr|Scy|scy|ncy|Ncy|vee|Vee|Cap|cap|nfr|scE|sce|Nfr|nge|ngE|nGg|vfr|Vfr|ngt|bot|nGt|nis|niv|Rsh|rsh|nle|nlE|bne|Bfr|bfr|nLl|nlt|nLt|Bcy|bcy|not|Not|rlm|wfr|Wfr|npr|nsc|num|ocy|ast|Ocy|ofr|xfr|Xfr|Ofr|ogt|ohm|apE|olt|Rho|ape|rho|Rfr|rfr|ord|REG|ang|reg|orv|And|and|AMP|Rcy|amp|Afr|ycy|Ycy|yen|yfr|Yfr|rcy|par|pcy|Pcy|pfr|Pfr|phi|Phi|afr|Acy|acy|zcy|Zcy|piv|acE|acd|zfr|Zfr|pre|prE|psi|Psi|qfr|Qfr|zwj|Or|ge|Gg|gt|gg|el|oS|lt|Lt|LT|Re|lg|gl|eg|ne|Im|it|le|DD|wp|wr|nu|Nu|dd|lE|Sc|sc|pi|Pi|ee|af|ll|Ll|rx|gE|xi|pm|Xi|ic|pr|Pr|in|ni|mp|mu|ac|Mu|or|ap|Gt|GT|ii);|&(Aacute|Agrave|Atilde|Ccedil|Eacute|Egrave|Iacute|Igrave|Ntilde|Oacute|Ograve|Oslash|Otilde|Uacute|Ugrave|Yacute|aacute|agrave|atilde|brvbar|ccedil|curren|divide|eacute|egrave|frac12|frac14|frac34|iacute|igrave|iquest|middot|ntilde|oacute|ograve|oslash|otilde|plusmn|uacute|ugrave|yacute|AElig|Acirc|Aring|Ecirc|Icirc|Ocirc|THORN|Ucirc|acirc|acute|aelig|aring|cedil|ecirc|icirc|iexcl|laquo|micro|ocirc|pound|raquo|szlig|thorn|times|ucirc|Auml|COPY|Euml|Iuml|Ouml|QUOT|Uuml|auml|cent|copy|euml|iuml|macr|nbsp|ordf|ordm|ouml|para|quot|sect|sup1|sup2|sup3|uuml|yuml|AMP|ETH|REG|amp|deg|eth|not|reg|shy|uml|yen|GT|LT|gt|lt)(?!;)([=a-zA-Z0-9]?)|&#([0-9]+)(;?)|&#[xX]([a-fA-F0-9]+)(;?)|&([0-9a-zA-Z]+)/g;
		var decodeMap = {'aacute':'\xE1','Aacute':'\xC1','abreve':'\u0103','Abreve':'\u0102','ac':'\u223E','acd':'\u223F','acE':'\u223E\u0333','acirc':'\xE2','Acirc':'\xC2','acute':'\xB4','acy':'\u0430','Acy':'\u0410','aelig':'\xE6','AElig':'\xC6','af':'\u2061','afr':'\uD835\uDD1E','Afr':'\uD835\uDD04','agrave':'\xE0','Agrave':'\xC0','alefsym':'\u2135','aleph':'\u2135','alpha':'\u03B1','Alpha':'\u0391','amacr':'\u0101','Amacr':'\u0100','amalg':'\u2A3F','amp':'&','AMP':'&','and':'\u2227','And':'\u2A53','andand':'\u2A55','andd':'\u2A5C','andslope':'\u2A58','andv':'\u2A5A','ang':'\u2220','ange':'\u29A4','angle':'\u2220','angmsd':'\u2221','angmsdaa':'\u29A8','angmsdab':'\u29A9','angmsdac':'\u29AA','angmsdad':'\u29AB','angmsdae':'\u29AC','angmsdaf':'\u29AD','angmsdag':'\u29AE','angmsdah':'\u29AF','angrt':'\u221F','angrtvb':'\u22BE','angrtvbd':'\u299D','angsph':'\u2222','angst':'\xC5','angzarr':'\u237C','aogon':'\u0105','Aogon':'\u0104','aopf':'\uD835\uDD52','Aopf':'\uD835\uDD38','ap':'\u2248','apacir':'\u2A6F','ape':'\u224A','apE':'\u2A70','apid':'\u224B','apos':'\'','ApplyFunction':'\u2061','approx':'\u2248','approxeq':'\u224A','aring':'\xE5','Aring':'\xC5','ascr':'\uD835\uDCB6','Ascr':'\uD835\uDC9C','Assign':'\u2254','ast':'*','asymp':'\u2248','asympeq':'\u224D','atilde':'\xE3','Atilde':'\xC3','auml':'\xE4','Auml':'\xC4','awconint':'\u2233','awint':'\u2A11','backcong':'\u224C','backepsilon':'\u03F6','backprime':'\u2035','backsim':'\u223D','backsimeq':'\u22CD','Backslash':'\u2216','Barv':'\u2AE7','barvee':'\u22BD','barwed':'\u2305','Barwed':'\u2306','barwedge':'\u2305','bbrk':'\u23B5','bbrktbrk':'\u23B6','bcong':'\u224C','bcy':'\u0431','Bcy':'\u0411','bdquo':'\u201E','becaus':'\u2235','because':'\u2235','Because':'\u2235','bemptyv':'\u29B0','bepsi':'\u03F6','bernou':'\u212C','Bernoullis':'\u212C','beta':'\u03B2','Beta':'\u0392','beth':'\u2136','between':'\u226C','bfr':'\uD835\uDD1F','Bfr':'\uD835\uDD05','bigcap':'\u22C2','bigcirc':'\u25EF','bigcup':'\u22C3','bigodot':'\u2A00','bigoplus':'\u2A01','bigotimes':'\u2A02','bigsqcup':'\u2A06','bigstar':'\u2605','bigtriangledown':'\u25BD','bigtriangleup':'\u25B3','biguplus':'\u2A04','bigvee':'\u22C1','bigwedge':'\u22C0','bkarow':'\u290D','blacklozenge':'\u29EB','blacksquare':'\u25AA','blacktriangle':'\u25B4','blacktriangledown':'\u25BE','blacktriangleleft':'\u25C2','blacktriangleright':'\u25B8','blank':'\u2423','blk12':'\u2592','blk14':'\u2591','blk34':'\u2593','block':'\u2588','bne':'=\u20E5','bnequiv':'\u2261\u20E5','bnot':'\u2310','bNot':'\u2AED','bopf':'\uD835\uDD53','Bopf':'\uD835\uDD39','bot':'\u22A5','bottom':'\u22A5','bowtie':'\u22C8','boxbox':'\u29C9','boxdl':'\u2510','boxdL':'\u2555','boxDl':'\u2556','boxDL':'\u2557','boxdr':'\u250C','boxdR':'\u2552','boxDr':'\u2553','boxDR':'\u2554','boxh':'\u2500','boxH':'\u2550','boxhd':'\u252C','boxhD':'\u2565','boxHd':'\u2564','boxHD':'\u2566','boxhu':'\u2534','boxhU':'\u2568','boxHu':'\u2567','boxHU':'\u2569','boxminus':'\u229F','boxplus':'\u229E','boxtimes':'\u22A0','boxul':'\u2518','boxuL':'\u255B','boxUl':'\u255C','boxUL':'\u255D','boxur':'\u2514','boxuR':'\u2558','boxUr':'\u2559','boxUR':'\u255A','boxv':'\u2502','boxV':'\u2551','boxvh':'\u253C','boxvH':'\u256A','boxVh':'\u256B','boxVH':'\u256C','boxvl':'\u2524','boxvL':'\u2561','boxVl':'\u2562','boxVL':'\u2563','boxvr':'\u251C','boxvR':'\u255E','boxVr':'\u255F','boxVR':'\u2560','bprime':'\u2035','breve':'\u02D8','Breve':'\u02D8','brvbar':'\xA6','bscr':'\uD835\uDCB7','Bscr':'\u212C','bsemi':'\u204F','bsim':'\u223D','bsime':'\u22CD','bsol':'\\','bsolb':'\u29C5','bsolhsub':'\u27C8','bull':'\u2022','bullet':'\u2022','bump':'\u224E','bumpe':'\u224F','bumpE':'\u2AAE','bumpeq':'\u224F','Bumpeq':'\u224E','cacute':'\u0107','Cacute':'\u0106','cap':'\u2229','Cap':'\u22D2','capand':'\u2A44','capbrcup':'\u2A49','capcap':'\u2A4B','capcup':'\u2A47','capdot':'\u2A40','CapitalDifferentialD':'\u2145','caps':'\u2229\uFE00','caret':'\u2041','caron':'\u02C7','Cayleys':'\u212D','ccaps':'\u2A4D','ccaron':'\u010D','Ccaron':'\u010C','ccedil':'\xE7','Ccedil':'\xC7','ccirc':'\u0109','Ccirc':'\u0108','Cconint':'\u2230','ccups':'\u2A4C','ccupssm':'\u2A50','cdot':'\u010B','Cdot':'\u010A','cedil':'\xB8','Cedilla':'\xB8','cemptyv':'\u29B2','cent':'\xA2','centerdot':'\xB7','CenterDot':'\xB7','cfr':'\uD835\uDD20','Cfr':'\u212D','chcy':'\u0447','CHcy':'\u0427','check':'\u2713','checkmark':'\u2713','chi':'\u03C7','Chi':'\u03A7','cir':'\u25CB','circ':'\u02C6','circeq':'\u2257','circlearrowleft':'\u21BA','circlearrowright':'\u21BB','circledast':'\u229B','circledcirc':'\u229A','circleddash':'\u229D','CircleDot':'\u2299','circledR':'\xAE','circledS':'\u24C8','CircleMinus':'\u2296','CirclePlus':'\u2295','CircleTimes':'\u2297','cire':'\u2257','cirE':'\u29C3','cirfnint':'\u2A10','cirmid':'\u2AEF','cirscir':'\u29C2','ClockwiseContourIntegral':'\u2232','CloseCurlyDoubleQuote':'\u201D','CloseCurlyQuote':'\u2019','clubs':'\u2663','clubsuit':'\u2663','colon':':','Colon':'\u2237','colone':'\u2254','Colone':'\u2A74','coloneq':'\u2254','comma':',','commat':'@','comp':'\u2201','compfn':'\u2218','complement':'\u2201','complexes':'\u2102','cong':'\u2245','congdot':'\u2A6D','Congruent':'\u2261','conint':'\u222E','Conint':'\u222F','ContourIntegral':'\u222E','copf':'\uD835\uDD54','Copf':'\u2102','coprod':'\u2210','Coproduct':'\u2210','copy':'\xA9','COPY':'\xA9','copysr':'\u2117','CounterClockwiseContourIntegral':'\u2233','crarr':'\u21B5','cross':'\u2717','Cross':'\u2A2F','cscr':'\uD835\uDCB8','Cscr':'\uD835\uDC9E','csub':'\u2ACF','csube':'\u2AD1','csup':'\u2AD0','csupe':'\u2AD2','ctdot':'\u22EF','cudarrl':'\u2938','cudarrr':'\u2935','cuepr':'\u22DE','cuesc':'\u22DF','cularr':'\u21B6','cularrp':'\u293D','cup':'\u222A','Cup':'\u22D3','cupbrcap':'\u2A48','cupcap':'\u2A46','CupCap':'\u224D','cupcup':'\u2A4A','cupdot':'\u228D','cupor':'\u2A45','cups':'\u222A\uFE00','curarr':'\u21B7','curarrm':'\u293C','curlyeqprec':'\u22DE','curlyeqsucc':'\u22DF','curlyvee':'\u22CE','curlywedge':'\u22CF','curren':'\xA4','curvearrowleft':'\u21B6','curvearrowright':'\u21B7','cuvee':'\u22CE','cuwed':'\u22CF','cwconint':'\u2232','cwint':'\u2231','cylcty':'\u232D','dagger':'\u2020','Dagger':'\u2021','daleth':'\u2138','darr':'\u2193','dArr':'\u21D3','Darr':'\u21A1','dash':'\u2010','dashv':'\u22A3','Dashv':'\u2AE4','dbkarow':'\u290F','dblac':'\u02DD','dcaron':'\u010F','Dcaron':'\u010E','dcy':'\u0434','Dcy':'\u0414','dd':'\u2146','DD':'\u2145','ddagger':'\u2021','ddarr':'\u21CA','DDotrahd':'\u2911','ddotseq':'\u2A77','deg':'\xB0','Del':'\u2207','delta':'\u03B4','Delta':'\u0394','demptyv':'\u29B1','dfisht':'\u297F','dfr':'\uD835\uDD21','Dfr':'\uD835\uDD07','dHar':'\u2965','dharl':'\u21C3','dharr':'\u21C2','DiacriticalAcute':'\xB4','DiacriticalDot':'\u02D9','DiacriticalDoubleAcute':'\u02DD','DiacriticalGrave':'`','DiacriticalTilde':'\u02DC','diam':'\u22C4','diamond':'\u22C4','Diamond':'\u22C4','diamondsuit':'\u2666','diams':'\u2666','die':'\xA8','DifferentialD':'\u2146','digamma':'\u03DD','disin':'\u22F2','div':'\xF7','divide':'\xF7','divideontimes':'\u22C7','divonx':'\u22C7','djcy':'\u0452','DJcy':'\u0402','dlcorn':'\u231E','dlcrop':'\u230D','dollar':'$','dopf':'\uD835\uDD55','Dopf':'\uD835\uDD3B','dot':'\u02D9','Dot':'\xA8','DotDot':'\u20DC','doteq':'\u2250','doteqdot':'\u2251','DotEqual':'\u2250','dotminus':'\u2238','dotplus':'\u2214','dotsquare':'\u22A1','doublebarwedge':'\u2306','DoubleContourIntegral':'\u222F','DoubleDot':'\xA8','DoubleDownArrow':'\u21D3','DoubleLeftArrow':'\u21D0','DoubleLeftRightArrow':'\u21D4','DoubleLeftTee':'\u2AE4','DoubleLongLeftArrow':'\u27F8','DoubleLongLeftRightArrow':'\u27FA','DoubleLongRightArrow':'\u27F9','DoubleRightArrow':'\u21D2','DoubleRightTee':'\u22A8','DoubleUpArrow':'\u21D1','DoubleUpDownArrow':'\u21D5','DoubleVerticalBar':'\u2225','downarrow':'\u2193','Downarrow':'\u21D3','DownArrow':'\u2193','DownArrowBar':'\u2913','DownArrowUpArrow':'\u21F5','DownBreve':'\u0311','downdownarrows':'\u21CA','downharpoonleft':'\u21C3','downharpoonright':'\u21C2','DownLeftRightVector':'\u2950','DownLeftTeeVector':'\u295E','DownLeftVector':'\u21BD','DownLeftVectorBar':'\u2956','DownRightTeeVector':'\u295F','DownRightVector':'\u21C1','DownRightVectorBar':'\u2957','DownTee':'\u22A4','DownTeeArrow':'\u21A7','drbkarow':'\u2910','drcorn':'\u231F','drcrop':'\u230C','dscr':'\uD835\uDCB9','Dscr':'\uD835\uDC9F','dscy':'\u0455','DScy':'\u0405','dsol':'\u29F6','dstrok':'\u0111','Dstrok':'\u0110','dtdot':'\u22F1','dtri':'\u25BF','dtrif':'\u25BE','duarr':'\u21F5','duhar':'\u296F','dwangle':'\u29A6','dzcy':'\u045F','DZcy':'\u040F','dzigrarr':'\u27FF','eacute':'\xE9','Eacute':'\xC9','easter':'\u2A6E','ecaron':'\u011B','Ecaron':'\u011A','ecir':'\u2256','ecirc':'\xEA','Ecirc':'\xCA','ecolon':'\u2255','ecy':'\u044D','Ecy':'\u042D','eDDot':'\u2A77','edot':'\u0117','eDot':'\u2251','Edot':'\u0116','ee':'\u2147','efDot':'\u2252','efr':'\uD835\uDD22','Efr':'\uD835\uDD08','eg':'\u2A9A','egrave':'\xE8','Egrave':'\xC8','egs':'\u2A96','egsdot':'\u2A98','el':'\u2A99','Element':'\u2208','elinters':'\u23E7','ell':'\u2113','els':'\u2A95','elsdot':'\u2A97','emacr':'\u0113','Emacr':'\u0112','empty':'\u2205','emptyset':'\u2205','EmptySmallSquare':'\u25FB','emptyv':'\u2205','EmptyVerySmallSquare':'\u25AB','emsp':'\u2003','emsp13':'\u2004','emsp14':'\u2005','eng':'\u014B','ENG':'\u014A','ensp':'\u2002','eogon':'\u0119','Eogon':'\u0118','eopf':'\uD835\uDD56','Eopf':'\uD835\uDD3C','epar':'\u22D5','eparsl':'\u29E3','eplus':'\u2A71','epsi':'\u03B5','epsilon':'\u03B5','Epsilon':'\u0395','epsiv':'\u03F5','eqcirc':'\u2256','eqcolon':'\u2255','eqsim':'\u2242','eqslantgtr':'\u2A96','eqslantless':'\u2A95','Equal':'\u2A75','equals':'=','EqualTilde':'\u2242','equest':'\u225F','Equilibrium':'\u21CC','equiv':'\u2261','equivDD':'\u2A78','eqvparsl':'\u29E5','erarr':'\u2971','erDot':'\u2253','escr':'\u212F','Escr':'\u2130','esdot':'\u2250','esim':'\u2242','Esim':'\u2A73','eta':'\u03B7','Eta':'\u0397','eth':'\xF0','ETH':'\xD0','euml':'\xEB','Euml':'\xCB','euro':'\u20AC','excl':'!','exist':'\u2203','Exists':'\u2203','expectation':'\u2130','exponentiale':'\u2147','ExponentialE':'\u2147','fallingdotseq':'\u2252','fcy':'\u0444','Fcy':'\u0424','female':'\u2640','ffilig':'\uFB03','fflig':'\uFB00','ffllig':'\uFB04','ffr':'\uD835\uDD23','Ffr':'\uD835\uDD09','filig':'\uFB01','FilledSmallSquare':'\u25FC','FilledVerySmallSquare':'\u25AA','fjlig':'fj','flat':'\u266D','fllig':'\uFB02','fltns':'\u25B1','fnof':'\u0192','fopf':'\uD835\uDD57','Fopf':'\uD835\uDD3D','forall':'\u2200','ForAll':'\u2200','fork':'\u22D4','forkv':'\u2AD9','Fouriertrf':'\u2131','fpartint':'\u2A0D','frac12':'\xBD','frac13':'\u2153','frac14':'\xBC','frac15':'\u2155','frac16':'\u2159','frac18':'\u215B','frac23':'\u2154','frac25':'\u2156','frac34':'\xBE','frac35':'\u2157','frac38':'\u215C','frac45':'\u2158','frac56':'\u215A','frac58':'\u215D','frac78':'\u215E','frasl':'\u2044','frown':'\u2322','fscr':'\uD835\uDCBB','Fscr':'\u2131','gacute':'\u01F5','gamma':'\u03B3','Gamma':'\u0393','gammad':'\u03DD','Gammad':'\u03DC','gap':'\u2A86','gbreve':'\u011F','Gbreve':'\u011E','Gcedil':'\u0122','gcirc':'\u011D','Gcirc':'\u011C','gcy':'\u0433','Gcy':'\u0413','gdot':'\u0121','Gdot':'\u0120','ge':'\u2265','gE':'\u2267','gel':'\u22DB','gEl':'\u2A8C','geq':'\u2265','geqq':'\u2267','geqslant':'\u2A7E','ges':'\u2A7E','gescc':'\u2AA9','gesdot':'\u2A80','gesdoto':'\u2A82','gesdotol':'\u2A84','gesl':'\u22DB\uFE00','gesles':'\u2A94','gfr':'\uD835\uDD24','Gfr':'\uD835\uDD0A','gg':'\u226B','Gg':'\u22D9','ggg':'\u22D9','gimel':'\u2137','gjcy':'\u0453','GJcy':'\u0403','gl':'\u2277','gla':'\u2AA5','glE':'\u2A92','glj':'\u2AA4','gnap':'\u2A8A','gnapprox':'\u2A8A','gne':'\u2A88','gnE':'\u2269','gneq':'\u2A88','gneqq':'\u2269','gnsim':'\u22E7','gopf':'\uD835\uDD58','Gopf':'\uD835\uDD3E','grave':'`','GreaterEqual':'\u2265','GreaterEqualLess':'\u22DB','GreaterFullEqual':'\u2267','GreaterGreater':'\u2AA2','GreaterLess':'\u2277','GreaterSlantEqual':'\u2A7E','GreaterTilde':'\u2273','gscr':'\u210A','Gscr':'\uD835\uDCA2','gsim':'\u2273','gsime':'\u2A8E','gsiml':'\u2A90','gt':'>','Gt':'\u226B','GT':'>','gtcc':'\u2AA7','gtcir':'\u2A7A','gtdot':'\u22D7','gtlPar':'\u2995','gtquest':'\u2A7C','gtrapprox':'\u2A86','gtrarr':'\u2978','gtrdot':'\u22D7','gtreqless':'\u22DB','gtreqqless':'\u2A8C','gtrless':'\u2277','gtrsim':'\u2273','gvertneqq':'\u2269\uFE00','gvnE':'\u2269\uFE00','Hacek':'\u02C7','hairsp':'\u200A','half':'\xBD','hamilt':'\u210B','hardcy':'\u044A','HARDcy':'\u042A','harr':'\u2194','hArr':'\u21D4','harrcir':'\u2948','harrw':'\u21AD','Hat':'^','hbar':'\u210F','hcirc':'\u0125','Hcirc':'\u0124','hearts':'\u2665','heartsuit':'\u2665','hellip':'\u2026','hercon':'\u22B9','hfr':'\uD835\uDD25','Hfr':'\u210C','HilbertSpace':'\u210B','hksearow':'\u2925','hkswarow':'\u2926','hoarr':'\u21FF','homtht':'\u223B','hookleftarrow':'\u21A9','hookrightarrow':'\u21AA','hopf':'\uD835\uDD59','Hopf':'\u210D','horbar':'\u2015','HorizontalLine':'\u2500','hscr':'\uD835\uDCBD','Hscr':'\u210B','hslash':'\u210F','hstrok':'\u0127','Hstrok':'\u0126','HumpDownHump':'\u224E','HumpEqual':'\u224F','hybull':'\u2043','hyphen':'\u2010','iacute':'\xED','Iacute':'\xCD','ic':'\u2063','icirc':'\xEE','Icirc':'\xCE','icy':'\u0438','Icy':'\u0418','Idot':'\u0130','iecy':'\u0435','IEcy':'\u0415','iexcl':'\xA1','iff':'\u21D4','ifr':'\uD835\uDD26','Ifr':'\u2111','igrave':'\xEC','Igrave':'\xCC','ii':'\u2148','iiiint':'\u2A0C','iiint':'\u222D','iinfin':'\u29DC','iiota':'\u2129','ijlig':'\u0133','IJlig':'\u0132','Im':'\u2111','imacr':'\u012B','Imacr':'\u012A','image':'\u2111','ImaginaryI':'\u2148','imagline':'\u2110','imagpart':'\u2111','imath':'\u0131','imof':'\u22B7','imped':'\u01B5','Implies':'\u21D2','in':'\u2208','incare':'\u2105','infin':'\u221E','infintie':'\u29DD','inodot':'\u0131','int':'\u222B','Int':'\u222C','intcal':'\u22BA','integers':'\u2124','Integral':'\u222B','intercal':'\u22BA','Intersection':'\u22C2','intlarhk':'\u2A17','intprod':'\u2A3C','InvisibleComma':'\u2063','InvisibleTimes':'\u2062','iocy':'\u0451','IOcy':'\u0401','iogon':'\u012F','Iogon':'\u012E','iopf':'\uD835\uDD5A','Iopf':'\uD835\uDD40','iota':'\u03B9','Iota':'\u0399','iprod':'\u2A3C','iquest':'\xBF','iscr':'\uD835\uDCBE','Iscr':'\u2110','isin':'\u2208','isindot':'\u22F5','isinE':'\u22F9','isins':'\u22F4','isinsv':'\u22F3','isinv':'\u2208','it':'\u2062','itilde':'\u0129','Itilde':'\u0128','iukcy':'\u0456','Iukcy':'\u0406','iuml':'\xEF','Iuml':'\xCF','jcirc':'\u0135','Jcirc':'\u0134','jcy':'\u0439','Jcy':'\u0419','jfr':'\uD835\uDD27','Jfr':'\uD835\uDD0D','jmath':'\u0237','jopf':'\uD835\uDD5B','Jopf':'\uD835\uDD41','jscr':'\uD835\uDCBF','Jscr':'\uD835\uDCA5','jsercy':'\u0458','Jsercy':'\u0408','jukcy':'\u0454','Jukcy':'\u0404','kappa':'\u03BA','Kappa':'\u039A','kappav':'\u03F0','kcedil':'\u0137','Kcedil':'\u0136','kcy':'\u043A','Kcy':'\u041A','kfr':'\uD835\uDD28','Kfr':'\uD835\uDD0E','kgreen':'\u0138','khcy':'\u0445','KHcy':'\u0425','kjcy':'\u045C','KJcy':'\u040C','kopf':'\uD835\uDD5C','Kopf':'\uD835\uDD42','kscr':'\uD835\uDCC0','Kscr':'\uD835\uDCA6','lAarr':'\u21DA','lacute':'\u013A','Lacute':'\u0139','laemptyv':'\u29B4','lagran':'\u2112','lambda':'\u03BB','Lambda':'\u039B','lang':'\u27E8','Lang':'\u27EA','langd':'\u2991','langle':'\u27E8','lap':'\u2A85','Laplacetrf':'\u2112','laquo':'\xAB','larr':'\u2190','lArr':'\u21D0','Larr':'\u219E','larrb':'\u21E4','larrbfs':'\u291F','larrfs':'\u291D','larrhk':'\u21A9','larrlp':'\u21AB','larrpl':'\u2939','larrsim':'\u2973','larrtl':'\u21A2','lat':'\u2AAB','latail':'\u2919','lAtail':'\u291B','late':'\u2AAD','lates':'\u2AAD\uFE00','lbarr':'\u290C','lBarr':'\u290E','lbbrk':'\u2772','lbrace':'{','lbrack':'[','lbrke':'\u298B','lbrksld':'\u298F','lbrkslu':'\u298D','lcaron':'\u013E','Lcaron':'\u013D','lcedil':'\u013C','Lcedil':'\u013B','lceil':'\u2308','lcub':'{','lcy':'\u043B','Lcy':'\u041B','ldca':'\u2936','ldquo':'\u201C','ldquor':'\u201E','ldrdhar':'\u2967','ldrushar':'\u294B','ldsh':'\u21B2','le':'\u2264','lE':'\u2266','LeftAngleBracket':'\u27E8','leftarrow':'\u2190','Leftarrow':'\u21D0','LeftArrow':'\u2190','LeftArrowBar':'\u21E4','LeftArrowRightArrow':'\u21C6','leftarrowtail':'\u21A2','LeftCeiling':'\u2308','LeftDoubleBracket':'\u27E6','LeftDownTeeVector':'\u2961','LeftDownVector':'\u21C3','LeftDownVectorBar':'\u2959','LeftFloor':'\u230A','leftharpoondown':'\u21BD','leftharpoonup':'\u21BC','leftleftarrows':'\u21C7','leftrightarrow':'\u2194','Leftrightarrow':'\u21D4','LeftRightArrow':'\u2194','leftrightarrows':'\u21C6','leftrightharpoons':'\u21CB','leftrightsquigarrow':'\u21AD','LeftRightVector':'\u294E','LeftTee':'\u22A3','LeftTeeArrow':'\u21A4','LeftTeeVector':'\u295A','leftthreetimes':'\u22CB','LeftTriangle':'\u22B2','LeftTriangleBar':'\u29CF','LeftTriangleEqual':'\u22B4','LeftUpDownVector':'\u2951','LeftUpTeeVector':'\u2960','LeftUpVector':'\u21BF','LeftUpVectorBar':'\u2958','LeftVector':'\u21BC','LeftVectorBar':'\u2952','leg':'\u22DA','lEg':'\u2A8B','leq':'\u2264','leqq':'\u2266','leqslant':'\u2A7D','les':'\u2A7D','lescc':'\u2AA8','lesdot':'\u2A7F','lesdoto':'\u2A81','lesdotor':'\u2A83','lesg':'\u22DA\uFE00','lesges':'\u2A93','lessapprox':'\u2A85','lessdot':'\u22D6','lesseqgtr':'\u22DA','lesseqqgtr':'\u2A8B','LessEqualGreater':'\u22DA','LessFullEqual':'\u2266','LessGreater':'\u2276','lessgtr':'\u2276','LessLess':'\u2AA1','lesssim':'\u2272','LessSlantEqual':'\u2A7D','LessTilde':'\u2272','lfisht':'\u297C','lfloor':'\u230A','lfr':'\uD835\uDD29','Lfr':'\uD835\uDD0F','lg':'\u2276','lgE':'\u2A91','lHar':'\u2962','lhard':'\u21BD','lharu':'\u21BC','lharul':'\u296A','lhblk':'\u2584','ljcy':'\u0459','LJcy':'\u0409','ll':'\u226A','Ll':'\u22D8','llarr':'\u21C7','llcorner':'\u231E','Lleftarrow':'\u21DA','llhard':'\u296B','lltri':'\u25FA','lmidot':'\u0140','Lmidot':'\u013F','lmoust':'\u23B0','lmoustache':'\u23B0','lnap':'\u2A89','lnapprox':'\u2A89','lne':'\u2A87','lnE':'\u2268','lneq':'\u2A87','lneqq':'\u2268','lnsim':'\u22E6','loang':'\u27EC','loarr':'\u21FD','lobrk':'\u27E6','longleftarrow':'\u27F5','Longleftarrow':'\u27F8','LongLeftArrow':'\u27F5','longleftrightarrow':'\u27F7','Longleftrightarrow':'\u27FA','LongLeftRightArrow':'\u27F7','longmapsto':'\u27FC','longrightarrow':'\u27F6','Longrightarrow':'\u27F9','LongRightArrow':'\u27F6','looparrowleft':'\u21AB','looparrowright':'\u21AC','lopar':'\u2985','lopf':'\uD835\uDD5D','Lopf':'\uD835\uDD43','loplus':'\u2A2D','lotimes':'\u2A34','lowast':'\u2217','lowbar':'_','LowerLeftArrow':'\u2199','LowerRightArrow':'\u2198','loz':'\u25CA','lozenge':'\u25CA','lozf':'\u29EB','lpar':'(','lparlt':'\u2993','lrarr':'\u21C6','lrcorner':'\u231F','lrhar':'\u21CB','lrhard':'\u296D','lrm':'\u200E','lrtri':'\u22BF','lsaquo':'\u2039','lscr':'\uD835\uDCC1','Lscr':'\u2112','lsh':'\u21B0','Lsh':'\u21B0','lsim':'\u2272','lsime':'\u2A8D','lsimg':'\u2A8F','lsqb':'[','lsquo':'\u2018','lsquor':'\u201A','lstrok':'\u0142','Lstrok':'\u0141','lt':'<','Lt':'\u226A','LT':'<','ltcc':'\u2AA6','ltcir':'\u2A79','ltdot':'\u22D6','lthree':'\u22CB','ltimes':'\u22C9','ltlarr':'\u2976','ltquest':'\u2A7B','ltri':'\u25C3','ltrie':'\u22B4','ltrif':'\u25C2','ltrPar':'\u2996','lurdshar':'\u294A','luruhar':'\u2966','lvertneqq':'\u2268\uFE00','lvnE':'\u2268\uFE00','macr':'\xAF','male':'\u2642','malt':'\u2720','maltese':'\u2720','map':'\u21A6','Map':'\u2905','mapsto':'\u21A6','mapstodown':'\u21A7','mapstoleft':'\u21A4','mapstoup':'\u21A5','marker':'\u25AE','mcomma':'\u2A29','mcy':'\u043C','Mcy':'\u041C','mdash':'\u2014','mDDot':'\u223A','measuredangle':'\u2221','MediumSpace':'\u205F','Mellintrf':'\u2133','mfr':'\uD835\uDD2A','Mfr':'\uD835\uDD10','mho':'\u2127','micro':'\xB5','mid':'\u2223','midast':'*','midcir':'\u2AF0','middot':'\xB7','minus':'\u2212','minusb':'\u229F','minusd':'\u2238','minusdu':'\u2A2A','MinusPlus':'\u2213','mlcp':'\u2ADB','mldr':'\u2026','mnplus':'\u2213','models':'\u22A7','mopf':'\uD835\uDD5E','Mopf':'\uD835\uDD44','mp':'\u2213','mscr':'\uD835\uDCC2','Mscr':'\u2133','mstpos':'\u223E','mu':'\u03BC','Mu':'\u039C','multimap':'\u22B8','mumap':'\u22B8','nabla':'\u2207','nacute':'\u0144','Nacute':'\u0143','nang':'\u2220\u20D2','nap':'\u2249','napE':'\u2A70\u0338','napid':'\u224B\u0338','napos':'\u0149','napprox':'\u2249','natur':'\u266E','natural':'\u266E','naturals':'\u2115','nbsp':'\xA0','nbump':'\u224E\u0338','nbumpe':'\u224F\u0338','ncap':'\u2A43','ncaron':'\u0148','Ncaron':'\u0147','ncedil':'\u0146','Ncedil':'\u0145','ncong':'\u2247','ncongdot':'\u2A6D\u0338','ncup':'\u2A42','ncy':'\u043D','Ncy':'\u041D','ndash':'\u2013','ne':'\u2260','nearhk':'\u2924','nearr':'\u2197','neArr':'\u21D7','nearrow':'\u2197','nedot':'\u2250\u0338','NegativeMediumSpace':'\u200B','NegativeThickSpace':'\u200B','NegativeThinSpace':'\u200B','NegativeVeryThinSpace':'\u200B','nequiv':'\u2262','nesear':'\u2928','nesim':'\u2242\u0338','NestedGreaterGreater':'\u226B','NestedLessLess':'\u226A','NewLine':'\n','nexist':'\u2204','nexists':'\u2204','nfr':'\uD835\uDD2B','Nfr':'\uD835\uDD11','nge':'\u2271','ngE':'\u2267\u0338','ngeq':'\u2271','ngeqq':'\u2267\u0338','ngeqslant':'\u2A7E\u0338','nges':'\u2A7E\u0338','nGg':'\u22D9\u0338','ngsim':'\u2275','ngt':'\u226F','nGt':'\u226B\u20D2','ngtr':'\u226F','nGtv':'\u226B\u0338','nharr':'\u21AE','nhArr':'\u21CE','nhpar':'\u2AF2','ni':'\u220B','nis':'\u22FC','nisd':'\u22FA','niv':'\u220B','njcy':'\u045A','NJcy':'\u040A','nlarr':'\u219A','nlArr':'\u21CD','nldr':'\u2025','nle':'\u2270','nlE':'\u2266\u0338','nleftarrow':'\u219A','nLeftarrow':'\u21CD','nleftrightarrow':'\u21AE','nLeftrightarrow':'\u21CE','nleq':'\u2270','nleqq':'\u2266\u0338','nleqslant':'\u2A7D\u0338','nles':'\u2A7D\u0338','nless':'\u226E','nLl':'\u22D8\u0338','nlsim':'\u2274','nlt':'\u226E','nLt':'\u226A\u20D2','nltri':'\u22EA','nltrie':'\u22EC','nLtv':'\u226A\u0338','nmid':'\u2224','NoBreak':'\u2060','NonBreakingSpace':'\xA0','nopf':'\uD835\uDD5F','Nopf':'\u2115','not':'\xAC','Not':'\u2AEC','NotCongruent':'\u2262','NotCupCap':'\u226D','NotDoubleVerticalBar':'\u2226','NotElement':'\u2209','NotEqual':'\u2260','NotEqualTilde':'\u2242\u0338','NotExists':'\u2204','NotGreater':'\u226F','NotGreaterEqual':'\u2271','NotGreaterFullEqual':'\u2267\u0338','NotGreaterGreater':'\u226B\u0338','NotGreaterLess':'\u2279','NotGreaterSlantEqual':'\u2A7E\u0338','NotGreaterTilde':'\u2275','NotHumpDownHump':'\u224E\u0338','NotHumpEqual':'\u224F\u0338','notin':'\u2209','notindot':'\u22F5\u0338','notinE':'\u22F9\u0338','notinva':'\u2209','notinvb':'\u22F7','notinvc':'\u22F6','NotLeftTriangle':'\u22EA','NotLeftTriangleBar':'\u29CF\u0338','NotLeftTriangleEqual':'\u22EC','NotLess':'\u226E','NotLessEqual':'\u2270','NotLessGreater':'\u2278','NotLessLess':'\u226A\u0338','NotLessSlantEqual':'\u2A7D\u0338','NotLessTilde':'\u2274','NotNestedGreaterGreater':'\u2AA2\u0338','NotNestedLessLess':'\u2AA1\u0338','notni':'\u220C','notniva':'\u220C','notnivb':'\u22FE','notnivc':'\u22FD','NotPrecedes':'\u2280','NotPrecedesEqual':'\u2AAF\u0338','NotPrecedesSlantEqual':'\u22E0','NotReverseElement':'\u220C','NotRightTriangle':'\u22EB','NotRightTriangleBar':'\u29D0\u0338','NotRightTriangleEqual':'\u22ED','NotSquareSubset':'\u228F\u0338','NotSquareSubsetEqual':'\u22E2','NotSquareSuperset':'\u2290\u0338','NotSquareSupersetEqual':'\u22E3','NotSubset':'\u2282\u20D2','NotSubsetEqual':'\u2288','NotSucceeds':'\u2281','NotSucceedsEqual':'\u2AB0\u0338','NotSucceedsSlantEqual':'\u22E1','NotSucceedsTilde':'\u227F\u0338','NotSuperset':'\u2283\u20D2','NotSupersetEqual':'\u2289','NotTilde':'\u2241','NotTildeEqual':'\u2244','NotTildeFullEqual':'\u2247','NotTildeTilde':'\u2249','NotVerticalBar':'\u2224','npar':'\u2226','nparallel':'\u2226','nparsl':'\u2AFD\u20E5','npart':'\u2202\u0338','npolint':'\u2A14','npr':'\u2280','nprcue':'\u22E0','npre':'\u2AAF\u0338','nprec':'\u2280','npreceq':'\u2AAF\u0338','nrarr':'\u219B','nrArr':'\u21CF','nrarrc':'\u2933\u0338','nrarrw':'\u219D\u0338','nrightarrow':'\u219B','nRightarrow':'\u21CF','nrtri':'\u22EB','nrtrie':'\u22ED','nsc':'\u2281','nsccue':'\u22E1','nsce':'\u2AB0\u0338','nscr':'\uD835\uDCC3','Nscr':'\uD835\uDCA9','nshortmid':'\u2224','nshortparallel':'\u2226','nsim':'\u2241','nsime':'\u2244','nsimeq':'\u2244','nsmid':'\u2224','nspar':'\u2226','nsqsube':'\u22E2','nsqsupe':'\u22E3','nsub':'\u2284','nsube':'\u2288','nsubE':'\u2AC5\u0338','nsubset':'\u2282\u20D2','nsubseteq':'\u2288','nsubseteqq':'\u2AC5\u0338','nsucc':'\u2281','nsucceq':'\u2AB0\u0338','nsup':'\u2285','nsupe':'\u2289','nsupE':'\u2AC6\u0338','nsupset':'\u2283\u20D2','nsupseteq':'\u2289','nsupseteqq':'\u2AC6\u0338','ntgl':'\u2279','ntilde':'\xF1','Ntilde':'\xD1','ntlg':'\u2278','ntriangleleft':'\u22EA','ntrianglelefteq':'\u22EC','ntriangleright':'\u22EB','ntrianglerighteq':'\u22ED','nu':'\u03BD','Nu':'\u039D','num':'#','numero':'\u2116','numsp':'\u2007','nvap':'\u224D\u20D2','nvdash':'\u22AC','nvDash':'\u22AD','nVdash':'\u22AE','nVDash':'\u22AF','nvge':'\u2265\u20D2','nvgt':'>\u20D2','nvHarr':'\u2904','nvinfin':'\u29DE','nvlArr':'\u2902','nvle':'\u2264\u20D2','nvlt':'<\u20D2','nvltrie':'\u22B4\u20D2','nvrArr':'\u2903','nvrtrie':'\u22B5\u20D2','nvsim':'\u223C\u20D2','nwarhk':'\u2923','nwarr':'\u2196','nwArr':'\u21D6','nwarrow':'\u2196','nwnear':'\u2927','oacute':'\xF3','Oacute':'\xD3','oast':'\u229B','ocir':'\u229A','ocirc':'\xF4','Ocirc':'\xD4','ocy':'\u043E','Ocy':'\u041E','odash':'\u229D','odblac':'\u0151','Odblac':'\u0150','odiv':'\u2A38','odot':'\u2299','odsold':'\u29BC','oelig':'\u0153','OElig':'\u0152','ofcir':'\u29BF','ofr':'\uD835\uDD2C','Ofr':'\uD835\uDD12','ogon':'\u02DB','ograve':'\xF2','Ograve':'\xD2','ogt':'\u29C1','ohbar':'\u29B5','ohm':'\u03A9','oint':'\u222E','olarr':'\u21BA','olcir':'\u29BE','olcross':'\u29BB','oline':'\u203E','olt':'\u29C0','omacr':'\u014D','Omacr':'\u014C','omega':'\u03C9','Omega':'\u03A9','omicron':'\u03BF','Omicron':'\u039F','omid':'\u29B6','ominus':'\u2296','oopf':'\uD835\uDD60','Oopf':'\uD835\uDD46','opar':'\u29B7','OpenCurlyDoubleQuote':'\u201C','OpenCurlyQuote':'\u2018','operp':'\u29B9','oplus':'\u2295','or':'\u2228','Or':'\u2A54','orarr':'\u21BB','ord':'\u2A5D','order':'\u2134','orderof':'\u2134','ordf':'\xAA','ordm':'\xBA','origof':'\u22B6','oror':'\u2A56','orslope':'\u2A57','orv':'\u2A5B','oS':'\u24C8','oscr':'\u2134','Oscr':'\uD835\uDCAA','oslash':'\xF8','Oslash':'\xD8','osol':'\u2298','otilde':'\xF5','Otilde':'\xD5','otimes':'\u2297','Otimes':'\u2A37','otimesas':'\u2A36','ouml':'\xF6','Ouml':'\xD6','ovbar':'\u233D','OverBar':'\u203E','OverBrace':'\u23DE','OverBracket':'\u23B4','OverParenthesis':'\u23DC','par':'\u2225','para':'\xB6','parallel':'\u2225','parsim':'\u2AF3','parsl':'\u2AFD','part':'\u2202','PartialD':'\u2202','pcy':'\u043F','Pcy':'\u041F','percnt':'%','period':'.','permil':'\u2030','perp':'\u22A5','pertenk':'\u2031','pfr':'\uD835\uDD2D','Pfr':'\uD835\uDD13','phi':'\u03C6','Phi':'\u03A6','phiv':'\u03D5','phmmat':'\u2133','phone':'\u260E','pi':'\u03C0','Pi':'\u03A0','pitchfork':'\u22D4','piv':'\u03D6','planck':'\u210F','planckh':'\u210E','plankv':'\u210F','plus':'+','plusacir':'\u2A23','plusb':'\u229E','pluscir':'\u2A22','plusdo':'\u2214','plusdu':'\u2A25','pluse':'\u2A72','PlusMinus':'\xB1','plusmn':'\xB1','plussim':'\u2A26','plustwo':'\u2A27','pm':'\xB1','Poincareplane':'\u210C','pointint':'\u2A15','popf':'\uD835\uDD61','Popf':'\u2119','pound':'\xA3','pr':'\u227A','Pr':'\u2ABB','prap':'\u2AB7','prcue':'\u227C','pre':'\u2AAF','prE':'\u2AB3','prec':'\u227A','precapprox':'\u2AB7','preccurlyeq':'\u227C','Precedes':'\u227A','PrecedesEqual':'\u2AAF','PrecedesSlantEqual':'\u227C','PrecedesTilde':'\u227E','preceq':'\u2AAF','precnapprox':'\u2AB9','precneqq':'\u2AB5','precnsim':'\u22E8','precsim':'\u227E','prime':'\u2032','Prime':'\u2033','primes':'\u2119','prnap':'\u2AB9','prnE':'\u2AB5','prnsim':'\u22E8','prod':'\u220F','Product':'\u220F','profalar':'\u232E','profline':'\u2312','profsurf':'\u2313','prop':'\u221D','Proportion':'\u2237','Proportional':'\u221D','propto':'\u221D','prsim':'\u227E','prurel':'\u22B0','pscr':'\uD835\uDCC5','Pscr':'\uD835\uDCAB','psi':'\u03C8','Psi':'\u03A8','puncsp':'\u2008','qfr':'\uD835\uDD2E','Qfr':'\uD835\uDD14','qint':'\u2A0C','qopf':'\uD835\uDD62','Qopf':'\u211A','qprime':'\u2057','qscr':'\uD835\uDCC6','Qscr':'\uD835\uDCAC','quaternions':'\u210D','quatint':'\u2A16','quest':'?','questeq':'\u225F','quot':'"','QUOT':'"','rAarr':'\u21DB','race':'\u223D\u0331','racute':'\u0155','Racute':'\u0154','radic':'\u221A','raemptyv':'\u29B3','rang':'\u27E9','Rang':'\u27EB','rangd':'\u2992','range':'\u29A5','rangle':'\u27E9','raquo':'\xBB','rarr':'\u2192','rArr':'\u21D2','Rarr':'\u21A0','rarrap':'\u2975','rarrb':'\u21E5','rarrbfs':'\u2920','rarrc':'\u2933','rarrfs':'\u291E','rarrhk':'\u21AA','rarrlp':'\u21AC','rarrpl':'\u2945','rarrsim':'\u2974','rarrtl':'\u21A3','Rarrtl':'\u2916','rarrw':'\u219D','ratail':'\u291A','rAtail':'\u291C','ratio':'\u2236','rationals':'\u211A','rbarr':'\u290D','rBarr':'\u290F','RBarr':'\u2910','rbbrk':'\u2773','rbrace':'}','rbrack':']','rbrke':'\u298C','rbrksld':'\u298E','rbrkslu':'\u2990','rcaron':'\u0159','Rcaron':'\u0158','rcedil':'\u0157','Rcedil':'\u0156','rceil':'\u2309','rcub':'}','rcy':'\u0440','Rcy':'\u0420','rdca':'\u2937','rdldhar':'\u2969','rdquo':'\u201D','rdquor':'\u201D','rdsh':'\u21B3','Re':'\u211C','real':'\u211C','realine':'\u211B','realpart':'\u211C','reals':'\u211D','rect':'\u25AD','reg':'\xAE','REG':'\xAE','ReverseElement':'\u220B','ReverseEquilibrium':'\u21CB','ReverseUpEquilibrium':'\u296F','rfisht':'\u297D','rfloor':'\u230B','rfr':'\uD835\uDD2F','Rfr':'\u211C','rHar':'\u2964','rhard':'\u21C1','rharu':'\u21C0','rharul':'\u296C','rho':'\u03C1','Rho':'\u03A1','rhov':'\u03F1','RightAngleBracket':'\u27E9','rightarrow':'\u2192','Rightarrow':'\u21D2','RightArrow':'\u2192','RightArrowBar':'\u21E5','RightArrowLeftArrow':'\u21C4','rightarrowtail':'\u21A3','RightCeiling':'\u2309','RightDoubleBracket':'\u27E7','RightDownTeeVector':'\u295D','RightDownVector':'\u21C2','RightDownVectorBar':'\u2955','RightFloor':'\u230B','rightharpoondown':'\u21C1','rightharpoonup':'\u21C0','rightleftarrows':'\u21C4','rightleftharpoons':'\u21CC','rightrightarrows':'\u21C9','rightsquigarrow':'\u219D','RightTee':'\u22A2','RightTeeArrow':'\u21A6','RightTeeVector':'\u295B','rightthreetimes':'\u22CC','RightTriangle':'\u22B3','RightTriangleBar':'\u29D0','RightTriangleEqual':'\u22B5','RightUpDownVector':'\u294F','RightUpTeeVector':'\u295C','RightUpVector':'\u21BE','RightUpVectorBar':'\u2954','RightVector':'\u21C0','RightVectorBar':'\u2953','ring':'\u02DA','risingdotseq':'\u2253','rlarr':'\u21C4','rlhar':'\u21CC','rlm':'\u200F','rmoust':'\u23B1','rmoustache':'\u23B1','rnmid':'\u2AEE','roang':'\u27ED','roarr':'\u21FE','robrk':'\u27E7','ropar':'\u2986','ropf':'\uD835\uDD63','Ropf':'\u211D','roplus':'\u2A2E','rotimes':'\u2A35','RoundImplies':'\u2970','rpar':')','rpargt':'\u2994','rppolint':'\u2A12','rrarr':'\u21C9','Rrightarrow':'\u21DB','rsaquo':'\u203A','rscr':'\uD835\uDCC7','Rscr':'\u211B','rsh':'\u21B1','Rsh':'\u21B1','rsqb':']','rsquo':'\u2019','rsquor':'\u2019','rthree':'\u22CC','rtimes':'\u22CA','rtri':'\u25B9','rtrie':'\u22B5','rtrif':'\u25B8','rtriltri':'\u29CE','RuleDelayed':'\u29F4','ruluhar':'\u2968','rx':'\u211E','sacute':'\u015B','Sacute':'\u015A','sbquo':'\u201A','sc':'\u227B','Sc':'\u2ABC','scap':'\u2AB8','scaron':'\u0161','Scaron':'\u0160','sccue':'\u227D','sce':'\u2AB0','scE':'\u2AB4','scedil':'\u015F','Scedil':'\u015E','scirc':'\u015D','Scirc':'\u015C','scnap':'\u2ABA','scnE':'\u2AB6','scnsim':'\u22E9','scpolint':'\u2A13','scsim':'\u227F','scy':'\u0441','Scy':'\u0421','sdot':'\u22C5','sdotb':'\u22A1','sdote':'\u2A66','searhk':'\u2925','searr':'\u2198','seArr':'\u21D8','searrow':'\u2198','sect':'\xA7','semi':';','seswar':'\u2929','setminus':'\u2216','setmn':'\u2216','sext':'\u2736','sfr':'\uD835\uDD30','Sfr':'\uD835\uDD16','sfrown':'\u2322','sharp':'\u266F','shchcy':'\u0449','SHCHcy':'\u0429','shcy':'\u0448','SHcy':'\u0428','ShortDownArrow':'\u2193','ShortLeftArrow':'\u2190','shortmid':'\u2223','shortparallel':'\u2225','ShortRightArrow':'\u2192','ShortUpArrow':'\u2191','shy':'\xAD','sigma':'\u03C3','Sigma':'\u03A3','sigmaf':'\u03C2','sigmav':'\u03C2','sim':'\u223C','simdot':'\u2A6A','sime':'\u2243','simeq':'\u2243','simg':'\u2A9E','simgE':'\u2AA0','siml':'\u2A9D','simlE':'\u2A9F','simne':'\u2246','simplus':'\u2A24','simrarr':'\u2972','slarr':'\u2190','SmallCircle':'\u2218','smallsetminus':'\u2216','smashp':'\u2A33','smeparsl':'\u29E4','smid':'\u2223','smile':'\u2323','smt':'\u2AAA','smte':'\u2AAC','smtes':'\u2AAC\uFE00','softcy':'\u044C','SOFTcy':'\u042C','sol':'/','solb':'\u29C4','solbar':'\u233F','sopf':'\uD835\uDD64','Sopf':'\uD835\uDD4A','spades':'\u2660','spadesuit':'\u2660','spar':'\u2225','sqcap':'\u2293','sqcaps':'\u2293\uFE00','sqcup':'\u2294','sqcups':'\u2294\uFE00','Sqrt':'\u221A','sqsub':'\u228F','sqsube':'\u2291','sqsubset':'\u228F','sqsubseteq':'\u2291','sqsup':'\u2290','sqsupe':'\u2292','sqsupset':'\u2290','sqsupseteq':'\u2292','squ':'\u25A1','square':'\u25A1','Square':'\u25A1','SquareIntersection':'\u2293','SquareSubset':'\u228F','SquareSubsetEqual':'\u2291','SquareSuperset':'\u2290','SquareSupersetEqual':'\u2292','SquareUnion':'\u2294','squarf':'\u25AA','squf':'\u25AA','srarr':'\u2192','sscr':'\uD835\uDCC8','Sscr':'\uD835\uDCAE','ssetmn':'\u2216','ssmile':'\u2323','sstarf':'\u22C6','star':'\u2606','Star':'\u22C6','starf':'\u2605','straightepsilon':'\u03F5','straightphi':'\u03D5','strns':'\xAF','sub':'\u2282','Sub':'\u22D0','subdot':'\u2ABD','sube':'\u2286','subE':'\u2AC5','subedot':'\u2AC3','submult':'\u2AC1','subne':'\u228A','subnE':'\u2ACB','subplus':'\u2ABF','subrarr':'\u2979','subset':'\u2282','Subset':'\u22D0','subseteq':'\u2286','subseteqq':'\u2AC5','SubsetEqual':'\u2286','subsetneq':'\u228A','subsetneqq':'\u2ACB','subsim':'\u2AC7','subsub':'\u2AD5','subsup':'\u2AD3','succ':'\u227B','succapprox':'\u2AB8','succcurlyeq':'\u227D','Succeeds':'\u227B','SucceedsEqual':'\u2AB0','SucceedsSlantEqual':'\u227D','SucceedsTilde':'\u227F','succeq':'\u2AB0','succnapprox':'\u2ABA','succneqq':'\u2AB6','succnsim':'\u22E9','succsim':'\u227F','SuchThat':'\u220B','sum':'\u2211','Sum':'\u2211','sung':'\u266A','sup':'\u2283','Sup':'\u22D1','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','supdot':'\u2ABE','supdsub':'\u2AD8','supe':'\u2287','supE':'\u2AC6','supedot':'\u2AC4','Superset':'\u2283','SupersetEqual':'\u2287','suphsol':'\u27C9','suphsub':'\u2AD7','suplarr':'\u297B','supmult':'\u2AC2','supne':'\u228B','supnE':'\u2ACC','supplus':'\u2AC0','supset':'\u2283','Supset':'\u22D1','supseteq':'\u2287','supseteqq':'\u2AC6','supsetneq':'\u228B','supsetneqq':'\u2ACC','supsim':'\u2AC8','supsub':'\u2AD4','supsup':'\u2AD6','swarhk':'\u2926','swarr':'\u2199','swArr':'\u21D9','swarrow':'\u2199','swnwar':'\u292A','szlig':'\xDF','Tab':'\t','target':'\u2316','tau':'\u03C4','Tau':'\u03A4','tbrk':'\u23B4','tcaron':'\u0165','Tcaron':'\u0164','tcedil':'\u0163','Tcedil':'\u0162','tcy':'\u0442','Tcy':'\u0422','tdot':'\u20DB','telrec':'\u2315','tfr':'\uD835\uDD31','Tfr':'\uD835\uDD17','there4':'\u2234','therefore':'\u2234','Therefore':'\u2234','theta':'\u03B8','Theta':'\u0398','thetasym':'\u03D1','thetav':'\u03D1','thickapprox':'\u2248','thicksim':'\u223C','ThickSpace':'\u205F\u200A','thinsp':'\u2009','ThinSpace':'\u2009','thkap':'\u2248','thksim':'\u223C','thorn':'\xFE','THORN':'\xDE','tilde':'\u02DC','Tilde':'\u223C','TildeEqual':'\u2243','TildeFullEqual':'\u2245','TildeTilde':'\u2248','times':'\xD7','timesb':'\u22A0','timesbar':'\u2A31','timesd':'\u2A30','tint':'\u222D','toea':'\u2928','top':'\u22A4','topbot':'\u2336','topcir':'\u2AF1','topf':'\uD835\uDD65','Topf':'\uD835\uDD4B','topfork':'\u2ADA','tosa':'\u2929','tprime':'\u2034','trade':'\u2122','TRADE':'\u2122','triangle':'\u25B5','triangledown':'\u25BF','triangleleft':'\u25C3','trianglelefteq':'\u22B4','triangleq':'\u225C','triangleright':'\u25B9','trianglerighteq':'\u22B5','tridot':'\u25EC','trie':'\u225C','triminus':'\u2A3A','TripleDot':'\u20DB','triplus':'\u2A39','trisb':'\u29CD','tritime':'\u2A3B','trpezium':'\u23E2','tscr':'\uD835\uDCC9','Tscr':'\uD835\uDCAF','tscy':'\u0446','TScy':'\u0426','tshcy':'\u045B','TSHcy':'\u040B','tstrok':'\u0167','Tstrok':'\u0166','twixt':'\u226C','twoheadleftarrow':'\u219E','twoheadrightarrow':'\u21A0','uacute':'\xFA','Uacute':'\xDA','uarr':'\u2191','uArr':'\u21D1','Uarr':'\u219F','Uarrocir':'\u2949','ubrcy':'\u045E','Ubrcy':'\u040E','ubreve':'\u016D','Ubreve':'\u016C','ucirc':'\xFB','Ucirc':'\xDB','ucy':'\u0443','Ucy':'\u0423','udarr':'\u21C5','udblac':'\u0171','Udblac':'\u0170','udhar':'\u296E','ufisht':'\u297E','ufr':'\uD835\uDD32','Ufr':'\uD835\uDD18','ugrave':'\xF9','Ugrave':'\xD9','uHar':'\u2963','uharl':'\u21BF','uharr':'\u21BE','uhblk':'\u2580','ulcorn':'\u231C','ulcorner':'\u231C','ulcrop':'\u230F','ultri':'\u25F8','umacr':'\u016B','Umacr':'\u016A','uml':'\xA8','UnderBar':'_','UnderBrace':'\u23DF','UnderBracket':'\u23B5','UnderParenthesis':'\u23DD','Union':'\u22C3','UnionPlus':'\u228E','uogon':'\u0173','Uogon':'\u0172','uopf':'\uD835\uDD66','Uopf':'\uD835\uDD4C','uparrow':'\u2191','Uparrow':'\u21D1','UpArrow':'\u2191','UpArrowBar':'\u2912','UpArrowDownArrow':'\u21C5','updownarrow':'\u2195','Updownarrow':'\u21D5','UpDownArrow':'\u2195','UpEquilibrium':'\u296E','upharpoonleft':'\u21BF','upharpoonright':'\u21BE','uplus':'\u228E','UpperLeftArrow':'\u2196','UpperRightArrow':'\u2197','upsi':'\u03C5','Upsi':'\u03D2','upsih':'\u03D2','upsilon':'\u03C5','Upsilon':'\u03A5','UpTee':'\u22A5','UpTeeArrow':'\u21A5','upuparrows':'\u21C8','urcorn':'\u231D','urcorner':'\u231D','urcrop':'\u230E','uring':'\u016F','Uring':'\u016E','urtri':'\u25F9','uscr':'\uD835\uDCCA','Uscr':'\uD835\uDCB0','utdot':'\u22F0','utilde':'\u0169','Utilde':'\u0168','utri':'\u25B5','utrif':'\u25B4','uuarr':'\u21C8','uuml':'\xFC','Uuml':'\xDC','uwangle':'\u29A7','vangrt':'\u299C','varepsilon':'\u03F5','varkappa':'\u03F0','varnothing':'\u2205','varphi':'\u03D5','varpi':'\u03D6','varpropto':'\u221D','varr':'\u2195','vArr':'\u21D5','varrho':'\u03F1','varsigma':'\u03C2','varsubsetneq':'\u228A\uFE00','varsubsetneqq':'\u2ACB\uFE00','varsupsetneq':'\u228B\uFE00','varsupsetneqq':'\u2ACC\uFE00','vartheta':'\u03D1','vartriangleleft':'\u22B2','vartriangleright':'\u22B3','vBar':'\u2AE8','Vbar':'\u2AEB','vBarv':'\u2AE9','vcy':'\u0432','Vcy':'\u0412','vdash':'\u22A2','vDash':'\u22A8','Vdash':'\u22A9','VDash':'\u22AB','Vdashl':'\u2AE6','vee':'\u2228','Vee':'\u22C1','veebar':'\u22BB','veeeq':'\u225A','vellip':'\u22EE','verbar':'|','Verbar':'\u2016','vert':'|','Vert':'\u2016','VerticalBar':'\u2223','VerticalLine':'|','VerticalSeparator':'\u2758','VerticalTilde':'\u2240','VeryThinSpace':'\u200A','vfr':'\uD835\uDD33','Vfr':'\uD835\uDD19','vltri':'\u22B2','vnsub':'\u2282\u20D2','vnsup':'\u2283\u20D2','vopf':'\uD835\uDD67','Vopf':'\uD835\uDD4D','vprop':'\u221D','vrtri':'\u22B3','vscr':'\uD835\uDCCB','Vscr':'\uD835\uDCB1','vsubne':'\u228A\uFE00','vsubnE':'\u2ACB\uFE00','vsupne':'\u228B\uFE00','vsupnE':'\u2ACC\uFE00','Vvdash':'\u22AA','vzigzag':'\u299A','wcirc':'\u0175','Wcirc':'\u0174','wedbar':'\u2A5F','wedge':'\u2227','Wedge':'\u22C0','wedgeq':'\u2259','weierp':'\u2118','wfr':'\uD835\uDD34','Wfr':'\uD835\uDD1A','wopf':'\uD835\uDD68','Wopf':'\uD835\uDD4E','wp':'\u2118','wr':'\u2240','wreath':'\u2240','wscr':'\uD835\uDCCC','Wscr':'\uD835\uDCB2','xcap':'\u22C2','xcirc':'\u25EF','xcup':'\u22C3','xdtri':'\u25BD','xfr':'\uD835\uDD35','Xfr':'\uD835\uDD1B','xharr':'\u27F7','xhArr':'\u27FA','xi':'\u03BE','Xi':'\u039E','xlarr':'\u27F5','xlArr':'\u27F8','xmap':'\u27FC','xnis':'\u22FB','xodot':'\u2A00','xopf':'\uD835\uDD69','Xopf':'\uD835\uDD4F','xoplus':'\u2A01','xotime':'\u2A02','xrarr':'\u27F6','xrArr':'\u27F9','xscr':'\uD835\uDCCD','Xscr':'\uD835\uDCB3','xsqcup':'\u2A06','xuplus':'\u2A04','xutri':'\u25B3','xvee':'\u22C1','xwedge':'\u22C0','yacute':'\xFD','Yacute':'\xDD','yacy':'\u044F','YAcy':'\u042F','ycirc':'\u0177','Ycirc':'\u0176','ycy':'\u044B','Ycy':'\u042B','yen':'\xA5','yfr':'\uD835\uDD36','Yfr':'\uD835\uDD1C','yicy':'\u0457','YIcy':'\u0407','yopf':'\uD835\uDD6A','Yopf':'\uD835\uDD50','yscr':'\uD835\uDCCE','Yscr':'\uD835\uDCB4','yucy':'\u044E','YUcy':'\u042E','yuml':'\xFF','Yuml':'\u0178','zacute':'\u017A','Zacute':'\u0179','zcaron':'\u017E','Zcaron':'\u017D','zcy':'\u0437','Zcy':'\u0417','zdot':'\u017C','Zdot':'\u017B','zeetrf':'\u2128','ZeroWidthSpace':'\u200B','zeta':'\u03B6','Zeta':'\u0396','zfr':'\uD835\uDD37','Zfr':'\u2128','zhcy':'\u0436','ZHcy':'\u0416','zigrarr':'\u21DD','zopf':'\uD835\uDD6B','Zopf':'\u2124','zscr':'\uD835\uDCCF','Zscr':'\uD835\uDCB5','zwj':'\u200D','zwnj':'\u200C'};
		var decodeMapLegacy = {'aacute':'\xE1','Aacute':'\xC1','acirc':'\xE2','Acirc':'\xC2','acute':'\xB4','aelig':'\xE6','AElig':'\xC6','agrave':'\xE0','Agrave':'\xC0','amp':'&','AMP':'&','aring':'\xE5','Aring':'\xC5','atilde':'\xE3','Atilde':'\xC3','auml':'\xE4','Auml':'\xC4','brvbar':'\xA6','ccedil':'\xE7','Ccedil':'\xC7','cedil':'\xB8','cent':'\xA2','copy':'\xA9','COPY':'\xA9','curren':'\xA4','deg':'\xB0','divide':'\xF7','eacute':'\xE9','Eacute':'\xC9','ecirc':'\xEA','Ecirc':'\xCA','egrave':'\xE8','Egrave':'\xC8','eth':'\xF0','ETH':'\xD0','euml':'\xEB','Euml':'\xCB','frac12':'\xBD','frac14':'\xBC','frac34':'\xBE','gt':'>','GT':'>','iacute':'\xED','Iacute':'\xCD','icirc':'\xEE','Icirc':'\xCE','iexcl':'\xA1','igrave':'\xEC','Igrave':'\xCC','iquest':'\xBF','iuml':'\xEF','Iuml':'\xCF','laquo':'\xAB','lt':'<','LT':'<','macr':'\xAF','micro':'\xB5','middot':'\xB7','nbsp':'\xA0','not':'\xAC','ntilde':'\xF1','Ntilde':'\xD1','oacute':'\xF3','Oacute':'\xD3','ocirc':'\xF4','Ocirc':'\xD4','ograve':'\xF2','Ograve':'\xD2','ordf':'\xAA','ordm':'\xBA','oslash':'\xF8','Oslash':'\xD8','otilde':'\xF5','Otilde':'\xD5','ouml':'\xF6','Ouml':'\xD6','para':'\xB6','plusmn':'\xB1','pound':'\xA3','quot':'"','QUOT':'"','raquo':'\xBB','reg':'\xAE','REG':'\xAE','sect':'\xA7','shy':'\xAD','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','szlig':'\xDF','thorn':'\xFE','THORN':'\xDE','times':'\xD7','uacute':'\xFA','Uacute':'\xDA','ucirc':'\xFB','Ucirc':'\xDB','ugrave':'\xF9','Ugrave':'\xD9','uml':'\xA8','uuml':'\xFC','Uuml':'\xDC','yacute':'\xFD','Yacute':'\xDD','yen':'\xA5','yuml':'\xFF'};
		var decodeMapNumeric = {'0':'\uFFFD','128':'\u20AC','130':'\u201A','131':'\u0192','132':'\u201E','133':'\u2026','134':'\u2020','135':'\u2021','136':'\u02C6','137':'\u2030','138':'\u0160','139':'\u2039','140':'\u0152','142':'\u017D','145':'\u2018','146':'\u2019','147':'\u201C','148':'\u201D','149':'\u2022','150':'\u2013','151':'\u2014','152':'\u02DC','153':'\u2122','154':'\u0161','155':'\u203A','156':'\u0153','158':'\u017E','159':'\u0178'};
		var invalidReferenceCodePoints = [1,2,3,4,5,6,7,8,11,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,64976,64977,64978,64979,64980,64981,64982,64983,64984,64985,64986,64987,64988,64989,64990,64991,64992,64993,64994,64995,64996,64997,64998,64999,65000,65001,65002,65003,65004,65005,65006,65007,65534,65535,131070,131071,196606,196607,262142,262143,327678,327679,393214,393215,458750,458751,524286,524287,589822,589823,655358,655359,720894,720895,786430,786431,851966,851967,917502,917503,983038,983039,1048574,1048575,1114110,1114111];

		/*--------------------------------------------------------------------------*/

		var stringFromCharCode = String.fromCharCode;

		var object$$1 = {};
		var hasOwnProperty = object$$1.hasOwnProperty;
		var has = function(object$$1, propertyName) {
			return hasOwnProperty.call(object$$1, propertyName);
		};

		var contains = function(array, value) {
			var index = -1;
			var length = array.length;
			while (++index < length) {
				if (array[index] == value) {
					return true;
				}
			}
			return false;
		};

		var merge = function(options, defaults) {
			if (!options) {
				return defaults;
			}
			var result = {};
			var key;
			for (key in defaults) {
				// A `hasOwnProperty` check is not needed here, since only recognized
				// option names are used anyway. Any others are ignored.
				result[key] = has(options, key) ? options[key] : defaults[key];
			}
			return result;
		};

		// Modified version of `ucs2encode`; see https://mths.be/punycode.
		var codePointToSymbol = function(codePoint, strict) {
			var output = '';
			if ((codePoint >= 0xD800 && codePoint <= 0xDFFF) || codePoint > 0x10FFFF) {
				// See issue #4:
				// “Otherwise, if the number is in the range 0xD800 to 0xDFFF or is
				// greater than 0x10FFFF, then this is a parse error. Return a U+FFFD
				// REPLACEMENT CHARACTER.”
				if (strict) {
					parseError('character reference outside the permissible Unicode range');
				}
				return '\uFFFD';
			}
			if (has(decodeMapNumeric, codePoint)) {
				if (strict) {
					parseError('disallowed character reference');
				}
				return decodeMapNumeric[codePoint];
			}
			if (strict && contains(invalidReferenceCodePoints, codePoint)) {
				parseError('disallowed character reference');
			}
			if (codePoint > 0xFFFF) {
				codePoint -= 0x10000;
				output += stringFromCharCode(codePoint >>> 10 & 0x3FF | 0xD800);
				codePoint = 0xDC00 | codePoint & 0x3FF;
			}
			output += stringFromCharCode(codePoint);
			return output;
		};

		var hexEscape = function(codePoint) {
			return '&#x' + codePoint.toString(16).toUpperCase() + ';';
		};

		var decEscape = function(codePoint) {
			return '&#' + codePoint + ';';
		};

		var parseError = function(message) {
			throw Error('Parse error: ' + message);
		};

		/*--------------------------------------------------------------------------*/

		var encode = function(string, options) {
			options = merge(options, encode.options);
			var strict = options.strict;
			if (strict && regexInvalidRawCodePoint.test(string)) {
				parseError('forbidden code point');
			}
			var encodeEverything = options.encodeEverything;
			var useNamedReferences = options.useNamedReferences;
			var allowUnsafeSymbols = options.allowUnsafeSymbols;
			var escapeCodePoint = options.decimal ? decEscape : hexEscape;

			var escapeBmpSymbol = function(symbol) {
				return escapeCodePoint(symbol.charCodeAt(0));
			};

			if (encodeEverything) {
				// Encode ASCII symbols.
				string = string.replace(regexAsciiWhitelist, function(symbol) {
					// Use named references if requested & possible.
					if (useNamedReferences && has(encodeMap, symbol)) {
						return '&' + encodeMap[symbol] + ';';
					}
					return escapeBmpSymbol(symbol);
				});
				// Shorten a few escapes that represent two symbols, of which at least one
				// is within the ASCII range.
				if (useNamedReferences) {
					string = string
						.replace(/&gt;\u20D2/g, '&nvgt;')
						.replace(/&lt;\u20D2/g, '&nvlt;')
						.replace(/&#x66;&#x6A;/g, '&fjlig;');
				}
				// Encode non-ASCII symbols.
				if (useNamedReferences) {
					// Encode non-ASCII symbols that can be replaced with a named reference.
					string = string.replace(regexEncodeNonAscii, function(string) {
						// Note: there is no need to check `has(encodeMap, string)` here.
						return '&' + encodeMap[string] + ';';
					});
				}
				// Note: any remaining non-ASCII symbols are handled outside of the `if`.
			} else if (useNamedReferences) {
				// Apply named character references.
				// Encode `<>"'&` using named character references.
				if (!allowUnsafeSymbols) {
					string = string.replace(regexEscape, function(string) {
						return '&' + encodeMap[string] + ';'; // no need to check `has()` here
					});
				}
				// Shorten escapes that represent two symbols, of which at least one is
				// `<>"'&`.
				string = string
					.replace(/&gt;\u20D2/g, '&nvgt;')
					.replace(/&lt;\u20D2/g, '&nvlt;');
				// Encode non-ASCII symbols that can be replaced with a named reference.
				string = string.replace(regexEncodeNonAscii, function(string) {
					// Note: there is no need to check `has(encodeMap, string)` here.
					return '&' + encodeMap[string] + ';';
				});
			} else if (!allowUnsafeSymbols) {
				// Encode `<>"'&` using hexadecimal escapes, now that they’re not handled
				// using named character references.
				string = string.replace(regexEscape, escapeBmpSymbol);
			}
			return string
				// Encode astral symbols.
				.replace(regexAstralSymbols, function($0) {
					// https://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
					var high = $0.charCodeAt(0);
					var low = $0.charCodeAt(1);
					var codePoint = (high - 0xD800) * 0x400 + low - 0xDC00 + 0x10000;
					return escapeCodePoint(codePoint);
				})
				// Encode any remaining BMP symbols that are not printable ASCII symbols
				// using a hexadecimal escape.
				.replace(regexBmpWhitelist, escapeBmpSymbol);
		};
		// Expose default options (so they can be overridden globally).
		encode.options = {
			'allowUnsafeSymbols': false,
			'encodeEverything': false,
			'strict': false,
			'useNamedReferences': false,
			'decimal' : false
		};

		var decode = function(html, options) {
			options = merge(options, decode.options);
			var strict = options.strict;
			if (strict && regexInvalidEntity.test(html)) {
				parseError('malformed character reference');
			}
			return html.replace(regexDecode, function($0, $1, $2, $3, $4, $5, $6, $7, $8) {
				var codePoint;
				var semicolon;
				var decDigits;
				var hexDigits;
				var reference;
				var next;

				if ($1) {
					reference = $1;
					// Note: there is no need to check `has(decodeMap, reference)`.
					return decodeMap[reference];
				}

				if ($2) {
					// Decode named character references without trailing `;`, e.g. `&amp`.
					// This is only a parse error if it gets converted to `&`, or if it is
					// followed by `=` in an attribute context.
					reference = $2;
					next = $3;
					if (next && options.isAttributeValue) {
						if (strict && next == '=') {
							parseError('`&` did not start a character reference');
						}
						return $0;
					} else {
						if (strict) {
							parseError(
								'named character reference was not terminated by a semicolon'
							);
						}
						// Note: there is no need to check `has(decodeMapLegacy, reference)`.
						return decodeMapLegacy[reference] + (next || '');
					}
				}

				if ($4) {
					// Decode decimal escapes, e.g. `&#119558;`.
					decDigits = $4;
					semicolon = $5;
					if (strict && !semicolon) {
						parseError('character reference was not terminated by a semicolon');
					}
					codePoint = parseInt(decDigits, 10);
					return codePointToSymbol(codePoint, strict);
				}

				if ($6) {
					// Decode hexadecimal escapes, e.g. `&#x1D306;`.
					hexDigits = $6;
					semicolon = $7;
					if (strict && !semicolon) {
						parseError('character reference was not terminated by a semicolon');
					}
					codePoint = parseInt(hexDigits, 16);
					return codePointToSymbol(codePoint, strict);
				}

				// If we’re still here, `if ($7)` is implied; it’s an ambiguous
				// ampersand for sure. https://mths.be/notes/ambiguous-ampersands
				if (strict) {
					parseError(
						'named character reference was not terminated by a semicolon'
					);
				}
				return $0;
			});
		};
		// Expose default options (so they can be overridden globally).
		decode.options = {
			'isAttributeValue': false,
			'strict': false
		};

		var escape = function(string) {
			return string.replace(regexEscape, function($0) {
				// Note: there is no need to check `has(escapeMap, $0)` here.
				return escapeMap[$0];
			});
		};

		/*--------------------------------------------------------------------------*/

		var he = {
			'version': '1.2.0',
			'encode': encode,
			'decode': decode,
			'escape': escape,
			'unescape': decode
		};

		// Some AMD build optimizers, like r.js, check for specific condition patterns
		// like the following:
		if (freeExports && !freeExports.nodeType) {
			if (freeModule) { // in Node.js, io.js, or RingoJS v0.8.0+
				freeModule.exports = he;
			} else { // in Narwhal or RingoJS v0.7.0-
				for (var key in he) {
					has(he, key) && (freeExports[key] = he[key]);
				}
			}
		} else { // in Rhino or a web browser
			root.he = he;
		}

	}(commonjsGlobal));
	});

	/**
	 * @module Errors
	 */
	/**
	 * Factory functions to create throwable error objects
	 */

	/**
	 * Creates an error object to be thrown when no files to be tested could be found using specified pattern.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} pattern - User-specified argument value.
	 * @returns {Error} instance detailing the error condition
	 */
	function createNoFilesMatchPatternError(message, pattern) {
	  var err = new Error(message);
	  err.code = 'ERR_MOCHA_NO_FILES_MATCH_PATTERN';
	  err.pattern = pattern;
	  return err;
	}

	/**
	 * Creates an error object to be thrown when the reporter specified in the options was not found.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} reporter - User-specified reporter value.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidReporterError(message, reporter) {
	  var err = new TypeError(message);
	  err.code = 'ERR_MOCHA_INVALID_REPORTER';
	  err.reporter = reporter;
	  return err;
	}

	/**
	 * Creates an error object to be thrown when the interface specified in the options was not found.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} ui - User-specified interface value.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidInterfaceError(message, ui) {
	  var err = new Error(message);
	  err.code = 'ERR_MOCHA_INVALID_INTERFACE';
	  err.interface = ui;
	  return err;
	}

	/**
	 * Creates an error object to be thrown when a behavior, option, or parameter is unsupported.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @returns {Error} instance detailing the error condition
	 */
	function createUnsupportedError(message) {
	  var err = new Error(message);
	  err.code = 'ERR_MOCHA_UNSUPPORTED';
	  return err;
	}

	/**
	 * Creates an error object to be thrown when an argument is missing.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} argument - Argument name.
	 * @param {string} expected - Expected argument datatype.
	 * @returns {Error} instance detailing the error condition
	 */
	function createMissingArgumentError(message, argument, expected) {
	  return createInvalidArgumentTypeError(message, argument, expected);
	}

	/**
	 * Creates an error object to be thrown when an argument did not use the supported type
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} argument - Argument name.
	 * @param {string} expected - Expected argument datatype.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidArgumentTypeError(message, argument, expected) {
	  var err = new TypeError(message);
	  err.code = 'ERR_MOCHA_INVALID_ARG_TYPE';
	  err.argument = argument;
	  err.expected = expected;
	  err.actual = typeof argument;
	  return err;
	}

	/**
	 * Creates an error object to be thrown when an argument did not use the supported value
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} argument - Argument name.
	 * @param {string} value - Argument value.
	 * @param {string} [reason] - Why value is invalid.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidArgumentValueError(message, argument, value, reason) {
	  var err = new TypeError(message);
	  err.code = 'ERR_MOCHA_INVALID_ARG_VALUE';
	  err.argument = argument;
	  err.value = value;
	  err.reason = typeof reason !== 'undefined' ? reason : 'is invalid';
	  return err;
	}

	/**
	 * Creates an error object to be thrown when an exception was caught, but the `Error` is falsy or undefined.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidExceptionError(message, value) {
	  var err = new Error(message);
	  err.code = 'ERR_MOCHA_INVALID_EXCEPTION';
	  err.valueType = typeof value;
	  err.value = value;
	  return err;
	}

	var errors = {
	  createInvalidArgumentTypeError: createInvalidArgumentTypeError,
	  createInvalidArgumentValueError: createInvalidArgumentValueError,
	  createInvalidExceptionError: createInvalidExceptionError,
	  createInvalidInterfaceError: createInvalidInterfaceError,
	  createInvalidReporterError: createInvalidReporterError,
	  createMissingArgumentError: createMissingArgumentError,
	  createNoFilesMatchPatternError: createNoFilesMatchPatternError,
	  createUnsupportedError: createUnsupportedError
	};

	var path = getCjsExportFromNamespace(_empty_module$1);

	var utils = createCommonjsModule(function (module, exports) {

	/**
	 * Various utility functions used throughout Mocha's codebase.
	 * @module utils
	 */

	/**
	 * Module dependencies.
	 */







	var createNoFilesMatchPatternError = errors.createNoFilesMatchPatternError;
	var createMissingArgumentError = errors.createMissingArgumentError;

	var assign = (exports.assign = object.getPolyfill());

	/**
	 * Inherit the prototype methods from one constructor into another.
	 *
	 * @param {function} ctor - Constructor function which needs to inherit the
	 *     prototype.
	 * @param {function} superCtor - Constructor function to inherit prototype from.
	 * @throws {TypeError} if either constructor is null, or if super constructor
	 *     lacks a prototype.
	 */
	exports.inherits = util.inherits;

	/**
	 * Escape special characters in the given string of html.
	 *
	 * @private
	 * @param  {string} html
	 * @return {string}
	 */
	exports.escape = function(html) {
	  return he.encode(String(html), {useNamedReferences: false});
	};

	/**
	 * Test if the given obj is type of string.
	 *
	 * @private
	 * @param {Object} obj
	 * @return {boolean}
	 */
	exports.isString = function(obj) {
	  return typeof obj === 'string';
	};

	/**
	 * Watch the given `files` for changes
	 * and invoke `fn(file)` on modification.
	 *
	 * @private
	 * @param {Array} files
	 * @param {Function} fn
	 */
	exports.watch = function(files, fn) {
	  var options = {interval: 100};
	  var debug$$1 = debug('mocha:watch');
	  files.forEach(function(file) {
	    debug$$1('file %s', file);
	    path.watchFile(file, options, function(curr, prev) {
	      if (prev.mtime < curr.mtime) {
	        fn(file);
	      }
	    });
	  });
	};

	/**
	 * Predicate to screen `pathname` for further consideration.
	 *
	 * @description
	 * Returns <code>false</code> for pathname referencing:
	 * <ul>
	 *   <li>'npm' package installation directory
	 *   <li>'git' version control directory
	 * </ul>
	 *
	 * @private
	 * @param {string} pathname - File or directory name to screen
	 * @return {boolean} whether pathname should be further considered
	 * @example
	 * ['node_modules', 'test.js'].filter(considerFurther); // => ['test.js']
	 */
	function considerFurther(pathname) {
	  var ignore = ['node_modules', '.git'];

	  return !~ignore.indexOf(pathname);
	}

	/**
	 * Lookup files in the given `dir`.
	 *
	 * @description
	 * Filenames are returned in _traversal_ order by the OS/filesystem.
	 * **Make no assumption that the names will be sorted in any fashion.**
	 *
	 * @private
	 * @param {string} dir
	 * @param {string[]} [exts=['js']]
	 * @param {Array} [ret=[]]
	 * @return {Array}
	 */
	exports.files = function(dir, exts, ret) {
	  ret = ret || [];
	  exts = exts || ['js'];

	  path.readdirSync(dir)
	    .filter(considerFurther)
	    .forEach(function(dirent) {
	      var pathname = path.join(dir, dirent);
	      if (path.lstatSync(pathname).isDirectory()) {
	        exports.files(pathname, exts, ret);
	      } else if (hasMatchingExtname(pathname, exts)) {
	        ret.push(pathname);
	      }
	    });

	  return ret;
	};

	/**
	 * Compute a slug from the given `str`.
	 *
	 * @private
	 * @param {string} str
	 * @return {string}
	 */
	exports.slug = function(str) {
	  return str
	    .toLowerCase()
	    .replace(/ +/g, '-')
	    .replace(/[^-\w]/g, '');
	};

	/**
	 * Strip the function definition from `str`, and re-indent for pre whitespace.
	 *
	 * @param {string} str
	 * @return {string}
	 */
	exports.clean = function(str) {
	  str = str
	    .replace(/\r\n?|[\n\u2028\u2029]/g, '\n')
	    .replace(/^\uFEFF/, '')
	    // (traditional)->  space/name     parameters    body     (lambda)-> parameters       body   multi-statement/single          keep body content
	    .replace(
	      /^function(?:\s*|\s+[^(]*)\([^)]*\)\s*\{((?:.|\n)*?)\s*\}$|^\([^)]*\)\s*=>\s*(?:\{((?:.|\n)*?)\s*\}|((?:.|\n)*))$/,
	      '$1$2$3'
	    );

	  var spaces = str.match(/^\n?( *)/)[1].length;
	  var tabs = str.match(/^\n?(\t*)/)[1].length;
	  var re = new RegExp(
	    '^\n?' + (tabs ? '\t' : ' ') + '{' + (tabs || spaces) + '}',
	    'gm'
	  );

	  str = str.replace(re, '');

	  return str.trim();
	};

	/**
	 * Parse the given `qs`.
	 *
	 * @private
	 * @param {string} qs
	 * @return {Object}
	 */
	exports.parseQuery = function(qs) {
	  return qs
	    .replace('?', '')
	    .split('&')
	    .reduce(function(obj, pair) {
	      var i = pair.indexOf('=');
	      var key = pair.slice(0, i);
	      var val = pair.slice(++i);

	      // Due to how the URLSearchParams API treats spaces
	      obj[key] = decodeURIComponent(val.replace(/\+/g, '%20'));

	      return obj;
	    }, {});
	};

	/**
	 * Highlight the given string of `js`.
	 *
	 * @private
	 * @param {string} js
	 * @return {string}
	 */
	function highlight(js) {
	  return js
	    .replace(/</g, '&lt;')
	    .replace(/>/g, '&gt;')
	    .replace(/\/\/(.*)/gm, '<span class="comment">//$1</span>')
	    .replace(/('.*?')/gm, '<span class="string">$1</span>')
	    .replace(/(\d+\.\d+)/gm, '<span class="number">$1</span>')
	    .replace(/(\d+)/gm, '<span class="number">$1</span>')
	    .replace(
	      /\bnew[ \t]+(\w+)/gm,
	      '<span class="keyword">new</span> <span class="init">$1</span>'
	    )
	    .replace(
	      /\b(function|new|throw|return|var|if|else)\b/gm,
	      '<span class="keyword">$1</span>'
	    );
	}

	/**
	 * Highlight the contents of tag `name`.
	 *
	 * @private
	 * @param {string} name
	 */
	exports.highlightTags = function(name) {
	  var code = document.getElementById('mocha').getElementsByTagName(name);
	  for (var i = 0, len = code.length; i < len; ++i) {
	    code[i].innerHTML = highlight(code[i].innerHTML);
	  }
	};

	/**
	 * If a value could have properties, and has none, this function is called,
	 * which returns a string representation of the empty value.
	 *
	 * Functions w/ no properties return `'[Function]'`
	 * Arrays w/ length === 0 return `'[]'`
	 * Objects w/ no properties return `'{}'`
	 * All else: return result of `value.toString()`
	 *
	 * @private
	 * @param {*} value The value to inspect.
	 * @param {string} typeHint The type of the value
	 * @returns {string}
	 */
	function emptyRepresentation(value, typeHint) {
	  switch (typeHint) {
	    case 'function':
	      return '[Function]';
	    case 'object':
	      return '{}';
	    case 'array':
	      return '[]';
	    default:
	      return value.toString();
	  }
	}

	/**
	 * Takes some variable and asks `Object.prototype.toString()` what it thinks it
	 * is.
	 *
	 * @private
	 * @see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/toString
	 * @param {*} value The value to test.
	 * @returns {string} Computed type
	 * @example
	 * type({}) // 'object'
	 * type([]) // 'array'
	 * type(1) // 'number'
	 * type(false) // 'boolean'
	 * type(Infinity) // 'number'
	 * type(null) // 'null'
	 * type(new Date()) // 'date'
	 * type(/foo/) // 'regexp'
	 * type('type') // 'string'
	 * type(global) // 'global'
	 * type(new String('foo') // 'object'
	 */
	var type = (exports.type = function type(value) {
	  if (value === undefined) {
	    return 'undefined';
	  } else if (value === null) {
	    return 'null';
	  } else if (Buffer.isBuffer(value)) {
	    return 'buffer';
	  }
	  return Object.prototype.toString
	    .call(value)
	    .replace(/^\[.+\s(.+?)]$/, '$1')
	    .toLowerCase();
	});

	/**
	 * Stringify `value`. Different behavior depending on type of value:
	 *
	 * - If `value` is undefined or null, return `'[undefined]'` or `'[null]'`, respectively.
	 * - If `value` is not an object, function or array, return result of `value.toString()` wrapped in double-quotes.
	 * - If `value` is an *empty* object, function, or array, return result of function
	 *   {@link emptyRepresentation}.
	 * - If `value` has properties, call {@link exports.canonicalize} on it, then return result of
	 *   JSON.stringify().
	 *
	 * @private
	 * @see exports.type
	 * @param {*} value
	 * @return {string}
	 */
	exports.stringify = function(value) {
	  var typeHint = type(value);

	  if (!~['object', 'array', 'function'].indexOf(typeHint)) {
	    if (typeHint === 'buffer') {
	      var json = Buffer.prototype.toJSON.call(value);
	      // Based on the toJSON result
	      return jsonStringify(
	        json.data && json.type ? json.data : json,
	        2
	      ).replace(/,(\n|$)/g, '$1');
	    }

	    // IE7/IE8 has a bizarre String constructor; needs to be coerced
	    // into an array and back to obj.
	    if (typeHint === 'string' && typeof value === 'object') {
	      value = value.split('').reduce(function(acc, char, idx) {
	        acc[idx] = char;
	        return acc;
	      }, {});
	      typeHint = 'object';
	    } else {
	      return jsonStringify(value);
	    }
	  }

	  for (var prop in value) {
	    if (Object.prototype.hasOwnProperty.call(value, prop)) {
	      return jsonStringify(
	        exports.canonicalize(value, null, typeHint),
	        2
	      ).replace(/,(\n|$)/g, '$1');
	    }
	  }

	  return emptyRepresentation(value, typeHint);
	};

	/**
	 * like JSON.stringify but more sense.
	 *
	 * @private
	 * @param {Object}  object
	 * @param {number=} spaces
	 * @param {number=} depth
	 * @returns {*}
	 */
	function jsonStringify(object$$1, spaces, depth) {
	  if (typeof spaces === 'undefined') {
	    // primitive types
	    return _stringify(object$$1);
	  }

	  depth = depth || 1;
	  var space = spaces * depth;
	  var str = Array.isArray(object$$1) ? '[' : '{';
	  var end = Array.isArray(object$$1) ? ']' : '}';
	  var length =
	    typeof object$$1.length === 'number'
	      ? object$$1.length
	      : Object.keys(object$$1).length;
	  // `.repeat()` polyfill
	  function repeat(s, n) {
	    return new Array(n).join(s);
	  }

	  function _stringify(val) {
	    switch (type(val)) {
	      case 'null':
	      case 'undefined':
	        val = '[' + val + ']';
	        break;
	      case 'array':
	      case 'object':
	        val = jsonStringify(val, spaces, depth + 1);
	        break;
	      case 'boolean':
	      case 'regexp':
	      case 'symbol':
	      case 'number':
	        val =
	          val === 0 && 1 / val === -Infinity // `-0`
	            ? '-0'
	            : val.toString();
	        break;
	      case 'date':
	        var sDate = isNaN(val.getTime()) ? val.toString() : val.toISOString();
	        val = '[Date: ' + sDate + ']';
	        break;
	      case 'buffer':
	        var json = val.toJSON();
	        // Based on the toJSON result
	        json = json.data && json.type ? json.data : json;
	        val = '[Buffer: ' + jsonStringify(json, 2, depth + 1) + ']';
	        break;
	      default:
	        val =
	          val === '[Function]' || val === '[Circular]'
	            ? val
	            : JSON.stringify(val); // string
	    }
	    return val;
	  }

	  for (var i in object$$1) {
	    if (!Object.prototype.hasOwnProperty.call(object$$1, i)) {
	      continue; // not my business
	    }
	    --length;
	    str +=
	      '\n ' +
	      repeat(' ', space) +
	      (Array.isArray(object$$1) ? '' : '"' + i + '": ') + // key
	      _stringify(object$$1[i]) + // value
	      (length ? ',' : ''); // comma
	  }

	  return (
	    str +
	    // [], {}
	    (str.length !== 1 ? '\n' + repeat(' ', --space) + end : end)
	  );
	}

	/**
	 * Return a new Thing that has the keys in sorted order. Recursive.
	 *
	 * If the Thing...
	 * - has already been seen, return string `'[Circular]'`
	 * - is `undefined`, return string `'[undefined]'`
	 * - is `null`, return value `null`
	 * - is some other primitive, return the value
	 * - is not a primitive or an `Array`, `Object`, or `Function`, return the value of the Thing's `toString()` method
	 * - is a non-empty `Array`, `Object`, or `Function`, return the result of calling this function again.
	 * - is an empty `Array`, `Object`, or `Function`, return the result of calling `emptyRepresentation()`
	 *
	 * @private
	 * @see {@link exports.stringify}
	 * @param {*} value Thing to inspect.  May or may not have properties.
	 * @param {Array} [stack=[]] Stack of seen values
	 * @param {string} [typeHint] Type hint
	 * @return {(Object|Array|Function|string|undefined)}
	 */
	exports.canonicalize = function canonicalize(value, stack, typeHint) {
	  var canonicalizedObj;
	  /* eslint-disable no-unused-vars */
	  var prop;
	  /* eslint-enable no-unused-vars */
	  typeHint = typeHint || type(value);
	  function withStack(value, fn) {
	    stack.push(value);
	    fn();
	    stack.pop();
	  }

	  stack = stack || [];

	  if (stack.indexOf(value) !== -1) {
	    return '[Circular]';
	  }

	  switch (typeHint) {
	    case 'undefined':
	    case 'buffer':
	    case 'null':
	      canonicalizedObj = value;
	      break;
	    case 'array':
	      withStack(value, function() {
	        canonicalizedObj = value.map(function(item) {
	          return exports.canonicalize(item, stack);
	        });
	      });
	      break;
	    case 'function':
	      /* eslint-disable guard-for-in */
	      for (prop in value) {
	        canonicalizedObj = {};
	        break;
	      }
	      /* eslint-enable guard-for-in */
	      if (!canonicalizedObj) {
	        canonicalizedObj = emptyRepresentation(value, typeHint);
	        break;
	      }
	    /* falls through */
	    case 'object':
	      canonicalizedObj = canonicalizedObj || {};
	      withStack(value, function() {
	        Object.keys(value)
	          .sort()
	          .forEach(function(key) {
	            canonicalizedObj[key] = exports.canonicalize(value[key], stack);
	          });
	      });
	      break;
	    case 'date':
	    case 'number':
	    case 'regexp':
	    case 'boolean':
	    case 'symbol':
	      canonicalizedObj = value;
	      break;
	    default:
	      canonicalizedObj = value + '';
	  }

	  return canonicalizedObj;
	};

	/**
	 * Determines if pathname has a matching file extension.
	 *
	 * @private
	 * @param {string} pathname - Pathname to check for match.
	 * @param {string[]} exts - List of file extensions (sans period).
	 * @return {boolean} whether file extension matches.
	 * @example
	 * hasMatchingExtname('foo.html', ['js', 'css']); // => false
	 */
	function hasMatchingExtname(pathname, exts) {
	  var suffix = path.extname(pathname).slice(1);
	  return exts.some(function(element) {
	    return suffix === element;
	  });
	}

	/**
	 * Determines if pathname would be a "hidden" file (or directory) on UN*X.
	 *
	 * @description
	 * On UN*X, pathnames beginning with a full stop (aka dot) are hidden during
	 * typical usage. Dotfiles, plain-text configuration files, are prime examples.
	 *
	 * @see {@link http://xahlee.info/UnixResource_dir/writ/unix_origin_of_dot_filename.html|Origin of Dot File Names}
	 *
	 * @private
	 * @param {string} pathname - Pathname to check for match.
	 * @return {boolean} whether pathname would be considered a hidden file.
	 * @example
	 * isHiddenOnUnix('.profile'); // => true
	 */
	function isHiddenOnUnix(pathname) {
	  return path.basename(pathname)[0] === '.';
	}

	/**
	 * Lookup file names at the given `path`.
	 *
	 * @description
	 * Filenames are returned in _traversal_ order by the OS/filesystem.
	 * **Make no assumption that the names will be sorted in any fashion.**
	 *
	 * @public
	 * @memberof Mocha.utils
	 * @param {string} filepath - Base path to start searching from.
	 * @param {string[]} [extensions=[]] - File extensions to look for.
	 * @param {boolean} [recursive=false] - Whether to recurse into subdirectories.
	 * @return {string[]} An array of paths.
	 * @throws {Error} if no files match pattern.
	 * @throws {TypeError} if `filepath` is directory and `extensions` not provided.
	 */
	exports.lookupFiles = function lookupFiles(filepath, extensions, recursive) {
	  extensions = extensions || [];
	  recursive = recursive || false;
	  var files = [];
	  var stat;

	  if (!path.existsSync(filepath)) {
	    var pattern;
	    if (path.hasMagic(filepath)) {
	      // Handle glob as is without extensions
	      pattern = filepath;
	    } else {
	      // glob pattern e.g. 'filepath+(.js|.ts)'
	      var strExtensions = extensions
	        .map(function(v) {
	          return '.' + v;
	        })
	        .join('|');
	      pattern = filepath + '+(' + strExtensions + ')';
	    }
	    files = path.sync(pattern, {nodir: true});
	    if (!files.length) {
	      throw createNoFilesMatchPatternError(
	        'Cannot find any files matching pattern ' + exports.dQuote(filepath),
	        filepath
	      );
	    }
	    return files;
	  }

	  // Handle file
	  try {
	    stat = path.statSync(filepath);
	    if (stat.isFile()) {
	      return filepath;
	    }
	  } catch (err) {
	    // ignore error
	    return;
	  }

	  // Handle directory
	  path.readdirSync(filepath).forEach(function(dirent) {
	    var pathname = path.join(filepath, dirent);
	    var stat;

	    try {
	      stat = path.statSync(pathname);
	      if (stat.isDirectory()) {
	        if (recursive) {
	          files = files.concat(lookupFiles(pathname, extensions, recursive));
	        }
	        return;
	      }
	    } catch (err) {
	      // ignore error
	      return;
	    }
	    if (!extensions.length) {
	      throw createMissingArgumentError(
	        util.format(
	          'Argument %s required when argument %s is a directory',
	          exports.sQuote('extensions'),
	          exports.sQuote('filepath')
	        ),
	        'extensions',
	        'array'
	      );
	    }

	    if (
	      !stat.isFile() ||
	      !hasMatchingExtname(pathname, extensions) ||
	      isHiddenOnUnix(pathname)
	    ) {
	      return;
	    }
	    files.push(pathname);
	  });

	  return files;
	};

	/**
	 * process.emitWarning or a polyfill
	 * @see https://nodejs.org/api/process.html#process_process_emitwarning_warning_options
	 * @ignore
	 */
	function emitWarning(msg, type) {
	  if (process.emitWarning) {
	    process.emitWarning(msg, type);
	  } else {
	    process.nextTick(function() {
	      console.warn(type + ': ' + msg);
	    });
	  }
	}

	/**
	 * Show a deprecation warning. Each distinct message is only displayed once.
	 * Ignores empty messages.
	 *
	 * @param {string} [msg] - Warning to print
	 * @private
	 */
	exports.deprecate = function deprecate(msg) {
	  msg = String(msg);
	  if (msg && !deprecate.cache[msg]) {
	    deprecate.cache[msg] = true;
	    emitWarning(msg, 'DeprecationWarning');
	  }
	};
	exports.deprecate.cache = {};

	/**
	 * Show a generic warning.
	 * Ignores empty messages.
	 *
	 * @param {string} [msg] - Warning to print
	 * @private
	 */
	exports.warn = function warn(msg) {
	  if (msg) {
	    emitWarning(msg);
	  }
	};

	/**
	 * @summary
	 * This Filter based on `mocha-clean` module.(see: `github.com/rstacruz/mocha-clean`)
	 * @description
	 * When invoking this function you get a filter function that get the Error.stack as an input,
	 * and return a prettify output.
	 * (i.e: strip Mocha and internal node functions from stack trace).
	 * @returns {Function}
	 */
	exports.stackTraceFilter = function() {
	  // TODO: Replace with `process.browser`
	  var is = typeof document === 'undefined' ? {node: true} : {browser: true};
	  var slash = path.sep;
	  var cwd;
	  if (is.node) {
	    cwd = process.cwd() + slash;
	  } else {
	    cwd = (typeof location === 'undefined'
	      ? window.location
	      : location
	    ).href.replace(/\/[^/]*$/, '/');
	    slash = '/';
	  }

	  function isMochaInternal(line) {
	    return (
	      ~line.indexOf('node_modules' + slash + 'mocha' + slash) ||
	      ~line.indexOf(slash + 'mocha.js') ||
	      ~line.indexOf(slash + 'mocha.min.js')
	    );
	  }

	  function isNodeInternal(line) {
	    return (
	      ~line.indexOf('(timers.js:') ||
	      ~line.indexOf('(events.js:') ||
	      ~line.indexOf('(node.js:') ||
	      ~line.indexOf('(module.js:') ||
	      ~line.indexOf('GeneratorFunctionPrototype.next (native)') ||
	      false
	    );
	  }

	  return function(stack) {
	    stack = stack.split('\n');

	    stack = stack.reduce(function(list, line) {
	      if (isMochaInternal(line)) {
	        return list;
	      }

	      if (is.node && isNodeInternal(line)) {
	        return list;
	      }

	      // Clean up cwd(absolute)
	      if (/:\d+:\d+\)?$/.test(line)) {
	        line = line.replace('(' + cwd, '(');
	      }

	      list.push(line);
	      return list;
	    }, []);

	    return stack.join('\n');
	  };
	};

	/**
	 * Crude, but effective.
	 * @public
	 * @param {*} value
	 * @returns {boolean} Whether or not `value` is a Promise
	 */
	exports.isPromise = function isPromise(value) {
	  return (
	    typeof value === 'object' &&
	    value !== null &&
	    typeof value.then === 'function'
	  );
	};

	/**
	 * Clamps a numeric value to an inclusive range.
	 *
	 * @param {number} value - Value to be clamped.
	 * @param {numer[]} range - Two element array specifying [min, max] range.
	 * @returns {number} clamped value
	 */
	exports.clamp = function clamp(value, range) {
	  return Math.min(Math.max(value, range[0]), range[1]);
	};

	/**
	 * Single quote text by combining with undirectional ASCII quotation marks.
	 *
	 * @description
	 * Provides a simple means of markup for quoting text to be used in output.
	 * Use this to quote names of variables, methods, and packages.
	 *
	 * <samp>package 'foo' cannot be found</samp>
	 *
	 * @private
	 * @param {string} str - Value to be quoted.
	 * @returns {string} quoted value
	 * @example
	 * sQuote('n') // => 'n'
	 */
	exports.sQuote = function(str) {
	  return "'" + str + "'";
	};

	/**
	 * Double quote text by combining with undirectional ASCII quotation marks.
	 *
	 * @description
	 * Provides a simple means of markup for quoting text to be used in output.
	 * Use this to quote names of datatypes, classes, pathnames, and strings.
	 *
	 * <samp>argument 'value' must be "string" or "number"</samp>
	 *
	 * @private
	 * @param {string} str - Value to be quoted.
	 * @returns {string} quoted value
	 * @example
	 * dQuote('number') // => "number"
	 */
	exports.dQuote = function(str) {
	  return '"' + str + '"';
	};

	/**
	 * Provides simplistic message translation for dealing with plurality.
	 *
	 * @description
	 * Use this to create messages which need to be singular or plural.
	 * Some languages have several plural forms, so _complete_ message clauses
	 * are preferable to generating the message on the fly.
	 *
	 * @private
	 * @param {number} n - Non-negative integer
	 * @param {string} msg1 - Message to be used in English for `n = 1`
	 * @param {string} msg2 - Message to be used in English for `n = 0, 2, 3, ...`
	 * @returns {string} message corresponding to value of `n`
	 * @example
	 * var sprintf = require('util').format;
	 * var pkgs = ['one', 'two'];
	 * var msg = sprintf(
	 *   ngettext(
	 *     pkgs.length,
	 *     'cannot load package: %s',
	 *     'cannot load packages: %s'
	 *   ),
	 *   pkgs.map(sQuote).join(', ')
	 * );
	 * console.log(msg); // => cannot load packages: 'one', 'two'
	 */
	exports.ngettext = function(n, msg1, msg2) {
	  if (typeof n === 'number' && n >= 0) {
	    return n === 1 ? msg1 : msg2;
	  }
	};

	/**
	 * It's a noop.
	 * @public
	 */
	exports.noop = function() {};

	/**
	 * Creates a map-like object.
	 *
	 * @description
	 * A "map" is an object with no prototype, for our purposes. In some cases
	 * this would be more appropriate than a `Map`, especially if your environment
	 * doesn't support it. Recommended for use in Mocha's public APIs.
	 *
	 * @public
	 * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map|MDN:Map}
	 * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/create#Custom_and_Null_objects|MDN:Object.create - Custom objects}
	 * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/assign|MDN:Object.assign}
	 * @param {...*} [obj] - Arguments to `Object.assign()`.
	 * @returns {Object} An object with no prototype, having `...obj` properties
	 */
	exports.createMap = function(obj) {
	  return assign.apply(
	    null,
	    [Object.create(null)].concat(Array.prototype.slice.call(arguments))
	  );
	};

	/**
	 * Creates a read-only map-like object.
	 *
	 * @description
	 * This differs from {@link module:utils.createMap createMap} only in that
	 * the argument must be non-empty, because the result is frozen.
	 *
	 * @see {@link module:utils.createMap createMap}
	 * @param {...*} [obj] - Arguments to `Object.assign()`.
	 * @returns {Object} A frozen object with no prototype, having `...obj` properties
	 * @throws {TypeError} if argument is not a non-empty object.
	 */
	exports.defineConstants = function(obj) {
	  if (type(obj) !== 'object' || !Object.keys(obj).length) {
	    throw new TypeError('Invalid argument; expected a non-empty object');
	  }
	  return Object.freeze(exports.createMap(obj));
	};
	});
	var utils_1 = utils.assign;
	var utils_2 = utils.inherits;
	var utils_3 = utils.escape;
	var utils_4 = utils.isString;
	var utils_5 = utils.watch;
	var utils_6 = utils.files;
	var utils_7 = utils.slug;
	var utils_8 = utils.clean;
	var utils_9 = utils.parseQuery;
	var utils_10 = utils.highlightTags;
	var utils_11 = utils.type;
	var utils_12 = utils.stringify;
	var utils_13 = utils.canonicalize;
	var utils_14 = utils.lookupFiles;
	var utils_15 = utils.deprecate;
	var utils_16 = utils.warn;
	var utils_17 = utils.stackTraceFilter;
	var utils_18 = utils.isPromise;
	var utils_19 = utils.clamp;
	var utils_20 = utils.sQuote;
	var utils_21 = utils.dQuote;
	var utils_22 = utils.ngettext;
	var utils_23 = utils.noop;
	var utils_24 = utils.createMap;
	var utils_25 = utils.defineConstants;

	var pending = Pending;

	/**
	 * Initialize a new `Pending` error with the given message.
	 *
	 * @param {string} message
	 */
	function Pending(message) {
	  this.message = message;
	}

	var EventEmitter = events.EventEmitter;

	var debug$1 = debug('mocha:runnable');


	var createInvalidExceptionError$1 = errors
	  .createInvalidExceptionError;

	/**
	 * Save timer references to avoid Sinon interfering (see GH-237).
	 */
	var Date = commonjsGlobal.Date;
	var setTimeout$1 = commonjsGlobal.setTimeout;
	var clearTimeout = commonjsGlobal.clearTimeout;
	var toString = Object.prototype.toString;

	var runnable = Runnable;

	/**
	 * Initialize a new `Runnable` with the given `title` and callback `fn`.
	 *
	 * @class
	 * @extends external:EventEmitter
	 * @public
	 * @param {String} title
	 * @param {Function} fn
	 */
	function Runnable(title, fn) {
	  this.title = title;
	  this.fn = fn;
	  this.body = (fn || '').toString();
	  this.async = fn && fn.length;
	  this.sync = !this.async;
	  this._timeout = 2000;
	  this._slow = 75;
	  this._enableTimeouts = true;
	  this.timedOut = false;
	  this._retries = -1;
	  this._currentRetry = 0;
	  this.pending = false;
	}

	/**
	 * Inherit from `EventEmitter.prototype`.
	 */
	utils.inherits(Runnable, EventEmitter);

	/**
	 * Get current timeout value in msecs.
	 *
	 * @private
	 * @returns {number} current timeout threshold value
	 */
	/**
	 * @summary
	 * Set timeout threshold value (msecs).
	 *
	 * @description
	 * A string argument can use shorthand (e.g., "2s") and will be converted.
	 * The value will be clamped to range [<code>0</code>, <code>2^<sup>31</sup>-1</code>].
	 * If clamped value matches either range endpoint, timeouts will be disabled.
	 *
	 * @private
	 * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/WindowOrWorkerGlobalScope/setTimeout#Maximum_delay_value}
	 * @param {number|string} ms - Timeout threshold value.
	 * @returns {Runnable} this
	 * @chainable
	 */
	Runnable.prototype.timeout = function(ms$$1) {
	  if (!arguments.length) {
	    return this._timeout;
	  }
	  if (typeof ms$$1 === 'string') {
	    ms$$1 = ms(ms$$1);
	  }

	  // Clamp to range
	  var INT_MAX = Math.pow(2, 31) - 1;
	  var range = [0, INT_MAX];
	  ms$$1 = utils.clamp(ms$$1, range);

	  // see #1652 for reasoning
	  if (ms$$1 === range[0] || ms$$1 === range[1]) {
	    this._enableTimeouts = false;
	  }
	  debug$1('timeout %d', ms$$1);
	  this._timeout = ms$$1;
	  if (this.timer) {
	    this.resetTimeout();
	  }
	  return this;
	};

	/**
	 * Set or get slow `ms`.
	 *
	 * @private
	 * @param {number|string} ms
	 * @return {Runnable|number} ms or Runnable instance.
	 */
	Runnable.prototype.slow = function(ms$$1) {
	  if (!arguments.length || typeof ms$$1 === 'undefined') {
	    return this._slow;
	  }
	  if (typeof ms$$1 === 'string') {
	    ms$$1 = ms(ms$$1);
	  }
	  debug$1('slow %d', ms$$1);
	  this._slow = ms$$1;
	  return this;
	};

	/**
	 * Set and get whether timeout is `enabled`.
	 *
	 * @private
	 * @param {boolean} enabled
	 * @return {Runnable|boolean} enabled or Runnable instance.
	 */
	Runnable.prototype.enableTimeouts = function(enabled) {
	  if (!arguments.length) {
	    return this._enableTimeouts;
	  }
	  debug$1('enableTimeouts %s', enabled);
	  this._enableTimeouts = enabled;
	  return this;
	};

	/**
	 * Halt and mark as pending.
	 *
	 * @memberof Mocha.Runnable
	 * @public
	 */
	Runnable.prototype.skip = function() {
	  throw new pending('sync skip');
	};

	/**
	 * Check if this runnable or its parent suite is marked as pending.
	 *
	 * @private
	 */
	Runnable.prototype.isPending = function() {
	  return this.pending || (this.parent && this.parent.isPending());
	};

	/**
	 * Return `true` if this Runnable has failed.
	 * @return {boolean}
	 * @private
	 */
	Runnable.prototype.isFailed = function() {
	  return !this.isPending() && this.state === constants.STATE_FAILED;
	};

	/**
	 * Return `true` if this Runnable has passed.
	 * @return {boolean}
	 * @private
	 */
	Runnable.prototype.isPassed = function() {
	  return !this.isPending() && this.state === constants.STATE_PASSED;
	};

	/**
	 * Set or get number of retries.
	 *
	 * @private
	 */
	Runnable.prototype.retries = function(n) {
	  if (!arguments.length) {
	    return this._retries;
	  }
	  this._retries = n;
	};

	/**
	 * Set or get current retry
	 *
	 * @private
	 */
	Runnable.prototype.currentRetry = function(n) {
	  if (!arguments.length) {
	    return this._currentRetry;
	  }
	  this._currentRetry = n;
	};

	/**
	 * Return the full title generated by recursively concatenating the parent's
	 * full title.
	 *
	 * @memberof Mocha.Runnable
	 * @public
	 * @return {string}
	 */
	Runnable.prototype.fullTitle = function() {
	  return this.titlePath().join(' ');
	};

	/**
	 * Return the title path generated by concatenating the parent's title path with the title.
	 *
	 * @memberof Mocha.Runnable
	 * @public
	 * @return {string}
	 */
	Runnable.prototype.titlePath = function() {
	  return this.parent.titlePath().concat([this.title]);
	};

	/**
	 * Clear the timeout.
	 *
	 * @private
	 */
	Runnable.prototype.clearTimeout = function() {
	  clearTimeout(this.timer);
	};

	/**
	 * Inspect the runnable void of private properties.
	 *
	 * @private
	 * @return {string}
	 */
	Runnable.prototype.inspect = function() {
	  return JSON.stringify(
	    this,
	    function(key, val) {
	      if (key[0] === '_') {
	        return;
	      }
	      if (key === 'parent') {
	        return '#<Suite>';
	      }
	      if (key === 'ctx') {
	        return '#<Context>';
	      }
	      return val;
	    },
	    2
	  );
	};

	/**
	 * Reset the timeout.
	 *
	 * @private
	 */
	Runnable.prototype.resetTimeout = function() {
	  var self = this;
	  var ms$$1 = this.timeout() || 1e9;

	  if (!this._enableTimeouts) {
	    return;
	  }
	  this.clearTimeout();
	  this.timer = setTimeout$1(function() {
	    if (!self._enableTimeouts) {
	      return;
	    }
	    self.callback(self._timeoutError(ms$$1));
	    self.timedOut = true;
	  }, ms$$1);
	};

	/**
	 * Set or get a list of whitelisted globals for this test run.
	 *
	 * @private
	 * @param {string[]} globals
	 */
	Runnable.prototype.globals = function(globals) {
	  if (!arguments.length) {
	    return this._allowedGlobals;
	  }
	  this._allowedGlobals = globals;
	};

	/**
	 * Run the test and invoke `fn(err)`.
	 *
	 * @param {Function} fn
	 * @private
	 */
	Runnable.prototype.run = function(fn) {
	  var self = this;
	  var start = new Date();
	  var ctx = this.ctx;
	  var finished;
	  var emitted;

	  // Sometimes the ctx exists, but it is not runnable
	  if (ctx && ctx.runnable) {
	    ctx.runnable(this);
	  }

	  // called multiple times
	  function multiple(err) {
	    if (emitted) {
	      return;
	    }
	    emitted = true;
	    var msg = 'done() called multiple times';
	    if (err && err.message) {
	      err.message += " (and Mocha's " + msg + ')';
	      self.emit('error', err);
	    } else {
	      self.emit('error', new Error(msg));
	    }
	  }

	  // finished
	  function done(err) {
	    var ms$$1 = self.timeout();
	    if (self.timedOut) {
	      return;
	    }

	    if (finished) {
	      return multiple(err);
	    }

	    self.clearTimeout();
	    self.duration = new Date() - start;
	    finished = true;
	    if (!err && self.duration > ms$$1 && self._enableTimeouts) {
	      err = self._timeoutError(ms$$1);
	    }
	    fn(err);
	  }

	  // for .resetTimeout()
	  this.callback = done;

	  // explicit async with `done` argument
	  if (this.async) {
	    this.resetTimeout();

	    // allows skip() to be used in an explicit async context
	    this.skip = function asyncSkip() {
	      done(new pending('async skip call'));
	      // halt execution.  the Runnable will be marked pending
	      // by the previous call, and the uncaught handler will ignore
	      // the failure.
	      throw new pending('async skip; aborting execution');
	    };

	    if (this.allowUncaught) {
	      return callFnAsync(this.fn);
	    }
	    try {
	      callFnAsync(this.fn);
	    } catch (err) {
	      emitted = true;
	      done(Runnable.toValueOrError(err));
	    }
	    return;
	  }

	  if (this.allowUncaught) {
	    if (this.isPending()) {
	      done();
	    } else {
	      callFn(this.fn);
	    }
	    return;
	  }

	  // sync or promise-returning
	  try {
	    if (this.isPending()) {
	      done();
	    } else {
	      callFn(this.fn);
	    }
	  } catch (err) {
	    emitted = true;
	    done(Runnable.toValueOrError(err));
	  }

	  function callFn(fn) {
	    var result = fn.call(ctx);
	    if (result && typeof result.then === 'function') {
	      self.resetTimeout();
	      result.then(
	        function() {
	          done();
	          // Return null so libraries like bluebird do not warn about
	          // subsequently constructed Promises.
	          return null;
	        },
	        function(reason) {
	          done(reason || new Error('Promise rejected with no or falsy reason'));
	        }
	      );
	    } else {
	      if (self.asyncOnly) {
	        return done(
	          new Error(
	            '--async-only option in use without declaring `done()` or returning a promise'
	          )
	        );
	      }

	      done();
	    }
	  }

	  function callFnAsync(fn) {
	    var result = fn.call(ctx, function(err) {
	      if (err instanceof Error || toString.call(err) === '[object Error]') {
	        return done(err);
	      }
	      if (err) {
	        if (Object.prototype.toString.call(err) === '[object Object]') {
	          return done(
	            new Error('done() invoked with non-Error: ' + JSON.stringify(err))
	          );
	        }
	        return done(new Error('done() invoked with non-Error: ' + err));
	      }
	      if (result && utils.isPromise(result)) {
	        return done(
	          new Error(
	            'Resolution method is overspecified. Specify a callback *or* return a Promise; not both.'
	          )
	        );
	      }

	      done();
	    });
	  }
	};

	/**
	 * Instantiates a "timeout" error
	 *
	 * @param {number} ms - Timeout (in milliseconds)
	 * @returns {Error} a "timeout" error
	 * @private
	 */
	Runnable.prototype._timeoutError = function(ms$$1) {
	  var msg =
	    'Timeout of ' +
	    ms$$1 +
	    'ms exceeded. For async tests and hooks, ensure "done()" is called; if returning a Promise, ensure it resolves.';
	  if (this.file) {
	    msg += ' (' + this.file + ')';
	  }
	  return new Error(msg);
	};

	var constants = utils.defineConstants(
	  /**
	   * {@link Runnable}-related constants.
	   * @public
	   * @memberof Runnable
	   * @readonly
	   * @static
	   * @alias constants
	   * @enum {string}
	   */
	  {
	    /**
	     * Value of `state` prop when a `Runnable` has failed
	     */
	    STATE_FAILED: 'failed',
	    /**
	     * Value of `state` prop when a `Runnable` has passed
	     */
	    STATE_PASSED: 'passed'
	  }
	);

	/**
	 * Given `value`, return identity if truthy, otherwise create an "invalid exception" error and return that.
	 * @param {*} [value] - Value to return, if present
	 * @returns {*|Error} `value`, otherwise an `Error`
	 * @private
	 */
	Runnable.toValueOrError = function(value) {
	  return (
	    value ||
	    createInvalidExceptionError$1(
	      'Runnable failed with falsy or undefined exception. Please throw an Error instead.',
	      value
	    )
	  );
	};

	Runnable.constants = constants;

	var inherits$1 = utils.inherits;

	/**
	 * Expose `Hook`.
	 */

	var hook = Hook;

	/**
	 * Initialize a new `Hook` with the given `title` and callback `fn`
	 *
	 * @class
	 * @extends Runnable
	 * @param {String} title
	 * @param {Function} fn
	 */
	function Hook(title, fn) {
	  runnable.call(this, title, fn);
	  this.type = 'hook';
	}

	/**
	 * Inherit from `Runnable.prototype`.
	 */
	inherits$1(Hook, runnable);

	/**
	 * Get or set the test `err`.
	 *
	 * @memberof Hook
	 * @public
	 * @param {Error} err
	 * @return {Error}
	 */
	Hook.prototype.error = function(err) {
	  if (!arguments.length) {
	    err = this._error;
	    this._error = null;
	    return err;
	  }

	  this._error = err;
	};

	var suite = createCommonjsModule(function (module, exports) {

	/**
	 * Module dependencies.
	 */
	var EventEmitter = events.EventEmitter;


	var inherits = utils.inherits;
	var debug$$1 = debug('mocha:suite');


	var createInvalidArgumentTypeError = errors.createInvalidArgumentTypeError;

	/**
	 * Expose `Suite`.
	 */

	exports = module.exports = Suite;

	/**
	 * Create a new `Suite` with the given `title` and parent `Suite`.
	 *
	 * @public
	 * @param {Suite} parent - Parent suite (required!)
	 * @param {string} title - Title
	 * @return {Suite}
	 */
	Suite.create = function(parent, title) {
	  var suite = new Suite(title, parent.ctx);
	  suite.parent = parent;
	  title = suite.fullTitle();
	  parent.addSuite(suite);
	  return suite;
	};

	/**
	 * Constructs a new `Suite` instance with the given `title`, `ctx`, and `isRoot`.
	 *
	 * @public
	 * @class
	 * @extends EventEmitter
	 * @see {@link https://nodejs.org/api/events.html#events_class_eventemitter|EventEmitter}
	 * @param {string} title - Suite title.
	 * @param {Context} parentContext - Parent context instance.
	 * @param {boolean} [isRoot=false] - Whether this is the root suite.
	 */
	function Suite(title, parentContext, isRoot) {
	  if (!utils.isString(title)) {
	    throw createInvalidArgumentTypeError(
	      'Suite argument "title" must be a string. Received type "' +
	        typeof title +
	        '"',
	      'title',
	      'string'
	    );
	  }
	  this.title = title;
	  function Context() {}
	  Context.prototype = parentContext;
	  this.ctx = new Context();
	  this.suites = [];
	  this.tests = [];
	  this.pending = false;
	  this._beforeEach = [];
	  this._beforeAll = [];
	  this._afterEach = [];
	  this._afterAll = [];
	  this.root = isRoot === true;
	  this._timeout = 2000;
	  this._enableTimeouts = true;
	  this._slow = 75;
	  this._bail = false;
	  this._retries = -1;
	  this._onlyTests = [];
	  this._onlySuites = [];
	  this.delayed = false;

	  this.on('newListener', function(event) {
	    if (deprecatedEvents[event]) {
	      utils.deprecate(
	        'Event "' +
	          event +
	          '" is deprecated.  Please let the Mocha team know about your use case: https://git.io/v6Lwm'
	      );
	    }
	  });
	}

	/**
	 * Inherit from `EventEmitter.prototype`.
	 */
	inherits(Suite, EventEmitter);

	/**
	 * Return a clone of this `Suite`.
	 *
	 * @private
	 * @return {Suite}
	 */
	Suite.prototype.clone = function() {
	  var suite = new Suite(this.title);
	  debug$$1('clone');
	  suite.ctx = this.ctx;
	  suite.root = this.root;
	  suite.timeout(this.timeout());
	  suite.retries(this.retries());
	  suite.enableTimeouts(this.enableTimeouts());
	  suite.slow(this.slow());
	  suite.bail(this.bail());
	  return suite;
	};

	/**
	 * Set or get timeout `ms` or short-hand such as "2s".
	 *
	 * @private
	 * @todo Do not attempt to set value if `ms` is undefined
	 * @param {number|string} ms
	 * @return {Suite|number} for chaining
	 */
	Suite.prototype.timeout = function(ms$$1) {
	  if (!arguments.length) {
	    return this._timeout;
	  }
	  if (ms$$1.toString() === '0') {
	    this._enableTimeouts = false;
	  }
	  if (typeof ms$$1 === 'string') {
	    ms$$1 = ms(ms$$1);
	  }
	  debug$$1('timeout %d', ms$$1);
	  this._timeout = parseInt(ms$$1, 10);
	  return this;
	};

	/**
	 * Set or get number of times to retry a failed test.
	 *
	 * @private
	 * @param {number|string} n
	 * @return {Suite|number} for chaining
	 */
	Suite.prototype.retries = function(n) {
	  if (!arguments.length) {
	    return this._retries;
	  }
	  debug$$1('retries %d', n);
	  this._retries = parseInt(n, 10) || 0;
	  return this;
	};

	/**
	 * Set or get timeout to `enabled`.
	 *
	 * @private
	 * @param {boolean} enabled
	 * @return {Suite|boolean} self or enabled
	 */
	Suite.prototype.enableTimeouts = function(enabled) {
	  if (!arguments.length) {
	    return this._enableTimeouts;
	  }
	  debug$$1('enableTimeouts %s', enabled);
	  this._enableTimeouts = enabled;
	  return this;
	};

	/**
	 * Set or get slow `ms` or short-hand such as "2s".
	 *
	 * @private
	 * @param {number|string} ms
	 * @return {Suite|number} for chaining
	 */
	Suite.prototype.slow = function(ms$$1) {
	  if (!arguments.length) {
	    return this._slow;
	  }
	  if (typeof ms$$1 === 'string') {
	    ms$$1 = ms(ms$$1);
	  }
	  debug$$1('slow %d', ms$$1);
	  this._slow = ms$$1;
	  return this;
	};

	/**
	 * Set or get whether to bail after first error.
	 *
	 * @private
	 * @param {boolean} bail
	 * @return {Suite|number} for chaining
	 */
	Suite.prototype.bail = function(bail) {
	  if (!arguments.length) {
	    return this._bail;
	  }
	  debug$$1('bail %s', bail);
	  this._bail = bail;
	  return this;
	};

	/**
	 * Check if this suite or its parent suite is marked as pending.
	 *
	 * @private
	 */
	Suite.prototype.isPending = function() {
	  return this.pending || (this.parent && this.parent.isPending());
	};

	/**
	 * Generic hook-creator.
	 * @private
	 * @param {string} title - Title of hook
	 * @param {Function} fn - Hook callback
	 * @returns {Hook} A new hook
	 */
	Suite.prototype._createHook = function(title, fn) {
	  var hook$$1 = new hook(title, fn);
	  hook$$1.parent = this;
	  hook$$1.timeout(this.timeout());
	  hook$$1.retries(this.retries());
	  hook$$1.enableTimeouts(this.enableTimeouts());
	  hook$$1.slow(this.slow());
	  hook$$1.ctx = this.ctx;
	  hook$$1.file = this.file;
	  return hook$$1;
	};

	/**
	 * Run `fn(test[, done])` before running tests.
	 *
	 * @private
	 * @param {string} title
	 * @param {Function} fn
	 * @return {Suite} for chaining
	 */
	Suite.prototype.beforeAll = function(title, fn) {
	  if (this.isPending()) {
	    return this;
	  }
	  if (typeof title === 'function') {
	    fn = title;
	    title = fn.name;
	  }
	  title = '"before all" hook' + (title ? ': ' + title : '');

	  var hook$$1 = this._createHook(title, fn);
	  this._beforeAll.push(hook$$1);
	  this.emit(constants.EVENT_SUITE_ADD_HOOK_BEFORE_ALL, hook$$1);
	  return this;
	};

	/**
	 * Run `fn(test[, done])` after running tests.
	 *
	 * @private
	 * @param {string} title
	 * @param {Function} fn
	 * @return {Suite} for chaining
	 */
	Suite.prototype.afterAll = function(title, fn) {
	  if (this.isPending()) {
	    return this;
	  }
	  if (typeof title === 'function') {
	    fn = title;
	    title = fn.name;
	  }
	  title = '"after all" hook' + (title ? ': ' + title : '');

	  var hook$$1 = this._createHook(title, fn);
	  this._afterAll.push(hook$$1);
	  this.emit(constants.EVENT_SUITE_ADD_HOOK_AFTER_ALL, hook$$1);
	  return this;
	};

	/**
	 * Run `fn(test[, done])` before each test case.
	 *
	 * @private
	 * @param {string} title
	 * @param {Function} fn
	 * @return {Suite} for chaining
	 */
	Suite.prototype.beforeEach = function(title, fn) {
	  if (this.isPending()) {
	    return this;
	  }
	  if (typeof title === 'function') {
	    fn = title;
	    title = fn.name;
	  }
	  title = '"before each" hook' + (title ? ': ' + title : '');

	  var hook$$1 = this._createHook(title, fn);
	  this._beforeEach.push(hook$$1);
	  this.emit(constants.EVENT_SUITE_ADD_HOOK_BEFORE_EACH, hook$$1);
	  return this;
	};

	/**
	 * Run `fn(test[, done])` after each test case.
	 *
	 * @private
	 * @param {string} title
	 * @param {Function} fn
	 * @return {Suite} for chaining
	 */
	Suite.prototype.afterEach = function(title, fn) {
	  if (this.isPending()) {
	    return this;
	  }
	  if (typeof title === 'function') {
	    fn = title;
	    title = fn.name;
	  }
	  title = '"after each" hook' + (title ? ': ' + title : '');

	  var hook$$1 = this._createHook(title, fn);
	  this._afterEach.push(hook$$1);
	  this.emit(constants.EVENT_SUITE_ADD_HOOK_AFTER_EACH, hook$$1);
	  return this;
	};

	/**
	 * Add a test `suite`.
	 *
	 * @private
	 * @param {Suite} suite
	 * @return {Suite} for chaining
	 */
	Suite.prototype.addSuite = function(suite) {
	  suite.parent = this;
	  suite.root = false;
	  suite.timeout(this.timeout());
	  suite.retries(this.retries());
	  suite.enableTimeouts(this.enableTimeouts());
	  suite.slow(this.slow());
	  suite.bail(this.bail());
	  this.suites.push(suite);
	  this.emit(constants.EVENT_SUITE_ADD_SUITE, suite);
	  return this;
	};

	/**
	 * Add a `test` to this suite.
	 *
	 * @private
	 * @param {Test} test
	 * @return {Suite} for chaining
	 */
	Suite.prototype.addTest = function(test) {
	  test.parent = this;
	  test.timeout(this.timeout());
	  test.retries(this.retries());
	  test.enableTimeouts(this.enableTimeouts());
	  test.slow(this.slow());
	  test.ctx = this.ctx;
	  this.tests.push(test);
	  this.emit(constants.EVENT_SUITE_ADD_TEST, test);
	  return this;
	};

	/**
	 * Return the full title generated by recursively concatenating the parent's
	 * full title.
	 *
	 * @memberof Suite
	 * @public
	 * @return {string}
	 */
	Suite.prototype.fullTitle = function() {
	  return this.titlePath().join(' ');
	};

	/**
	 * Return the title path generated by recursively concatenating the parent's
	 * title path.
	 *
	 * @memberof Suite
	 * @public
	 * @return {string}
	 */
	Suite.prototype.titlePath = function() {
	  var result = [];
	  if (this.parent) {
	    result = result.concat(this.parent.titlePath());
	  }
	  if (!this.root) {
	    result.push(this.title);
	  }
	  return result;
	};

	/**
	 * Return the total number of tests.
	 *
	 * @memberof Suite
	 * @public
	 * @return {number}
	 */
	Suite.prototype.total = function() {
	  return (
	    this.suites.reduce(function(sum, suite) {
	      return sum + suite.total();
	    }, 0) + this.tests.length
	  );
	};

	/**
	 * Iterates through each suite recursively to find all tests. Applies a
	 * function in the format `fn(test)`.
	 *
	 * @private
	 * @param {Function} fn
	 * @return {Suite}
	 */
	Suite.prototype.eachTest = function(fn) {
	  this.tests.forEach(fn);
	  this.suites.forEach(function(suite) {
	    suite.eachTest(fn);
	  });
	  return this;
	};

	/**
	 * This will run the root suite if we happen to be running in delayed mode.
	 * @private
	 */
	Suite.prototype.run = function run() {
	  if (this.root) {
	    this.emit(constants.EVENT_ROOT_SUITE_RUN);
	  }
	};

	/**
	 * Determines whether a suite has an `only` test or suite as a descendant.
	 *
	 * @private
	 * @returns {Boolean}
	 */
	Suite.prototype.hasOnly = function hasOnly() {
	  return (
	    this._onlyTests.length > 0 ||
	    this._onlySuites.length > 0 ||
	    this.suites.some(function(suite) {
	      return suite.hasOnly();
	    })
	  );
	};

	/**
	 * Filter suites based on `isOnly` logic.
	 *
	 * @private
	 * @returns {Boolean}
	 */
	Suite.prototype.filterOnly = function filterOnly() {
	  if (this._onlyTests.length) {
	    // If the suite contains `only` tests, run those and ignore any nested suites.
	    this.tests = this._onlyTests;
	    this.suites = [];
	  } else {
	    // Otherwise, do not run any of the tests in this suite.
	    this.tests = [];
	    this._onlySuites.forEach(function(onlySuite) {
	      // If there are other `only` tests/suites nested in the current `only` suite, then filter that `only` suite.
	      // Otherwise, all of the tests on this `only` suite should be run, so don't filter it.
	      if (onlySuite.hasOnly()) {
	        onlySuite.filterOnly();
	      }
	    });
	    // Run the `only` suites, as well as any other suites that have `only` tests/suites as descendants.
	    var onlySuites = this._onlySuites;
	    this.suites = this.suites.filter(function(childSuite) {
	      return onlySuites.indexOf(childSuite) !== -1 || childSuite.filterOnly();
	    });
	  }
	  // Keep the suite only if there is something to run
	  return this.tests.length > 0 || this.suites.length > 0;
	};

	/**
	 * Adds a suite to the list of subsuites marked `only`.
	 *
	 * @private
	 * @param {Suite} suite
	 */
	Suite.prototype.appendOnlySuite = function(suite) {
	  this._onlySuites.push(suite);
	};

	/**
	 * Adds a test to the list of tests marked `only`.
	 *
	 * @private
	 * @param {Test} test
	 */
	Suite.prototype.appendOnlyTest = function(test) {
	  this._onlyTests.push(test);
	};

	/**
	 * Returns the array of hooks by hook name; see `HOOK_TYPE_*` constants.
	 * @private
	 */
	Suite.prototype.getHooks = function getHooks(name) {
	  return this['_' + name];
	};

	/**
	 * Cleans up the references to all the deferred functions
	 * (before/after/beforeEach/afterEach) and tests of a Suite.
	 * These must be deleted otherwise a memory leak can happen,
	 * as those functions may reference variables from closures,
	 * thus those variables can never be garbage collected as long
	 * as the deferred functions exist.
	 *
	 * @private
	 */
	Suite.prototype.cleanReferences = function cleanReferences() {
	  var this$1 = this;

	  function cleanArrReferences(arr) {
	    for (var i = 0; i < arr.length; i++) {
	      delete arr[i].fn;
	    }
	  }

	  if (Array.isArray(this._beforeAll)) {
	    cleanArrReferences(this._beforeAll);
	  }

	  if (Array.isArray(this._beforeEach)) {
	    cleanArrReferences(this._beforeEach);
	  }

	  if (Array.isArray(this._afterAll)) {
	    cleanArrReferences(this._afterAll);
	  }

	  if (Array.isArray(this._afterEach)) {
	    cleanArrReferences(this._afterEach);
	  }

	  for (var i = 0; i < this.tests.length; i++) {
	    delete this$1.tests[i].fn;
	  }
	};

	var constants = utils.defineConstants(
	  /**
	   * {@link Suite}-related constants.
	   * @public
	   * @memberof Suite
	   * @alias constants
	   * @readonly
	   * @static
	   * @enum {string}
	   */
	  {
	    /**
	     * Event emitted after a test file has been loaded Not emitted in browser.
	     */
	    EVENT_FILE_POST_REQUIRE: 'post-require',
	    /**
	     * Event emitted before a test file has been loaded. In browser, this is emitted once an interface has been selected.
	     */
	    EVENT_FILE_PRE_REQUIRE: 'pre-require',
	    /**
	     * Event emitted immediately after a test file has been loaded. Not emitted in browser.
	     */
	    EVENT_FILE_REQUIRE: 'require',
	    /**
	     * Event emitted when `global.run()` is called (use with `delay` option)
	     */
	    EVENT_ROOT_SUITE_RUN: 'run',

	    /**
	     * Namespace for collection of a `Suite`'s "after all" hooks
	     */
	    HOOK_TYPE_AFTER_ALL: 'afterAll',
	    /**
	     * Namespace for collection of a `Suite`'s "after each" hooks
	     */
	    HOOK_TYPE_AFTER_EACH: 'afterEach',
	    /**
	     * Namespace for collection of a `Suite`'s "before all" hooks
	     */
	    HOOK_TYPE_BEFORE_ALL: 'beforeAll',
	    /**
	     * Namespace for collection of a `Suite`'s "before all" hooks
	     */
	    HOOK_TYPE_BEFORE_EACH: 'beforeEach',

	    // the following events are all deprecated

	    /**
	     * Emitted after an "after all" `Hook` has been added to a `Suite`. Deprecated
	     */
	    EVENT_SUITE_ADD_HOOK_AFTER_ALL: 'afterAll',
	    /**
	     * Emitted after an "after each" `Hook` has been added to a `Suite` Deprecated
	     */
	    EVENT_SUITE_ADD_HOOK_AFTER_EACH: 'afterEach',
	    /**
	     * Emitted after an "before all" `Hook` has been added to a `Suite` Deprecated
	     */
	    EVENT_SUITE_ADD_HOOK_BEFORE_ALL: 'beforeAll',
	    /**
	     * Emitted after an "before each" `Hook` has been added to a `Suite` Deprecated
	     */
	    EVENT_SUITE_ADD_HOOK_BEFORE_EACH: 'beforeEach',
	    /**
	     * Emitted after a child `Suite` has been added to a `Suite`. Deprecated
	     */
	    EVENT_SUITE_ADD_SUITE: 'suite',
	    /**
	     * Emitted after a `Test` has been added to a `Suite`. Deprecated
	     */
	    EVENT_SUITE_ADD_TEST: 'test'
	  }
	);

	/**
	 * @summary There are no known use cases for these events.
	 * @desc This is a `Set`-like object having all keys being the constant's string value and the value being `true`.
	 * @todo Remove eventually
	 * @type {Object<string,boolean>}
	 * @ignore
	 */
	var deprecatedEvents = Object.keys(constants)
	  .filter(function(constant) {
	    return constant.substring(0, 15) === 'EVENT_SUITE_ADD';
	  })
	  .reduce(function(acc, constant) {
	    acc[constants[constant]] = true;
	    return acc;
	  }, utils.createMap());

	Suite.constants = constants;
	});

	/**
	 * Module dependencies.
	 */

	var EventEmitter$1 = events.EventEmitter;


	var inherits$2 = utils.inherits;
	var debug$2 = debug('mocha:runner');


	var HOOK_TYPE_BEFORE_EACH = suite.constants.HOOK_TYPE_BEFORE_EACH;
	var HOOK_TYPE_AFTER_EACH = suite.constants.HOOK_TYPE_AFTER_EACH;
	var HOOK_TYPE_AFTER_ALL = suite.constants.HOOK_TYPE_AFTER_ALL;
	var HOOK_TYPE_BEFORE_ALL = suite.constants.HOOK_TYPE_BEFORE_ALL;
	var EVENT_ROOT_SUITE_RUN = suite.constants.EVENT_ROOT_SUITE_RUN;
	var STATE_FAILED = runnable.constants.STATE_FAILED;
	var STATE_PASSED = runnable.constants.STATE_PASSED;
	var dQuote = utils.dQuote;
	var ngettext = utils.ngettext;
	var sQuote = utils.sQuote;
	var stackFilter = utils.stackTraceFilter();
	var stringify = utils.stringify;
	var type = utils.type;
	var createInvalidExceptionError$2 = errors
	  .createInvalidExceptionError;

	/**
	 * Non-enumerable globals.
	 * @readonly
	 */
	var globals = [
	  'setTimeout',
	  'clearTimeout',
	  'setInterval',
	  'clearInterval',
	  'XMLHttpRequest',
	  'Date',
	  'setImmediate',
	  'clearImmediate'
	];

	var constants$1 = utils.defineConstants(
	  /**
	   * {@link Runner}-related constants.
	   * @public
	   * @memberof Runner
	   * @readonly
	   * @alias constants
	   * @static
	   * @enum {string}
	   */
	  {
	    /**
	     * Emitted when {@link Hook} execution begins
	     */
	    EVENT_HOOK_BEGIN: 'hook',
	    /**
	     * Emitted when {@link Hook} execution ends
	     */
	    EVENT_HOOK_END: 'hook end',
	    /**
	     * Emitted when Root {@link Suite} execution begins (all files have been parsed and hooks/tests are ready for execution)
	     */
	    EVENT_RUN_BEGIN: 'start',
	    /**
	     * Emitted when Root {@link Suite} execution has been delayed via `delay` option
	     */
	    EVENT_DELAY_BEGIN: 'waiting',
	    /**
	     * Emitted when delayed Root {@link Suite} execution is triggered by user via `global.run()`
	     */
	    EVENT_DELAY_END: 'ready',
	    /**
	     * Emitted when Root {@link Suite} execution ends
	     */
	    EVENT_RUN_END: 'end',
	    /**
	     * Emitted when {@link Suite} execution begins
	     */
	    EVENT_SUITE_BEGIN: 'suite',
	    /**
	     * Emitted when {@link Suite} execution ends
	     */
	    EVENT_SUITE_END: 'suite end',
	    /**
	     * Emitted when {@link Test} execution begins
	     */
	    EVENT_TEST_BEGIN: 'test',
	    /**
	     * Emitted when {@link Test} execution ends
	     */
	    EVENT_TEST_END: 'test end',
	    /**
	     * Emitted when {@link Test} execution fails
	     */
	    EVENT_TEST_FAIL: 'fail',
	    /**
	     * Emitted when {@link Test} execution succeeds
	     */
	    EVENT_TEST_PASS: 'pass',
	    /**
	     * Emitted when {@link Test} becomes pending
	     */
	    EVENT_TEST_PENDING: 'pending',
	    /**
	     * Emitted when {@link Test} execution has failed, but will retry
	     */
	    EVENT_TEST_RETRY: 'retry'
	  }
	);

	var runner = Runner;

	/**
	 * Initialize a `Runner` at the Root {@link Suite}, which represents a hierarchy of {@link Suite|Suites} and {@link Test|Tests}.
	 *
	 * @extends external:EventEmitter
	 * @public
	 * @class
	 * @param {Suite} suite Root suite
	 * @param {boolean} [delay] Whether or not to delay execution of root suite
	 * until ready.
	 */
	function Runner(suite$$1, delay) {
	  var self = this;
	  this._globals = [];
	  this._abort = false;
	  this._delay = delay;
	  this.suite = suite$$1;
	  this.started = false;
	  this.total = suite$$1.total();
	  this.failures = 0;
	  this.on(constants$1.EVENT_TEST_END, function(test) {
	    self.checkGlobals(test);
	  });
	  this.on(constants$1.EVENT_HOOK_END, function(hook) {
	    self.checkGlobals(hook);
	  });
	  this._defaultGrep = /.*/;
	  this.grep(this._defaultGrep);
	  this.globals(this.globalProps().concat(extraGlobals()));
	}

	/**
	 * Wrapper for setImmediate, process.nextTick, or browser polyfill.
	 *
	 * @param {Function} fn
	 * @private
	 */
	Runner.immediately = commonjsGlobal.setImmediate || process.nextTick;

	/**
	 * Inherit from `EventEmitter.prototype`.
	 */
	inherits$2(Runner, EventEmitter$1);

	/**
	 * Run tests with full titles matching `re`. Updates runner.total
	 * with number of tests matched.
	 *
	 * @public
	 * @memberof Runner
	 * @param {RegExp} re
	 * @param {boolean} invert
	 * @return {Runner} Runner instance.
	 */
	Runner.prototype.grep = function(re, invert) {
	  debug$2('grep %s', re);
	  this._grep = re;
	  this._invert = invert;
	  this.total = this.grepTotal(this.suite);
	  return this;
	};

	/**
	 * Returns the number of tests matching the grep search for the
	 * given suite.
	 *
	 * @memberof Runner
	 * @public
	 * @param {Suite} suite
	 * @return {number}
	 */
	Runner.prototype.grepTotal = function(suite$$1) {
	  var self = this;
	  var total = 0;

	  suite$$1.eachTest(function(test) {
	    var match = self._grep.test(test.fullTitle());
	    if (self._invert) {
	      match = !match;
	    }
	    if (match) {
	      total++;
	    }
	  });

	  return total;
	};

	/**
	 * Return a list of global properties.
	 *
	 * @return {Array}
	 * @private
	 */
	Runner.prototype.globalProps = function() {
	  var props = Object.keys(commonjsGlobal);

	  // non-enumerables
	  for (var i = 0; i < globals.length; ++i) {
	    if (~props.indexOf(globals[i])) {
	      continue;
	    }
	    props.push(globals[i]);
	  }

	  return props;
	};

	/**
	 * Allow the given `arr` of globals.
	 *
	 * @public
	 * @memberof Runner
	 * @param {Array} arr
	 * @return {Runner} Runner instance.
	 */
	Runner.prototype.globals = function(arr) {
	  if (!arguments.length) {
	    return this._globals;
	  }
	  debug$2('globals %j', arr);
	  this._globals = this._globals.concat(arr);
	  return this;
	};

	/**
	 * Check for global variable leaks.
	 *
	 * @private
	 */
	Runner.prototype.checkGlobals = function(test) {
	  if (this.ignoreLeaks) {
	    return;
	  }
	  var ok = this._globals;

	  var globals = this.globalProps();
	  var leaks;

	  if (test) {
	    ok = ok.concat(test._allowedGlobals || []);
	  }

	  if (this.prevGlobalsLength === globals.length) {
	    return;
	  }
	  this.prevGlobalsLength = globals.length;

	  leaks = filterLeaks(ok, globals);
	  this._globals = this._globals.concat(leaks);

	  if (leaks.length) {
	    var format = ngettext(
	      leaks.length,
	      'global leak detected: %s',
	      'global leaks detected: %s'
	    );
	    var error = new Error(util.format(format, leaks.map(sQuote).join(', ')));
	    this.fail(test, error);
	  }
	};

	/**
	 * Fail the given `test`.
	 *
	 * @private
	 * @param {Test} test
	 * @param {Error} err
	 */
	Runner.prototype.fail = function(test, err) {
	  if (test.isPending()) {
	    return;
	  }

	  ++this.failures;
	  test.state = STATE_FAILED;

	  if (!isError(err)) {
	    err = thrown2Error(err);
	  }

	  try {
	    err.stack =
	      this.fullStackTrace || !err.stack ? err.stack : stackFilter(err.stack);
	  } catch (ignore) {
	    // some environments do not take kindly to monkeying with the stack
	  }

	  this.emit(constants$1.EVENT_TEST_FAIL, test, err);
	};

	/**
	 * Fail the given `hook` with `err`.
	 *
	 * Hook failures work in the following pattern:
	 * - If bail, run corresponding `after each` and `after` hooks,
	 *   then exit
	 * - Failed `before` hook skips all tests in a suite and subsuites,
	 *   but jumps to corresponding `after` hook
	 * - Failed `before each` hook skips remaining tests in a
	 *   suite and jumps to corresponding `after each` hook,
	 *   which is run only once
	 * - Failed `after` hook does not alter
	 *   execution order
	 * - Failed `after each` hook skips remaining tests in a
	 *   suite and subsuites, but executes other `after each`
	 *   hooks
	 *
	 * @private
	 * @param {Hook} hook
	 * @param {Error} err
	 */
	Runner.prototype.failHook = function(hook, err) {
	  hook.originalTitle = hook.originalTitle || hook.title;
	  if (hook.ctx && hook.ctx.currentTest) {
	    hook.title =
	      hook.originalTitle + ' for ' + dQuote(hook.ctx.currentTest.title);
	  } else {
	    var parentTitle;
	    if (hook.parent.title) {
	      parentTitle = hook.parent.title;
	    } else {
	      parentTitle = hook.parent.root ? '{root}' : '';
	    }
	    hook.title = hook.originalTitle + ' in ' + dQuote(parentTitle);
	  }

	  this.fail(hook, err);
	};

	/**
	 * Run hook `name` callbacks and then invoke `fn()`.
	 *
	 * @private
	 * @param {string} name
	 * @param {Function} fn
	 */

	Runner.prototype.hook = function(name, fn) {
	  var suite$$1 = this.suite;
	  var hooks = suite$$1.getHooks(name);
	  var self = this;

	  function next(i) {
	    var hook = hooks[i];
	    if (!hook) {
	      return fn();
	    }
	    self.currentRunnable = hook;

	    if (name === HOOK_TYPE_BEFORE_ALL) {
	      hook.ctx.currentTest = hook.parent.tests[0];
	    } else if (name === HOOK_TYPE_AFTER_ALL) {
	      hook.ctx.currentTest = hook.parent.tests[hook.parent.tests.length - 1];
	    } else {
	      hook.ctx.currentTest = self.test;
	    }

	    hook.allowUncaught = self.allowUncaught;

	    self.emit(constants$1.EVENT_HOOK_BEGIN, hook);

	    if (!hook.listeners('error').length) {
	      hook.on('error', function(err) {
	        self.failHook(hook, err);
	      });
	    }

	    hook.run(function(err) {
	      var testError = hook.error();
	      if (testError) {
	        self.fail(self.test, testError);
	      }
	      if (err) {
	        if (err instanceof pending) {
	          if (name === HOOK_TYPE_AFTER_ALL) {
	            utils.deprecate(
	              'Skipping a test within an "after all" hook is DEPRECATED and will throw an exception in a future version of Mocha. ' +
	                'Use a return statement or other means to abort hook execution.'
	            );
	          }
	          if (name === HOOK_TYPE_BEFORE_EACH || name === HOOK_TYPE_AFTER_EACH) {
	            if (self.test) {
	              self.test.pending = true;
	            }
	          } else {
	            suite$$1.tests.forEach(function(test) {
	              test.pending = true;
	            });
	            suite$$1.suites.forEach(function(suite$$1) {
	              suite$$1.pending = true;
	            });
	            // a pending hook won't be executed twice.
	            hook.pending = true;
	          }
	        } else {
	          self.failHook(hook, err);

	          // stop executing hooks, notify callee of hook err
	          return fn(err);
	        }
	      }
	      self.emit(constants$1.EVENT_HOOK_END, hook);
	      delete hook.ctx.currentTest;
	      next(++i);
	    });
	  }

	  Runner.immediately(function() {
	    next(0);
	  });
	};

	/**
	 * Run hook `name` for the given array of `suites`
	 * in order, and callback `fn(err, errSuite)`.
	 *
	 * @private
	 * @param {string} name
	 * @param {Array} suites
	 * @param {Function} fn
	 */
	Runner.prototype.hooks = function(name, suites, fn) {
	  var self = this;
	  var orig = this.suite;

	  function next(suite$$1) {
	    self.suite = suite$$1;

	    if (!suite$$1) {
	      self.suite = orig;
	      return fn();
	    }

	    self.hook(name, function(err) {
	      if (err) {
	        var errSuite = self.suite;
	        self.suite = orig;
	        return fn(err, errSuite);
	      }

	      next(suites.pop());
	    });
	  }

	  next(suites.pop());
	};

	/**
	 * Run hooks from the top level down.
	 *
	 * @param {String} name
	 * @param {Function} fn
	 * @private
	 */
	Runner.prototype.hookUp = function(name, fn) {
	  var suites = [this.suite].concat(this.parents()).reverse();
	  this.hooks(name, suites, fn);
	};

	/**
	 * Run hooks from the bottom up.
	 *
	 * @param {String} name
	 * @param {Function} fn
	 * @private
	 */
	Runner.prototype.hookDown = function(name, fn) {
	  var suites = [this.suite].concat(this.parents());
	  this.hooks(name, suites, fn);
	};

	/**
	 * Return an array of parent Suites from
	 * closest to furthest.
	 *
	 * @return {Array}
	 * @private
	 */
	Runner.prototype.parents = function() {
	  var suite$$1 = this.suite;
	  var suites = [];
	  while (suite$$1.parent) {
	    suite$$1 = suite$$1.parent;
	    suites.push(suite$$1);
	  }
	  return suites;
	};

	/**
	 * Run the current test and callback `fn(err)`.
	 *
	 * @param {Function} fn
	 * @private
	 */
	Runner.prototype.runTest = function(fn) {
	  var self = this;
	  var test = this.test;

	  if (!test) {
	    return;
	  }

	  var suite$$1 = this.parents().reverse()[0] || this.suite;
	  if (this.forbidOnly && suite$$1.hasOnly()) {
	    fn(new Error('`.only` forbidden'));
	    return;
	  }
	  if (this.asyncOnly) {
	    test.asyncOnly = true;
	  }
	  test.on('error', function(err) {
	    self.fail(test, err);
	  });
	  if (this.allowUncaught) {
	    test.allowUncaught = true;
	    return test.run(fn);
	  }
	  try {
	    test.run(fn);
	  } catch (err) {
	    fn(err);
	  }
	};

	/**
	 * Run tests in the given `suite` and invoke the callback `fn()` when complete.
	 *
	 * @private
	 * @param {Suite} suite
	 * @param {Function} fn
	 */
	Runner.prototype.runTests = function(suite$$1, fn) {
	  var self = this;
	  var tests = suite$$1.tests.slice();
	  var test;

	  function hookErr(_, errSuite, after) {
	    // before/after Each hook for errSuite failed:
	    var orig = self.suite;

	    // for failed 'after each' hook start from errSuite parent,
	    // otherwise start from errSuite itself
	    self.suite = after ? errSuite.parent : errSuite;

	    if (self.suite) {
	      // call hookUp afterEach
	      self.hookUp(HOOK_TYPE_AFTER_EACH, function(err2, errSuite2) {
	        self.suite = orig;
	        // some hooks may fail even now
	        if (err2) {
	          return hookErr(err2, errSuite2, true);
	        }
	        // report error suite
	        fn(errSuite);
	      });
	    } else {
	      // there is no need calling other 'after each' hooks
	      self.suite = orig;
	      fn(errSuite);
	    }
	  }

	  function next(err, errSuite) {
	    // if we bail after first err
	    if (self.failures && suite$$1._bail) {
	      tests = [];
	    }

	    if (self._abort) {
	      return fn();
	    }

	    if (err) {
	      return hookErr(err, errSuite, true);
	    }

	    // next test
	    test = tests.shift();

	    // all done
	    if (!test) {
	      return fn();
	    }

	    // grep
	    var match = self._grep.test(test.fullTitle());
	    if (self._invert) {
	      match = !match;
	    }
	    if (!match) {
	      // Run immediately only if we have defined a grep. When we
	      // define a grep — It can cause maximum callstack error if
	      // the grep is doing a large recursive loop by neglecting
	      // all tests. The run immediately function also comes with
	      // a performance cost. So we don't want to run immediately
	      // if we run the whole test suite, because running the whole
	      // test suite don't do any immediate recursive loops. Thus,
	      // allowing a JS runtime to breathe.
	      if (self._grep !== self._defaultGrep) {
	        Runner.immediately(next);
	      } else {
	        next();
	      }
	      return;
	    }

	    if (test.isPending()) {
	      if (self.forbidPending) {
	        test.isPending = alwaysFalse;
	        self.fail(test, new Error('Pending test forbidden'));
	        delete test.isPending;
	      } else {
	        self.emit(constants$1.EVENT_TEST_PENDING, test);
	      }
	      self.emit(constants$1.EVENT_TEST_END, test);
	      return next();
	    }

	    // execute test and hook(s)
	    self.emit(constants$1.EVENT_TEST_BEGIN, (self.test = test));
	    self.hookDown(HOOK_TYPE_BEFORE_EACH, function(err, errSuite) {
	      if (test.isPending()) {
	        if (self.forbidPending) {
	          test.isPending = alwaysFalse;
	          self.fail(test, new Error('Pending test forbidden'));
	          delete test.isPending;
	        } else {
	          self.emit(constants$1.EVENT_TEST_PENDING, test);
	        }
	        self.emit(constants$1.EVENT_TEST_END, test);
	        return next();
	      }
	      if (err) {
	        return hookErr(err, errSuite, false);
	      }
	      self.currentRunnable = self.test;
	      self.runTest(function(err) {
	        test = self.test;
	        if (err) {
	          var retry = test.currentRetry();
	          if (err instanceof pending && self.forbidPending) {
	            self.fail(test, new Error('Pending test forbidden'));
	          } else if (err instanceof pending) {
	            test.pending = true;
	            self.emit(constants$1.EVENT_TEST_PENDING, test);
	          } else if (retry < test.retries()) {
	            var clonedTest = test.clone();
	            clonedTest.currentRetry(retry + 1);
	            tests.unshift(clonedTest);

	            self.emit(constants$1.EVENT_TEST_RETRY, test, err);

	            // Early return + hook trigger so that it doesn't
	            // increment the count wrong
	            return self.hookUp(HOOK_TYPE_AFTER_EACH, next);
	          } else {
	            self.fail(test, err);
	          }
	          self.emit(constants$1.EVENT_TEST_END, test);

	          if (err instanceof pending) {
	            return next();
	          }

	          return self.hookUp(HOOK_TYPE_AFTER_EACH, next);
	        }

	        test.state = STATE_PASSED;
	        self.emit(constants$1.EVENT_TEST_PASS, test);
	        self.emit(constants$1.EVENT_TEST_END, test);
	        self.hookUp(HOOK_TYPE_AFTER_EACH, next);
	      });
	    });
	  }

	  this.next = next;
	  this.hookErr = hookErr;
	  next();
	};

	function alwaysFalse() {
	  return false;
	}

	/**
	 * Run the given `suite` and invoke the callback `fn()` when complete.
	 *
	 * @private
	 * @param {Suite} suite
	 * @param {Function} fn
	 */
	Runner.prototype.runSuite = function(suite$$1, fn) {
	  var i = 0;
	  var self = this;
	  var total = this.grepTotal(suite$$1);
	  var afterAllHookCalled = false;

	  debug$2('run suite %s', suite$$1.fullTitle());

	  if (!total || (self.failures && suite$$1._bail)) {
	    return fn();
	  }

	  this.emit(constants$1.EVENT_SUITE_BEGIN, (this.suite = suite$$1));

	  function next(errSuite) {
	    if (errSuite) {
	      // current suite failed on a hook from errSuite
	      if (errSuite === suite$$1) {
	        // if errSuite is current suite
	        // continue to the next sibling suite
	        return done();
	      }
	      // errSuite is among the parents of current suite
	      // stop execution of errSuite and all sub-suites
	      return done(errSuite);
	    }

	    if (self._abort) {
	      return done();
	    }

	    var curr = suite$$1.suites[i++];
	    if (!curr) {
	      return done();
	    }

	    // Avoid grep neglecting large number of tests causing a
	    // huge recursive loop and thus a maximum call stack error.
	    // See comment in `this.runTests()` for more information.
	    if (self._grep !== self._defaultGrep) {
	      Runner.immediately(function() {
	        self.runSuite(curr, next);
	      });
	    } else {
	      self.runSuite(curr, next);
	    }
	  }

	  function done(errSuite) {
	    self.suite = suite$$1;
	    self.nextSuite = next;

	    if (afterAllHookCalled) {
	      fn(errSuite);
	    } else {
	      // mark that the afterAll block has been called once
	      // and so can be skipped if there is an error in it.
	      afterAllHookCalled = true;

	      // remove reference to test
	      delete self.test;

	      self.hook(HOOK_TYPE_AFTER_ALL, function() {
	        self.emit(constants$1.EVENT_SUITE_END, suite$$1);
	        fn(errSuite);
	      });
	    }
	  }

	  this.nextSuite = next;

	  this.hook(HOOK_TYPE_BEFORE_ALL, function(err) {
	    if (err) {
	      return done();
	    }
	    self.runTests(suite$$1, next);
	  });
	};

	/**
	 * Handle uncaught exceptions.
	 *
	 * @param {Error} err
	 * @private
	 */
	Runner.prototype.uncaught = function(err) {
	  if (err instanceof pending) {
	    return;
	  }
	  if (err) {
	    debug$2('uncaught exception %O', err);
	  } else {
	    debug$2('uncaught undefined/falsy exception');
	    err = createInvalidExceptionError$2(
	      'Caught falsy/undefined exception which would otherwise be uncaught. No stack trace found; try a debugger',
	      err
	    );
	  }

	  if (!isError(err)) {
	    err = thrown2Error(err);
	  }
	  err.uncaught = true;

	  var runnable$$1 = this.currentRunnable;

	  if (!runnable$$1) {
	    runnable$$1 = new runnable('Uncaught error outside test suite');
	    runnable$$1.parent = this.suite;

	    if (this.started) {
	      this.fail(runnable$$1, err);
	    } else {
	      // Can't recover from this failure
	      this.emit(constants$1.EVENT_RUN_BEGIN);
	      this.fail(runnable$$1, err);
	      this.emit(constants$1.EVENT_RUN_END);
	    }

	    return;
	  }

	  runnable$$1.clearTimeout();

	  // Ignore errors if already failed or pending
	  // See #3226
	  if (runnable$$1.isFailed() || runnable$$1.isPending()) {
	    return;
	  }
	  // we cannot recover gracefully if a Runnable has already passed
	  // then fails asynchronously
	  var alreadyPassed = runnable$$1.isPassed();
	  // this will change the state to "failed" regardless of the current value
	  this.fail(runnable$$1, err);
	  if (!alreadyPassed) {
	    // recover from test
	    if (runnable$$1.type === constants$1.EVENT_TEST_BEGIN) {
	      this.emit(constants$1.EVENT_TEST_END, runnable$$1);
	      this.hookUp(HOOK_TYPE_AFTER_EACH, this.next);
	      return;
	    }
	    debug$2(runnable$$1);

	    // recover from hooks
	    var errSuite = this.suite;

	    // XXX how about a less awful way to determine this?
	    // if hook failure is in afterEach block
	    if (runnable$$1.fullTitle().indexOf('after each') > -1) {
	      return this.hookErr(err, errSuite, true);
	    }
	    // if hook failure is in beforeEach block
	    if (runnable$$1.fullTitle().indexOf('before each') > -1) {
	      return this.hookErr(err, errSuite, false);
	    }
	    // if hook failure is in after or before blocks
	    return this.nextSuite(errSuite);
	  }

	  // bail
	  this.emit(constants$1.EVENT_RUN_END);
	};

	/**
	 * Run the root suite and invoke `fn(failures)`
	 * on completion.
	 *
	 * @public
	 * @memberof Runner
	 * @param {Function} fn
	 * @return {Runner} Runner instance.
	 */
	Runner.prototype.run = function(fn) {
	  var self = this;
	  var rootSuite = this.suite;

	  fn = fn || function() {};

	  function uncaught(err) {
	    self.uncaught(err);
	  }

	  function start() {
	    // If there is an `only` filter
	    if (rootSuite.hasOnly()) {
	      rootSuite.filterOnly();
	    }
	    self.started = true;
	    if (self._delay) {
	      self.emit(constants$1.EVENT_DELAY_END);
	    }
	    self.emit(constants$1.EVENT_RUN_BEGIN);

	    self.runSuite(rootSuite, function() {
	      debug$2('finished running');
	      self.emit(constants$1.EVENT_RUN_END);
	    });
	  }

	  debug$2(constants$1.EVENT_RUN_BEGIN);

	  // references cleanup to avoid memory leaks
	  this.on(constants$1.EVENT_SUITE_END, function(suite$$1) {
	    suite$$1.cleanReferences();
	  });

	  // callback
	  this.on(constants$1.EVENT_RUN_END, function() {
	    debug$2(constants$1.EVENT_RUN_END);
	    process.removeListener('uncaughtException', uncaught);
	    fn(self.failures);
	  });

	  // uncaught exception
	  process.on('uncaughtException', uncaught);

	  if (this._delay) {
	    // for reporters, I guess.
	    // might be nice to debounce some dots while we wait.
	    this.emit(constants$1.EVENT_DELAY_BEGIN, rootSuite);
	    rootSuite.once(EVENT_ROOT_SUITE_RUN, start);
	  } else {
	    start();
	  }

	  return this;
	};

	/**
	 * Cleanly abort execution.
	 *
	 * @memberof Runner
	 * @public
	 * @return {Runner} Runner instance.
	 */
	Runner.prototype.abort = function() {
	  debug$2('aborting');
	  this._abort = true;

	  return this;
	};

	/**
	 * Filter leaks with the given globals flagged as `ok`.
	 *
	 * @private
	 * @param {Array} ok
	 * @param {Array} globals
	 * @return {Array}
	 */
	function filterLeaks(ok, globals) {
	  return globals.filter(function(key) {
	    // Firefox and Chrome exposes iframes as index inside the window object
	    if (/^\d+/.test(key)) {
	      return false;
	    }

	    // in firefox
	    // if runner runs in an iframe, this iframe's window.getInterface method
	    // not init at first it is assigned in some seconds
	    if (commonjsGlobal.navigator && /^getInterface/.test(key)) {
	      return false;
	    }

	    // an iframe could be approached by window[iframeIndex]
	    // in ie6,7,8 and opera, iframeIndex is enumerable, this could cause leak
	    if (commonjsGlobal.navigator && /^\d+/.test(key)) {
	      return false;
	    }

	    // Opera and IE expose global variables for HTML element IDs (issue #243)
	    if (/^mocha-/.test(key)) {
	      return false;
	    }

	    var matched = ok.filter(function(ok) {
	      if (~ok.indexOf('*')) {
	        return key.indexOf(ok.split('*')[0]) === 0;
	      }
	      return key === ok;
	    });
	    return !matched.length && (!commonjsGlobal.navigator || key !== 'onerror');
	  });
	}

	/**
	 * Check if argument is an instance of Error object or a duck-typed equivalent.
	 *
	 * @private
	 * @param {Object} err - object to check
	 * @param {string} err.message - error message
	 * @returns {boolean}
	 */
	function isError(err) {
	  return err instanceof Error || (err && typeof err.message === 'string');
	}

	/**
	 *
	 * Converts thrown non-extensible type into proper Error.
	 *
	 * @private
	 * @param {*} thrown - Non-extensible type thrown by code
	 * @return {Error}
	 */
	function thrown2Error(err) {
	  return new Error(
	    'the ' + type(err) + ' ' + stringify(err) + ' was thrown, throw an Error :)'
	  );
	}

	/**
	 * Array of globals dependent on the environment.
	 *
	 * @return {Array}
	 * @deprecated
	 * @todo remove; long since unsupported
	 * @private
	 */
	function extraGlobals() {
	  if (typeof process === 'object' && typeof process.version === 'string') {
	    var parts = process.version.split('.');
	    var nodeVersion = parts.reduce(function(a, v) {
	      return (a << 8) | v;
	    });

	    // 'errno' was renamed to process._errno in v0.9.11.
	    if (nodeVersion < 0x00090b) {
	      return ['errno'];
	    }
	  }

	  return [];
	}

	Runner.constants = constants$1;

	var base = createCommonjsModule(function (module, exports) {
	/**
	 * @module Base
	 */
	/**
	 * Module dependencies.
	 */





	var supportsColor = process.browser ? null : path;
	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;

	/**
	 * Expose `Base`.
	 */

	exports = module.exports = Base;

	/**
	 * Check if both stdio streams are associated with a tty.
	 */

	var isatty = tty.isatty(1) && tty.isatty(2);

	/**
	 * Save log references to avoid tests interfering (see GH-3604).
	 */
	var consoleLog = console.log;

	/**
	 * Enable coloring by default, except in the browser interface.
	 */

	exports.useColors =
	  !process.browser &&
	  (supportsColor.stdout || process.env.MOCHA_COLORS !== undefined);

	/**
	 * Inline diffs instead of +/-
	 */

	exports.inlineDiffs = false;

	/**
	 * Default color map.
	 */

	exports.colors = {
	  pass: 90,
	  fail: 31,
	  'bright pass': 92,
	  'bright fail': 91,
	  'bright yellow': 93,
	  pending: 36,
	  suite: 0,
	  'error title': 0,
	  'error message': 31,
	  'error stack': 90,
	  checkmark: 32,
	  fast: 90,
	  medium: 33,
	  slow: 31,
	  green: 32,
	  light: 90,
	  'diff gutter': 90,
	  'diff added': 32,
	  'diff removed': 31
	};

	/**
	 * Default symbol map.
	 */

	exports.symbols = {
	  ok: '✓',
	  err: '✖',
	  dot: '․',
	  comma: ',',
	  bang: '!'
	};

	// With node.js on Windows: use symbols available in terminal default fonts
	if (process.platform === 'win32') {
	  exports.symbols.ok = '\u221A';
	  exports.symbols.err = '\u00D7';
	  exports.symbols.dot = '.';
	}

	/**
	 * Color `str` with the given `type`,
	 * allowing colors to be disabled,
	 * as well as user-defined color
	 * schemes.
	 *
	 * @private
	 * @param {string} type
	 * @param {string} str
	 * @return {string}
	 */
	var color = (exports.color = function(type, str) {
	  if (!exports.useColors) {
	    return String(str);
	  }
	  return '\u001b[' + exports.colors[type] + 'm' + str + '\u001b[0m';
	});

	/**
	 * Expose term window size, with some defaults for when stderr is not a tty.
	 */

	exports.window = {
	  width: 75
	};

	if (isatty) {
	  exports.window.width = process.stdout.getWindowSize
	    ? process.stdout.getWindowSize(1)[0]
	    : tty.getWindowSize()[1];
	}

	/**
	 * Expose some basic cursor interactions that are common among reporters.
	 */

	exports.cursor = {
	  hide: function() {
	    isatty && process.stdout.write('\u001b[?25l');
	  },

	  show: function() {
	    isatty && process.stdout.write('\u001b[?25h');
	  },

	  deleteLine: function() {
	    isatty && process.stdout.write('\u001b[2K');
	  },

	  beginningOfLine: function() {
	    isatty && process.stdout.write('\u001b[0G');
	  },

	  CR: function() {
	    if (isatty) {
	      exports.cursor.deleteLine();
	      exports.cursor.beginningOfLine();
	    } else {
	      process.stdout.write('\r');
	    }
	  }
	};

	function showDiff(err) {
	  return (
	    err &&
	    err.showDiff !== false &&
	    sameType(err.actual, err.expected) &&
	    err.expected !== undefined
	  );
	}

	function stringifyDiffObjs(err) {
	  if (!utils.isString(err.actual) || !utils.isString(err.expected)) {
	    err.actual = utils.stringify(err.actual);
	    err.expected = utils.stringify(err.expected);
	  }
	}

	/**
	 * Returns a diff between 2 strings with coloured ANSI output.
	 *
	 * @description
	 * The diff will be either inline or unified dependent on the value
	 * of `Base.inlineDiff`.
	 *
	 * @param {string} actual
	 * @param {string} expected
	 * @return {string} Diff
	 */
	var generateDiff = (exports.generateDiff = function(actual, expected) {
	  return exports.inlineDiffs
	    ? inlineDiff(actual, expected)
	    : unifiedDiff(actual, expected);
	});

	/**
	 * Outputs the given `failures` as a list.
	 *
	 * @public
	 * @memberof Mocha.reporters.Base
	 * @variation 1
	 * @param {Object[]} failures - Each is Test instance with corresponding
	 *     Error property
	 */
	exports.list = function(failures) {
	  Base.consoleLog();
	  failures.forEach(function(test, i) {
	    // format
	    var fmt =
	      color('error title', '  %s) %s:\n') +
	      color('error message', '     %s') +
	      color('error stack', '\n%s\n');

	    // msg
	    var msg;
	    var err = test.err;
	    var message;
	    if (err.message && typeof err.message.toString === 'function') {
	      message = err.message + '';
	    } else if (typeof err.inspect === 'function') {
	      message = err.inspect() + '';
	    } else {
	      message = '';
	    }
	    var stack = err.stack || message;
	    var index = message ? stack.indexOf(message) : -1;

	    if (index === -1) {
	      msg = message;
	    } else {
	      index += message.length;
	      msg = stack.slice(0, index);
	      // remove msg from stack
	      stack = stack.slice(index + 1);
	    }

	    // uncaught
	    if (err.uncaught) {
	      msg = 'Uncaught ' + msg;
	    }
	    // explicitly show diff
	    if (!exports.hideDiff && showDiff(err)) {
	      stringifyDiffObjs(err);
	      fmt =
	        color('error title', '  %s) %s:\n%s') + color('error stack', '\n%s\n');
	      var match = message.match(/^([^:]+): expected/);
	      msg = '\n      ' + color('error message', match ? match[1] : msg);

	      msg += generateDiff(err.actual, err.expected);
	    }

	    // indent stack trace
	    stack = stack.replace(/^/gm, '  ');

	    // indented test title
	    var testTitle = '';
	    test.titlePath().forEach(function(str, index) {
	      if (index !== 0) {
	        testTitle += '\n     ';
	      }
	      for (var i = 0; i < index; i++) {
	        testTitle += '  ';
	      }
	      testTitle += str;
	    });

	    Base.consoleLog(fmt, i + 1, testTitle, msg, stack);
	  });
	};

	/**
	 * Constructs a new `Base` reporter instance.
	 *
	 * @description
	 * All other reporters generally inherit from this reporter.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Base(runner$$1, options) {
	  var failures = (this.failures = []);

	  if (!runner$$1) {
	    throw new TypeError('Missing runner argument');
	  }
	  this.options = options || {};
	  this.runner = runner$$1;
	  this.stats = runner$$1.stats; // assigned so Reporters keep a closer reference

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    if (test.duration > test.slow()) {
	      test.speed = 'slow';
	    } else if (test.duration > test.slow() / 2) {
	      test.speed = 'medium';
	    } else {
	      test.speed = 'fast';
	    }
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function(test, err) {
	    if (showDiff(err)) {
	      stringifyDiffObjs(err);
	    }
	    test.err = err;
	    failures.push(test);
	  });
	}

	/**
	 * Outputs common epilogue used by many of the bundled reporters.
	 *
	 * @public
	 * @memberof Mocha.reporters.Base
	 */
	Base.prototype.epilogue = function() {
	  var stats = this.stats;
	  var fmt;

	  Base.consoleLog();

	  // passes
	  fmt =
	    color('bright pass', ' ') +
	    color('green', ' %d passing') +
	    color('light', ' (%s)');

	  Base.consoleLog(fmt, stats.passes || 0, ms(stats.duration));

	  // pending
	  if (stats.pending) {
	    fmt = color('pending', ' ') + color('pending', ' %d pending');

	    Base.consoleLog(fmt, stats.pending);
	  }

	  // failures
	  if (stats.failures) {
	    fmt = color('fail', '  %d failing');

	    Base.consoleLog(fmt, stats.failures);

	    Base.list(this.failures);
	    Base.consoleLog();
	  }

	  Base.consoleLog();
	};

	/**
	 * Pads the given `str` to `len`.
	 *
	 * @private
	 * @param {string} str
	 * @param {string} len
	 * @return {string}
	 */
	function pad(str, len) {
	  str = String(str);
	  return Array(len - str.length + 1).join(' ') + str;
	}

	/**
	 * Returns inline diff between 2 strings with coloured ANSI output.
	 *
	 * @private
	 * @param {String} actual
	 * @param {String} expected
	 * @return {string} Diff
	 */
	function inlineDiff(actual, expected) {
	  var msg = errorDiff(actual, expected);

	  // linenos
	  var lines = msg.split('\n');
	  if (lines.length > 4) {
	    var width = String(lines.length).length;
	    msg = lines
	      .map(function(str, i) {
	        return pad(++i, width) + ' |' + ' ' + str;
	      })
	      .join('\n');
	  }

	  // legend
	  msg =
	    '\n' +
	    color('diff removed', 'actual') +
	    ' ' +
	    color('diff added', 'expected') +
	    '\n\n' +
	    msg +
	    '\n';

	  // indent
	  msg = msg.replace(/^/gm, '      ');
	  return msg;
	}

	/**
	 * Returns unified diff between two strings with coloured ANSI output.
	 *
	 * @private
	 * @param {String} actual
	 * @param {String} expected
	 * @return {string} The diff.
	 */
	function unifiedDiff(actual, expected) {
	  var indent = '      ';
	  function cleanUp(line) {
	    if (line[0] === '+') {
	      return indent + colorLines('diff added', line);
	    }
	    if (line[0] === '-') {
	      return indent + colorLines('diff removed', line);
	    }
	    if (line.match(/@@/)) {
	      return '--';
	    }
	    if (line.match(/\\ No newline/)) {
	      return null;
	    }
	    return indent + line;
	  }
	  function notBlank(line) {
	    return typeof line !== 'undefined' && line !== null;
	  }
	  var msg = diff.createPatch('string', actual, expected);
	  var lines = msg.split('\n').splice(5);
	  return (
	    '\n      ' +
	    colorLines('diff added', '+ expected') +
	    ' ' +
	    colorLines('diff removed', '- actual') +
	    '\n\n' +
	    lines
	      .map(cleanUp)
	      .filter(notBlank)
	      .join('\n')
	  );
	}

	/**
	 * Returns character diff for `err`.
	 *
	 * @private
	 * @param {String} actual
	 * @param {String} expected
	 * @return {string} the diff
	 */
	function errorDiff(actual, expected) {
	  return diff
	    .diffWordsWithSpace(actual, expected)
	    .map(function(str) {
	      if (str.added) {
	        return colorLines('diff added', str.value);
	      }
	      if (str.removed) {
	        return colorLines('diff removed', str.value);
	      }
	      return str.value;
	    })
	    .join('');
	}

	/**
	 * Colors lines for `str`, using the color `name`.
	 *
	 * @private
	 * @param {string} name
	 * @param {string} str
	 * @return {string}
	 */
	function colorLines(name, str) {
	  return str
	    .split('\n')
	    .map(function(str) {
	      return color(name, str);
	    })
	    .join('\n');
	}

	/**
	 * Object#toString reference.
	 */
	var objToString = Object.prototype.toString;

	/**
	 * Checks that a / b have the same type.
	 *
	 * @private
	 * @param {Object} a
	 * @param {Object} b
	 * @return {boolean}
	 */
	function sameType(a, b) {
	  return objToString.call(a) === objToString.call(b);
	}

	Base.consoleLog = consoleLog;

	Base.abstract = true;
	});
	var base_1 = base.useColors;
	var base_2 = base.inlineDiffs;
	var base_3 = base.colors;
	var base_4 = base.symbols;
	var base_5 = base.color;
	var base_6 = base.window;
	var base_7 = base.cursor;
	var base_8 = base.generateDiff;
	var base_9 = base.list;

	var dot = createCommonjsModule(function (module, exports) {
	/**
	 * @module Dot
	 */
	/**
	 * Module dependencies.
	 */


	var inherits = utils.inherits;
	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var EVENT_RUN_END = constants.EVENT_RUN_END;

	/**
	 * Expose `Dot`.
	 */

	exports = module.exports = Dot;

	/**
	 * Constructs a new `Dot` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Dot(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var width = (base.window.width * 0.75) | 0;
	  var n = -1;

	  runner$$1.on(EVENT_RUN_BEGIN, function() {
	    process.stdout.write('\n');
	  });

	  runner$$1.on(EVENT_TEST_PENDING, function() {
	    if (++n % width === 0) {
	      process.stdout.write('\n  ');
	    }
	    process.stdout.write(base.color('pending', base.symbols.comma));
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    if (++n % width === 0) {
	      process.stdout.write('\n  ');
	    }
	    if (test.speed === 'slow') {
	      process.stdout.write(base.color('bright yellow', base.symbols.dot));
	    } else {
	      process.stdout.write(base.color(test.speed, base.symbols.dot));
	    }
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function() {
	    if (++n % width === 0) {
	      process.stdout.write('\n  ');
	    }
	    process.stdout.write(base.color('fail', base.symbols.bang));
	  });

	  runner$$1.once(EVENT_RUN_END, function() {
	    process.stdout.write('\n');
	    self.epilogue();
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Dot, base);

	Dot.description = 'dot matrix representation';
	});

	var doc = createCommonjsModule(function (module, exports) {
	/**
	 * @module Doc
	 */
	/**
	 * Module dependencies.
	 */



	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_SUITE_BEGIN = constants.EVENT_SUITE_BEGIN;
	var EVENT_SUITE_END = constants.EVENT_SUITE_END;

	/**
	 * Expose `Doc`.
	 */

	exports = module.exports = Doc;

	/**
	 * Constructs a new `Doc` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Doc(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var indents = 2;

	  function indent() {
	    return Array(indents).join('  ');
	  }

	  runner$$1.on(EVENT_SUITE_BEGIN, function(suite) {
	    if (suite.root) {
	      return;
	    }
	    ++indents;
	    base.consoleLog('%s<section class="suite">', indent());
	    ++indents;
	    base.consoleLog('%s<h1>%s</h1>', indent(), utils.escape(suite.title));
	    base.consoleLog('%s<dl>', indent());
	  });

	  runner$$1.on(EVENT_SUITE_END, function(suite) {
	    if (suite.root) {
	      return;
	    }
	    base.consoleLog('%s</dl>', indent());
	    --indents;
	    base.consoleLog('%s</section>', indent());
	    --indents;
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    base.consoleLog('%s  <dt>%s</dt>', indent(), utils.escape(test.title));
	    var code = utils.escape(utils.clean(test.body));
	    base.consoleLog('%s  <dd><pre><code>%s</code></pre></dd>', indent(), code);
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function(test, err) {
	    base.consoleLog(
	      '%s  <dt class="error">%s</dt>',
	      indent(),
	      utils.escape(test.title)
	    );
	    var code = utils.escape(utils.clean(test.body));
	    base.consoleLog(
	      '%s  <dd class="error"><pre><code>%s</code></pre></dd>',
	      indent(),
	      code
	    );
	    base.consoleLog(
	      '%s  <dd class="error">%s</dd>',
	      indent(),
	      utils.escape(err)
	    );
	  });
	}

	Doc.description = 'HTML documentation';
	});

	var tap = createCommonjsModule(function (module, exports) {
	/**
	 * @module TAP
	 */
	/**
	 * Module dependencies.
	 */



	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var EVENT_TEST_END = constants.EVENT_TEST_END;
	var inherits = utils.inherits;
	var sprintf = util.format;

	/**
	 * Expose `TAP`.
	 */

	exports = module.exports = TAP;

	/**
	 * Constructs a new `TAP` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function TAP(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var n = 1;

	  var tapVersion = '12';
	  if (options && options.reporterOptions) {
	    if (options.reporterOptions.tapVersion) {
	      tapVersion = options.reporterOptions.tapVersion.toString();
	    }
	  }

	  this._producer = createProducer(tapVersion);

	  runner$$1.once(EVENT_RUN_BEGIN, function() {
	    var ntests = runner$$1.grepTotal(runner$$1.suite);
	    self._producer.writeVersion();
	    self._producer.writePlan(ntests);
	  });

	  runner$$1.on(EVENT_TEST_END, function() {
	    ++n;
	  });

	  runner$$1.on(EVENT_TEST_PENDING, function(test) {
	    self._producer.writePending(n, test);
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    self._producer.writePass(n, test);
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function(test, err) {
	    self._producer.writeFail(n, test, err);
	  });

	  runner$$1.once(EVENT_RUN_END, function() {
	    self._producer.writeEpilogue(runner$$1.stats);
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(TAP, base);

	/**
	 * Returns a TAP-safe title of `test`.
	 *
	 * @private
	 * @param {Test} test - Test instance.
	 * @return {String} title with any hash character removed
	 */
	function title(test) {
	  return test.fullTitle().replace(/#/g, '');
	}

	/**
	 * Writes newline-terminated formatted string to reporter output stream.
	 *
	 * @private
	 * @param {string} format - `printf`-like format string
	 * @param {...*} [varArgs] - Format string arguments
	 */
	function println(format, varArgs) {
	  var vargs = Array.from(arguments);
	  vargs[0] += '\n';
	  process.stdout.write(sprintf.apply(null, vargs));
	}

	/**
	 * Returns a `tapVersion`-appropriate TAP producer instance, if possible.
	 *
	 * @private
	 * @param {string} tapVersion - Version of TAP specification to produce.
	 * @returns {TAPProducer} specification-appropriate instance
	 * @throws {Error} if specification version has no associated producer.
	 */
	function createProducer(tapVersion) {
	  var producers = {
	    '12': new TAP12Producer(),
	    '13': new TAP13Producer()
	  };
	  var producer = producers[tapVersion];

	  if (!producer) {
	    throw new Error(
	      'invalid or unsupported TAP version: ' + JSON.stringify(tapVersion)
	    );
	  }

	  return producer;
	}

	/**
	 * @summary
	 * Constructs a new TAPProducer.
	 *
	 * @description
	 * <em>Only</em> to be used as an abstract base class.
	 *
	 * @private
	 * @constructor
	 */
	function TAPProducer() {}

	/**
	 * Writes the TAP version to reporter output stream.
	 *
	 * @abstract
	 */
	TAPProducer.prototype.writeVersion = function() {};

	/**
	 * Writes the plan to reporter output stream.
	 *
	 * @abstract
	 * @param {number} ntests - Number of tests that are planned to run.
	 */
	TAPProducer.prototype.writePlan = function(ntests) {
	  println('%d..%d', 1, ntests);
	};

	/**
	 * Writes that test passed to reporter output stream.
	 *
	 * @abstract
	 * @param {number} n - Index of test that passed.
	 * @param {Test} test - Instance containing test information.
	 */
	TAPProducer.prototype.writePass = function(n, test) {
	  println('ok %d %s', n, title(test));
	};

	/**
	 * Writes that test was skipped to reporter output stream.
	 *
	 * @abstract
	 * @param {number} n - Index of test that was skipped.
	 * @param {Test} test - Instance containing test information.
	 */
	TAPProducer.prototype.writePending = function(n, test) {
	  println('ok %d %s # SKIP -', n, title(test));
	};

	/**
	 * Writes that test failed to reporter output stream.
	 *
	 * @abstract
	 * @param {number} n - Index of test that failed.
	 * @param {Test} test - Instance containing test information.
	 * @param {Error} err - Reason the test failed.
	 */
	TAPProducer.prototype.writeFail = function(n, test, err) {
	  println('not ok %d %s', n, title(test));
	};

	/**
	 * Writes the summary epilogue to reporter output stream.
	 *
	 * @abstract
	 * @param {Object} stats - Object containing run statistics.
	 */
	TAPProducer.prototype.writeEpilogue = function(stats) {
	  // :TBD: Why is this not counting pending tests?
	  println('# tests ' + (stats.passes + stats.failures));
	  println('# pass ' + stats.passes);
	  // :TBD: Why are we not showing pending results?
	  println('# fail ' + stats.failures);
	};

	/**
	 * @summary
	 * Constructs a new TAP12Producer.
	 *
	 * @description
	 * Produces output conforming to the TAP12 specification.
	 *
	 * @private
	 * @constructor
	 * @extends TAPProducer
	 * @see {@link https://testanything.org/tap-specification.html|Specification}
	 */
	function TAP12Producer() {
	  /**
	   * Writes that test failed to reporter output stream, with error formatting.
	   * @override
	   */
	  this.writeFail = function(n, test, err) {
	    TAPProducer.prototype.writeFail.call(this, n, test, err);
	    if (err.message) {
	      println(err.message.replace(/^/gm, '  '));
	    }
	    if (err.stack) {
	      println(err.stack.replace(/^/gm, '  '));
	    }
	  };
	}

	/**
	 * Inherit from `TAPProducer.prototype`.
	 */
	inherits(TAP12Producer, TAPProducer);

	/**
	 * @summary
	 * Constructs a new TAP13Producer.
	 *
	 * @description
	 * Produces output conforming to the TAP13 specification.
	 *
	 * @private
	 * @constructor
	 * @extends TAPProducer
	 * @see {@link https://testanything.org/tap-version-13-specification.html|Specification}
	 */
	function TAP13Producer() {
	  /**
	   * Writes the TAP version to reporter output stream.
	   * @override
	   */
	  this.writeVersion = function() {
	    println('TAP version 13');
	  };

	  /**
	   * Writes that test failed to reporter output stream, with error formatting.
	   * @override
	   */
	  this.writeFail = function(n, test, err) {
	    TAPProducer.prototype.writeFail.call(this, n, test, err);
	    var emitYamlBlock = err.message != null || err.stack != null;
	    if (emitYamlBlock) {
	      println(indent(1) + '---');
	      if (err.message) {
	        println(indent(2) + 'message: |-');
	        println(err.message.replace(/^/gm, indent(3)));
	      }
	      if (err.stack) {
	        println(indent(2) + 'stack: |-');
	        println(err.stack.replace(/^/gm, indent(3)));
	      }
	      println(indent(1) + '...');
	    }
	  };

	  function indent(level) {
	    return Array(level + 1).join('  ');
	  }
	}

	/**
	 * Inherit from `TAPProducer.prototype`.
	 */
	inherits(TAP13Producer, TAPProducer);

	TAP.description = 'TAP-compatible output';
	});

	var json = createCommonjsModule(function (module, exports) {
	/**
	 * @module JSON
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_TEST_END = constants.EVENT_TEST_END;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;

	/**
	 * Expose `JSON`.
	 */

	exports = module.exports = JSONReporter;

	/**
	 * Constructs a new `JSON` reporter instance.
	 *
	 * @public
	 * @class JSON
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function JSONReporter(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var tests = [];
	  var pending = [];
	  var failures = [];
	  var passes = [];

	  runner$$1.on(EVENT_TEST_END, function(test) {
	    tests.push(test);
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    passes.push(test);
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function(test) {
	    failures.push(test);
	  });

	  runner$$1.on(EVENT_TEST_PENDING, function(test) {
	    pending.push(test);
	  });

	  runner$$1.once(EVENT_RUN_END, function() {
	    var obj = {
	      stats: self.stats,
	      tests: tests.map(clean),
	      pending: pending.map(clean),
	      failures: failures.map(clean),
	      passes: passes.map(clean)
	    };

	    runner$$1.testResults = obj;

	    process.stdout.write(JSON.stringify(obj, null, 2));
	  });
	}

	/**
	 * Return a plain-object representation of `test`
	 * free of cyclic properties etc.
	 *
	 * @private
	 * @param {Object} test
	 * @return {Object}
	 */
	function clean(test) {
	  var err = test.err || {};
	  if (err instanceof Error) {
	    err = errorJSON(err);
	  }

	  return {
	    title: test.title,
	    fullTitle: test.fullTitle(),
	    duration: test.duration,
	    currentRetry: test.currentRetry(),
	    err: cleanCycles(err)
	  };
	}

	/**
	 * Replaces any circular references inside `obj` with '[object Object]'
	 *
	 * @private
	 * @param {Object} obj
	 * @return {Object}
	 */
	function cleanCycles(obj) {
	  var cache = [];
	  return JSON.parse(
	    JSON.stringify(obj, function(key, value) {
	      if (typeof value === 'object' && value !== null) {
	        if (cache.indexOf(value) !== -1) {
	          // Instead of going in a circle, we'll print [object Object]
	          return '' + value;
	        }
	        cache.push(value);
	      }

	      return value;
	    })
	  );
	}

	/**
	 * Transform an Error object into a JSON object.
	 *
	 * @private
	 * @param {Error} err
	 * @return {Object}
	 */
	function errorJSON(err) {
	  var res = {};
	  Object.getOwnPropertyNames(err).forEach(function(key) {
	    res[key] = err[key];
	  }, err);
	  return res;
	}

	JSONReporter.description = 'single JSON object';
	});

	/**
	 * Expose `Progress`.
	 */

	var progress = Progress;

	/**
	 * Initialize a new `Progress` indicator.
	 */
	function Progress() {
	  this.percent = 0;
	  this.size(0);
	  this.fontSize(11);
	  this.font('helvetica, arial, sans-serif');
	}

	/**
	 * Set progress size to `size`.
	 *
	 * @public
	 * @param {number} size
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.size = function(size) {
	  this._size = size;
	  return this;
	};

	/**
	 * Set text to `text`.
	 *
	 * @public
	 * @param {string} text
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.text = function(text) {
	  this._text = text;
	  return this;
	};

	/**
	 * Set font size to `size`.
	 *
	 * @public
	 * @param {number} size
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.fontSize = function(size) {
	  this._fontSize = size;
	  return this;
	};

	/**
	 * Set font to `family`.
	 *
	 * @param {string} family
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.font = function(family) {
	  this._font = family;
	  return this;
	};

	/**
	 * Update percentage to `n`.
	 *
	 * @param {number} n
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.update = function(n) {
	  this.percent = n;
	  return this;
	};

	/**
	 * Draw on `ctx`.
	 *
	 * @param {CanvasRenderingContext2d} ctx
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.draw = function(ctx) {
	  try {
	    var percent = Math.min(this.percent, 100);
	    var size = this._size;
	    var half = size / 2;
	    var x = half;
	    var y = half;
	    var rad = half - 1;
	    var fontSize = this._fontSize;

	    ctx.font = fontSize + 'px ' + this._font;

	    var angle = Math.PI * 2 * (percent / 100);
	    ctx.clearRect(0, 0, size, size);

	    // outer circle
	    ctx.strokeStyle = '#9f9f9f';
	    ctx.beginPath();
	    ctx.arc(x, y, rad, 0, angle, false);
	    ctx.stroke();

	    // inner circle
	    ctx.strokeStyle = '#eee';
	    ctx.beginPath();
	    ctx.arc(x, y, rad - 1, 0, angle, true);
	    ctx.stroke();

	    // text
	    var text = this._text || (percent | 0) + '%';
	    var w = ctx.measureText(text).width;

	    ctx.fillText(text, x - w / 2 + 1, y + fontSize / 2 - 1);
	  } catch (ignore) {
	    // don't fail if we can't render progress
	  }
	  return this;
	};

	var html = createCommonjsModule(function (module, exports) {

	/* eslint-env browser */
	/**
	 * @module HTML
	 */
	/**
	 * Module dependencies.
	 */





	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_SUITE_BEGIN = constants.EVENT_SUITE_BEGIN;
	var EVENT_SUITE_END = constants.EVENT_SUITE_END;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var escape = utils.escape;

	/**
	 * Save timer references to avoid Sinon interfering (see GH-237).
	 */

	var Date = commonjsGlobal.Date;

	/**
	 * Expose `HTML`.
	 */

	exports = module.exports = HTML;

	/**
	 * Stats template.
	 */

	var statsTemplate =
	  '<ul id="mocha-stats">' +
	  '<li class="progress"><canvas width="40" height="40"></canvas></li>' +
	  '<li class="passes"><a href="javascript:void(0);">passes:</a> <em>0</em></li>' +
	  '<li class="failures"><a href="javascript:void(0);">failures:</a> <em>0</em></li>' +
	  '<li class="duration">duration: <em>0</em>s</li>' +
	  '</ul>';

	var playIcon = '&#x2023;';

	/**
	 * Constructs a new `HTML` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function HTML(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var stats = this.stats;
	  var stat = fragment(statsTemplate);
	  var items = stat.getElementsByTagName('li');
	  var passes = items[1].getElementsByTagName('em')[0];
	  var passesLink = items[1].getElementsByTagName('a')[0];
	  var failures = items[2].getElementsByTagName('em')[0];
	  var failuresLink = items[2].getElementsByTagName('a')[0];
	  var duration = items[3].getElementsByTagName('em')[0];
	  var canvas = stat.getElementsByTagName('canvas')[0];
	  var report = fragment('<ul id="mocha-report"></ul>');
	  var stack = [report];
	  var progress$$1;
	  var ctx;
	  var root = document.getElementById('mocha');

	  if (canvas.getContext) {
	    var ratio = window.devicePixelRatio || 1;
	    canvas.style.width = canvas.width;
	    canvas.style.height = canvas.height;
	    canvas.width *= ratio;
	    canvas.height *= ratio;
	    ctx = canvas.getContext('2d');
	    ctx.scale(ratio, ratio);
	    progress$$1 = new progress();
	  }

	  if (!root) {
	    return error('#mocha div missing, add it to your document');
	  }

	  // pass toggle
	  on(passesLink, 'click', function(evt) {
	    evt.preventDefault();
	    unhide();
	    var name = /pass/.test(report.className) ? '' : ' pass';
	    report.className = report.className.replace(/fail|pass/g, '') + name;
	    if (report.className.trim()) {
	      hideSuitesWithout('test pass');
	    }
	  });

	  // failure toggle
	  on(failuresLink, 'click', function(evt) {
	    evt.preventDefault();
	    unhide();
	    var name = /fail/.test(report.className) ? '' : ' fail';
	    report.className = report.className.replace(/fail|pass/g, '') + name;
	    if (report.className.trim()) {
	      hideSuitesWithout('test fail');
	    }
	  });

	  root.appendChild(stat);
	  root.appendChild(report);

	  if (progress$$1) {
	    progress$$1.size(40);
	  }

	  runner$$1.on(EVENT_SUITE_BEGIN, function(suite) {
	    if (suite.root) {
	      return;
	    }

	    // suite
	    var url = self.suiteURL(suite);
	    var el = fragment(
	      '<li class="suite"><h1><a href="%s">%s</a></h1></li>',
	      url,
	      escape(suite.title)
	    );

	    // container
	    stack[0].appendChild(el);
	    stack.unshift(document.createElement('ul'));
	    el.appendChild(stack[0]);
	  });

	  runner$$1.on(EVENT_SUITE_END, function(suite) {
	    if (suite.root) {
	      updateStats();
	      return;
	    }
	    stack.shift();
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    var url = self.testURL(test);
	    var markup =
	      '<li class="test pass %e"><h2>%e<span class="duration">%ems</span> ' +
	      '<a href="%s" class="replay">' +
	      playIcon +
	      '</a></h2></li>';
	    var el = fragment(markup, test.speed, test.title, test.duration, url);
	    self.addCodeToggle(el, test.body);
	    appendToStack(el);
	    updateStats();
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function(test) {
	    var el = fragment(
	      '<li class="test fail"><h2>%e <a href="%e" class="replay">' +
	        playIcon +
	        '</a></h2></li>',
	      test.title,
	      self.testURL(test)
	    );
	    var stackString; // Note: Includes leading newline
	    var message = test.err.toString();

	    // <=IE7 stringifies to [Object Error]. Since it can be overloaded, we
	    // check for the result of the stringifying.
	    if (message === '[object Error]') {
	      message = test.err.message;
	    }

	    if (test.err.stack) {
	      var indexOfMessage = test.err.stack.indexOf(test.err.message);
	      if (indexOfMessage === -1) {
	        stackString = test.err.stack;
	      } else {
	        stackString = test.err.stack.substr(
	          test.err.message.length + indexOfMessage
	        );
	      }
	    } else if (test.err.sourceURL && test.err.line !== undefined) {
	      // Safari doesn't give you a stack. Let's at least provide a source line.
	      stackString = '\n(' + test.err.sourceURL + ':' + test.err.line + ')';
	    }

	    stackString = stackString || '';

	    if (test.err.htmlMessage && stackString) {
	      el.appendChild(
	        fragment(
	          '<div class="html-error">%s\n<pre class="error">%e</pre></div>',
	          test.err.htmlMessage,
	          stackString
	        )
	      );
	    } else if (test.err.htmlMessage) {
	      el.appendChild(
	        fragment('<div class="html-error">%s</div>', test.err.htmlMessage)
	      );
	    } else {
	      el.appendChild(
	        fragment('<pre class="error">%e%e</pre>', message, stackString)
	      );
	    }

	    self.addCodeToggle(el, test.body);
	    appendToStack(el);
	    updateStats();
	  });

	  runner$$1.on(EVENT_TEST_PENDING, function(test) {
	    var el = fragment(
	      '<li class="test pass pending"><h2>%e</h2></li>',
	      test.title
	    );
	    appendToStack(el);
	    updateStats();
	  });

	  function appendToStack(el) {
	    // Don't call .appendChild if #mocha-report was already .shift()'ed off the stack.
	    if (stack[0]) {
	      stack[0].appendChild(el);
	    }
	  }

	  function updateStats() {
	    // TODO: add to stats
	    var percent = ((stats.tests / runner$$1.total) * 100) | 0;
	    if (progress$$1) {
	      progress$$1.update(percent).draw(ctx);
	    }

	    // update stats
	    var ms$$1 = new Date() - stats.start;
	    text(passes, stats.passes);
	    text(failures, stats.failures);
	    text(duration, (ms$$1 / 1000).toFixed(2));
	  }
	}

	/**
	 * Makes a URL, preserving querystring ("search") parameters.
	 *
	 * @param {string} s
	 * @return {string} A new URL.
	 */
	function makeUrl(s) {
	  var search = window.location.search;

	  // Remove previous grep query parameter if present
	  if (search) {
	    search = search.replace(/[?&]grep=[^&\s]*/g, '').replace(/^&/, '?');
	  }

	  return (
	    window.location.pathname +
	    (search ? search + '&' : '?') +
	    'grep=' +
	    encodeURIComponent(escapeStringRegexp(s))
	  );
	}

	/**
	 * Provide suite URL.
	 *
	 * @param {Object} [suite]
	 */
	HTML.prototype.suiteURL = function(suite) {
	  return makeUrl(suite.fullTitle());
	};

	/**
	 * Provide test URL.
	 *
	 * @param {Object} [test]
	 */
	HTML.prototype.testURL = function(test) {
	  return makeUrl(test.fullTitle());
	};

	/**
	 * Adds code toggle functionality for the provided test's list element.
	 *
	 * @param {HTMLLIElement} el
	 * @param {string} contents
	 */
	HTML.prototype.addCodeToggle = function(el, contents) {
	  var h2 = el.getElementsByTagName('h2')[0];

	  on(h2, 'click', function() {
	    pre.style.display = pre.style.display === 'none' ? 'block' : 'none';
	  });

	  var pre = fragment('<pre><code>%e</code></pre>', utils.clean(contents));
	  el.appendChild(pre);
	  pre.style.display = 'none';
	};

	/**
	 * Display error `msg`.
	 *
	 * @param {string} msg
	 */
	function error(msg) {
	  document.body.appendChild(fragment('<div id="mocha-error">%s</div>', msg));
	}

	/**
	 * Return a DOM fragment from `html`.
	 *
	 * @param {string} html
	 */
	function fragment(html) {
	  var args = arguments;
	  var div = document.createElement('div');
	  var i = 1;

	  div.innerHTML = html.replace(/%([se])/g, function(_, type) {
	    switch (type) {
	      case 's':
	        return String(args[i++]);
	      case 'e':
	        return escape(args[i++]);
	      // no default
	    }
	  });

	  return div.firstChild;
	}

	/**
	 * Check for suites that do not have elements
	 * with `classname`, and hide them.
	 *
	 * @param {text} classname
	 */
	function hideSuitesWithout(classname) {
	  var suites = document.getElementsByClassName('suite');
	  for (var i = 0; i < suites.length; i++) {
	    var els = suites[i].getElementsByClassName(classname);
	    if (!els.length) {
	      suites[i].className += ' hidden';
	    }
	  }
	}

	/**
	 * Unhide .hidden suites.
	 */
	function unhide() {
	  var els = document.getElementsByClassName('suite hidden');
	  for (var i = 0; i < els.length; ++i) {
	    els[i].className = els[i].className.replace('suite hidden', 'suite');
	  }
	}

	/**
	 * Set an element's text contents.
	 *
	 * @param {HTMLElement} el
	 * @param {string} contents
	 */
	function text(el, contents) {
	  if (el.textContent) {
	    el.textContent = contents;
	  } else {
	    el.innerText = contents;
	  }
	}

	/**
	 * Listen on `event` with callback `fn`.
	 */
	function on(el, event, fn) {
	  if (el.addEventListener) {
	    el.addEventListener(event, fn, false);
	  } else {
	    el.attachEvent('on' + event, fn);
	  }
	}

	HTML.browserOnly = true;
	});

	var list = createCommonjsModule(function (module, exports) {
	/**
	 * @module List
	 */
	/**
	 * Module dependencies.
	 */


	var inherits = utils.inherits;
	var constants = runner.constants;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_BEGIN = constants.EVENT_TEST_BEGIN;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var color = base.color;
	var cursor = base.cursor;

	/**
	 * Expose `List`.
	 */

	exports = module.exports = List;

	/**
	 * Constructs a new `List` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function List(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var n = 0;

	  runner$$1.on(EVENT_RUN_BEGIN, function() {
	    base.consoleLog();
	  });

	  runner$$1.on(EVENT_TEST_BEGIN, function(test) {
	    process.stdout.write(color('pass', '    ' + test.fullTitle() + ': '));
	  });

	  runner$$1.on(EVENT_TEST_PENDING, function(test) {
	    var fmt = color('checkmark', '  -') + color('pending', ' %s');
	    base.consoleLog(fmt, test.fullTitle());
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    var fmt =
	      color('checkmark', '  ' + base.symbols.ok) +
	      color('pass', ' %s: ') +
	      color(test.speed, '%dms');
	    cursor.CR();
	    base.consoleLog(fmt, test.fullTitle(), test.duration);
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function(test) {
	    cursor.CR();
	    base.consoleLog(color('fail', '  %d) %s'), ++n, test.fullTitle());
	  });

	  runner$$1.once(EVENT_RUN_END, self.epilogue.bind(self));
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(List, base);

	List.description = 'like "spec" reporter but flat';
	});

	var min = createCommonjsModule(function (module, exports) {
	/**
	 * @module Min
	 */
	/**
	 * Module dependencies.
	 */


	var inherits = utils.inherits;
	var constants = runner.constants;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;

	/**
	 * Expose `Min`.
	 */

	exports = module.exports = Min;

	/**
	 * Constructs a new `Min` reporter instance.
	 *
	 * @description
	 * This minimal test reporter is best used with '--watch'.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Min(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  runner$$1.on(EVENT_RUN_BEGIN, function() {
	    // clear screen
	    process.stdout.write('\u001b[2J');
	    // set cursor position
	    process.stdout.write('\u001b[1;3H');
	  });

	  runner$$1.once(EVENT_RUN_END, this.epilogue.bind(this));
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Min, base);

	Min.description = 'essentially just a summary';
	});

	var spec = createCommonjsModule(function (module, exports) {
	/**
	 * @module Spec
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_SUITE_BEGIN = constants.EVENT_SUITE_BEGIN;
	var EVENT_SUITE_END = constants.EVENT_SUITE_END;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var inherits = utils.inherits;
	var color = base.color;

	/**
	 * Expose `Spec`.
	 */

	exports = module.exports = Spec;

	/**
	 * Constructs a new `Spec` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Spec(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var indents = 0;
	  var n = 0;

	  function indent() {
	    return Array(indents).join('  ');
	  }

	  runner$$1.on(EVENT_RUN_BEGIN, function() {
	    base.consoleLog();
	  });

	  runner$$1.on(EVENT_SUITE_BEGIN, function(suite) {
	    ++indents;
	    base.consoleLog(color('suite', '%s%s'), indent(), suite.title);
	  });

	  runner$$1.on(EVENT_SUITE_END, function() {
	    --indents;
	    if (indents === 1) {
	      base.consoleLog();
	    }
	  });

	  runner$$1.on(EVENT_TEST_PENDING, function(test) {
	    var fmt = indent() + color('pending', '  - %s');
	    base.consoleLog(fmt, test.title);
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    var fmt;
	    if (test.speed === 'fast') {
	      fmt =
	        indent() +
	        color('checkmark', '  ' + base.symbols.ok) +
	        color('pass', ' %s');
	      base.consoleLog(fmt, test.title);
	    } else {
	      fmt =
	        indent() +
	        color('checkmark', '  ' + base.symbols.ok) +
	        color('pass', ' %s') +
	        color(test.speed, ' (%dms)');
	      base.consoleLog(fmt, test.title, test.duration);
	    }
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function(test) {
	    base.consoleLog(indent() + color('fail', '  %d) %s'), ++n, test.title);
	  });

	  runner$$1.once(EVENT_RUN_END, self.epilogue.bind(self));
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Spec, base);

	Spec.description = 'hierarchical & verbose [default]';
	});

	var nyan = createCommonjsModule(function (module, exports) {
	/**
	 * @module Nyan
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var inherits = utils.inherits;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;

	/**
	 * Expose `Dot`.
	 */

	exports = module.exports = NyanCat;

	/**
	 * Constructs a new `Nyan` reporter instance.
	 *
	 * @public
	 * @class Nyan
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function NyanCat(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var width = (base.window.width * 0.75) | 0;
	  var nyanCatWidth = (this.nyanCatWidth = 11);

	  this.colorIndex = 0;
	  this.numberOfLines = 4;
	  this.rainbowColors = self.generateColors();
	  this.scoreboardWidth = 5;
	  this.tick = 0;
	  this.trajectories = [[], [], [], []];
	  this.trajectoryWidthMax = width - nyanCatWidth;

	  runner$$1.on(EVENT_RUN_BEGIN, function() {
	    base.cursor.hide();
	    self.draw();
	  });

	  runner$$1.on(EVENT_TEST_PENDING, function() {
	    self.draw();
	  });

	  runner$$1.on(EVENT_TEST_PASS, function() {
	    self.draw();
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function() {
	    self.draw();
	  });

	  runner$$1.once(EVENT_RUN_END, function() {
	    base.cursor.show();
	    for (var i = 0; i < self.numberOfLines; i++) {
	      write('\n');
	    }
	    self.epilogue();
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(NyanCat, base);

	/**
	 * Draw the nyan cat
	 *
	 * @private
	 */

	NyanCat.prototype.draw = function() {
	  this.appendRainbow();
	  this.drawScoreboard();
	  this.drawRainbow();
	  this.drawNyanCat();
	  this.tick = !this.tick;
	};

	/**
	 * Draw the "scoreboard" showing the number
	 * of passes, failures and pending tests.
	 *
	 * @private
	 */

	NyanCat.prototype.drawScoreboard = function() {
	  var stats = this.stats;

	  function draw(type, n) {
	    write(' ');
	    write(base.color(type, n));
	    write('\n');
	  }

	  draw('green', stats.passes);
	  draw('fail', stats.failures);
	  draw('pending', stats.pending);
	  write('\n');

	  this.cursorUp(this.numberOfLines);
	};

	/**
	 * Append the rainbow.
	 *
	 * @private
	 */

	NyanCat.prototype.appendRainbow = function() {
	  var this$1 = this;

	  var segment = this.tick ? '_' : '-';
	  var rainbowified = this.rainbowify(segment);

	  for (var index = 0; index < this.numberOfLines; index++) {
	    var trajectory = this$1.trajectories[index];
	    if (trajectory.length >= this$1.trajectoryWidthMax) {
	      trajectory.shift();
	    }
	    trajectory.push(rainbowified);
	  }
	};

	/**
	 * Draw the rainbow.
	 *
	 * @private
	 */

	NyanCat.prototype.drawRainbow = function() {
	  var self = this;

	  this.trajectories.forEach(function(line) {
	    write('\u001b[' + self.scoreboardWidth + 'C');
	    write(line.join(''));
	    write('\n');
	  });

	  this.cursorUp(this.numberOfLines);
	};

	/**
	 * Draw the nyan cat
	 *
	 * @private
	 */
	NyanCat.prototype.drawNyanCat = function() {
	  var self = this;
	  var startWidth = this.scoreboardWidth + this.trajectories[0].length;
	  var dist = '\u001b[' + startWidth + 'C';
	  var padding = '';

	  write(dist);
	  write('_,------,');
	  write('\n');

	  write(dist);
	  padding = self.tick ? '  ' : '   ';
	  write('_|' + padding + '/\\_/\\ ');
	  write('\n');

	  write(dist);
	  padding = self.tick ? '_' : '__';
	  var tail = self.tick ? '~' : '^';
	  write(tail + '|' + padding + this.face() + ' ');
	  write('\n');

	  write(dist);
	  padding = self.tick ? ' ' : '  ';
	  write(padding + '""  "" ');
	  write('\n');

	  this.cursorUp(this.numberOfLines);
	};

	/**
	 * Draw nyan cat face.
	 *
	 * @private
	 * @return {string}
	 */

	NyanCat.prototype.face = function() {
	  var stats = this.stats;
	  if (stats.failures) {
	    return '( x .x)';
	  } else if (stats.pending) {
	    return '( o .o)';
	  } else if (stats.passes) {
	    return '( ^ .^)';
	  }
	  return '( - .-)';
	};

	/**
	 * Move cursor up `n`.
	 *
	 * @private
	 * @param {number} n
	 */

	NyanCat.prototype.cursorUp = function(n) {
	  write('\u001b[' + n + 'A');
	};

	/**
	 * Move cursor down `n`.
	 *
	 * @private
	 * @param {number} n
	 */

	NyanCat.prototype.cursorDown = function(n) {
	  write('\u001b[' + n + 'B');
	};

	/**
	 * Generate rainbow colors.
	 *
	 * @private
	 * @return {Array}
	 */
	NyanCat.prototype.generateColors = function() {
	  var colors = [];

	  for (var i = 0; i < 6 * 7; i++) {
	    var pi3 = Math.floor(Math.PI / 3);
	    var n = i * (1.0 / 6);
	    var r = Math.floor(3 * Math.sin(n) + 3);
	    var g = Math.floor(3 * Math.sin(n + 2 * pi3) + 3);
	    var b = Math.floor(3 * Math.sin(n + 4 * pi3) + 3);
	    colors.push(36 * r + 6 * g + b + 16);
	  }

	  return colors;
	};

	/**
	 * Apply rainbow to the given `str`.
	 *
	 * @private
	 * @param {string} str
	 * @return {string}
	 */
	NyanCat.prototype.rainbowify = function(str) {
	  if (!base.useColors) {
	    return str;
	  }
	  var color = this.rainbowColors[this.colorIndex % this.rainbowColors.length];
	  this.colorIndex += 1;
	  return '\u001b[38;5;' + color + 'm' + str + '\u001b[0m';
	};

	/**
	 * Stdout helper.
	 *
	 * @param {string} string A message to write to stdout.
	 */
	function write(string) {
	  process.stdout.write(string);
	}

	NyanCat.description = '"nyan cat"';
	});

	var xunit = createCommonjsModule(function (module, exports) {
	/**
	 * @module XUnit
	 */
	/**
	 * Module dependencies.
	 */







	var createUnsupportedError = errors.createUnsupportedError;
	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var STATE_FAILED = runnable.constants.STATE_FAILED;
	var inherits = utils.inherits;
	var escape = utils.escape;

	/**
	 * Save timer references to avoid Sinon interfering (see GH-237).
	 */
	var Date = commonjsGlobal.Date;

	/**
	 * Expose `XUnit`.
	 */

	exports = module.exports = XUnit;

	/**
	 * Constructs a new `XUnit` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function XUnit(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var stats = this.stats;
	  var tests = [];
	  var self = this;

	  // the name of the test suite, as it will appear in the resulting XML file
	  var suiteName;

	  // the default name of the test suite if none is provided
	  var DEFAULT_SUITE_NAME = 'Mocha Tests';

	  if (options && options.reporterOptions) {
	    if (options.reporterOptions.output) {
	      if (!path.createWriteStream) {
	        throw createUnsupportedError('file output not supported in browser');
	      }

	      mkdirp.sync(path.dirname(options.reporterOptions.output));
	      self.fileStream = path.createWriteStream(options.reporterOptions.output);
	    }

	    // get the suite name from the reporter options (if provided)
	    suiteName = options.reporterOptions.suiteName;
	  }

	  // fall back to the default suite name
	  suiteName = suiteName || DEFAULT_SUITE_NAME;

	  runner$$1.on(EVENT_TEST_PENDING, function(test) {
	    tests.push(test);
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    tests.push(test);
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function(test) {
	    tests.push(test);
	  });

	  runner$$1.once(EVENT_RUN_END, function() {
	    self.write(
	      tag(
	        'testsuite',
	        {
	          name: suiteName,
	          tests: stats.tests,
	          failures: 0,
	          errors: stats.failures,
	          skipped: stats.tests - stats.failures - stats.passes,
	          timestamp: new Date().toUTCString(),
	          time: stats.duration / 1000 || 0
	        },
	        false
	      )
	    );

	    tests.forEach(function(t) {
	      self.test(t);
	    });

	    self.write('</testsuite>');
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(XUnit, base);

	/**
	 * Override done to close the stream (if it's a file).
	 *
	 * @param failures
	 * @param {Function} fn
	 */
	XUnit.prototype.done = function(failures, fn) {
	  if (this.fileStream) {
	    this.fileStream.end(function() {
	      fn(failures);
	    });
	  } else {
	    fn(failures);
	  }
	};

	/**
	 * Write out the given line.
	 *
	 * @param {string} line
	 */
	XUnit.prototype.write = function(line) {
	  if (this.fileStream) {
	    this.fileStream.write(line + '\n');
	  } else if (typeof process === 'object' && process.stdout) {
	    process.stdout.write(line + '\n');
	  } else {
	    base.consoleLog(line);
	  }
	};

	/**
	 * Output tag for the given `test.`
	 *
	 * @param {Test} test
	 */
	XUnit.prototype.test = function(test) {
	  base.useColors = false;

	  var attrs = {
	    classname: test.parent.fullTitle(),
	    name: test.title,
	    time: test.duration / 1000 || 0
	  };

	  if (test.state === STATE_FAILED) {
	    var err = test.err;
	    var diff =
	      base.hideDiff || !err.actual || !err.expected
	        ? ''
	        : '\n' + base.generateDiff(err.actual, err.expected);
	    this.write(
	      tag(
	        'testcase',
	        attrs,
	        false,
	        tag(
	          'failure',
	          {},
	          false,
	          escape(err.message) + escape(diff) + '\n' + escape(err.stack)
	        )
	      )
	    );
	  } else if (test.isPending()) {
	    this.write(tag('testcase', attrs, false, tag('skipped', {}, true)));
	  } else {
	    this.write(tag('testcase', attrs, true));
	  }
	};

	/**
	 * HTML tag helper.
	 *
	 * @param name
	 * @param attrs
	 * @param close
	 * @param content
	 * @return {string}
	 */
	function tag(name, attrs, close, content) {
	  var end = close ? '/>' : '>';
	  var pairs = [];
	  var tag;

	  for (var key in attrs) {
	    if (Object.prototype.hasOwnProperty.call(attrs, key)) {
	      pairs.push(key + '="' + escape(attrs[key]) + '"');
	    }
	  }

	  tag = '<' + name + (pairs.length ? ' ' + pairs.join(' ') : '') + end;
	  if (content) {
	    tag += content + '</' + name + end;
	  }
	  return tag;
	}

	XUnit.description = 'XUnit-compatible XML output';
	});

	var markdown = createCommonjsModule(function (module, exports) {
	/**
	 * @module Markdown
	 */
	/**
	 * Module dependencies.
	 */



	var constants = runner.constants;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_SUITE_BEGIN = constants.EVENT_SUITE_BEGIN;
	var EVENT_SUITE_END = constants.EVENT_SUITE_END;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;

	/**
	 * Constants
	 */

	var SUITE_PREFIX = '$';

	/**
	 * Expose `Markdown`.
	 */

	exports = module.exports = Markdown;

	/**
	 * Constructs a new `Markdown` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Markdown(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var level = 0;
	  var buf = '';

	  function title(str) {
	    return Array(level).join('#') + ' ' + str;
	  }

	  function mapTOC(suite, obj) {
	    var ret = obj;
	    var key = SUITE_PREFIX + suite.title;

	    obj = obj[key] = obj[key] || {suite: suite};
	    suite.suites.forEach(function(suite) {
	      mapTOC(suite, obj);
	    });

	    return ret;
	  }

	  function stringifyTOC(obj, level) {
	    ++level;
	    var buf = '';
	    var link;
	    for (var key in obj) {
	      if (key === 'suite') {
	        continue;
	      }
	      if (key !== SUITE_PREFIX) {
	        link = ' - [' + key.substring(1) + ']';
	        link += '(#' + utils.slug(obj[key].suite.fullTitle()) + ')\n';
	        buf += Array(level).join('  ') + link;
	      }
	      buf += stringifyTOC(obj[key], level);
	    }
	    return buf;
	  }

	  function generateTOC(suite) {
	    var obj = mapTOC(suite, {});
	    return stringifyTOC(obj, 0);
	  }

	  generateTOC(runner$$1.suite);

	  runner$$1.on(EVENT_SUITE_BEGIN, function(suite) {
	    ++level;
	    var slug = utils.slug(suite.fullTitle());
	    buf += '<a name="' + slug + '"></a>' + '\n';
	    buf += title(suite.title) + '\n';
	  });

	  runner$$1.on(EVENT_SUITE_END, function() {
	    --level;
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    var code = utils.clean(test.body);
	    buf += test.title + '.\n';
	    buf += '\n```js\n';
	    buf += code + '\n';
	    buf += '```\n\n';
	  });

	  runner$$1.once(EVENT_RUN_END, function() {
	    process.stdout.write('# TOC\n');
	    process.stdout.write(generateTOC(runner$$1.suite));
	    process.stdout.write(buf);
	  });
	}

	Markdown.description = 'GitHub Flavored Markdown';
	});

	var progress$1 = createCommonjsModule(function (module, exports) {
	/**
	 * @module Progress
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_TEST_END = constants.EVENT_TEST_END;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var inherits = utils.inherits;
	var color = base.color;
	var cursor = base.cursor;

	/**
	 * Expose `Progress`.
	 */

	exports = module.exports = Progress;

	/**
	 * General progress bar color.
	 */

	base.colors.progress = 90;

	/**
	 * Constructs a new `Progress` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Progress(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var width = (base.window.width * 0.5) | 0;
	  var total = runner$$1.total;
	  var complete = 0;
	  var lastN = -1;

	  // default chars
	  options = options || {};
	  var reporterOptions = options.reporterOptions || {};

	  options.open = reporterOptions.open || '[';
	  options.complete = reporterOptions.complete || '▬';
	  options.incomplete = reporterOptions.incomplete || base.symbols.dot;
	  options.close = reporterOptions.close || ']';
	  options.verbose = reporterOptions.verbose || false;

	  // tests started
	  runner$$1.on(EVENT_RUN_BEGIN, function() {
	    process.stdout.write('\n');
	    cursor.hide();
	  });

	  // tests complete
	  runner$$1.on(EVENT_TEST_END, function() {
	    complete++;

	    var percent = complete / total;
	    var n = (width * percent) | 0;
	    var i = width - n;

	    if (n === lastN && !options.verbose) {
	      // Don't re-render the line if it hasn't changed
	      return;
	    }
	    lastN = n;

	    cursor.CR();
	    process.stdout.write('\u001b[J');
	    process.stdout.write(color('progress', '  ' + options.open));
	    process.stdout.write(Array(n).join(options.complete));
	    process.stdout.write(Array(i).join(options.incomplete));
	    process.stdout.write(color('progress', options.close));
	    if (options.verbose) {
	      process.stdout.write(color('progress', ' ' + complete + ' of ' + total));
	    }
	  });

	  // tests are complete, output some stats
	  // and the failures if any
	  runner$$1.once(EVENT_RUN_END, function() {
	    cursor.show();
	    process.stdout.write('\n');
	    self.epilogue();
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Progress, base);

	Progress.description = 'a progress bar';
	});

	var landing = createCommonjsModule(function (module, exports) {
	/**
	 * @module Landing
	 */
	/**
	 * Module dependencies.
	 */


	var inherits = utils.inherits;
	var constants = runner.constants;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_END = constants.EVENT_TEST_END;
	var STATE_FAILED = runnable.constants.STATE_FAILED;

	var cursor = base.cursor;
	var color = base.color;

	/**
	 * Expose `Landing`.
	 */

	exports = module.exports = Landing;

	/**
	 * Airplane color.
	 */

	base.colors.plane = 0;

	/**
	 * Airplane crash color.
	 */

	base.colors['plane crash'] = 31;

	/**
	 * Runway color.
	 */

	base.colors.runway = 90;

	/**
	 * Constructs a new `Landing` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Landing(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var width = (base.window.width * 0.75) | 0;
	  var total = runner$$1.total;
	  var stream$$1 = process.stdout;
	  var plane = color('plane', '✈');
	  var crashed = -1;
	  var n = 0;

	  function runway() {
	    var buf = Array(width).join('-');
	    return '  ' + color('runway', buf);
	  }

	  runner$$1.on(EVENT_RUN_BEGIN, function() {
	    stream$$1.write('\n\n\n  ');
	    cursor.hide();
	  });

	  runner$$1.on(EVENT_TEST_END, function(test) {
	    // check if the plane crashed
	    var col = crashed === -1 ? ((width * ++n) / total) | 0 : crashed;

	    // show the crash
	    if (test.state === STATE_FAILED) {
	      plane = color('plane crash', '✈');
	      crashed = col;
	    }

	    // render landing strip
	    stream$$1.write('\u001b[' + (width + 1) + 'D\u001b[2A');
	    stream$$1.write(runway());
	    stream$$1.write('\n  ');
	    stream$$1.write(color('runway', Array(col).join('⋅')));
	    stream$$1.write(plane);
	    stream$$1.write(color('runway', Array(width - col).join('⋅') + '\n'));
	    stream$$1.write(runway());
	    stream$$1.write('\u001b[0m');
	  });

	  runner$$1.once(EVENT_RUN_END, function() {
	    cursor.show();
	    process.stdout.write('\n');
	    self.epilogue();
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Landing, base);

	Landing.description = 'Unicode landing strip';
	});

	var jsonStream = createCommonjsModule(function (module, exports) {
	/**
	 * @module JSONStream
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;

	/**
	 * Expose `JSONStream`.
	 */

	exports = module.exports = JSONStream;

	/**
	 * Constructs a new `JSONStream` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function JSONStream(runner$$1, options) {
	  base.call(this, runner$$1, options);

	  var self = this;
	  var total = runner$$1.total;

	  runner$$1.once(EVENT_RUN_BEGIN, function() {
	    writeEvent(['start', {total: total}]);
	  });

	  runner$$1.on(EVENT_TEST_PASS, function(test) {
	    writeEvent(['pass', clean(test)]);
	  });

	  runner$$1.on(EVENT_TEST_FAIL, function(test, err) {
	    test = clean(test);
	    test.err = err.message;
	    test.stack = err.stack || null;
	    writeEvent(['fail', test]);
	  });

	  runner$$1.once(EVENT_RUN_END, function() {
	    writeEvent(['end', self.stats]);
	  });
	}

	/**
	 * Mocha event to be written to the output stream.
	 * @typedef {Array} JSONStream~MochaEvent
	 */

	/**
	 * Writes Mocha event to reporter output stream.
	 *
	 * @private
	 * @param {JSONStream~MochaEvent} event - Mocha event to be output.
	 */
	function writeEvent(event) {
	  process.stdout.write(JSON.stringify(event) + '\n');
	}

	/**
	 * Returns an object literal representation of `test`
	 * free of cyclic properties, etc.
	 *
	 * @private
	 * @param {Test} test - Instance used as data source.
	 * @return {Object} object containing pared-down test instance data
	 */
	function clean(test) {
	  return {
	    title: test.title,
	    fullTitle: test.fullTitle(),
	    duration: test.duration,
	    currentRetry: test.currentRetry()
	  };
	}

	JSONStream.description = 'newline delimited JSON events';
	});

	var reporters = createCommonjsModule(function (module, exports) {

	// Alias exports to a their normalized format Mocha#reporter to prevent a need
	// for dynamic (try/catch) requires, which Browserify doesn't handle.
	exports.Base = exports.base = base;
	exports.Dot = exports.dot = dot;
	exports.Doc = exports.doc = doc;
	exports.TAP = exports.tap = tap;
	exports.JSON = exports.json = json;
	exports.HTML = exports.html = html;
	exports.List = exports.list = list;
	exports.Min = exports.min = min;
	exports.Spec = exports.spec = spec;
	exports.Nyan = exports.nyan = nyan;
	exports.XUnit = exports.xunit = xunit;
	exports.Markdown = exports.markdown = markdown;
	exports.Progress = exports.progress = progress$1;
	exports.Landing = exports.landing = landing;
	exports.JSONStream = exports['json-stream'] = jsonStream;
	});
	var reporters_1 = reporters.Base;
	var reporters_2 = reporters.base;
	var reporters_3 = reporters.Dot;
	var reporters_4 = reporters.dot;
	var reporters_5 = reporters.Doc;
	var reporters_6 = reporters.doc;
	var reporters_7 = reporters.TAP;
	var reporters_8 = reporters.tap;
	var reporters_9 = reporters.JSON;
	var reporters_10 = reporters.json;
	var reporters_11 = reporters.HTML;
	var reporters_12 = reporters.html;
	var reporters_13 = reporters.List;
	var reporters_14 = reporters.list;
	var reporters_15 = reporters.Min;
	var reporters_16 = reporters.min;
	var reporters_17 = reporters.Spec;
	var reporters_18 = reporters.spec;
	var reporters_19 = reporters.Nyan;
	var reporters_20 = reporters.nyan;
	var reporters_21 = reporters.XUnit;
	var reporters_22 = reporters.xunit;
	var reporters_23 = reporters.Markdown;
	var reporters_24 = reporters.markdown;
	var reporters_25 = reporters.Progress;
	var reporters_26 = reporters.progress;
	var reporters_27 = reporters.Landing;
	var reporters_28 = reporters.landing;
	var reporters_29 = reporters.JSONStream;

	var isWindows = process.platform === 'win32' ||
	    process.env.OSTYPE === 'cygwin' ||
	    process.env.OSTYPE === 'msys';


	var COLON = isWindows ? ';' : ':';


	var getNotFoundError = function (cmd) { return Object.assign(new Error(("not found: " + cmd)), { code: 'ENOENT' }); };

	var getPathInfo = function (cmd, opt) {
	  var colon = opt.colon || COLON;

	  // If it has a slash, then we don't bother searching the pathenv.
	  // just check the file itself, and that's it.
	  var pathEnv = cmd.match(/\//) || isWindows && cmd.match(/\\/) ? ['']
	    : (
	      (isWindows ? [process.cwd()] : []).concat( (opt.path || process.env.PATH ||
	          /* istanbul ignore next: very unusual */ '').split(colon) )
	    );
	  var pathExtExe = isWindows
	    ? opt.pathExt || process.env.PATHEXT || '.EXE;.CMD;.BAT;.COM'
	    : '';
	  var pathExt = isWindows ? pathExtExe.split(colon) : [''];

	  if (isWindows) {
	    if (cmd.indexOf('.') !== -1 && pathExt[0] !== '')
	      { pathExt.unshift(''); }
	  }

	  return {
	    pathEnv: pathEnv,
	    pathExt: pathExt,
	    pathExtExe: pathExtExe,
	  }
	};

	var which = function (cmd, opt, cb) {
	  if (typeof opt === 'function') {
	    cb = opt;
	    opt = {};
	  }
	  if (!opt)
	    { opt = {}; }

	  var ref = getPathInfo(cmd, opt);
	  var pathEnv = ref.pathEnv;
	  var pathExt = ref.pathExt;
	  var pathExtExe = ref.pathExtExe;
	  var found = [];

	  var step = function (i) { return new Promise(function (resolve, reject) {
	    if (i === pathEnv.length)
	      { return opt.all && found.length ? resolve(found)
	        : reject(getNotFoundError(cmd)) }

	    var ppRaw = pathEnv[i];
	    var pathPart = /^".*"$/.test(ppRaw) ? ppRaw.slice(1, -1) : ppRaw;

	    var pCmd = path.join(pathPart, cmd);
	    var p = !pathPart && /^\.[\\\/]/.test(cmd) ? cmd.slice(0, 2) + pCmd
	      : pCmd;

	    resolve(subStep(p, i, 0));
	  }); };

	  var subStep = function (p, i, ii) { return new Promise(function (resolve, reject) {
	    if (ii === pathExt.length)
	      { return resolve(step(i + 1)) }
	    var ext = pathExt[ii];
	    isexe(p + ext, { pathExt: pathExtExe }, function (er, is) {
	      if (!er && is) {
	        if (opt.all)
	          { found.push(p + ext); }
	        else
	          { return resolve(p + ext) }
	      }
	      return resolve(subStep(p, i, ii + 1))
	    });
	  }); };

	  return cb ? step(0).then(function (res) { return cb(null, res); }, cb) : step(0)
	};

	var whichSync = function (cmd, opt) {
	  opt = opt || {};

	  var ref = getPathInfo(cmd, opt);
	  var pathEnv = ref.pathEnv;
	  var pathExt = ref.pathExt;
	  var pathExtExe = ref.pathExtExe;
	  var found = [];

	  for (var i = 0; i < pathEnv.length; i ++) {
	    var ppRaw = pathEnv[i];
	    var pathPart = /^".*"$/.test(ppRaw) ? ppRaw.slice(1, -1) : ppRaw;

	    var pCmd = path.join(pathPart, cmd);
	    var p = !pathPart && /^\.[\\\/]/.test(cmd) ? cmd.slice(0, 2) + pCmd
	      : pCmd;

	    for (var j = 0; j < pathExt.length; j ++) {
	      var cur = p + pathExt[j];
	      try {
	        var is = isexe.sync(cur, { pathExt: pathExtExe });
	        if (is) {
	          if (opt.all)
	            { found.push(cur); }
	          else
	            { return cur }
	        }
	      } catch (ex) {}
	    }
	  }

	  if (opt.all && found.length)
	    { return found }

	  if (opt.nothrow)
	    { return null }

	  throw getNotFoundError(cmd)
	};

	var which_1 = which;
	which.sync = whichSync;

	/**
	 * Desktop Notifications module.
	 * @module Growl
	 */



	var which$1 = which_1.sync;
	var ref = runner.constants;
	var EVENT_RUN_END = ref.EVENT_RUN_END;

	/**
	 * @summary
	 * Checks if Growl notification support seems likely.
	 *
	 * @description
	 * Glosses over the distinction between an unsupported platform
	 * and one that lacks prerequisite software installations.
	 *
	 * @public
	 * @see {@link https://github.com/tj/node-growl/blob/master/README.md|Prerequisite Installs}
	 * @see {@link Mocha#growl}
	 * @see {@link Mocha#isGrowlCapable}
	 * @return {boolean} whether Growl notification support can be expected
	 */
	var isCapable = function () {
	  if (!process.browser) {
	    return getSupportBinaries().reduce(
	      function (acc, binary) { return acc || Boolean(which$1(binary, {nothrow: true})); },
	      false
	    );
	  }
	  return false;
	};

	/**
	 * Implements desktop notifications as a pseudo-reporter.
	 *
	 * @public
	 * @see {@link Mocha#_growl}
	 * @param {Runner} runner - Runner instance.
	 */
	var notify = function (runner$$1) {
	  runner$$1.once(EVENT_RUN_END, function () {
	    display(runner$$1);
	  });
	};

	/**
	 * Displays the notification.
	 *
	 * @private
	 * @param {Runner} runner - Runner instance.
	 */
	var display = function (runner$$1) {
	  var growl$$1 = growl;
	  var stats = runner$$1.stats;
	  var symbol = {
	    cross: '\u274C',
	    tick: '\u2705'
	  };
	  var _message;
	  var message;
	  var title;

	  if (stats.failures) {
	    _message = (stats.failures) + " of " + (stats.tests) + " tests failed";
	    message = (symbol.cross) + " " + _message;
	    title = 'Failed';
	  } else {
	    _message = (stats.passes) + " tests passed in " + (stats.duration) + "ms";
	    message = (symbol.tick) + " " + _message;
	    title = 'Passed';
	  }

	  // Send notification
	  var options = {
	    image: logo(),
	    name: 'mocha',
	    title: title
	  };
	  growl$$1(message, options, onCompletion);
	};

	/**
	 * @summary
	 * Callback for result of attempted Growl notification.
	 *
	 * @description
	 * Despite its appearance, this is <strong>not</strong> an Error-first
	 * callback -- all parameters are populated regardless of success.
	 *
	 * @private
	 * @callback Growl~growlCB
	 * @param {*} err - Error object, or <code>null</code> if successful.
	 */
	function onCompletion(err) {
	  if (err) {
	    // As notifications are tangential to our purpose, just log the error.
	    var message =
	      err.code === 'ENOENT' ? 'prerequisite software not found' : err.message;
	    console.error('notification error:', message);
	  }
	}

	/**
	 * Returns Mocha logo image path.
	 *
	 * @private
	 * @return {string} Pathname of Mocha logo
	 */
	var logo = function () {
	  return path.join(__dirname, '..', 'assets', 'mocha-logo-96.png');
	};

	/**
	 * @summary
	 * Gets platform-specific Growl support binaries.
	 *
	 * @description
	 * Somewhat brittle dependency on `growl` package implementation, but it
	 * rarely changes.
	 *
	 * @private
	 * @see {@link https://github.com/tj/node-growl/blob/master/lib/growl.js#L28-L126|setupCmd}
	 * @return {string[]} names of Growl support binaries
	 */
	var getSupportBinaries = function () {
	  var binaries = {
	    Darwin: ['terminal-notifier', 'growlnotify'],
	    Linux: ['notify-send', 'growl'],
	    Windows_NT: ['growlnotify.exe']
	  };
	  return binaries[os.type()] || [];
	};

	var growl$1 = {
		isCapable: isCapable,
		notify: notify
	};

	var diff$1 = true;
	var extension = [
		"js"
	];
	var opts = "./test/mocha.opts";
	var reporter = "spec";
	var slow = 75;
	var timeout = 2000;
	var ui = "bdd";
	var mocharc = {
		diff: diff$1,
		extension: extension,
		opts: opts,
		"package": "./package.json",
		reporter: reporter,
		slow: slow,
		timeout: timeout,
		ui: ui
	};

	var mocharc$1 = /*#__PURE__*/Object.freeze({
		diff: diff$1,
		extension: extension,
		opts: opts,
		reporter: reporter,
		slow: slow,
		timeout: timeout,
		ui: ui,
		default: mocharc
	});

	/**
	 * Provides a factory function for a {@link StatsCollector} object.
	 * @module
	 */

	var constants$2 = runner.constants;
	var EVENT_TEST_PASS = constants$2.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants$2.EVENT_TEST_FAIL;
	var EVENT_SUITE_BEGIN = constants$2.EVENT_SUITE_BEGIN;
	var EVENT_RUN_BEGIN = constants$2.EVENT_RUN_BEGIN;
	var EVENT_TEST_PENDING = constants$2.EVENT_TEST_PENDING;
	var EVENT_RUN_END$1 = constants$2.EVENT_RUN_END;
	var EVENT_TEST_END = constants$2.EVENT_TEST_END;

	/**
	 * Test statistics collector.
	 *
	 * @public
	 * @typedef {Object} StatsCollector
	 * @property {number} suites - integer count of suites run.
	 * @property {number} tests - integer count of tests run.
	 * @property {number} passes - integer count of passing tests.
	 * @property {number} pending - integer count of pending tests.
	 * @property {number} failures - integer count of failed tests.
	 * @property {Date} start - time when testing began.
	 * @property {Date} end - time when testing concluded.
	 * @property {number} duration - number of msecs that testing took.
	 */

	var Date$1 = commonjsGlobal.Date;

	/**
	 * Provides stats such as test duration, number of tests passed / failed etc., by listening for events emitted by `runner`.
	 *
	 * @private
	 * @param {Runner} runner - Runner instance
	 * @throws {TypeError} If falsy `runner`
	 */
	function createStatsCollector(runner$$1) {
	  /**
	   * @type StatsCollector
	   */
	  var stats = {
	    suites: 0,
	    tests: 0,
	    passes: 0,
	    pending: 0,
	    failures: 0
	  };

	  if (!runner$$1) {
	    throw new TypeError('Missing runner argument');
	  }

	  runner$$1.stats = stats;

	  runner$$1.once(EVENT_RUN_BEGIN, function() {
	    stats.start = new Date$1();
	  });
	  runner$$1.on(EVENT_SUITE_BEGIN, function(suite) {
	    suite.root || stats.suites++;
	  });
	  runner$$1.on(EVENT_TEST_PASS, function() {
	    stats.passes++;
	  });
	  runner$$1.on(EVENT_TEST_FAIL, function() {
	    stats.failures++;
	  });
	  runner$$1.on(EVENT_TEST_PENDING, function() {
	    stats.pending++;
	  });
	  runner$$1.on(EVENT_TEST_END, function() {
	    stats.tests++;
	  });
	  runner$$1.once(EVENT_RUN_END$1, function() {
	    stats.end = new Date$1();
	    stats.duration = stats.end - stats.start;
	  });
	}

	var statsCollector = createStatsCollector;

	var createInvalidArgumentTypeError$1 = errors.createInvalidArgumentTypeError;
	var isString = utils.isString;

	var test = Test;

	/**
	 * Initialize a new `Test` with the given `title` and callback `fn`.
	 *
	 * @public
	 * @class
	 * @extends Runnable
	 * @param {String} title - Test title (required)
	 * @param {Function} [fn] - Test callback.  If omitted, the Test is considered "pending"
	 */
	function Test(title, fn) {
	  if (!isString(title)) {
	    throw createInvalidArgumentTypeError$1(
	      'Test argument "title" should be a string. Received type "' +
	        typeof title +
	        '"',
	      'title',
	      'string'
	    );
	  }
	  runnable.call(this, title, fn);
	  this.pending = !fn;
	  this.type = 'test';
	}

	/**
	 * Inherit from `Runnable.prototype`.
	 */
	utils.inherits(Test, runnable);

	Test.prototype.clone = function() {
	  var test = new Test(this.title, this.fn);
	  test.timeout(this.timeout());
	  test.slow(this.slow());
	  test.enableTimeouts(this.enableTimeouts());
	  test.retries(this.retries());
	  test.currentRetry(this.currentRetry());
	  test.globals(this.globals());
	  test.parent = this.parent;
	  test.file = this.file;
	  test.ctx = this.ctx;
	  return test;
	};

	var createMissingArgumentError$1 = errors.createMissingArgumentError;

	/**
	 * Functions common to more than one interface.
	 *
	 * @param {Suite[]} suites
	 * @param {Context} context
	 * @param {Mocha} mocha
	 * @return {Object} An object containing common functions.
	 */
	var common = function(suites, context, mocha) {
	  /**
	   * Check if the suite should be tested.
	   *
	   * @private
	   * @param {Suite} suite - suite to check
	   * @returns {boolean}
	   */
	  function shouldBeTested(suite$$1) {
	    return (
	      !mocha.options.grep ||
	      (mocha.options.grep &&
	        mocha.options.grep.test(suite$$1.fullTitle()) &&
	        !mocha.options.invert)
	    );
	  }

	  return {
	    /**
	     * This is only present if flag --delay is passed into Mocha. It triggers
	     * root suite execution.
	     *
	     * @param {Suite} suite The root suite.
	     * @return {Function} A function which runs the root suite
	     */
	    runWithSuite: function runWithSuite(suite$$1) {
	      return function run() {
	        suite$$1.run();
	      };
	    },

	    /**
	     * Execute before running tests.
	     *
	     * @param {string} name
	     * @param {Function} fn
	     */
	    before: function(name, fn) {
	      suites[0].beforeAll(name, fn);
	    },

	    /**
	     * Execute after running tests.
	     *
	     * @param {string} name
	     * @param {Function} fn
	     */
	    after: function(name, fn) {
	      suites[0].afterAll(name, fn);
	    },

	    /**
	     * Execute before each test case.
	     *
	     * @param {string} name
	     * @param {Function} fn
	     */
	    beforeEach: function(name, fn) {
	      suites[0].beforeEach(name, fn);
	    },

	    /**
	     * Execute after each test case.
	     *
	     * @param {string} name
	     * @param {Function} fn
	     */
	    afterEach: function(name, fn) {
	      suites[0].afterEach(name, fn);
	    },

	    suite: {
	      /**
	       * Create an exclusive Suite; convenience function
	       * See docstring for create() below.
	       *
	       * @param {Object} opts
	       * @returns {Suite}
	       */
	      only: function only(opts) {
	        opts.isOnly = true;
	        return this.create(opts);
	      },

	      /**
	       * Create a Suite, but skip it; convenience function
	       * See docstring for create() below.
	       *
	       * @param {Object} opts
	       * @returns {Suite}
	       */
	      skip: function skip(opts) {
	        opts.pending = true;
	        return this.create(opts);
	      },

	      /**
	       * Creates a suite.
	       *
	       * @param {Object} opts Options
	       * @param {string} opts.title Title of Suite
	       * @param {Function} [opts.fn] Suite Function (not always applicable)
	       * @param {boolean} [opts.pending] Is Suite pending?
	       * @param {string} [opts.file] Filepath where this Suite resides
	       * @param {boolean} [opts.isOnly] Is Suite exclusive?
	       * @returns {Suite}
	       */
	      create: function create(opts) {
	        var suite$$1 = suite.create(suites[0], opts.title);
	        suite$$1.pending = Boolean(opts.pending);
	        suite$$1.file = opts.file;
	        suites.unshift(suite$$1);
	        if (opts.isOnly) {
	          if (mocha.options.forbidOnly && shouldBeTested(suite$$1)) {
	            throw new Error('`.only` forbidden');
	          }

	          suite$$1.parent.appendOnlySuite(suite$$1);
	        }
	        if (suite$$1.pending) {
	          if (mocha.options.forbidPending && shouldBeTested(suite$$1)) {
	            throw new Error('Pending test forbidden');
	          }
	        }
	        if (typeof opts.fn === 'function') {
	          opts.fn.call(suite$$1);
	          suites.shift();
	        } else if (typeof opts.fn === 'undefined' && !suite$$1.pending) {
	          throw createMissingArgumentError$1(
	            'Suite "' +
	              suite$$1.fullTitle() +
	              '" was defined but no callback was supplied. ' +
	              'Supply a callback or explicitly skip the suite.',
	            'callback',
	            'function'
	          );
	        } else if (!opts.fn && suite$$1.pending) {
	          suites.shift();
	        }

	        return suite$$1;
	      }
	    },

	    test: {
	      /**
	       * Exclusive test-case.
	       *
	       * @param {Object} mocha
	       * @param {Function} test
	       * @returns {*}
	       */
	      only: function(mocha, test) {
	        test.parent.appendOnlyTest(test);
	        return test;
	      },

	      /**
	       * Pending test case.
	       *
	       * @param {string} title
	       */
	      skip: function(title) {
	        context.test(title);
	      },

	      /**
	       * Number of retry attempts
	       *
	       * @param {number} n
	       */
	      retries: function(n) {
	        context.retries(n);
	      }
	    }
	  };
	};

	var EVENT_FILE_PRE_REQUIRE = suite.constants
	  .EVENT_FILE_PRE_REQUIRE;

	/**
	 * BDD-style interface:
	 *
	 *      describe('Array', function() {
	 *        describe('#indexOf()', function() {
	 *          it('should return -1 when not present', function() {
	 *            // ...
	 *          });
	 *
	 *          it('should return the index when present', function() {
	 *            // ...
	 *          });
	 *        });
	 *      });
	 *
	 * @param {Suite} suite Root suite.
	 */
	var bdd = function bddInterface(suite$$1) {
	  var suites = [suite$$1];

	  suite$$1.on(EVENT_FILE_PRE_REQUIRE, function(context, file, mocha) {
	    var common$$1 = common(suites, context, mocha);

	    context.before = common$$1.before;
	    context.after = common$$1.after;
	    context.beforeEach = common$$1.beforeEach;
	    context.afterEach = common$$1.afterEach;
	    context.run = mocha.options.delay && common$$1.runWithSuite(suite$$1);
	    /**
	     * Describe a "suite" with the given `title`
	     * and callback `fn` containing nested suites
	     * and/or tests.
	     */

	    context.describe = context.context = function(title, fn) {
	      return common$$1.suite.create({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Pending describe.
	     */

	    context.xdescribe = context.xcontext = context.describe.skip = function(
	      title,
	      fn
	    ) {
	      return common$$1.suite.skip({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Exclusive suite.
	     */

	    context.describe.only = function(title, fn) {
	      return common$$1.suite.only({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Describe a specification or test-case
	     * with the given `title` and callback `fn`
	     * acting as a thunk.
	     */

	    context.it = context.specify = function(title, fn) {
	      var suite$$1 = suites[0];
	      if (suite$$1.isPending()) {
	        fn = null;
	      }
	      var test$$1 = new test(title, fn);
	      test$$1.file = file;
	      suite$$1.addTest(test$$1);
	      return test$$1;
	    };

	    /**
	     * Exclusive test-case.
	     */

	    context.it.only = function(title, fn) {
	      return common$$1.test.only(mocha, context.it(title, fn));
	    };

	    /**
	     * Pending test case.
	     */

	    context.xit = context.xspecify = context.it.skip = function(title) {
	      return context.it(title);
	    };

	    /**
	     * Number of attempts to retry.
	     */
	    context.it.retries = function(n) {
	      context.retries(n);
	    };
	  });
	};

	var description = 'BDD or RSpec style [default]';
	bdd.description = description;

	var EVENT_FILE_PRE_REQUIRE$1 = suite.constants
	  .EVENT_FILE_PRE_REQUIRE;

	/**
	 * TDD-style interface:
	 *
	 *      suite('Array', function() {
	 *        suite('#indexOf()', function() {
	 *          suiteSetup(function() {
	 *
	 *          });
	 *
	 *          test('should return -1 when not present', function() {
	 *
	 *          });
	 *
	 *          test('should return the index when present', function() {
	 *
	 *          });
	 *
	 *          suiteTeardown(function() {
	 *
	 *          });
	 *        });
	 *      });
	 *
	 * @param {Suite} suite Root suite.
	 */
	var tdd = function(suite$$1) {
	  var suites = [suite$$1];

	  suite$$1.on(EVENT_FILE_PRE_REQUIRE$1, function(context, file, mocha) {
	    var common$$1 = common(suites, context, mocha);

	    context.setup = common$$1.beforeEach;
	    context.teardown = common$$1.afterEach;
	    context.suiteSetup = common$$1.before;
	    context.suiteTeardown = common$$1.after;
	    context.run = mocha.options.delay && common$$1.runWithSuite(suite$$1);

	    /**
	     * Describe a "suite" with the given `title` and callback `fn` containing
	     * nested suites and/or tests.
	     */
	    context.suite = function(title, fn) {
	      return common$$1.suite.create({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Pending suite.
	     */
	    context.suite.skip = function(title, fn) {
	      return common$$1.suite.skip({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Exclusive test-case.
	     */
	    context.suite.only = function(title, fn) {
	      return common$$1.suite.only({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Describe a specification or test-case with the given `title` and
	     * callback `fn` acting as a thunk.
	     */
	    context.test = function(title, fn) {
	      var suite$$1 = suites[0];
	      if (suite$$1.isPending()) {
	        fn = null;
	      }
	      var test$$1 = new test(title, fn);
	      test$$1.file = file;
	      suite$$1.addTest(test$$1);
	      return test$$1;
	    };

	    /**
	     * Exclusive test-case.
	     */

	    context.test.only = function(title, fn) {
	      return common$$1.test.only(mocha, context.test(title, fn));
	    };

	    context.test.skip = common$$1.test.skip;
	    context.test.retries = common$$1.test.retries;
	  });
	};

	var description$1 =
	  'traditional "suite"/"test" instead of BDD\'s "describe"/"it"';
	tdd.description = description$1;

	var EVENT_FILE_PRE_REQUIRE$2 = suite.constants
	  .EVENT_FILE_PRE_REQUIRE;

	/**
	 * QUnit-style interface:
	 *
	 *     suite('Array');
	 *
	 *     test('#length', function() {
	 *       var arr = [1,2,3];
	 *       ok(arr.length == 3);
	 *     });
	 *
	 *     test('#indexOf()', function() {
	 *       var arr = [1,2,3];
	 *       ok(arr.indexOf(1) == 0);
	 *       ok(arr.indexOf(2) == 1);
	 *       ok(arr.indexOf(3) == 2);
	 *     });
	 *
	 *     suite('String');
	 *
	 *     test('#length', function() {
	 *       ok('foo'.length == 3);
	 *     });
	 *
	 * @param {Suite} suite Root suite.
	 */
	var qunit = function qUnitInterface(suite$$1) {
	  var suites = [suite$$1];

	  suite$$1.on(EVENT_FILE_PRE_REQUIRE$2, function(context, file, mocha) {
	    var common$$1 = common(suites, context, mocha);

	    context.before = common$$1.before;
	    context.after = common$$1.after;
	    context.beforeEach = common$$1.beforeEach;
	    context.afterEach = common$$1.afterEach;
	    context.run = mocha.options.delay && common$$1.runWithSuite(suite$$1);
	    /**
	     * Describe a "suite" with the given `title`.
	     */

	    context.suite = function(title) {
	      if (suites.length > 1) {
	        suites.shift();
	      }
	      return common$$1.suite.create({
	        title: title,
	        file: file,
	        fn: false
	      });
	    };

	    /**
	     * Exclusive Suite.
	     */

	    context.suite.only = function(title) {
	      if (suites.length > 1) {
	        suites.shift();
	      }
	      return common$$1.suite.only({
	        title: title,
	        file: file,
	        fn: false
	      });
	    };

	    /**
	     * Describe a specification or test-case
	     * with the given `title` and callback `fn`
	     * acting as a thunk.
	     */

	    context.test = function(title, fn) {
	      var test$$1 = new test(title, fn);
	      test$$1.file = file;
	      suites[0].addTest(test$$1);
	      return test$$1;
	    };

	    /**
	     * Exclusive test-case.
	     */

	    context.test.only = function(title, fn) {
	      return common$$1.test.only(mocha, context.test(title, fn));
	    };

	    context.test.skip = common$$1.test.skip;
	    context.test.retries = common$$1.test.retries;
	  });
	};

	var description$2 = 'QUnit style';
	qunit.description = description$2;

	/**
	 * Exports-style (as Node.js module) interface:
	 *
	 *     exports.Array = {
	 *       '#indexOf()': {
	 *         'should return -1 when the value is not present': function() {
	 *
	 *         },
	 *
	 *         'should return the correct index when the value is present': function() {
	 *
	 *         }
	 *       }
	 *     };
	 *
	 * @param {Suite} suite Root suite.
	 */
	var exports$1 = function(suite$$1) {
	  var suites = [suite$$1];

	  suite$$1.on(suite.constants.EVENT_FILE_REQUIRE, visit);

	  function visit(obj, file) {
	    var suite$$1;
	    for (var key in obj) {
	      if (typeof obj[key] === 'function') {
	        var fn = obj[key];
	        switch (key) {
	          case 'before':
	            suites[0].beforeAll(fn);
	            break;
	          case 'after':
	            suites[0].afterAll(fn);
	            break;
	          case 'beforeEach':
	            suites[0].beforeEach(fn);
	            break;
	          case 'afterEach':
	            suites[0].afterEach(fn);
	            break;
	          default:
	            var test$$1 = new test(key, fn);
	            test$$1.file = file;
	            suites[0].addTest(test$$1);
	        }
	      } else {
	        suite$$1 = suite.create(suites[0], key);
	        suites.unshift(suite$$1);
	        visit(obj[key], file);
	        suites.shift();
	      }
	    }
	  }
	};

	var description$3 = 'Node.js module ("exports") style';
	exports$1.description = description$3;

	var bdd$1 = bdd;
	var tdd$1 = tdd;
	var qunit$1 = qunit;
	var exports$2 = exports$1;

	var interfaces = {
		bdd: bdd$1,
		tdd: tdd$1,
		qunit: qunit$1,
		exports: exports$2
	};

	/**
	 * @module Context
	 */
	/**
	 * Expose `Context`.
	 */

	var context = Context;

	/**
	 * Initialize a new `Context`.
	 *
	 * @private
	 */
	function Context() {}

	/**
	 * Set or get the context `Runnable` to `runnable`.
	 *
	 * @private
	 * @param {Runnable} runnable
	 * @return {Context} context
	 */
	Context.prototype.runnable = function(runnable) {
	  if (!arguments.length) {
	    return this._runnable;
	  }
	  this.test = this._runnable = runnable;
	  return this;
	};

	/**
	 * Set or get test timeout `ms`.
	 *
	 * @private
	 * @param {number} ms
	 * @return {Context} self
	 */
	Context.prototype.timeout = function(ms$$1) {
	  if (!arguments.length) {
	    return this.runnable().timeout();
	  }
	  this.runnable().timeout(ms$$1);
	  return this;
	};

	/**
	 * Set test timeout `enabled`.
	 *
	 * @private
	 * @param {boolean} enabled
	 * @return {Context} self
	 */
	Context.prototype.enableTimeouts = function(enabled) {
	  if (!arguments.length) {
	    return this.runnable().enableTimeouts();
	  }
	  this.runnable().enableTimeouts(enabled);
	  return this;
	};

	/**
	 * Set or get test slowness threshold `ms`.
	 *
	 * @private
	 * @param {number} ms
	 * @return {Context} self
	 */
	Context.prototype.slow = function(ms$$1) {
	  if (!arguments.length) {
	    return this.runnable().slow();
	  }
	  this.runnable().slow(ms$$1);
	  return this;
	};

	/**
	 * Mark a test as skipped.
	 *
	 * @private
	 * @throws Pending
	 */
	Context.prototype.skip = function() {
	  this.runnable().skip();
	};

	/**
	 * Set or get a number of allowed retries on failed tests
	 *
	 * @private
	 * @param {number} n
	 * @return {Context} self
	 */
	Context.prototype.retries = function(n) {
	  if (!arguments.length) {
	    return this.runnable().retries();
	  }
	  this.runnable().retries(n);
	  return this;
	};

	var name = "mocha";
	var version = "6.2.0";
	var description$4 = "simple, flexible, fun test framework";
	var keywords = [
		"mocha",
		"test",
		"bdd",
		"tdd",
		"tap"
	];
	var author = "TJ Holowaychuk <tj@vision-media.ca>";
	var contributors = [
		"38elements <mh19820223@gmail.com>",
		"Aaron Brady <aaron@mori.com>",
		"Aaron Hamid <aaron.hamid@gmail.com>",
		"Aaron Heckmann <aaron.heckmann+github@gmail.com>",
		"Aaron Krause <aaronjkrause@gmail.com>",
		"Aaron Petcoff <hello@aaronpetcoff.me>",
		"abrkn <a@abrkn.com>",
		"Adam Crabtree <adam.crabtree@redrobotlabs.com>",
		"Adam Ginzberg <aginzberg@gmail.com>",
		"Adam Gruber <talknmime@gmail.com>",
		"Adrian Ludwig <me@adrianludwig.pl>",
		"Ahmad Bamieh <ahmadbamieh@gmail.com>",
		"airportyh <airportyh@gmail.com>",
		"Ajay Kodali <ajay.kodali@citrix.com>",
		"Al Scott <al.scott@atomicobject.com>",
		"Alex Bainter <metalex9@users.noreply.github.com>",
		"Alexander Early <alexander.early@gmail.com>",
		"Alexander Shepelin <Brightcor@gmail.com>",
		"Alhadis <gardnerjohng@gmail.com>",
		"amsul <reach@amsul.ca>",
		"Anders Olsen Sandvik <Andersos@users.noreply.github.com>",
		"Andreas Brekken <andreas@opuno.com>",
		"Andreas Lind <andreaslindpetersen@gmail.com>",
		"Andreas Lind Petersen <andreas@one.com>",
		"Andrew Bradley <abradley@brightcove.com>",
		"Andrew Bradley <cspotcode@gmail.com>",
		"Andrew Krawchyk <903716+akrawchyk@users.noreply.github.com>",
		"Andrew Nesbitt <andrewnez@gmail.com>",
		"Andrey Popp <8mayday@gmail.com>",
		"Andrii Shumada <eagleeyes91@gmail.com>",
		"andy matthews <andy@commadelimited.com>",
		"Angelica Valenta <angelicavalenta@gmail.com>",
		"Anis Safine <anis.safine.ext@francetv.fr>",
		"Anish Karandikar <anishkny@gmail.com>",
		"Anna Henningsen <github@addaleax.net>",
		"Anthony <keppi@o2.pl>",
		"Anton <anton.redfox@gmail.com>",
		"anton <anton.valickij@gmail.com>",
		"APerson <danielhglus@gmail.com>",
		"Arian Stolwijk <arian@aryweb.nl>",
		"Ariel Mashraki <ariel@mashraki.co.il>",
		"Arnaud Brousseau <arnaud.brousseau@gmail.com>",
		"Artem Govorov <artem.govorov@gmail.com>",
		"Atsuya Takagi <asoftonight@gmail.com>",
		"Attila Domokos <adomokos@gmail.com>",
		"Austin Birch <mraustinbirch@gmail.com>",
		"Avi Vahl <avi.vahl@wix.com>",
		"badunk <baduncaduncan@gmail.com>",
		"Bamieh <ahmadbamieh@gmail.com>",
		"Ben Bradley <ben@bradleyit.com>",
		"Ben Glassman <benglass@users.noreply.github.com>",
		"Ben Harris <benhdev@gmail.com>",
		"Ben Hutchison <ben@aldaviva.com>",
		"Ben Lindsey <ben.lindsey@vungle.com>",
		"Ben Noordhuis <info@bnoordhuis.nl>",
		"Ben Vinegar <ben@benv.ca>",
		"Benjamin Eidelman <beneidel@gmail.com>",
		"Benjie Gillam <benjie@jemjie.com>",
		"Benoit Larroque <zeta.ben@gmail.com>",
		"Benoît Zugmeyer <bzugmeyer@gmail.com>",
		"Benson Trent <bensontrent@gmail.com>",
		"Berker Peksag <berker.peksag@gmail.com>",
		"berni <berni@extensa.pl>",
		"Bjørge Næss <bjoerge@origo.no>",
		"Bjorn Stromberg <bjorn@bjornstar.com>",
		"Brendan Nee <brendan.nee@gmail.com>",
		"Brian Beck <exogen@gmail.com>",
		"Brian Lagerman <49239617+brian-lagerman@users.noreply.github.com>",
		"Brian Lalor <blalor@bravo5.org>",
		"Brian M. Carlson <brian.m.carlson@gmail.com>",
		"Brian Moore <guardbionic-github@yahoo.com>",
		"Brian Tomlin <tendonstrength@gmail.com>",
		"Brittany Moore <moore.brittanyann@gmail.com>",
		"Bryan Donovan <bdondo@gmail.com>",
		"Buck Doyle <b@chromatin.ca>",
		"C. Scott Ananian <cscott@cscott.net>",
		"Callum Macrae <callum@macr.ae>",
		"Can Oztokmak <can@zeplin.io>",
		"Capacitor Set <CapacitorSet@users.noreply.github.com>",
		"Carl-Erik Kopseng <carlerik@gmail.com>",
		"Casey Foster <casey@caseywebdev.com>",
		"Charles Lowell <cowboyd@frontside.io>",
		"Charles Merriam <charles.merriam@gmail.com>",
		"Charles Samborski <demurgos@demurgos.net>",
		"Charlie Rudolph <charles.w.rudolph@gmail.com>",
		"Chen Yangjian <252317+cyjake@users.noreply.github.com>",
		"Chris <chrisleck@users.noreply.github.com>",
		"Chris Buckley <chris@cmbuckley.co.uk>",
		"Chris Lamb <chris@chris-lamb.co.uk>",
		"Christian <me@rndm.de>",
		"Christoffer Hallas <christoffer.hallas@gmail.com>",
		"Christoph Neuroth <christoph.neuroth@gmail.com>",
		"Christopher Hiller <boneskull@boneskull.com>",
		"ChrisWren <cthewren@gmail.com>",
		"claudyus <claudyus@HEX.(none)>",
		"Connor Dunn <connorhd@gmail.com>",
		"Corey Butler <corey@coreybutler.com>",
		"Corey Farrell <git@cfware.com>",
		"Cory Thomas <cory.thomas@bazaarvoice.com>",
		"Craig Taub <craigtaub@gmail.com>",
		"Cube <maty21@gmail.com>",
		"Daniel Ruf <827205+DanielRuf@users.noreply.github.com>",
		"Daniel Ruf <daniel@daniel-ruf.de>",
		"Daniel St. Jules <danielst.jules@gmail.com>",
		"Daniel Stockman <daniel.stockman@gmail.com>",
		"Darryl Pogue <dvpdiner2@gmail.com>",
		"Dave McKenna <davemckenna01@gmail.com>",
		"David da Silva Contín <dasilvacontin@gmail.com>",
		"David Henderson <david.henderson@triggeredmessaging.com>",
		"David M. Lee <leedm777@yahoo.com>",
		"David Neubauer <davidneub@gmail.com>",
		"DavidLi119 <han.david.li@gmail.com>",
		"DavNej <davnej.dev@gmail.com>",
		"Denis Bardadym <bardadymchik@gmail.com>",
		"Devin Weaver <suki@tritarget.org>",
		"dfberry <dinaberry@outlook.com>",
		"Di Wu <dwu@palantir.com>",
		"Dina Berry <dfberry@users.noreply.github.com>",
		"Diogo Monteiro <diogo.gmt@gmail.com>",
		"Dmitriy Simushev <simushevds@gmail.com>",
		"Dmitry Shirokov <deadrunk@gmail.com>",
		"Dmitry Sorin <info@staypositive.ru>",
		"Domenic Denicola <domenic@domenicdenicola.com>",
		"Dominic Barnes <dominic@dbarnes.info>",
		"Dominique Quatravaux <dominique@quatravaux.org>",
		"Douglas Christopher Wilson <doug@somethingdoug.com>",
		"Duncan Beevers <duncan@dweebd.com>",
		"eiji.ienaga <eiji.ienaga@gmail.com>",
		"elergy <elergy@yandex-team.ru>",
		"Eli Skeggs <skeggse@users.noreply.github.com>",
		"ELLIOTTCABLE <me@ell.io>",
		"Emanuele <my.burning@gmail.com>",
		"Enric Pallerols <enric@pallerols.cat>",
		"Erik Eng <mail@ptz0n.se>",
		"Eugene Tiutiunnyk <eugene.tiutiunnyk@lookout.com>",
		"Fabio M. Costa <fabiomcosta@gmail.com>",
		"Fábio Santos <fabiosantosart@gmail.com>",
		"Fagner Brack <github3@fagnermartins.com>",
		"fargies <fargies@users.noreply.github.com>",
		"FARKAS Máté <mate.farkas@virtual-call-center.eu>",
		"fcrisci <fabio.crisci@amadeus.com>",
		"Fede Ramirez <i@2fd.me>",
		"Fedor Indutny <fedor.indutny@gmail.com>",
		"fengmk2 <fengmk2@gmail.com>",
		"Fin Chen <finfin@gmail.com>",
		"Florian Margaine <florian@margaine.com>",
		"FND <FND@users.noreply.github.com>",
		"fool2fish <fool2fish@gmail.com>",
		"Forbes Lindesay <forbes@lindesay.co.uk>",
		"Frank Leon Rose <frankleonrose@gmail.com>",
		"Frederico Silva <frederico.silva@gmail.com>",
		"Fredrik Enestad <fredrik@devloop.se>",
		"Fredrik Lindin <fredriklindin@gmail.com>",
		"Fumiaki MATSUSHIMA <mtsmfm@gmail.com>",
		"Gabe Gorelick <gabegorelick@gmail.com>",
		"Gabriel Silk <gabesilk@gmail.com>",
		"Gareth Aye <gaye@mozilla.com>",
		"Gareth Murphy <gareth.cpm@gmail.com>",
		"Gastón I. Silva <givanse@gmail.com>",
		"Gavin Mogan <GavinM@airg.com>",
		"gaye <gaye@mozilla.com>",
		"gigadude <gigadude@users.noreply.github.com>",
		"Giovanni Bassi <giggio@giggio.net>",
		"gizemkeser <44727928+gizemkeser@users.noreply.github.com>",
		"Glen Huang <curvedmark@gmail.com>",
		"Glen Mailer <glenjamin@gmail.com>",
		"grasGendarme <me@grasgendar.me>",
		"Greg Perkins <gregperkins@alum.mit.edu>",
		"Guangcong Luo <guangcongluo@gmail.com>",
		"Guillermo Rauch <rauchg@gmail.com>",
		"Guy Arye <arye.guy@gmail.com>",
		"Gyandeep Singh <gyandeeps@gmail.com>",
		"Harish <hyeluri@gmail.com>",
		"Harry Brundage <harry.brundage@gmail.com>",
		"Harry Sarson <harry.sarson@hotmail.co.uk>",
		"Harry Wolff <hswolff@users.noreply.github.com>",
		"Herman Junge <herman@geekli.st>",
		"hokaccha <k.hokamura@gmail.com>",
		"Honza Javorek <mail@honzajavorek.cz>",
		"Hugo Giraudel <hugo.giraudel@gmail.com>",
		"Ian Storm Taylor <ian@ianstormtaylor.com>",
		"Ian W. Remmel <design@ianwremmel.com>",
		"Ian Young <ian.greenleaf@gmail.com>",
		"Ian Zamojc <ian@thesecretlocation.net>",
		"Igwe Kalu <igwe.kalu@live.com>",
		"ImgBot <31427850+ImgBotApp@users.noreply.github.com>",
		"inxorable <inxorable@codewren.ch>",
		"Ivan <ivan@kinvey.com>",
		"Jaakko Salonen <jaakko.salonen@iki.fi>",
		"Jacob Wejendorp <jacob@wejendorp.dk>",
		"Jake Craige <james.craige@gmail.com>",
		"Jake Marsh <jakemmarsh@gmail.com>",
		"Jakob Krigovsky <jakob@krigovsky.com>",
		"Jakub Nešetřil <jakub@apiary.io>",
		"James Bowes <jbowes@repl.ca>",
		"James Carr <james.r.carr@gmail.com>",
		"James D. Rogers <jd2rogers2@gmail.com>",
		"James G. Kim <jgkim@jayg.org>",
		"James Lal <james@lightsofapollo.com>",
		"James Nylen <jnylen@gmail.com>",
		"Jan Kopriva <jan.kopriva@gooddata.com>",
		"Jan Krems <jan.krems@groupon.com>",
		"Jan Lehnardt <jan@apache.org>",
		"Jason Barry <jay@jcbarry.com>",
		"Jason Lai <jason@getpebble.com>",
		"Jason Leyba <jmleyba@gmail.com>",
		"Javier Aranda <javierav@javierav.com>",
		"Jayasankar <jayasankar.m@gmail.com>",
		"Jean Ponchon <gelule@gmail.com>",
		"Jeff Kunkle <jeff.kunkle@nearinfinity.com>",
		"Jeff Schilling <jeff.schilling@q2ebanking.com>",
		"JeongHoon Byun (aka Outsider) <outsideris@gmail.com>",
		"Jérémie Astori <jeremie@astori.fr>",
		"Jeremy Martin <jmar777@gmail.com>",
		"Jerry Muzsik <jerrymuzsik@icloud.com>",
		"Jesse Dailey <jesse.dailey@gmail.com>",
		"jimenglish81 <jimenglish81@gmail.com>",
		"Jimmy Cuadra <jimmy@jimmycuadra.com>",
		"Jo Liss <joliss42@gmail.com>",
		"Joao Moreno <mail@joaomoreno.com>",
		"Joel Kemp <mrjoelkemp@gmail.com>",
		"Joey Cozza <joey@grow.com>",
		"John Doty <jrhdoty@gmail.com>",
		"John Firebaugh <john.firebaugh@gmail.com>",
		"John Reeves <github@jonnyreeves.co.uk>",
		"Johnathon Sanders <outdooricon@gmail.com>",
		"Jon Surrell <jon.surrell@automattic.com>",
		"Jonas Dohse <jonas@mbr-targeting.com>",
		"Jonas Westerlund <jonas.westerlund@me.com>",
		"Jonathan Creamer <matrixhasyou2k4@gmail.com>",
		"Jonathan Delgado <jdelgado@rewip.com>",
		"Jonathan Kim <jkimbo@gmail.com>",
		"Jonathan Ong <jonathanrichardong@gmail.com>",
		"Jonathan Park <jpark@daptiv.com>",
		"Jonathan Rajavuori <jrajav@gmail.com>",
		"Jordan Sexton <jordan@jordansexton.com>",
		"Joseph Lin <josephlin55555@gmail.com>",
		"Josh Eversmann <josh.eversmann@gmail.com>",
		"Josh Lory <josh.lory@code.org>",
		"Josh Soref <jsoref@users.noreply.github.com>",
		"Joshua Appelman <jappelman@xebia.com>",
		"Joshua Krall <joshuakrall@pobox.com>",
		"JP Bochi <jpbochi@gmail.com>",
		"jsdevel <js.developer.undefined@gmail.com>",
		"Juerg B <44573692+juergba@users.noreply.github.com>",
		"juergba <filodron@gmail.com>",
		"Julien Wajsberg <felash@gmail.com>",
		"Jupp Müller <jupp0r@gmail.com>",
		"Jussi Virtanen <jussi.k.virtanen@gmail.com>",
		"Justin DuJardin <justin.dujardin@sococo.com>",
		"Juzer Ali <er.juzerali@gmail.com>",
		"Katie Gengler <katiegengler@gmail.com>",
		"kavun <kevin.a.reed@gmail.com>",
		"Kazuhito Hokamura <k.hokamura@gmail.com>",
		"Keith Cirkel <github@keithcirkel.co.uk>",
		"Kelong Wang <buaawkl@gmail.com>",
		"Kent C. Dodds <kent+github@doddsfamily.us>",
		"Kevin Burke <kev@inburke.com>",
		"Kevin Conway <kevinjacobconway@gmail.com>",
		"Kevin Kirsche <Kev.Kirsche+GitHub@gmail.com>",
		"Kevin Partington <platinum.azure@kernelpanicstudios.com>",
		"Kevin Wang <kevin@fossa.io>",
		"Kirill Korolyov <kirill.korolyov@gmail.com>",
		"klaemo <klaemo@fastmail.fm>",
		"Koen Punt <koen@koenpunt.nl>",
		"Konstantin Käfer <github@kkaefer.com>",
		"Kris Rasmussen <kristopher.rasmussen@gmail.com>",
		"Kunal Nagpal <kunagpal@users.noreply.github.com>",
		"Kyle Mitchell <kyle@kemitchell.com>",
		"lakmeer <lakmeerkravid@gmail.com>",
		"Lane Kelly <lanekelly16@gmail.com>",
		"László Bácsi <lackac@lackac.hu>",
		"Laurence Rowe <lrowe@netflix.com>",
		"Liam Newman <bitwiseman@gmail.com>",
		"Linus Unnebäck <linus@folkdatorn.se>",
		"lodr <salva@unoyunodiez.com>",
		"Long Ho <longlho@users.noreply.github.com>",
		"Maciej Małecki <maciej.malecki@notimplemented.org>",
		"Mal Graty <mal.graty@googlemail.com>",
		"Marais Rossouw <me@maraisr.com>",
		"Marc Kuo <kuomarc2@gmail.com>",
		"Marc Udoff <mlucool@gmail.com>",
		"Marcello Bastea-Forte <marcello@cellosoft.com>",
		"Mark Banner <standard8@mozilla.com>",
		"Mark Owsiak <mark.owsiak@gmail.com>",
		"Markus Tacker <m@coderbyheart.com>",
		"Martijn Cuppens <martijn.cuppens@intracto.com>",
		"Martin Marko <marcus@gratex.com>",
		"Mathieu Desvé <mathieudesve@MacBook-Pro-de-Mathieu.local>",
		"Matija Marohnić <matija.marohnic@gmail.com>",
		"Matt Bierner <mattbierner@gmail.com>",
		"Matt Giles <matt.giles@cerner.com>",
		"Matt Robenolt <matt@ydekproductions.com>",
		"Matt Smith <matthewgarysmith@gmail.com>",
		"Matthew Shanley <matthewshanley@littlesecretsrecords.com>",
		"Mattias Tidlund <mattias.tidlund@learningwell.se>",
		"Max Goodman <c@chromakode.com>",
		"Maximilian Antoni <mail@maxantoni.de>",
		"Merrick Christensen <merrick.christensen@gmail.com>",
		"Michael Demmer <demmer@jut.io>",
		"Michael Jackson <mjijackson@gmail.com>",
		"Michael Olson <mwolson@member.fsf.org>",
		"Michael Riley <michael.riley@autodesk.com>",
		"Michael Schoonmaker <michael.r.schoonmaker@gmail.com>",
		"Michal Charemza <michalcharemza@gmail.com>",
		"Michiel de Jong <michiel@unhosted.org>",
		"Mick Brooks <mick.brooks@sinking.in>",
		"Mike Pennisi <mike@mikepennisi.com>",
		"Mislav Marohnić <mislav.marohnic@gmail.com>",
		"monowerker <monowerker@gmail.com>",
		"Moshe Kolodny <mkolodny@integralads.com>",
		"mrShturman <mrshturman@gmail.com>",
		"Nathan Alderson <nathan.alderson@adtran.com>",
		"Nathan Black <nathan@nathanblack.org>",
		"Nathan Bowser <nathan.bowser@spiderstrategies.com>",
		"Nathan Houle <nathan@nathanhoule.com>",
		"Nathan Rajlich <nathan@tootallnate.net>",
		"nexdrew <andrew.goode@nextraq.com>",
		"Nick Fitzgerald <fitzgen@gmail.com>",
		"Nicolas Girault <nic.girault@gmail.com>",
		"Nicolo Taddei <taddei.uk@gmail.com>",
		"Nik Nyby <nnyby@columbia.edu>",
		"Nikolaos Georgiou <Nikolaos.Georgiou@gmail.com>",
		"nishigori <Takuya_Nishigori@voyagegroup.com>",
		"Noshir Patel <nosh@blackpiano.com>",
		"not-an-aardvark <not-an-aardvark@users.noreply.github.com>",
		"OlegTsyba <oleg.tsyba.ua@gmail.com>",
		"olsonpm <olsonpm@users.noreply.github.com>",
		"omardelarosa <thedelarosa@gmail.com>",
		"Oscar Godson <oscargodson@outlook.com>",
		"Outsider <outsideris@gmail.com>",
		"oveddan <stangogh@gmail.com>",
		"P. Roebuck <plroebuck@users.noreply.github.com>",
		"Panu Horsmalahti <panu.horsmalahti@iki.fi>",
		"Parker Moore <parkrmoore@gmail.com>",
		"Pascal <pascal@pascal.com>",
		"Pat Finnigan <patrick.k.finnigan@gmail.com>",
		"Paul Armstrong <paul@paularmstrongdesigns.com>",
		"Paul Miller <paul@paulmillr.com>",
		"Paul Roebuck <plroebuck@users.noreply.github.com>",
		"Pavel Zubkou <pavel.zubkou@gmail.com>",
		"Pete Hawkins <pete@petes-imac.frontinternal.net>",
		"Peter Müller <munter@fumle.dk>",
		"Peter Rust <peter@cornerstonenw.com>",
		"Phil Sung <psung@dnanexus.com>",
		"Philip M. White <philip@mailworks.org>",
		"Piotr Kuczynski <piotr.kuczynski@gmail.com>",
		"PoppinL <poppinlp@gmail.com>",
		"Poprádi Árpád <popradi.arpad11@gmail.com>",
		"Prayag Verma <prayag.verma@gmail.com>",
		"qiuzuhui <qiuzuhui@users.noreply.github.com>",
		"Quang Van <quangvvv@gmail.com>",
		"Quanlong He <kyan.ql.he@gmail.com>",
		"R56 <rviskus@gmail.com>",
		"Raynos <raynos2@gmail.com>",
		"Refael Ackermann <refael@empeeric.com>",
		"Rich Trott <rtrott@gmail.com>",
		"Richard Dingwall <rdingwall@gmail.com>",
		"Richard Knop <RichardKnop@users.noreply.github.com>",
		"Rico Sta. Cruz <rstacruz@users.noreply.github.com>",
		"rmacklin <richard.github@nrm.com>",
		"Rob Loach <robloach@gmail.com>",
		"Rob Raux <rraux@peachworks.com>",
		"Rob Wu <rob@robwu.nl>",
		"Robert Rossmann <rr.rossmann@me.com>",
		"Romain Prieto <romain.prieto@gmail.com>",
		"Roman Neuhauser <rneuhauser@suse.cz>",
		"Roman Shtylman <shtylman@gmail.com>",
		"Ross Warren <rosswarren4@gmail.com>",
		"rotemdan <rotemdan@gmail.com>",
		"Russ Bradberry <devdazed@me.com>",
		"Russell Munson <rmunson@github.com>",
		"Rustem Mustafin <mustafin.rustem@gmail.com>",
		"Ryan Hubbard <ryanmhubbard@gmail.com>",
		"Ryan Shaw <ryan.shaw@min.vc>",
		"Ryan Tablada <ryan.tablada@gmail.com>",
		"Ryunosuke SATO <tricknotes.rs@gmail.com>",
		"ryym <ryym.64@gmail.com>",
		"Salehen Shovon Rahman <salehen.rahman@gmail.com>",
		"Sam Mussell <smussell@gmail.com>",
		"samuel goldszmidt <samuel.goldszmidt@gmail.com>",
		"sarehag <joakim.sarehag@gmail.com>",
		"Sasha Koss <koss@nocorp.me>",
		"Scott Kao <Scottkao85@users.noreply.github.com>",
		"Scott Santucci <ScottFreeCode@users.noreply.github.com>",
		"ScottFreeCode <ScottFreeCode@users.noreply.github.com>",
		"Sean Lang <slang800@gmail.com>",
		"Sebastian Van Sande <sebastian@vansande.org>",
		"sebv <seb.vincent@gmail.com>",
		"Seiya Konno <nulltask@gmail.com>",
		"Sergey Simonchik <sergey.simonchik@jetbrains.com>",
		"Sergio Santoro <santoro.srg@gmail.com>",
		"Shaine Hatch <shaine@squidtree.com>",
		"Shawn Krisman <telaviv@github>",
		"Shinnosuke Watanabe <snnskwtnb@gmail.com>",
		"silentcloud <rjmuqiang@gmail.com>",
		"Silvio Massari <silvio.massari@auth0.com>",
		"Simon Gaeremynck <gaeremyncks@gmail.com>",
		"Simon Goumaz <simon@attentif.ch>",
		"simov <simeonvelichkov@gmail.com>",
		"Sindre Sorhus <sindresorhus@gmail.com>",
		"Slobodan Mišković <slobodan@miskovic.ca>",
		"slyg <syl.faucherand@gmail.com>",
		"Soel <shachar.soel@sap.com>",
		"solodynamo <bittuf3@gmail.com>",
		"Sorin Iclanzan <sorin@iclanzan.com>",
		"Standa Opichal <opichals@gmail.com>",
		"startswithaj <jake.mc@icloud.com>",
		"Stephen Hess <trescube@users.noreply.github.com>",
		"Stephen Mathieson <smath23@gmail.com>",
		"Steve Mason <stevem@brandwatch.com>",
		"Stewart Taylor <stewart.taylor1@gmail.com>",
		"Stone <baoshi.li@adleida.com>",
		"Sulabh Bista <sul4bh@gmail.com>",
		"Sune Simonsen <sune@we-knowhow.dk>",
		"Svetlana <39729453+Lana-Light@users.noreply.github.com>",
		"Sylvain <sstephant+github@gmail.com>",
		"Sylvester Keil <sylvester@keil.or.at>",
		"Szauka <33459309+Szauka@users.noreply.github.com>",
		"Tapiwa Kelvin <tapiwa@munzwa.tk>",
		"Ted Yavuzkurt <hello@TedY.io>",
		"Teddy Zeenny <teddyzeenny@gmail.com>",
		"tgautier@yahoo.com <tgautier@gmail.com>",
		"Thedark1337 <thedark1337@thedark1337.com>",
		"Thomas Broadley <buriedunderbooks@hotmail.com>",
		"Thomas Grainger <tagrain@gmail.com>",
		"Thomas Scholtes <thomas-scholtes@gmx.de>",
		"Thomas Vantuycom <thomasvantuycom@protonmail.com>",
		"Tim Ehat <timehat@gmail.com>",
		"Tim Harshman <goteamtim+git@gmail.com>",
		"Timo Tijhof <krinklemail@gmail.com>",
		"Timothy Gu <timothygu99@gmail.com>",
		"Tingan Ho <tingan87@gmail.com>",
		"tmont <tommy.mont@gmail.com>",
		"Tobias Bieniek <tobias.bieniek@gmail.com>",
		"Tobias Mollstam <tobias@mollstam.com>",
		"Todd Agulnick <tagulnick@onjack.com>",
		"Tom Coquereau <tom@thau.me>",
		"Tom Hughes <tom@compton.nu>",
		"Tomer Eskenazi <tomer.eskenazi@ironsrc.com>",
		"toyjhlee <toyjhlee@gmail.com>",
		"traleig1 <darkphoenix739@gmail.com>",
		"Travis Jeffery <tj@travisjeffery.com>",
		"tripu <t@tripu.info>",
		"Tyson Tate <tyson@tysontate.com>",
		"Vadim Nikitin <vnikiti@ncsu.edu>",
		"Valentin Agachi <github-com@agachi.name>",
		"Valeri Karpov <val@karpov.io>",
		"Victor <victor@turo.com>",
		"Victor Costan <costan@gmail.com>",
		"Ville Saukkonen <villesau@users.noreply.github.com>",
		"Vivek Ganesan <caliberoviv@gmail.com>",
		"vlad <iamvlad@gmail.com>",
		"Vlad Magdalin <vlad@webflow.com>",
		"Volker Buzek <volker.buzek@sap.com>",
		"Wanseob Lim <email@wanseob.com>",
		"Wil Moore III <wil.moore@wilmoore.com>",
		"Will Langstroth <will@langstroth.com>",
		"wsw <wsw0108@gmail.com>",
		"Xavier Antoviaque <xavier@antoviaque.org>",
		"Xavier Damman <xdamman@gmail.com>",
		"XhmikosR <xhmikosr@gmail.com>",
		"XhmikosR <xhmikosr@users.sourceforge.net>",
		"Yanis Wang <yanis.wang@gmail.com>",
		"yehiyam <yehiyam@users.noreply.github.com>",
		"Yoshiya Hinosawa <hinosawa@waku-2.com>",
		"Yuest Wang <yuestwang@gmail.com>",
		"yuitest <yuitest@cjhat.net>",
		"zhiyelee <zhiyelee@gmail.com>",
		"Zsolt Takács <zsolt@takacs.cc>",
		"现充 <qixiang.cqx@alibaba-inc.com>"
	];
	var license = "MIT";
	var repository = {
		type: "git",
		url: "https://github.com/mochajs/mocha.git"
	};
	var bugs = {
		url: "https://github.com/mochajs/mocha/issues/"
	};
	var homepage = "https://mochajs.org/";
	var logo$1 = "https://cldup.com/S9uQ-cOLYz.svg";
	var notifyLogo = "https://ibin.co/4QuRuGjXvl36.png";
	var bin = {
		mocha: "./bin/mocha",
		_mocha: "./bin/_mocha"
	};
	var directories = {
		lib: "./lib",
		test: "./test"
	};
	var engines = {
		node: ">= 6.0.0"
	};
	var scripts = {
		prepublishOnly: "nps test clean build",
		start: "nps",
		test: "nps test",
		version: "nps version"
	};
	var dependencies = {
		"ansi-colors": "3.2.3",
		"browser-stdout": "1.3.1",
		debug: "3.2.6",
		diff: "3.5.0",
		"escape-string-regexp": "1.0.5",
		"find-up": "3.0.0",
		glob: "7.1.3",
		growl: "1.10.5",
		he: "1.2.0",
		"js-yaml": "3.13.1",
		"log-symbols": "2.2.0",
		minimatch: "3.0.4",
		mkdirp: "0.5.1",
		ms: "2.1.1",
		"node-environment-flags": "1.0.5",
		"object.assign": "4.1.0",
		"strip-json-comments": "2.0.1",
		"supports-color": "6.0.0",
		which: "1.3.1",
		"wide-align": "1.1.3",
		yargs: "13.2.2",
		"yargs-parser": "13.0.0",
		"yargs-unparser": "1.5.0"
	};
	var devDependencies = {
		"@11ty/eleventy": "^0.8.3",
		"@mocha/contributors": "^1.0.4",
		"@mocha/docdash": "^2.1.1",
		"assetgraph-builder": "^6.10.1",
		autoprefixer: "^9.6.0",
		browserify: "^16.2.3",
		"browserify-package-json": "^1.0.1",
		chai: "^4.2.0",
		"coffee-script": "^1.12.7",
		coveralls: "^3.0.3",
		"cross-env": "^5.2.0",
		"cross-spawn": "^6.0.5",
		eslint: "^5.16.0",
		"eslint-config-prettier": "^3.6.0",
		"eslint-config-semistandard": "^13.0.0",
		"eslint-config-standard": "^12.0.0",
		"eslint-plugin-import": "^2.17.3",
		"eslint-plugin-node": "^8.0.1",
		"eslint-plugin-prettier": "^3.1.0",
		"eslint-plugin-promise": "^4.1.1",
		"eslint-plugin-standard": "^4.0.0",
		"fs-extra": "^8.0.1",
		husky: "^1.3.1",
		jsdoc: "^3.6.2",
		karma: "^4.1.0",
		"karma-browserify": "^6.0.0",
		"karma-chrome-launcher": "^2.2.0",
		"karma-mocha": "^1.3.0",
		"karma-mocha-reporter": "^2.2.5",
		"karma-sauce-launcher": "^2.0.2",
		"lint-staged": "^8.1.7",
		"markdown-it": "^8.4.2",
		"markdown-it-anchor": "^5.2.4",
		"markdown-it-attrs": "^2.4.1",
		"markdown-it-prism": "^2.0.2",
		"markdown-magic": "^0.1.25",
		"markdown-magic-package-json": "^2.0.0",
		"markdown-toc": "^1.2.0",
		"markdownlint-cli": "^0.14.1",
		nps: "^5.9.5",
		nyc: "^14.1.1",
		prettier: "^1.17.1",
		remark: "^10.0.1",
		"remark-github": "^7.0.6",
		"remark-inline-links": "^3.1.2",
		rewiremock: "^3.13.7",
		rimraf: "^2.6.3",
		sinon: "^7.3.2",
		"strip-ansi": "^5.2.0",
		svgo: "^1.2.2",
		through2: "^3.0.1",
		"to-vfile": "^5.0.3",
		unexpected: "^10.40.2",
		"unexpected-eventemitter": "^1.1.3",
		"unexpected-sinon": "^10.11.2",
		uslug: "^1.0.4",
		watchify: "^3.11.1"
	};
	var files = [
		"bin/{*mocha,options.js}",
		"assets/growl/*.png",
		"lib/**/*.{js,html,json}",
		"index.js",
		"mocha.css",
		"mocha.js",
		"browser-entry.js"
	];
	var browserify = {
		transform: [
			"./scripts/package-json-cullify"
		]
	};
	var browser = {
		"./index.js": "./browser-entry.js",
		"./lib/growl.js": "./lib/browser/growl.js",
		tty: "./lib/browser/tty.js",
		fs: false,
		glob: false,
		path: false,
		"supports-color": false
	};
	var prettier = {
		singleQuote: true,
		bracketSpacing: false,
		endOfLine: "auto"
	};
	var gitter = "https://gitter.im/mochajs/mocha";
	var husky = {
		hooks: {
			"pre-commit": "lint-staged"
		}
	};
	var _package = {
		name: name,
		version: version,
		description: description$4,
		keywords: keywords,
		author: author,
		contributors: contributors,
		license: license,
		repository: repository,
		bugs: bugs,
		homepage: homepage,
		logo: logo$1,
		notifyLogo: notifyLogo,
		bin: bin,
		directories: directories,
		engines: engines,
		scripts: scripts,
		dependencies: dependencies,
		devDependencies: devDependencies,
		files: files,
		browserify: browserify,
		browser: browser,
		prettier: prettier,
		gitter: gitter,
		"@mocha/contributors": {
		exclude: [
			"greenkeeperio-bot <support@greenkeeper.io>",
			"greenkeeper[bot] <greenkeeper[bot]@users.noreply.github.com>",
			"TJ Holowaychuk <tj@vision-media.ca>"
		]
	},
		husky: husky
	};

	var _package$1 = /*#__PURE__*/Object.freeze({
		name: name,
		version: version,
		description: description$4,
		keywords: keywords,
		author: author,
		contributors: contributors,
		license: license,
		repository: repository,
		bugs: bugs,
		homepage: homepage,
		logo: logo$1,
		notifyLogo: notifyLogo,
		bin: bin,
		directories: directories,
		engines: engines,
		scripts: scripts,
		dependencies: dependencies,
		devDependencies: devDependencies,
		files: files,
		browserify: browserify,
		browser: browser,
		prettier: prettier,
		gitter: gitter,
		husky: husky,
		default: _package
	});

	var mocharc$2 = getCjsExportFromNamespace(mocharc$1);

	var require$$6 = getCjsExportFromNamespace(_package$1);

	var mocha = createCommonjsModule(function (module, exports) {

	/*!
	 * mocha
	 * Copyright(c) 2011 TJ Holowaychuk <tj@vision-media.ca>
	 * MIT Licensed
	 */










	var createInvalidReporterError = errors.createInvalidReporterError;
	var createInvalidInterfaceError = errors.createInvalidInterfaceError;
	var EVENT_FILE_PRE_REQUIRE = suite.constants.EVENT_FILE_PRE_REQUIRE;
	var EVENT_FILE_POST_REQUIRE = suite.constants.EVENT_FILE_POST_REQUIRE;
	var EVENT_FILE_REQUIRE = suite.constants.EVENT_FILE_REQUIRE;
	var sQuote = utils.sQuote;

	exports = module.exports = Mocha;

	/**
	 * To require local UIs and reporters when running in node.
	 */

	if (!process.browser) {
	  var cwd = process.cwd();
	  module.paths.push(cwd, path.join(cwd, 'node_modules'));
	}

	/**
	 * Expose internals.
	 */

	/**
	 * @public
	 * @class utils
	 * @memberof Mocha
	 */
	exports.utils = utils;
	exports.interfaces = interfaces;
	/**
	 * @public
	 * @memberof Mocha
	 */
	exports.reporters = reporters;
	exports.Runnable = runnable;
	exports.Context = context;
	/**
	 *
	 * @memberof Mocha
	 */
	exports.Runner = runner;
	exports.Suite = suite;
	exports.Hook = hook;
	exports.Test = test;

	/**
	 * Constructs a new Mocha instance with `options`.
	 *
	 * @public
	 * @class Mocha
	 * @param {Object} [options] - Settings object.
	 * @param {boolean} [options.allowUncaught] - Propagate uncaught errors?
	 * @param {boolean} [options.asyncOnly] - Force `done` callback or promise?
	 * @param {boolean} [options.bail] - Bail after first test failure?
	 * @param {boolean} [options.checkLeaks] - If true, check leaks.
	 * @param {boolean} [options.delay] - Delay root suite execution?
	 * @param {boolean} [options.enableTimeouts] - Enable timeouts?
	 * @param {string} [options.fgrep] - Test filter given string.
	 * @param {boolean} [options.forbidOnly] - Tests marked `only` fail the suite?
	 * @param {boolean} [options.forbidPending] - Pending tests fail the suite?
	 * @param {boolean} [options.fullStackTrace] - Full stacktrace upon failure?
	 * @param {string[]} [options.global] - Variables expected in global scope.
	 * @param {RegExp|string} [options.grep] - Test filter given regular expression.
	 * @param {boolean} [options.growl] - Enable desktop notifications?
	 * @param {boolean} [options.hideDiff] - Suppress diffs from failures?
	 * @param {boolean} [options.ignoreLeaks] - Ignore global leaks?
	 * @param {boolean} [options.invert] - Invert test filter matches?
	 * @param {boolean} [options.noHighlighting] - Disable syntax highlighting?
	 * @param {string} [options.reporter] - Reporter name.
	 * @param {Object} [options.reporterOption] - Reporter settings object.
	 * @param {number} [options.retries] - Number of times to retry failed tests.
	 * @param {number} [options.slow] - Slow threshold value.
	 * @param {number|string} [options.timeout] - Timeout threshold value.
	 * @param {string} [options.ui] - Interface name.
	 * @param {boolean} [options.color] - Color TTY output from reporter?
	 * @param {boolean} [options.useInlineDiffs] - Use inline diffs?
	 */
	function Mocha(options) {
	  options = utils.assign({}, mocharc$2, options || {});
	  this.files = [];
	  this.options = options;
	  // root suite
	  this.suite = new exports.Suite('', new exports.Context(), true);

	  if ('useColors' in options) {
	    utils.deprecate(
	      'useColors is DEPRECATED and will be removed from a future version of Mocha. Instead, use the "color" option'
	    );
	    options.color = 'color' in options ? options.color : options.useColors;
	  }

	  // Globals are passed in as options.global, with options.globals for backward compatibility.
	  options.globals = options.global || options.globals || [];
	  delete options.global;

	  this.grep(options.grep)
	    .fgrep(options.fgrep)
	    .ui(options.ui)
	    .bail(options.bail)
	    .reporter(options.reporter, options.reporterOptions)
	    .useColors(options.color)
	    .slow(options.slow)
	    .useInlineDiffs(options.inlineDiffs)
	    .globals(options.globals);

	  if ('enableTimeouts' in options) {
	    utils.deprecate(
	      'enableTimeouts is DEPRECATED and will be removed from a future version of Mocha. Instead, use "timeout: false" to disable timeouts.'
	    );
	    if (options.enableTimeouts === false) {
	      this.timeout(0);
	    }
	  }

	  // this guard exists because Suite#timeout does not consider `undefined` to be valid input
	  if (typeof options.timeout !== 'undefined') {
	    this.timeout(options.timeout === false ? 0 : options.timeout);
	  }

	  if ('retries' in options) {
	    this.retries(options.retries);
	  }

	  if ('diff' in options) {
	    this.hideDiff(!options.diff);
	  }

	  [
	    'allowUncaught',
	    'asyncOnly',
	    'checkLeaks',
	    'delay',
	    'forbidOnly',
	    'forbidPending',
	    'fullTrace',
	    'growl',
	    'invert'
	  ].forEach(function(opt) {
	    if (options[opt]) {
	      this[opt]();
	    }
	  }, this);
	}

	/**
	 * Enables or disables bailing on the first failure.
	 *
	 * @public
	 * @see {@link https://mochajs.org/#-b---bail|CLI option}
	 * @param {boolean} [bail=true] - Whether to bail on first error.
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.bail = function(bail) {
	  if (!arguments.length) {
	    bail = true;
	  }
	  this.suite.bail(bail);
	  return this;
	};

	/**
	 * @summary
	 * Adds `file` to be loaded for execution.
	 *
	 * @description
	 * Useful for generic setup code that must be included within test suite.
	 *
	 * @public
	 * @see {@link https://mochajs.org/#--file-file|CLI option}
	 * @param {string} file - Pathname of file to be loaded.
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.addFile = function(file) {
	  this.files.push(file);
	  return this;
	};

	/**
	 * Sets reporter to `reporter`, defaults to "spec".
	 *
	 * @public
	 * @see {@link https://mochajs.org/#-r---reporter-name|CLI option}
	 * @see {@link https://mochajs.org/#reporters|Reporters}
	 * @param {String|Function} reporter - Reporter name or constructor.
	 * @param {Object} [reporterOptions] - Options used to configure the reporter.
	 * @returns {Mocha} this
	 * @chainable
	 * @throws {Error} if requested reporter cannot be loaded
	 * @example
	 *
	 * // Use XUnit reporter and direct its output to file
	 * mocha.reporter('xunit', { output: '/path/to/testspec.xunit.xml' });
	 */
	Mocha.prototype.reporter = function(reporter, reporterOptions) {
	  if (typeof reporter === 'function') {
	    this._reporter = reporter;
	  } else {
	    reporter = reporter || 'spec';
	    var _reporter;
	    // Try to load a built-in reporter.
	    if (reporters[reporter]) {
	      _reporter = reporters[reporter];
	    }
	    // Try to load reporters from process.cwd() and node_modules
	    if (!_reporter) {
	      try {
	        _reporter = commonjsRequire(reporter);
	      } catch (err) {
	        if (
	          err.code !== 'MODULE_NOT_FOUND' ||
	          err.message.indexOf('Cannot find module') !== -1
	        ) {
	          // Try to load reporters from a path (absolute or relative)
	          try {
	            _reporter = commonjsRequire(path.resolve(process.cwd(), reporter));
	          } catch (_err) {
	            _err.code !== 'MODULE_NOT_FOUND' ||
	            _err.message.indexOf('Cannot find module') !== -1
	              ? console.warn(sQuote(reporter) + ' reporter not found')
	              : console.warn(
	                  sQuote(reporter) +
	                    ' reporter blew up with error:\n' +
	                    err.stack
	                );
	          }
	        } else {
	          console.warn(
	            sQuote(reporter) + ' reporter blew up with error:\n' + err.stack
	          );
	        }
	      }
	    }
	    if (!_reporter) {
	      throw createInvalidReporterError(
	        'invalid reporter ' + sQuote(reporter),
	        reporter
	      );
	    }
	    this._reporter = _reporter;
	  }
	  this.options.reporterOptions = reporterOptions;
	  return this;
	};

	/**
	 * Sets test UI `name`, defaults to "bdd".
	 *
	 * @public
	 * @see {@link https://mochajs.org/#-u---ui-name|CLI option}
	 * @see {@link https://mochajs.org/#interfaces|Interface DSLs}
	 * @param {string|Function} [ui=bdd] - Interface name or class.
	 * @returns {Mocha} this
	 * @chainable
	 * @throws {Error} if requested interface cannot be loaded
	 */
	Mocha.prototype.ui = function(ui) {
	  var bindInterface;
	  if (typeof ui === 'function') {
	    bindInterface = ui;
	  } else {
	    ui = ui || 'bdd';
	    bindInterface = exports.interfaces[ui];
	    if (!bindInterface) {
	      try {
	        bindInterface = commonjsRequire(ui);
	      } catch (err) {
	        throw createInvalidInterfaceError(
	          'invalid interface ' + sQuote(ui),
	          ui
	        );
	      }
	    }
	  }
	  bindInterface(this.suite);

	  this.suite.on(EVENT_FILE_PRE_REQUIRE, function(context$$1) {
	    exports.afterEach = context$$1.afterEach || context$$1.teardown;
	    exports.after = context$$1.after || context$$1.suiteTeardown;
	    exports.beforeEach = context$$1.beforeEach || context$$1.setup;
	    exports.before = context$$1.before || context$$1.suiteSetup;
	    exports.describe = context$$1.describe || context$$1.suite;
	    exports.it = context$$1.it || context$$1.test;
	    exports.xit = context$$1.xit || (context$$1.test && context$$1.test.skip);
	    exports.setup = context$$1.setup || context$$1.beforeEach;
	    exports.suiteSetup = context$$1.suiteSetup || context$$1.before;
	    exports.suiteTeardown = context$$1.suiteTeardown || context$$1.after;
	    exports.suite = context$$1.suite || context$$1.describe;
	    exports.teardown = context$$1.teardown || context$$1.afterEach;
	    exports.test = context$$1.test || context$$1.it;
	    exports.run = context$$1.run;
	  });

	  return this;
	};

	/**
	 * Loads `files` prior to execution.
	 *
	 * @description
	 * The implementation relies on Node's `require` to execute
	 * the test interface functions and will be subject to its cache.
	 *
	 * @private
	 * @see {@link Mocha#addFile}
	 * @see {@link Mocha#run}
	 * @see {@link Mocha#unloadFiles}
	 * @param {Function} [fn] - Callback invoked upon completion.
	 */
	Mocha.prototype.loadFiles = function(fn) {
	  var self = this;
	  var suite$$1 = this.suite;
	  this.files.forEach(function(file) {
	    file = path.resolve(file);
	    suite$$1.emit(EVENT_FILE_PRE_REQUIRE, commonjsGlobal, file, self);
	    suite$$1.emit(EVENT_FILE_REQUIRE, commonjsRequire(file), file, self);
	    suite$$1.emit(EVENT_FILE_POST_REQUIRE, commonjsGlobal, file, self);
	  });
	  fn && fn();
	};

	/**
	 * Removes a previously loaded file from Node's `require` cache.
	 *
	 * @private
	 * @static
	 * @see {@link Mocha#unloadFiles}
	 * @param {string} file - Pathname of file to be unloaded.
	 */
	Mocha.unloadFile = function(file) {
	  delete commonjsRequire.cache[commonjsRequire.resolve(file)];
	};

	/**
	 * Unloads `files` from Node's `require` cache.
	 *
	 * @description
	 * This allows files to be "freshly" reloaded, providing the ability
	 * to reuse a Mocha instance programmatically.
	 *
	 * <strong>Intended for consumers &mdash; not used internally</strong>
	 *
	 * @public
	 * @see {@link Mocha.unloadFile}
	 * @see {@link Mocha#loadFiles}
	 * @see {@link Mocha#run}
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.unloadFiles = function() {
	  this.files.forEach(Mocha.unloadFile);
	  return this;
	};

	/**
	 * Sets `grep` filter after escaping RegExp special characters.
	 *
	 * @public
	 * @see {@link Mocha#grep}
	 * @param {string} str - Value to be converted to a regexp.
	 * @returns {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Select tests whose full title begins with `"foo"` followed by a period
	 * mocha.fgrep('foo.');
	 */
	Mocha.prototype.fgrep = function(str) {
	  if (!str) {
	    return this;
	  }
	  return this.grep(new RegExp(escapeStringRegexp(str)));
	};

	/**
	 * @summary
	 * Sets `grep` filter used to select specific tests for execution.
	 *
	 * @description
	 * If `re` is a regexp-like string, it will be converted to regexp.
	 * The regexp is tested against the full title of each test (i.e., the
	 * name of the test preceded by titles of each its ancestral suites).
	 * As such, using an <em>exact-match</em> fixed pattern against the
	 * test name itself will not yield any matches.
	 * <br>
	 * <strong>Previous filter value will be overwritten on each call!</strong>
	 *
	 * @public
	 * @see {@link https://mochajs.org/#-g---grep-pattern|CLI option}
	 * @see {@link Mocha#fgrep}
	 * @see {@link Mocha#invert}
	 * @param {RegExp|String} re - Regular expression used to select tests.
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Select tests whose full title contains `"match"`, ignoring case
	 * mocha.grep(/match/i);
	 * @example
	 *
	 * // Same as above but with regexp-like string argument
	 * mocha.grep('/match/i');
	 * @example
	 *
	 * // ## Anti-example
	 * // Given embedded test `it('only-this-test')`...
	 * mocha.grep('/^only-this-test$/');    // NO! Use `.only()` to do this!
	 */
	Mocha.prototype.grep = function(re) {
	  if (utils.isString(re)) {
	    // extract args if it's regex-like, i.e: [string, pattern, flag]
	    var arg = re.match(/^\/(.*)\/(g|i|)$|.*/);
	    this.options.grep = new RegExp(arg[1] || arg[0], arg[2]);
	  } else {
	    this.options.grep = re;
	  }
	  return this;
	};

	/**
	 * Inverts `grep` matches.
	 *
	 * @public
	 * @see {@link Mocha#grep}
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Select tests whose full title does *not* contain `"match"`, ignoring case
	 * mocha.grep(/match/i).invert();
	 */
	Mocha.prototype.invert = function() {
	  this.options.invert = true;
	  return this;
	};

	/**
	 * Enables or disables ignoring global leaks.
	 *
	 * @public
	 * @see {@link Mocha#checkLeaks}
	 * @param {boolean} ignoreLeaks - Whether to ignore global leaks.
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Ignore global leaks
	 * mocha.ignoreLeaks(true);
	 */
	Mocha.prototype.ignoreLeaks = function(ignoreLeaks) {
	  this.options.ignoreLeaks = Boolean(ignoreLeaks);
	  return this;
	};

	/**
	 * Enables checking for global variables leaked while running tests.
	 *
	 * @public
	 * @see {@link https://mochajs.org/#--check-leaks|CLI option}
	 * @see {@link Mocha#ignoreLeaks}
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.checkLeaks = function() {
	  this.options.ignoreLeaks = false;
	  return this;
	};

	/**
	 * Displays full stack trace upon test failure.
	 *
	 * @public
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.fullTrace = function() {
	  this.options.fullStackTrace = true;
	  return this;
	};

	/**
	 * Enables desktop notification support if prerequisite software installed.
	 *
	 * @public
	 * @see {@link Mocha#isGrowlCapable}
	 * @see {@link Mocha#_growl}
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.growl = function() {
	  this.options.growl = this.isGrowlCapable();
	  if (!this.options.growl) {
	    var detail = process.browser
	      ? 'notification support not available in this browser...'
	      : 'notification support prerequisites not installed...';
	    console.error(detail + ' cannot enable!');
	  }
	  return this;
	};

	/**
	 * @summary
	 * Determines if Growl support seems likely.
	 *
	 * @description
	 * <strong>Not available when run in browser.</strong>
	 *
	 * @private
	 * @see {@link Growl#isCapable}
	 * @see {@link Mocha#growl}
	 * @return {boolean} whether Growl support can be expected
	 */
	Mocha.prototype.isGrowlCapable = growl$1.isCapable;

	/**
	 * Implements desktop notifications using a pseudo-reporter.
	 *
	 * @private
	 * @see {@link Mocha#growl}
	 * @see {@link Growl#notify}
	 * @param {Runner} runner - Runner instance.
	 */
	Mocha.prototype._growl = growl$1.notify;

	/**
	 * Specifies whitelist of variable names to be expected in global scope.
	 *
	 * @public
	 * @see {@link https://mochajs.org/#-global-variable-name|CLI option}
	 * @see {@link Mocha#checkLeaks}
	 * @param {String[]|String} globals - Accepted global variable name(s).
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Specify variables to be expected in global scope
	 * mocha.globals(['jQuery', 'MyLib']);
	 */
	Mocha.prototype.globals = function(globals) {
	  this.options.globals = this.options.globals
	    .concat(globals)
	    .filter(Boolean)
	    .filter(function(elt, idx, arr) {
	      return arr.indexOf(elt) === idx;
	    });
	  return this;
	};

	/**
	 * Enables or disables TTY color output by screen-oriented reporters.
	 *
	 * @public
	 * @param {boolean} colors - Whether to enable color output.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.useColors = function(colors) {
	  if (colors !== undefined) {
	    this.options.useColors = colors;
	  }
	  return this;
	};

	/**
	 * Determines if reporter should use inline diffs (rather than +/-)
	 * in test failure output.
	 *
	 * @public
	 * @param {boolean} inlineDiffs - Whether to use inline diffs.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.useInlineDiffs = function(inlineDiffs) {
	  this.options.useInlineDiffs = inlineDiffs !== undefined && inlineDiffs;
	  return this;
	};

	/**
	 * Determines if reporter should include diffs in test failure output.
	 *
	 * @public
	 * @param {boolean} hideDiff - Whether to hide diffs.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.hideDiff = function(hideDiff) {
	  this.options.hideDiff = hideDiff !== undefined && hideDiff;
	  return this;
	};

	/**
	 * @summary
	 * Sets timeout threshold value.
	 *
	 * @description
	 * A string argument can use shorthand (such as "2s") and will be converted.
	 * If the value is `0`, timeouts will be disabled.
	 *
	 * @public
	 * @see {@link https://mochajs.org/#-t---timeout-ms|CLI option}
	 * @see {@link https://mochajs.org/#--no-timeouts|CLI option}
	 * @see {@link https://mochajs.org/#timeouts|Timeouts}
	 * @see {@link Mocha#enableTimeouts}
	 * @param {number|string} msecs - Timeout threshold value.
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Sets timeout to one second
	 * mocha.timeout(1000);
	 * @example
	 *
	 * // Same as above but using string argument
	 * mocha.timeout('1s');
	 */
	Mocha.prototype.timeout = function(msecs) {
	  this.suite.timeout(msecs);
	  return this;
	};

	/**
	 * Sets the number of times to retry failed tests.
	 *
	 * @public
	 * @see {@link https://mochajs.org/#retry-tests|Retry Tests}
	 * @param {number} retry - Number of times to retry failed tests.
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Allow any failed test to retry one more time
	 * mocha.retries(1);
	 */
	Mocha.prototype.retries = function(n) {
	  this.suite.retries(n);
	  return this;
	};

	/**
	 * Sets slowness threshold value.
	 *
	 * @public
	 * @see {@link https://mochajs.org/#-s---slow-ms|CLI option}
	 * @param {number} msecs - Slowness threshold value.
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Sets "slow" threshold to half a second
	 * mocha.slow(500);
	 * @example
	 *
	 * // Same as above but using string argument
	 * mocha.slow('0.5s');
	 */
	Mocha.prototype.slow = function(msecs) {
	  this.suite.slow(msecs);
	  return this;
	};

	/**
	 * Enables or disables timeouts.
	 *
	 * @public
	 * @see {@link https://mochajs.org/#-t---timeout-ms|CLI option}
	 * @see {@link https://mochajs.org/#--no-timeouts|CLI option}
	 * @param {boolean} enableTimeouts - Whether to enable timeouts.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.enableTimeouts = function(enableTimeouts) {
	  this.suite.enableTimeouts(
	    arguments.length && enableTimeouts !== undefined ? enableTimeouts : true
	  );
	  return this;
	};

	/**
	 * Forces all tests to either accept a `done` callback or return a promise.
	 *
	 * @public
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.asyncOnly = function() {
	  this.options.asyncOnly = true;
	  return this;
	};

	/**
	 * Disables syntax highlighting (in browser).
	 *
	 * @public
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.noHighlighting = function() {
	  this.options.noHighlighting = true;
	  return this;
	};

	/**
	 * Enables uncaught errors to propagate (in browser).
	 *
	 * @public
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.allowUncaught = function() {
	  this.options.allowUncaught = true;
	  return this;
	};

	/**
	 * @summary
	 * Delays root suite execution.
	 *
	 * @description
	 * Used to perform asynch operations before any suites are run.
	 *
	 * @public
	 * @see {@link https://mochajs.org/#delayed-root-suite|delayed root suite}
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.delay = function delay() {
	  this.options.delay = true;
	  return this;
	};

	/**
	 * Causes tests marked `only` to fail the suite.
	 *
	 * @public
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.forbidOnly = function() {
	  this.options.forbidOnly = true;
	  return this;
	};

	/**
	 * Causes pending tests and tests marked `skip` to fail the suite.
	 *
	 * @public
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.forbidPending = function() {
	  this.options.forbidPending = true;
	  return this;
	};

	/**
	 * Mocha version as specified by "package.json".
	 *
	 * @name Mocha#version
	 * @type string
	 * @readonly
	 */
	Object.defineProperty(Mocha.prototype, 'version', {
	  value: require$$6.version,
	  configurable: false,
	  enumerable: true,
	  writable: false
	});

	/**
	 * Callback to be invoked when test execution is complete.
	 *
	 * @callback DoneCB
	 * @param {number} failures - Number of failures that occurred.
	 */

	/**
	 * Runs root suite and invokes `fn()` when complete.
	 *
	 * @description
	 * To run tests multiple times (or to run tests in files that are
	 * already in the `require` cache), make sure to clear them from
	 * the cache first!
	 *
	 * @public
	 * @see {@link Mocha#loadFiles}
	 * @see {@link Mocha#unloadFiles}
	 * @see {@link Runner#run}
	 * @param {DoneCB} [fn] - Callback invoked when test execution completed.
	 * @return {Runner} runner instance
	 */
	Mocha.prototype.run = function(fn) {
	  if (this.files.length) {
	    this.loadFiles();
	  }
	  var suite$$1 = this.suite;
	  var options = this.options;
	  options.files = this.files;
	  var runner$$1 = new exports.Runner(suite$$1, options.delay);
	  statsCollector(runner$$1);
	  var reporter = new this._reporter(runner$$1, options);
	  runner$$1.ignoreLeaks = options.ignoreLeaks !== false;
	  runner$$1.fullStackTrace = options.fullStackTrace;
	  runner$$1.asyncOnly = options.asyncOnly;
	  runner$$1.allowUncaught = options.allowUncaught;
	  runner$$1.forbidOnly = options.forbidOnly;
	  runner$$1.forbidPending = options.forbidPending;
	  if (options.grep) {
	    runner$$1.grep(options.grep, options.invert);
	  }
	  if (options.globals) {
	    runner$$1.globals(options.globals);
	  }
	  if (options.growl) {
	    this._growl(runner$$1);
	  }
	  if (options.useColors !== undefined) {
	    exports.reporters.Base.useColors = options.useColors;
	  }
	  exports.reporters.Base.inlineDiffs = options.useInlineDiffs;
	  exports.reporters.Base.hideDiff = options.hideDiff;

	  function done(failures) {
	    fn = fn || utils.noop;
	    if (reporter.done) {
	      reporter.done(failures, fn);
	    } else {
	      fn(failures);
	    }
	  }

	  return runner$$1.run(done);
	};
	});
	var mocha_1 = mocha.utils;
	var mocha_2 = mocha.interfaces;
	var mocha_3 = mocha.reporters;
	var mocha_4 = mocha.Runnable;
	var mocha_5 = mocha.Context;
	var mocha_6 = mocha.Runner;
	var mocha_7 = mocha.Suite;
	var mocha_8 = mocha.Hook;
	var mocha_9 = mocha.Test;
	var mocha_10 = mocha.afterEach;
	var mocha_11 = mocha.after;
	var mocha_12 = mocha.beforeEach;
	var mocha_13 = mocha.before;
	var mocha_14 = mocha.describe;
	var mocha_15 = mocha.it;
	var mocha_16 = mocha.xit;
	var mocha_17 = mocha.setup;
	var mocha_18 = mocha.suiteSetup;
	var mocha_19 = mocha.suiteTeardown;
	var mocha_20 = mocha.suite;
	var mocha_21 = mocha.teardown;
	var mocha_22 = mocha.test;
	var mocha_23 = mocha.run;

	/* eslint no-unused-vars: off */
	/* eslint-env commonjs */

	/**
	 * Shim process.stdout.
	 */

	process.stdout = browserStdout({label: false});



	/**
	 * Create a Mocha instance.
	 *
	 * @return {undefined}
	 */

	var mocha$1 = new mocha({reporter: 'html'});

	/**
	 * Save timer references to avoid Sinon interfering (see GH-237).
	 */

	var Date$2 = commonjsGlobal.Date;
	var setTimeout$2 = commonjsGlobal.setTimeout;
	var setInterval = commonjsGlobal.setInterval;
	var clearTimeout$1 = commonjsGlobal.clearTimeout;
	var clearInterval = commonjsGlobal.clearInterval;

	var uncaughtExceptionHandlers = [];

	var originalOnerrorHandler = commonjsGlobal.onerror;

	/**
	 * Remove uncaughtException listener.
	 * Revert to original onerror handler if previously defined.
	 */

	process.removeListener = function(e, fn) {
	  if (e === 'uncaughtException') {
	    if (originalOnerrorHandler) {
	      commonjsGlobal.onerror = originalOnerrorHandler;
	    } else {
	      commonjsGlobal.onerror = function() {};
	    }
	    var i = uncaughtExceptionHandlers.indexOf(fn);
	    if (i !== -1) {
	      uncaughtExceptionHandlers.splice(i, 1);
	    }
	  }
	};

	/**
	 * Implements uncaughtException listener.
	 */

	process.on = function(e, fn) {
	  if (e === 'uncaughtException') {
	    commonjsGlobal.onerror = function(err, url, line) {
	      fn(new Error(err + ' (' + url + ':' + line + ')'));
	      return !mocha$1.allowUncaught;
	    };
	    uncaughtExceptionHandlers.push(fn);
	  }
	};

	// The BDD UI is registered by default, but no UI will be functional in the
	// browser without an explicit call to the overridden `mocha.ui` (see below).
	// Ensure that this default UI does not expose its methods to the global scope.
	mocha$1.suite.removeAllListeners('pre-require');

	var immediateQueue = [];
	var immediateTimeout;

	function timeslice() {
	  var immediateStart = new Date$2().getTime();
	  while (immediateQueue.length && new Date$2().getTime() - immediateStart < 100) {
	    immediateQueue.shift()();
	  }
	  if (immediateQueue.length) {
	    immediateTimeout = setTimeout$2(timeslice, 0);
	  } else {
	    immediateTimeout = null;
	  }
	}

	/**
	 * High-performance override of Runner.immediately.
	 */

	mocha.Runner.immediately = function(callback) {
	  immediateQueue.push(callback);
	  if (!immediateTimeout) {
	    immediateTimeout = setTimeout$2(timeslice, 0);
	  }
	};

	/**
	 * Function to allow assertion libraries to throw errors directly into mocha.
	 * This is useful when running tests in a browser because window.onerror will
	 * only receive the 'message' attribute of the Error.
	 */
	mocha$1.throwError = function(err) {
	  uncaughtExceptionHandlers.forEach(function(fn) {
	    fn(err);
	  });
	  throw err;
	};

	/**
	 * Override ui to ensure that the ui functions are initialized.
	 * Normally this would happen in Mocha.prototype.loadFiles.
	 */

	mocha$1.ui = function(ui) {
	  mocha.prototype.ui.call(this, ui);
	  this.suite.emit('pre-require', commonjsGlobal, null, this);
	  return this;
	};

	/**
	 * Setup mocha with the given setting options.
	 */

	mocha$1.setup = function(opts) {
	  var this$1 = this;

	  if (typeof opts === 'string') {
	    opts = {ui: opts};
	  }
	  for (var opt in opts) {
	    if (opts.hasOwnProperty(opt)) {
	      this$1[opt](opts[opt]);
	    }
	  }
	  return this;
	};

	/**
	 * Run mocha, returning the Runner.
	 */

	mocha$1.run = function(fn) {
	  var options = mocha$1.options;
	  mocha$1.globals('location');

	  var query = mocha.utils.parseQuery(commonjsGlobal.location.search || '');
	  if (query.grep) {
	    mocha$1.grep(query.grep);
	  }
	  if (query.fgrep) {
	    mocha$1.fgrep(query.fgrep);
	  }
	  if (query.invert) {
	    mocha$1.invert();
	  }

	  return mocha.prototype.run.call(mocha$1, function(err) {
	    // The DOM Document is not available in Web Workers.
	    var document = commonjsGlobal.document;
	    if (
	      document &&
	      document.getElementById('mocha') &&
	      options.noHighlighting !== true
	    ) {
	      mocha.utils.highlightTags('code');
	    }
	    if (fn) {
	      fn(err);
	    }
	  });
	};

	/**
	 * Expose the process shim.
	 * https://github.com/mochajs/mocha/pull/916
	 */

	mocha.process = process;

	/**
	 * Expose mocha.
	 */

	commonjsGlobal.Mocha = mocha;
	commonjsGlobal.mocha = mocha$1;

	// this allows test/acceptance/required-tokens.js to pass; thus,
	// you can now do `const describe = require('mocha').describe` in a
	// browser context (assuming browserification).  should fix #880
	var browserEntry = commonjsGlobal;

	return browserEntry;

}));
